      double precision function AFUNC_EDM(x)
      
      implicit none
      
      double precision x
      
      if(x.eq.1d0) then
      AFUNC_EDM=-1d0/3d0
      else
      AFUNC_EDM=(3d0-x+2d0*Log(x)/(1d0-x))/2d0/(1d0-x)**2
      end if
      
      return
      end
      
      
      double precision function BFUNC_EDM(x)
      
      implicit none
      
      double precision x
      
      if(x.eq.1d0) then
      BFUNC_EDM=1d0/6d0
      else
      BFUNC_EDM=(1d0+x+2d0*x*Log(x)/(1d0-x))/2d0/(1d0-x)**2
      end if
      
      return
      end
      
      
      double precision function CFUNC_EDM(x)
      
      implicit none
      
      double precision x
      
      if(x.eq.1) then
      CFUNC_EDM=19d0/18d0
      else
      CFUNC_EDM=(10d0*x-26d0+2d0*x*Log(x)/(1d0-x)-
     &           18d0*Log(x)/(1-x))/6d0/(1d0-x)**2
      end if
      
      return
      end
      
      
      
      double precision function FUNC_EDM(x)
      
      implicit none
      
      double precision x,z
      double precision res,rel
      double precision FUNC_EDM_VEGAS
      integer ivegas(4),iprint
      
      double complex DiLi,arg1,arg2,arg3
      
      external FUNC_EDM_VEGAS

      common/inpVEGAS/ivegas,iprint
      common/FUNCEDM/z
         
      arg1=1d0-4d0*x
      arg2=-2d0/(-1d0+Sqrt(arg1))
      arg3=2d0/(1d0+Sqrt(arg1))
      if(AIMAG(Sqrt(arg1)).ne.0d0 .or. Realpart(Sqrt(arg1)).ge.1d0) 
     &    then
          res=-((-2*Sqrt(arg1)+2*x*DiLi(arg2) - 
     -      2*x*DiLi(arg3)+Sqrt(arg1)*Log(1/x) - 
     -      x*Log((-1+Sqrt(arg1))/(1+Sqrt(arg1)))*Log(1/x)+
     -      x*Log((1+Sqrt(arg1))/(-1+Sqrt(arg1)))*Log(1/x))/Sqrt(arg1))
      else
          z=x
          call INTEG(FUNC_EDM_VEGAS,1,iprint,ivegas,res,rel)
      end if
      
      FUNC_EDM=res
      
      return
      end
      
      
      double precision function FUNC_EDM_VEGAS(dum)
      
      implicit none
      
      double precision dum
      double precision z
      double precision xlow,xhigh,x,func
     
      common/FUNCEDM/z
      
      xlow=0d0
      xhigh=1d0
      x=xlow+(xhigh-xlow)*dum
      func=x*(1d0-x)/(z-x*(1d0-x))*log(x*(1d0-x)/z)
      FUNC_EDM_VEGAS=func*(xhigh-xlow)
      
      return
      end
      
      
      double precision function fFUNC_EDM(x)
      
      implicit none
      
      double precision x,z
      double precision res,rel,res1
      double precision fFUNC_EDM_VEGAS
      integer ivegas(4),iprint
      
      double complex DiLi,arg1,arg2,arg3
      
      external fFUNC_EDM_VEGAS

      common/inpVEGAS/ivegas,iprint
      common/FUNCEDM/z
         
      arg1=1d0-4d0*x
      arg2=-2d0/(-1d0+Sqrt(arg1))
      arg3=2d0/(1d0+Sqrt(arg1))

      res=-(x*(-4*Sqrt(arg1) + (-2 + 4*x)*DiLi(arg2) + (2 - 4*x)*DiLi(arg3) + 
     -       2*Sqrt(arg1)*Log(1/x) + 
     -       Log((-1 + Sqrt(arg1))/(1 + Sqrt(arg1)))*Log(1/x) - 
     -       2*x*Log((-1 + Sqrt(arg1))/(1 + Sqrt(arg1)))*Log(1/x) - 
     -       Log((1 + Sqrt(arg1))/(-1 + Sqrt(arg1)))*Log(1/x) + 
     -       2*x*Log((1 + Sqrt(arg1))/(-1 + Sqrt(arg1)))*Log(1/x)))/
     -  (2.*Sqrt(arg1))
          z=x
      fFUNC_EDM=res
      
      return
      end
      
      
      double precision function fFUNC_EDM_VEGAS(dum)
      
      implicit none
      
      double precision dum
      double precision z
      double precision xlow,xhigh,x,func
     
      common/FUNCEDM/z
      
      xlow=0d0
      xhigh=1d0
      x=xlow+(xhigh-xlow)*dum
      func=z/2d0*(1d0-2d0*x*(1d0-x))/(x*(1d0-x)-z)*Log(x*(1d0-x)/z)
      fFUNC_EDM_VEGAS=func*(xhigh-xlow)
      
      return
      end
      

      
      
      double precision function gFUNC_EDM(x)
      
      implicit none
      
      double precision x,z
      double precision res,rel,res1
      double precision gFUNC_EDM_VEGAS
      integer ivegas(4),iprint
      
      double complex DiLi,arg1,arg2,arg3
      
      external gFUNC_EDM_VEGAS

      common/inpVEGAS/ivegas,iprint
      common/FUNCEDM/z
         
      arg1=1d0-4d0*x
      arg2=-2d0/(-1d0+Sqrt(arg1))
      arg3=2d0/(1d0+Sqrt(arg1))

      res=-(x*(-2*DiLi(arg2) + 2*DiLi(arg3) + 
     -       Log(1/x)*(-Log(-((1 + Sqrt(arg1) - 2*x)/x)) + 
     -          Log((-1 + Sqrt(arg1) + 2*x)/x))))/(2.*Sqrt(arg1))

      z=x
      gFUNC_EDM=res
      
      return
      end
      
      
      double precision function gFUNC_EDM_VEGAS(dum)
      
      implicit none
      
      double precision dum
      double precision z
      double precision xlow,xhigh,x,func
     
      common/FUNCEDM/z
      
      xlow=0d0
      xhigh=1d0
      x=xlow+(xhigh-xlow)*dum
      func=z/2d0/(x*(1d0-x)-z)*Log(x*(1d0-x)/z)
      gFUNC_EDM_VEGAS=func*(xhigh-xlow)
      
      return
      end
      
      
      
    
      
      
      double precision function JFUNC1_EDM(j1,j2,j3,a,b,c,d)
      
      implicit none
      
      double precision j1,j2,j3,a,b,c,d
      double precision para(7)
      double precision res,rel,res1
      double precision JFUNC1_EDM_VEGAS
      integer ivegas(4),iprint
      
      external JFUNC1_EDM_VEGAS

      common/inpVEGAS/ivegas,iprint
      common/JFUNCEDM1/para
      
      para(1)=j1
      para(2)=j2
      para(3)=j3
      para(4)=a
      para(5)=b
      para(6)=c
      para(7)=d
      
     
      call INTEG(JFUNC1_EDM_VEGAS,1,iprint,ivegas,res,rel)
      JFUNC1_EDM=res

      return
      end
      
      
      double precision function JFUNC1_EDM_VEGAS(dum)
      
      implicit none
      
      double precision dum
      double precision para(7)
      double precision xlow,xhigh,x,func
      double precision J2arg
     
      common/JFUNCEDM1/para
      
      xlow=0d0
      xhigh=1d0
      x=xlow+(xhigh-xlow)*dum
      func=J2arg(para(1),para(2)/(1d0-x)+para(3)/x)/(1d0-x)*
     &     (para(4)*x**2+para(5)*(1d0-x)**2+para(6)*x+para(7)*(1d0-x))
      JFUNC1_EDM_VEGAS=func*(xhigh-xlow)
      
      return
      end
      
      
      double precision function J2arg(arg1,arg2)
      
      implicit none
      
      double precision arg1,arg2
      double precision J1arg
      
      if(arg1.eq.arg2) then
       if(arg1.eq.1d0) then
       J2arg=1d0/2d0
       else
       J2arg=(-Log(arg1)+arg1-1d0)/(arg1-1d0)**2
       end if
      
      else
      J2arg=(J1arg(arg1)-J1arg(arg2))/(arg1-arg2)
      end if
      
      
      return
      end
      
      
      double precision function J1arg(x)
      
      implicit none
      double precision x
      
      if(x.eq.0d0) then
      J1arg=0d0
      else
      J1arg=x*Log(x)/(x-1d0)
      end if
      
      return
      end
      
      
      
      double precision function fWWFUNC_EDM(a,b)
      
      implicit none
      
      double precision a,b
      double precision para(2)
      double precision res,rel,res1
      double precision fWWFUNC_EDM_VEGAS
      integer ivegas(4),iprint
      
      external fWWFUNC_EDM_VEGAS

      common/inpVEGAS/ivegas,iprint
      common/fWWFUNCEDM/para
     
      para(1)=a
      para(2)=b
      
     
      call INTEG(fWWFUNC_EDM_VEGAS,1,iprint,ivegas,res,rel)
      fWWFUNC_EDM=res
      
      return
      end
      
      
      double precision function fWWFUNC_EDM_VEGAS(dum)
      
      implicit none
      
      double precision dum
      double precision para(2)
      double precision xlow,xhigh,x,func
      double precision J2arg
     
      common/fWWFUNCEDM/para
      
      xlow=0d0
      xhigh=1d0
      x=xlow+(xhigh-xlow)*dum
      func=J2arg(0d0,((1d0-x)*para(1)+x*para(2))/x/(1d0-x))/(1d0-x)
      fWWFUNC_EDM_VEGAS=func*(xhigh-xlow)
      
      return
      end
      
      
      
      double precision function JFUNC2_EDM(a,b)
      
      implicit none
      
      double precision a,b
      double precision para(2)
      double precision res,rel,res1
      double precision JFUNC2_EDM_VEGAS
      integer ivegas(4),iprint
      
      external JFUNC2_EDM_VEGAS

      common/inpVEGAS/ivegas,iprint
      common/JFUNCEDM2/para
      
      para(1)=a
      para(2)=b
     
      call INTEG(JFUNC2_EDM_VEGAS,1,iprint,ivegas,res,rel)
      JFUNC2_EDM=res
      
      return
      end
      
      
      double precision function JFUNC2_EDM_VEGAS(dum)
      
      implicit none
      
      double precision dum
      double precision para(2)
      double precision xlow,xhigh,x,func
      double precision J2arg
     
      common/JFUNCEDM2/para
      
      xlow=0d0
      xhigh=1d0
      x=xlow+(xhigh-xlow)*dum
      func=J2arg(para(1),para(2)/x/(1d0-x))/x
      JFUNC2_EDM_VEGAS=func*(xhigh-xlow)
      
      return
      end
      
      
      
      
      
      
      
      double precision function JFUNC3_EDM(a,b)
      
      implicit none
      
      double precision a,b
      double precision para(2)
      double precision res,rel,res1
      double precision JFUNC3_EDM_VEGAS
      integer ivegas(4),iprint
      
      external JFUNC3_EDM_VEGAS

      common/inpVEGAS/ivegas,iprint
      common/JFUNCEDM3/para
      
      para(1)=a
      para(2)=b
     
      call INTEG(JFUNC3_EDM_VEGAS,1,iprint,ivegas,res,rel)
      JFUNC3_EDM=res
      
      return
      end
      
      
      double precision function JFUNC3_EDM_VEGAS(dum)
      
      implicit none
      
      double precision dum
      double precision para(2)
      double precision xlow,xhigh,x,func
      double precision J2arg
     
      common/JFUNCEDM3/para
      
      xlow=0d0
      xhigh=1d0
      x=xlow+(xhigh-xlow)*dum
      func=J2arg(para(1),para(2)/x/(1d0-x))/x*(1d0-x)
      JFUNC3_EDM_VEGAS=func*(xhigh-xlow)
      
      return
      end
      
      
      
      
      
      double precision function JFUNC4_EDM(a,b,c)
      
      implicit none
      
      double precision a,b,c
      double precision para(3)
      double precision res,rel,res1
      double precision JFUNC4_EDM_VEGAS
      integer ivegas(4),iprint
      
      external JFUNC4_EDM_VEGAS

      common/inpVEGAS/ivegas,iprint
      common/JFUNCEDM4/para
      
      para(1)=a
      para(2)=b
      para(3)=c
     
      call INTEG(JFUNC4_EDM_VEGAS,1,iprint,ivegas,res,rel)
      JFUNC4_EDM=res
      
      return
      end
      
      
      double precision function JFUNC4_EDM_VEGAS(dum)
      
      implicit none
      
      double precision dum
      double precision para(3)
      double precision xlow,xhigh,x,func
      double precision J2arg
     
      common/JFUNCEDM4/para
      
      xlow=0d0
      xhigh=1d0
      x=xlow+(xhigh-xlow)*dum
      func=J2arg(para(1),(x*para(2)+(1d0-x)*para(3))/(1d0-x)/x)/x
      JFUNC4_EDM_VEGAS=func*(xhigh-xlow)
      
      return
      end
      
      
      
      double precision function JFUNC5_EDM(a,b,c)
      
      implicit none
      
      double precision a,b,c
      double precision para(3)
      double precision res,rel,res1
      double precision JFUNC5_EDM_VEGAS
      integer ivegas(4),iprint
      
      external JFUNC5_EDM_VEGAS

      common/inpVEGAS/ivegas,iprint
      common/JFUNCEDM5/para
      
      para(1)=a
      para(2)=b
      para(3)=c
     
      call INTEG(JFUNC5_EDM_VEGAS,1,iprint,ivegas,res,rel)
      JFUNC5_EDM=res
      
      return
      end
      
      
      double precision function JFUNC5_EDM_VEGAS(dum)
      
      implicit none
      
      double precision dum
      double precision para(3)
      double precision xlow,xhigh,x,func
      double precision J2arg
     
      common/JFUNCEDM5/para
      
      xlow=0d0
      xhigh=1d0
      x=xlow+(xhigh-xlow)*dum
      func=J2arg(para(1),(x*para(2)+(1d0-x)*para(3))/(1d0-x)/x)/x*
     &     (1d0-x)
      JFUNC5_EDM_VEGAS=func*(xhigh-xlow)
      
      return
      end
      
      
      double precision function hFUNC_EDM(a)
      
      implicit none
      double precision a,u
      double precision res,rel
      double precision hFUNC_EDM_VEGAS
      integer ivegas(4),iprint
      
      external hFUNC_EDM_VEGAS

      common/inpVEGAS/ivegas,iprint
      common/hFUNC/u
      
      u=a
      call INTEG(hFUNC_EDM_VEGAS,2,iprint,ivegas,res,rel)
      hFUNC_EDM=res
      
      
      return
      end
      
      
      double precision function hFUNC_EDM_VEGAS(dum)
      
      implicit none
      double precision dum(2)
      double precision u
      double precision xlow,xhigh,x,func
      double precision ylow,yhigh,y
     
      common/hFUNC/u
      
      xlow=0d0
      xhigh=1d0
      x=xlow+(xhigh-xlow)*dum(1)
      ylow=0d0
      yhigh=1d0
      y=ylow+(yhigh-ylow)*dum(2)
      func=y**3*x**3*(1d0-x)/(x*(1d0-y*x)+u*(1d0-y)*(1D0-x))**2/4d0
      hFUNC_EDM_VEGAS=func*(xhigh-xlow)*(yhigh-ylow)
      
      return
      end
      
      
      double precision function HcapFUNC_EDM(a,b,c)
      
      implicit none
      double precision a,b,c,z1,z2,z3
      double precision res,rel
      double precision hFUNC_EDM_VEGAS
      integer ivegas(4),iprint
      
      external HcapFUNC_EDM_VEGAS

      common/inpVEGAS/ivegas,iprint
      common/HcapFUNC/z1,z2,z3
      
      z1=a
      z2=b
      Z3=c
      call INTEG(HcapFUNC_EDM_VEGAS,3,iprint,ivegas,res,rel)
      HcapFUNC_EDM=res
      
      return
      end
      
      
      double precision function HcapFUNC_EDM_VEGAS(dum)
      
      implicit none
      double precision dum(3)
      double precision z1,z2,z3
      double precision xlow,xhigh,x,func
      double precision ylow,yhigh,y
      double precision ulow,uhigh,u
      double precision N1,N2,D
     
      common/HcapFUNC/z1,z2,z3
      
      xlow=0d0
      xhigh=1d0
      x=xlow+(xhigh-xlow)*dum(1)
      ylow=0d0
      yhigh=1d0
      y=ylow+(yhigh-ylow)*dum(2)
      ulow=0d0
      uhigh=1d0
      u=ulow+(uhigh-ulow)*dum(3)
      N1=u*(1d0-x)+z3*x*(1d0-x)*(1d0-u)-2d0*u*x*(z1*y+z2*(1d0-y))
      N2=(1d0-x)**2*(1d0-u)**2+u**2-x**2*(1d0-u)**2/9d0
      D=u*(1d0-x)+z3*x*(1d0-x)*(1d0-u)+u*x*(z1*y+z2*(1d0-y))
      func=0.5d0*x*(1d0-x)*u*N1*N2/D**4
      HcapFUNC_EDM_VEGAS=func*(xhigh-xlow)*(yhigh-ylow)*(uhigh-ulow)
      
      return
      end