* This files contain the following subroutine to compute
* unrenormalized neutral Higgs selfenergies which are called by  
* selfHH_atlambda in  CalcMasses_atlambda.F to compute renormalized
* Higgs selfenergies
* subroutine UnselfHH_atlambda1(selfIN) compute finite part of 
* two-loop diagrams which donot have infared divegences
* subroutine UnselfHH_atlambda2(selfIN) compute finite part of 
* two-loop diagrams which have infared divegences
* subroutine subroutine UnselfHH_atlambdap2(selfIN, selfINla1, selfINla2, mode)
* to connect with a mathematica code which computes finite part of 
* two-loop diagrams with full momentum dependence. That mathematica code is not included in 
* the current package. 
* written by Thi Nhung Dao, last update: 6/2021  
c#define printMT4
#define epsi 1D-10
c======================================================================
      subroutine UnselfHH_atlambda1(selfIN)
      implicit none
      integer i,j,gen2,gen3
      double precision fac,MSQ,A0T,fac1,selfIN(6,6)
      double complex selfDP(6,6),selfSP(6,6),self(6,6)
      double complex selfCTDP(6,6),selfCTSP(6,6),selfCT(6,6)
#include "TLMT4.h"
#include "TLMT4lambda.h"

      fac=1D0/16D0/Pi**4
      fac1=1D0/16D0/Pi**2
      self(1:6,1:6) =0D0;  selfSP(1:6,1:6) =0D0;  selfDP(1:6,1:6) =0D0
      selfCT(1:6,1:6) =0D0;  selfCTSP(1:6,1:6) =0D0;  selfCTDP(1:6,1:6) =0D0
      MSQ=Sqrt(MSQ2)

c one-loop counterterm inserted diagrams
      do i=ihiggs,ihiggse
      do j=i,ihiggse

       selfCT(i,j)=4*(-2*aCEpTCha3*MCha**3*(CFF12S1L(i)+CFF12S1R(i))*
     &  (CFF12S1L(j)+CFF12S1R(j))*dMCha1L(1)-aBEpTCha*MCha*(CFF12S1R(i)
     &  *(2*CFF12S1L(j)+CFF12S1R(j))+CFF12S1L(i)*(CFF12S1L(j)+2*
     &  CFF12S1R(j)))*dMCha1L(1)-2*aC0TCha3*MCha**3*(CFF12S1L(i)+
     &  CFF12S1R(i))*(CFF12S1L(j)+CFF12S1R(j))*dMCha1L(2)-aB0TCha*MCha*
     &  (CFF12S1R(i)*(2*CFF12S1L(j)+CFF12S1R(j))+CFF12S1L(i)*
     &  (CFF12S1L(j)+2*CFF12S1R(j)))*dMCha1L(2)-MCha*CFF12S1L(i)*
     &  CFF12S1L(j)*dMCha1L(3)-2*MCha*CFF12S1L(j)*CFF12S1R(i)*
     &  dMCha1L(3)-2*MCha*CFF12S1L(i)*CFF12S1R(j)*dMCha1L(3)-MCha*
     &  CFF12S1R(i)*CFF12S1R(j)*dMCha1L(3)-3*M1*dmt4(3)*hy(i)*hy(j)-6*
     &  M1*dmt4(3)*hy(j)*hyc(i)-6*M1*dmt4(3)*hy(i)*hyc(j)-3*M1*dmt4(3)*
     &  hyc(i)*hyc(j)-6*aCEpTT3*M1**3*dmt4(1)*(hy(i)+hyc(i))*(hy(j)+
     &  hyc(j))-6*aC0TT3*M1**3*dmt4(2)*(hy(i)+hyc(i))*(hy(j)+hyc(j))-3*
     &  aBEpTN1*M1*dmt4(1)*(hyc(i)*(2*hy(j)+hyc(j))+hy(i)*(hy(j)+2*
     &  hyc(j)))-3*aB0TN1*M1*dmt4(2)*(hyc(i)*(2*hy(j)+hyc(j))+hy(i)*
     &  (hy(j)+2*hyc(j))))+selfCT(i,j)
       
        
       do INe3=ineu,3
       do INe4=ineu,3
       do INe5=ineu,3
       selfCT(i,j)=(-2*(CFF11S1L(INe4,INe5,j)*(CFF11S1R(INe5,INe3,i)*
     &  (DCONJG(dMNeu1L(INe4,INe3,3))*MNeu(INe3)+dMNeu1L(INe3,INe4,3)*
     &  MNeu(INe4))+CFF11S1L(INe5,INe3,i)*DCONJG(dMNeu1L(INe4,INe3,3))*
     &  MNeu(INe5))+CFF11S1R(INe4,INe5,j)*(CFF11S1L(INe5,INe3,i)*
     &  (dMNeu1L(INe3,INe4,3)*MNeu(INe3)+DCONJG(dMNeu1L(INe4,INe3,3))*
     &  MNeu(INe4))+CFF11S1R(INe5,INe3,i)*dMNeu1L(INe3,INe4,3)*
     &  MNeu(INe5)))-2*(aCEpTChi3(INe3,INe4,INe5)*MNeu(INe3)*
     &  (CFF11S1L(INe4,INe5,j)*(DCONJG(dMNeu1L(INe4,INe3,1))*MNeu(INe3)
     &  +dMNeu1L(INe3,INe4,1)*MNeu(INe4))*(CFF11S1R(INe5,INe3,i)*
     &  MNeu(INe3)+CFF11S1L(INe5,INe3,i)*MNeu(INe5))+
     &  CFF11S1R(INe4,INe5,j)*(dMNeu1L(INe3,INe4,1)*MNeu(INe3)+
     &  DCONJG(dMNeu1L(INe4,INe3,1))*MNeu(INe4))*(CFF11S1L(INe5,INe3,i)
     &  *MNeu(INe3)+CFF11S1R(INe5,INe3,i)*MNeu(INe5)))+
     &  aBEpTNeu(INe4,INe5)*(CFF11S1L(INe4,INe5,j)*
     &  (CFF11S1R(INe5,INe3,i)*(DCONJG(dMNeu1L(INe4,INe3,1))*MNeu(INe3)
     &  +dMNeu1L(INe3,INe4,1)*MNeu(INe4))+CFF11S1L(INe5,INe3,i)*
     &  DCONJG(dMNeu1L(INe4,INe3,1))*MNeu(INe5))+CFF11S1R(INe4,INe5,j)*
     &  (CFF11S1L(INe5,INe3,i)*(dMNeu1L(INe3,INe4,1)*MNeu(INe3)+
     &  DCONJG(dMNeu1L(INe4,INe3,1))*MNeu(INe4))+CFF11S1R(INe5,INe3,i)*
     &  dMNeu1L(INe3,INe4,1)*MNeu(INe5))))-2*(aC0TChi3(INe3,INe4,INe5)*
     &  MNeu(INe3)*(CFF11S1L(INe4,INe5,j)*(DCONJG(dMNeu1L(INe4,INe3,2))
     &  *MNeu(INe3)+dMNeu1L(INe3,INe4,2)*MNeu(INe4))*
     &  (CFF11S1R(INe5,INe3,i)*MNeu(INe3)+CFF11S1L(INe5,INe3,i)*
     &  MNeu(INe5))+CFF11S1R(INe4,INe5,j)*(dMNeu1L(INe3,INe4,2)*
     &  MNeu(INe3)+DCONJG(dMNeu1L(INe4,INe3,2))*MNeu(INe4))*
     &  (CFF11S1L(INe5,INe3,i)*MNeu(INe3)+CFF11S1R(INe5,INe3,i)*
     &  MNeu(INe5)))+aB0TNeu(INe4,INe5)*(CFF11S1L(INe4,INe5,j)*
     &  (CFF11S1R(INe5,INe3,i)*(DCONJG(dMNeu1L(INe4,INe3,2))*MNeu(INe3)
     &  +dMNeu1L(INe3,INe4,2)*MNeu(INe4))+CFF11S1L(INe5,INe3,i)*
     &  DCONJG(dMNeu1L(INe4,INe3,2))*MNeu(INe5))+CFF11S1R(INe4,INe5,j)*
     &  (CFF11S1L(INe5,INe3,i)*(dMNeu1L(INe3,INe4,2)*MNeu(INe3)+
     &  DCONJG(dMNeu1L(INe4,INe3,2))*MNeu(INe4))+CFF11S1R(INe5,INe3,i)*
     &  dMNeu1L(INe3,INe4,2)*MNeu(INe5)))))+selfCT(i,j)
       enddo 
       enddo 
       enddo
c
c CTtopo1
c
       do INH3= ihiggs,6
       do INH4= ihiggs,6
       do INH5= ihiggs,6
              if( Mah(INH3)*Mah(INH4) + Mah(INH3)*Mah(INH5) + Mah(INH4)*Mah(INH5) .gt. 1D-15) then 
       selfCT(i,j)=(CS1S1S1(i,INH3,INH5)*CS1S1S1(j,INH4,INH5)*(-2*
     &  (aBEpTNH(INH4,INH5)*dZHiggs1(INH3,INH4,1)+aB0TNH(INH4,INH5)*
     &  dZHiggs1(INH3,INH4,2)+dZHiggs1(INH3,INH4,3))+
     &  aCEpTNH(INH3,INH4,INH5)*(2*dMH1MT4(INH3,INH4,1)+
     &  dZHiggs1(INH3,INH4,1)*(-Mah2(INH3)+Mah2(INH4)))+
     &  aC0TNH(INH3,INH4,INH5)*(2*dMH1MT4(INH3,INH4,2)+
     &  dZHiggs1(INH3,INH4,2)*(-Mah2(INH3)+Mah2(INH4)))))/2.+selfCT(i,j)
              endif
       enddo 
       enddo 
       enddo 
       
       do ICH3=1,2
       do ICH4=1,2
       do ICH5=1,2
              if( MassHpm(ICH3)*MassHpm(ICH4) + MassHpm(ICH3)*MassHpm(ICH5) + MassHpm(ICH4)*MassHpm(ICH5) .gt. 1D-15) then 
       selfCT(i,j)=(-2*(CS1S3S3(i,ICH3,ICH5)*CS1S3S3(j,ICH5,ICH4)*
     &  dZCHiggs1(ICH3,ICH4,3)+aBEpTCH(ICH4,ICH5)*(CS1S3S3(i,ICH3,ICH5)
     &  *CS1S3S3(j,ICH5,ICH4)*dZCHiggs1(ICH3,ICH4,1)+
     &  CS1S3S3(i,ICH5,ICH3)*CS1S3S3(j,ICH4,ICH5)*
     &  dZCHiggs1(ICH4,ICH3,1))+aB0TCH(ICH4,ICH5)*(CS1S3S3(i,ICH3,ICH5)
     &  *CS1S3S3(j,ICH5,ICH4)*dZCHiggs1(ICH3,ICH4,2)+
     &  CS1S3S3(i,ICH5,ICH3)*CS1S3S3(j,ICH4,ICH5)*
     &  dZCHiggs1(ICH4,ICH3,2))+CS1S3S3(i,ICH5,ICH3)*
     &  CS1S3S3(j,ICH4,ICH5)*dZCHiggs1(ICH4,ICH3,3))+
     &  aCEpTCH(ICH3,ICH4,ICH5)*(CS1S3S3(i,ICH3,ICH5)*
     &  CS1S3S3(j,ICH5,ICH4)*(2*dMCH1L(ICH3,ICH4,1)+
     &  dZCHiggs1(ICH3,ICH4,1)*(-MassHpm(ICH3)**2+MassHpm(ICH4)**2))+
     &  CS1S3S3(i,ICH5,ICH3)*CS1S3S3(j,ICH4,ICH5)*(2*
     &  dMCH1L(ICH4,ICH3,1)+dZCHiggs1(ICH4,ICH3,1)*(-MassHpm(ICH3)**2+
     &  MassHpm(ICH4)**2)))+aC0TCH(ICH3,ICH4,ICH5)*
     &  (CS1S3S3(i,ICH3,ICH5)*CS1S3S3(j,ICH5,ICH4)*(2*
     &  dMCH1L(ICH3,ICH4,2)+dZCHiggs1(ICH3,ICH4,2)*(-MassHpm(ICH3)**2+
     &  MassHpm(ICH4)**2))+CS1S3S3(i,ICH5,ICH3)*CS1S3S3(j,ICH4,ICH5)*
     &  (2*dMCH1L(ICH4,ICH3,2)+dZCHiggs1(ICH4,ICH3,2)*(-MassHpm(ICH3)**
     &  2+MassHpm(ICH4)**2))))/2.+selfCT(i,j)
              endif
       enddo 
       enddo 
       enddo 
          
       do ISt3=1,2
       do ISt4=1,2
       do ISt5=1,2
       selfCT(i,j)=3*(aCEpT(ISt3,ISt4,ISt5)*(CSSS(i,ISt3,ISt5)*
     &  CSSS(j,ISt5,ISt4)*dMSf4(ISt3,ISt4,1)+CSSS(i,ISt5,ISt3)*
     &  CSSS(j,ISt4,ISt5)*dMSf4(ISt4,ISt3,1))+aC0T(ISt3,ISt4,ISt5)*
     &  (CSSS(i,ISt3,ISt5)*CSSS(j,ISt5,ISt4)*dMSf4(ISt3,ISt4,2)+
     &  CSSS(i,ISt5,ISt3)*CSSS(j,ISt4,ISt5)*dMSf4(ISt4,ISt3,2)))+
     &  selfCT(i,j)
       enddo 
       enddo 
       enddo
c
c CTtopo2
c
       do INH3= ihiggs,6
       selfCT(i,j)=(AETNH(INH3)*dCS1S1S1S1(i,j,INH3,INH3,1)+A0TNH(INH3)
     &  *dCS1S1S1S1(i,j,INH3,INH3,2)+dCS1S1S1S1(i,j,INH3,INH3,3)*
     &  Mah2(INH3))/2.+selfCT(i,j)
       enddo 
 
       do ICH3=1,2
       selfCT(i,j)=(AETHpN(ICH3)*dCS1S1S3S3(i,j,ICH3,ICH3,1)+
     &  A0THpN(ICH3)*dCS1S1S3S3(i,j,ICH3,ICH3,2)+
     &  dCS1S1S3S3(i,j,ICH3,ICH3,3)*MassHpm(ICH3)**2)+selfCT(i,j)
       enddo 
        
       do ISt3=1,2
       selfCT(i,j)=3*(aAETN(ISt3)*dCSSSS(i,j,ISt3,ISt3,1)+aA0TN(ISt3)*
     &  dCSSSS(i,j,ISt3,ISt3,2)+dCSSSS(i,j,ISt3,ISt3,3)*MassSu2(ISt3))+
     &  selfCT(i,j)
       enddo 
 
c
c CTtopo3
c
       selfCT(i,j)=(-2*(MCha2*((CFF12S1L(j)+2*CFF12S1R(j))*
     &  dCFF12S1L(i,3)+(CFF12S1L(i)+2*CFF12S1R(i))*dCFF12S1L(j,3)+(2*
     &  CFF12S1L(j)+CFF12S1R(j))*dCFF12S1R(i,3)+(2*CFF12S1L(i)+
     &  CFF12S1R(i))*dCFF12S1R(j,3))+3*M12*(dhyc(j,3)*(2*hy(i)+hyc(i))+
     &  dhy(j,3)*(hy(i)+2*hyc(i))+dhyc(i,3)*(2*hy(j)+hyc(j))+dhy(i,3)*
     &  (hy(j)+2*hyc(j))))-2*(aetcha*(CFF12S1R(j)*dCFF12S1L(i,1)+
     &  CFF12S1R(i)*dCFF12S1L(j,1)+CFF12S1L(j)*dCFF12S1R(i,1)+
     &  CFF12S1L(i)*dCFF12S1R(j,1))+aBEpTCha*MCha2*((CFF12S1L(j)+
     &  CFF12S1R(j))*(dCFF12S1L(i,1)+dCFF12S1R(i,1))+(CFF12S1L(i)+
     &  CFF12S1R(i))*(dCFF12S1L(j,1)+dCFF12S1R(j,1)))+3*(aet1*
     &  (dhyc(j,1)*hy(i)+dhyc(i,1)*hy(j)+dhy(j,1)*hyc(i)+dhy(i,1)*
     &  hyc(j))+aBEpTN1*M12*((dhy(j,1)+dhyc(j,1))*(hy(i)+hyc(i))+
     &  (dhy(i,1)+dhyc(i,1))*(hy(j)+hyc(j)))))-2*(a0tcha*(CFF12S1R(j)*
     &  dCFF12S1L(i,2)+CFF12S1R(i)*dCFF12S1L(j,2)+CFF12S1L(j)*
     &  dCFF12S1R(i,2)+CFF12S1L(i)*dCFF12S1R(j,2))+aB0TCha*MCha2*
     &  ((CFF12S1L(j)+CFF12S1R(j))*(dCFF12S1L(i,2)+dCFF12S1R(i,2))+
     &  (CFF12S1L(i)+CFF12S1R(i))*(dCFF12S1L(j,2)+dCFF12S1R(j,2)))+3*
     &  (a0t1*(dhyc(j,2)*hy(i)+dhyc(i,2)*hy(j)+dhy(j,2)*hyc(i)+dhy(i,2)
     &  *hyc(j))+aB0TN1*M12*((dhy(j,2)+dhyc(j,2))*(hy(i)+hyc(i))+
     &  (dhy(i,2)+dhyc(i,2))*(hy(j)+hyc(j))))))+selfCT(i,j)
     
       do INe3=ineu,3
       do INe4=ineu,3
              if( MNeu(INe3) + MNeu(INe4) .gt. 1D-15) then 
       selfCT(i,j)=(-(AETNeu(INe4)*(CFF11S1R(INe4,INe3,i)*
     &  dCFF11S1L(INe3,INe4,j,1)+CFF11S1R(INe3,INe4,j)*
     &  dCFF11S1L(INe4,INe3,i,1)+CFF11S1L(INe4,INe3,i)*
     &  dCFF11S1R(INe3,INe4,j,1)+CFF11S1L(INe3,INe4,j)*
     &  dCFF11S1R(INe4,INe3,i,1)))-A0TNeu(INe4)*(CFF11S1R(INe4,INe3,i)*
     &  dCFF11S1L(INe3,INe4,j,2)+CFF11S1R(INe3,INe4,j)*
     &  dCFF11S1L(INe4,INe3,i,2)+CFF11S1L(INe4,INe3,i)*
     &  dCFF11S1R(INe3,INe4,j,2)+CFF11S1L(INe3,INe4,j)*
     &  dCFF11S1R(INe4,INe3,i,2))-(CFF11S1L(INe4,INe3,i)*
     &  dCFF11S1L(INe3,INe4,j,3)+CFF11S1L(INe3,INe4,j)*
     &  dCFF11S1L(INe4,INe3,i,3)+CFF11S1R(INe4,INe3,i)*
     &  dCFF11S1R(INe3,INe4,j,3)+aBEpTNeu(INe3,INe4)*
     &  (CFF11S1L(INe4,INe3,i)*dCFF11S1L(INe3,INe4,j,1)+
     &  CFF11S1L(INe3,INe4,j)*dCFF11S1L(INe4,INe3,i,1)+
     &  CFF11S1R(INe4,INe3,i)*dCFF11S1R(INe3,INe4,j,1)+
     &  CFF11S1R(INe3,INe4,j)*dCFF11S1R(INe4,INe3,i,1))+
     &  aB0TNeu(INe3,INe4)*(CFF11S1L(INe4,INe3,i)*
     &  dCFF11S1L(INe3,INe4,j,2)+CFF11S1L(INe3,INe4,j)*
     &  dCFF11S1L(INe4,INe3,i,2)+CFF11S1R(INe4,INe3,i)*
     &  dCFF11S1R(INe3,INe4,j,2)+CFF11S1R(INe3,INe4,j)*
     &  dCFF11S1R(INe4,INe3,i,2))+CFF11S1R(INe3,INe4,j)*
     &  dCFF11S1R(INe4,INe3,i,3))*MNeu(INe3)*MNeu(INe4)-
     &  (CFF11S1R(INe4,INe3,i)*dCFF11S1L(INe3,INe4,j,3)+
     &  CFF11S1R(INe3,INe4,j)*dCFF11S1L(INe4,INe3,i,3)+
     &  CFF11S1L(INe4,INe3,i)*dCFF11S1R(INe3,INe4,j,3)+
     &  aBEpTNeu(INe3,INe4)*(CFF11S1R(INe4,INe3,i)*
     &  dCFF11S1L(INe3,INe4,j,1)+CFF11S1R(INe3,INe4,j)*
     &  dCFF11S1L(INe4,INe3,i,1)+CFF11S1L(INe4,INe3,i)*
     &  dCFF11S1R(INe3,INe4,j,1)+CFF11S1L(INe3,INe4,j)*
     &  dCFF11S1R(INe4,INe3,i,1))+aB0TNeu(INe3,INe4)*
     &  (CFF11S1R(INe4,INe3,i)*dCFF11S1L(INe3,INe4,j,2)+
     &  CFF11S1R(INe3,INe4,j)*dCFF11S1L(INe4,INe3,i,2)+
     &  CFF11S1L(INe4,INe3,i)*dCFF11S1R(INe3,INe4,j,2)+
     &  CFF11S1L(INe3,INe4,j)*dCFF11S1R(INe4,INe3,i,2))+
     &  CFF11S1L(INe3,INe4,j)*dCFF11S1R(INe4,INe3,i,3))*MNeu2(INe3)-
     &  (CFF11S1R(INe4,INe3,i)*dCFF11S1L(INe3,INe4,j,3)+
     &  CFF11S1R(INe3,INe4,j)*dCFF11S1L(INe4,INe3,i,3)+
     &  CFF11S1L(INe4,INe3,i)*dCFF11S1R(INe3,INe4,j,3)+CFF11S1L(INe3,INe4,j)
     &  *dCFF11S1R(INe4,INe3,i,3))*MNeu2(INe4))+selfCT(i,j)
              endif
       enddo 
       enddo 
  
c
c CTtopo4+7
c
       do INH3= ihiggs,6
       do INH4= ihiggs,6
              if( Mah(INH3) + Mah(INH4) .gt. 1D-15) then 
       selfCT(i,j)=(CS1S1S1(j,INH3,INH4)*dCS1S1S1(i,INH3,INH4,3)+
     &  aBEpTNH(INH3,INH4)*(CS1S1S1(j,INH3,INH4)*
     &  dCS1S1S1(i,INH3,INH4,1)+CS1S1S1(i,INH3,INH4)*
     &  dCS1S1S1(j,INH3,INH4,1))+aB0TNH(INH3,INH4)*
     &  (CS1S1S1(j,INH3,INH4)*dCS1S1S1(i,INH3,INH4,2)+
     &  CS1S1S1(i,INH3,INH4)*dCS1S1S1(j,INH3,INH4,2))+
     &  CS1S1S1(i,INH3,INH4)*dCS1S1S1(j,INH3,INH4,3))/2.+selfCT(i,j)
              endif
       enddo 
       enddo 
         
       do ICH3=1,2
       do ICH4=1,2
              if( MassHpm(ICH3) + MassHpm(ICH4) .gt. 1D-15) then 
       selfCT(i,j)=(CS1S3S3(j,ICH4,ICH3)*dCS1S3S3(i,ICH3,ICH4,3)+
     &  aBEpTCH(ICH3,ICH4)*(CS1S3S3(j,ICH4,ICH3)*
     &  dCS1S3S3(i,ICH3,ICH4,1)+CS1S3S3(i,ICH3,ICH4)*
     &  dCS1S3S3(j,ICH4,ICH3,1))+aB0TCH(ICH3,ICH4)*
     &  (CS1S3S3(j,ICH4,ICH3)*dCS1S3S3(i,ICH3,ICH4,2)+
     &  CS1S3S3(i,ICH3,ICH4)*dCS1S3S3(j,ICH4,ICH3,2))+
     &  CS1S3S3(i,ICH3,ICH4)*dCS1S3S3(j,ICH4,ICH3,3))+selfCT(i,j)
              endif
       enddo 
       enddo 
         
       do ISt3=1,2
       do ISt4=1,2
              if( MassSu(ISt3) + MassSu(ISt4) .gt. 1D-15) then 
       selfCT(i,j)=3*(CSSS(j,ISt4,ISt3)*dCSSS(i,ISt3,ISt4,3)+
     &  aBEpT1(ISt3,ISt4)*(CSSS(j,ISt4,ISt3)*dCSSS(i,ISt3,ISt4,1)+
     &  CSSS(i,ISt3,ISt4)*dCSSS(j,ISt4,ISt3,1))+aB0T1(ISt3,ISt4)*
     &  (CSSS(j,ISt4,ISt3)*dCSSS(i,ISt3,ISt4,2)+CSSS(i,ISt3,ISt4)*
     &  dCSSS(j,ISt4,ISt3,2))+CSSS(i,ISt3,ISt4)*dCSSS(j,ISt4,ISt3,3))+
     &  selfCT(i,j)
              endif
       enddo 
       enddo 
  
c
c CTtopo5+8
c
       do INH3= ihiggs,6
       do INH4= ihiggs,6
              if( Mah(INH3) + Mah(INH4) .gt. 1D-15) then 
       selfCT(i,j)=(CS1S1S1S1(i,j,INH3,INH4)*(2*dMH1MT4(INH3,INH4,3)-2*
     &  AETNH(INH4)*dZHiggs1(INH3,INH4,1)-2*A0TNH(INH4)*
     &  dZHiggs1(INH3,INH4,2)-dZHiggs1(INH3,INH4,3)*(Mah2(INH3)+
     &  Mah2(INH4))+aBEpTNH(INH3,INH4)*(2*dMH1MT4(INH3,INH4,1)+
     &  dZHiggs1(INH3,INH4,1)*(-Mah2(INH3)+Mah2(INH4)))+
     &  aB0TNH(INH3,INH4)*(2*dMH1MT4(INH3,INH4,2)+dZHiggs1(INH3,INH4,2)
     &  *(-Mah2(INH3)+Mah2(INH4)))))/4.+selfCT(i,j)
              endif
       enddo 
       enddo        
       do ICH3=1,2
       do ICH4=1,2
              if( MassHpm(ICH3) + MassHpm(ICH4) .gt. 1D-15) then 
       selfCT(i,j)=(CS1S1S3S3(i,j,ICH4,ICH3)*(2*dMCH1L(ICH4,ICH3,3)-2*
     &  AETHpN(ICH4)*dZCHiggs1(ICH4,ICH3,1)-2*A0THpN(ICH4)*
     &  dZCHiggs1(ICH4,ICH3,2)-dZCHiggs1(ICH4,ICH3,3)*(MassHpm(ICH3)**
     &  2+MassHpm(ICH4)**2)+aBEpTCH(ICH3,ICH4)*(2*dMCH1L(ICH4,ICH3,1)+
     &  dZCHiggs1(ICH4,ICH3,1)*(-MassHpm(ICH3)**2+MassHpm(ICH4)**2))+
     &  aB0TCH(ICH3,ICH4)*(2*dMCH1L(ICH4,ICH3,2)+dZCHiggs1(ICH4,ICH3,2)
     &  *(-MassHpm(ICH3)**2+MassHpm(ICH4)**2))))/2.+selfCT(i,j)
              endif
       enddo 
       enddo 
        
       do ISt3=1,2
       do ISt4=1,2
              if( MassSu(ISt3) + MassSu(ISt4) .gt. 1D-15) then 
       selfCT(i,j)=3*CSSSS(i,j,ISt4,ISt3)*(aBEpT1(ISt3,ISt4)*
     &  dMSf4(ISt4,ISt3,1)+aB0T1(ISt3,ISt4)*dMSf4(ISt4,ISt3,2)+
     &  dMSf4(ISt4,ISt3,3))+selfCT(i,j)
              endif
       enddo 
       enddo
  
c
c CTtopo6
c
c end one-loop counterterm inserted diagrams
      
       do INH3= ihiggs,6
       do INH4= ihiggs,6
       do INH5= ihiggs,6
              if( Mah(INH3) + Mah(INH4) .gt. 1D-15) then 
       self(i,j)=-(CS1S1S1S1(i,j,INH3,INH4)*
     &  CS1S1S1S1(INH3,INH4,INH5,INH5)*(A0TNH(INH5)*aB0TNH(INH3,INH4)+
     &  AETNH(INH5)+aBEpTNH(INH3,INH4)*Mah2(INH5)))/64.+self(i,j)
              endif
       enddo 
       enddo 
       enddo 

        
       do ICH3=1,2
       do INH3= ihiggs,6
       do INH4= ihiggs,6
              if( Mah(INH3) + Mah(INH4) .gt. 1D-15) then 
       self(i,j)=-(CS1S1S1S1(i,j,INH3,INH4)*
     &  CS1S1S3S3(INH3,INH4,ICH3,ICH3)*(A0THpN(ICH3)*aB0TNH(INH3,INH4)+
     &  AETHpN(ICH3)+aBEpTNH(INH3,INH4)*MassHpm(ICH3)**2))/32.+
     &  self(i,j)
              endif
       enddo 
       enddo 
       enddo 
        
       do ICH3=1,2
       do ICH4=1,2
       do INH3= ihiggs,6
              if( MassHpm(ICH3) + MassHpm(ICH4) .gt. 1D-15) then 
       self(i,j)=-(CS1S1S3S3(i,j,ICH3,ICH4)*
     &  CS1S1S3S3(INH3,INH3,ICH4,ICH3)*(A0TNH(INH3)*aB0TCH(ICH3,ICH4)+
     &  AETNH(INH3)+aBEpTCH(ICH3,ICH4)*Mah2(INH3)))/32.+self(i,j)
              endif
       enddo 
       enddo 
       enddo 
        
       do ICH3=1,2
       do ICH4=1,2
       do ICH5=1,2
              if( MassHpm(ICH3) + MassHpm(ICH4) .gt. 1D-15) then 
       self(i,j)=-(CS1S1S3S3(i,j,ICH3,ICH4)*
     &  CS3S3S3S3(ICH4,ICH5,ICH3,ICH5)*(A0THpN(ICH5)*aB0TCH(ICH3,ICH4)+
     &  AETHpN(ICH5)+aBEpTCH(ICH3,ICH4)*MassHpm(ICH5)**2))/16.+
     &  self(i,j)
              endif
       enddo 
       enddo 
       enddo 
        
       do INH3= ihiggs,6
       do INH4= ihiggs,6
       do ISt3=1,2
              if( Mah(INH3) + Mah(INH4) .gt. 1D-15) then 
       self(i,j)=(-3*CS1S1S1S1(i,j,INH3,INH4)*
     &  CSSSS(INH3,INH4,ISt3,ISt3)*(aAETN(ISt3)+aA0TN(ISt3)*
     &  aB0TNH(INH3,INH4)+aBEpTNH(INH3,INH4)*MassSu2(ISt3)))/32.+
     &  self(i,j)
              endif
       enddo 
       enddo 
       enddo 
        
       do ICH3=1,2
       do ICH4=1,2
       do ISt3=1,2
              if( MassHpm(ICH3) + MassHpm(ICH4) .gt. 1D-15) then 
       self(i,j)=(-3*CS1S1S3S3(i,j,ICH3,ICH4)*
     &  CS3S3S13S13(ICH4,ICH3,ISt3,ISt3)*(aAETN(ISt3)+aA0TN(ISt3)*
     &  aB0TCH(ICH3,ICH4)+aBEpTCH(ICH3,ICH4)*MassSu2(ISt3)))/16.+
     &  self(i,j)
              endif
       enddo 
       enddo 
       enddo 
        
       do ICH3=1,2
       do ICH4=1,2
              if( MassHpm(ICH3) + MassHpm(ICH4) .gt. 1D-15) then 
       self(i,j)=(-3*(aet5+a0t5*aB0TCH(ICH3,ICH4)+MSQ2*
     &  aBEpTCH(ICH3,ICH4))*CS1S1S3S3(i,j,ICH3,ICH4)*
     &  CS3S3S14S14(ICH4,ICH3))/16.+self(i,j)
              endif
       enddo 
       enddo
  
c
c topo11
c
       do INH3= ihiggs,6
       do INH4= ihiggs,6
       do INH5= ihiggs,6
       do INH6= ihiggs,6
              if( Mah(INH3) + Mah(INH4) .gt. 1D-15) then 
               if( Mah(INH5) + Mah(INH6) .gt. 1D-15) then 
       self(i,j)=-((aB0TNH(INH3,INH4)*aB0TNH(INH5,INH6)+
     &  aBEpTNH(INH3,INH4)+aBEpTNH(INH5,INH6))*CS1S1S1(i,INH3,INH4)*
     &  CS1S1S1(j,INH5,INH6)*CS1S1S1S1(INH3,INH4,INH5,INH6))/64.+
     &  self(i,j)
               endif
              endif
       enddo 
       enddo 
       enddo 
       enddo 
       do ICH3=1,2
       do ICH4=1,2
       do INH3= ihiggs,6
       do INH4= ihiggs,6
              if( Mah(INH3) + Mah(INH4) .gt. 1D-15) then 
               if( MassHpm(ICH3) + MassHpm(ICH4) .gt. 1D-15) then 
       self(i,j)=-((aB0TCH(ICH3,ICH4)*aB0TNH(INH3,INH4)+
     &  aBEpTCH(ICH3,ICH4)+aBEpTNH(INH3,INH4))*
     &  CS1S1S3S3(INH3,INH4,ICH4,ICH3)*(CS1S1S1(j,INH3,INH4)*
     &  CS1S3S3(i,ICH3,ICH4)+CS1S1S1(i,INH3,INH4)*CS1S3S3(j,ICH3,ICH4))
     &  )/32.+self(i,j)
               endif
              endif
       enddo 
       enddo 
       enddo 
       enddo 
        
       do ICH3=1,2
       do ICH4=1,2
       do ICH5=1,2
       do ICH6=1,2
              if( MassHpm(ICH3) + MassHpm(ICH4) .gt. 1D-15) then 
               if( MassHpm(ICH5) + MassHpm(ICH6) .gt. 1D-15) then 
       self(i,j)=-((aB0TCH(ICH3,ICH4)*aB0TCH(ICH5,ICH6)+
     &  aBEpTCH(ICH3,ICH4)+aBEpTCH(ICH5,ICH6))*CS1S3S3(i,ICH3,ICH4)*
     &  CS1S3S3(j,ICH5,ICH6)*CS3S3S3S3(ICH4,ICH6,ICH3,ICH5))/16.+
     &  self(i,j)
               endif
              endif
       enddo 
       enddo 
       enddo 
       enddo 
        
       do INH3= ihiggs,6
       do INH4= ihiggs,6
       do ISt3=1,2
       do ISt4=1,2
              if( Mah(INH3) + Mah(INH4) .gt. 1D-15) then 
               if( MassSu(ISt3) + MassSu(ISt4) .gt. 1D-15) then 
       self(i,j)=(-3*(aB0T1(ISt3,ISt4)*aB0TNH(INH3,INH4)+
     &  aBEpT1(ISt3,ISt4)+aBEpTNH(INH3,INH4))*(CS1S1S1(j,INH3,INH4)*
     &  CSSS(i,ISt3,ISt4)+CS1S1S1(i,INH3,INH4)*CSSS(j,ISt3,ISt4))*
     &  CSSSS(INH3,INH4,ISt4,ISt3))/32.+self(i,j)
               endif
              endif
       enddo 
       enddo 
       enddo 
       enddo 
        
       do ICH3=1,2
       do ICH4=1,2
       do ISt3=1,2
       do ISt4=1,2
              if( MassHpm(ICH3) + MassHpm(ICH4) .gt. 1D-15) then 
               if( MassSu(ISt3) + MassSu(ISt4) .gt. 1D-15) then 
       self(i,j)=(-3*(aB0T1(ISt3,ISt4)*aB0TCH(ICH3,ICH4)+
     &  aBEpT1(ISt3,ISt4)+aBEpTCH(ICH3,ICH4))*
     &  CS3S3S13S13(ICH4,ICH3,ISt4,ISt3)*(CS1S3S3(j,ICH3,ICH4)*
     &  CSSS(i,ISt3,ISt4)+CS1S3S3(i,ICH3,ICH4)*CSSS(j,ISt3,ISt4)))/16.+
     &  self(i,j)
               endif
              endif
       enddo 
       enddo 
       enddo 
       enddo
c
c topo1
c       
       do INH3= ihiggs,6
       do INH4= ihiggs,6
       do INH5= ihiggs,6
       do INH6= ihiggs,6
              if( Mah(INH3)*Mah(INH4) + Mah(INH3)*Mah(INH5) + Mah(INH4)*Mah(INH5) .gt. 1D-15) then 
       self(i,j)=-(CS1S1S1(i,INH3,INH4)*CS1S1S1(j,INH3,INH5)*
     &  CS1S1S1S1(INH4,INH5,INH6,INH6)*(A0TNH(INH6)*
     &  aC0TNH(INH3,INH4,INH5)+aCEpTNH(INH3,INH4,INH5)*Mah2(INH6)))
     &  /32.+self(i,j)
              endif
       enddo 
       enddo 
       enddo 
       enddo 
        
       do ICH3=1,2
       do INH3= ihiggs,6
       do INH4= ihiggs,6
       do INH5= ihiggs,6
              if( Mah(INH3)*Mah(INH4) + Mah(INH3)*Mah(INH5) + Mah(INH4)*Mah(INH5) .gt. 1D-15) then 
       self(i,j)=-(CS1S1S1(i,INH3,INH4)*CS1S1S1(j,INH3,INH5)*
     &  CS1S1S3S3(INH4,INH5,ICH3,ICH3)*(A0THpN(ICH3)*
     &  aC0TNH(INH3,INH4,INH5)+aCEpTNH(INH3,INH4,INH5)*MassHpm(ICH3)**
     &  2))/16.+self(i,j)
              endif
       enddo 
       enddo 
       enddo 
       enddo 
        
       do ICH3=1,2
       do ICH4=1,2
       do ICH5=1,2
       do INH3= ihiggs,6
              if( MassHpm(ICH3)*MassHpm(ICH4) + MassHpm(ICH3)*MassHpm(ICH5) + MassHpm(ICH4)*MassHpm(ICH5) .gt. 1D-15) then 
       self(i,j)=-((CS1S1S3S3(INH3,INH3,ICH5,ICH4)*CS1S3S3(i,ICH4,ICH3)
     &  *CS1S3S3(j,ICH3,ICH5)+CS1S1S3S3(INH3,INH3,ICH4,ICH5)*
     &  CS1S3S3(i,ICH3,ICH4)*CS1S3S3(j,ICH5,ICH3))*(A0TNH(INH3)*
     &  aC0TCH(ICH3,ICH4,ICH5)+aCEpTCH(ICH3,ICH4,ICH5)*Mah2(INH3)))
     &  /32.+self(i,j)
              endif
       enddo 
       enddo 
       enddo 
       enddo 
        
       do ICH3=1,2
       do ICH4=1,2
       do ICH5=1,2
       do ICH6=1,2
              if( MassHpm(ICH3)*MassHpm(ICH4) + MassHpm(ICH3)*MassHpm(ICH5) + MassHpm(ICH4)*MassHpm(ICH5) .gt. 1D-15) then 
       self(i,j)=-((CS1S3S3(i,ICH3,ICH4)*CS1S3S3(j,ICH5,ICH3)*
     &  CS3S3S3S3(ICH4,ICH6,ICH5,ICH6)+CS1S3S3(i,ICH4,ICH3)*
     &  CS1S3S3(j,ICH3,ICH5)*CS3S3S3S3(ICH5,ICH6,ICH4,ICH6))*
     &  (A0THpN(ICH6)*aC0TCH(ICH3,ICH4,ICH5)+aCEpTCH(ICH3,ICH4,ICH5)*
     &  MassHpm(ICH6)**2))/16.+self(i,j)
              endif
       enddo 
       enddo 
       enddo 
       enddo 
        
       do INH3= ihiggs,6
       do INH4= ihiggs,6
       do INH5= ihiggs,6
       do ISt3=1,2
              if( Mah(INH3)*Mah(INH4) + Mah(INH3)*Mah(INH5) + Mah(INH4)*Mah(INH5) .gt. 1D-15) then 
       self(i,j)=(-3*CS1S1S1(i,INH3,INH4)*CS1S1S1(j,INH3,INH5)*
     &  CSSSS(INH4,INH5,ISt3,ISt3)*(aA0TN(ISt3)*aC0TNH(INH3,INH4,INH5)+
     &  aCEpTNH(INH3,INH4,INH5)*MassSu2(ISt3)))/16.+self(i,j)
              endif
       enddo 
       enddo 
       enddo 
       enddo 
        
       do ICH3=1,2
       do ICH4=1,2
       do ICH5=1,2
       do ISt3=1,2
              if( MassHpm(ICH3)*MassHpm(ICH4) + MassHpm(ICH3)*MassHpm(ICH5) + MassHpm(ICH4)*MassHpm(ICH5) .gt. 1D-15) then 
       self(i,j)=(-3*(CS1S3S3(i,ICH3,ICH4)*CS1S3S3(j,ICH5,ICH3)*
     &  CS3S3S13S13(ICH4,ICH5,ISt3,ISt3)+CS1S3S3(i,ICH4,ICH3)*
     &  CS1S3S3(j,ICH3,ICH5)*CS3S3S13S13(ICH5,ICH4,ISt3,ISt3))*
     &  (aA0TN(ISt3)*aC0TCH(ICH3,ICH4,ICH5)+aCEpTCH(ICH3,ICH4,ICH5)*
     &  MassSu2(ISt3)))/16.+self(i,j)
              endif
       enddo 
       enddo 
       enddo 
       enddo 
        
       do ICH3=1,2
       do ICH4=1,2
       do ICH5=1,2
              if( MassHpm(ICH3)*MassHpm(ICH4) + MassHpm(ICH3)*MassHpm(ICH5) + MassHpm(ICH4)*MassHpm(ICH5) .gt. 1D-15) then 
       self(i,j)=(-3*(a0t5*aC0TCH(ICH3,ICH4,ICH5)+MSQ2*
     &  aCEpTCH(ICH3,ICH4,ICH5))*(CS1S3S3(i,ICH3,ICH4)*
     &  CS1S3S3(j,ICH5,ICH3)*CS3S3S14S14(ICH4,ICH5)+
     &  CS1S3S3(i,ICH4,ICH3)*CS1S3S3(j,ICH3,ICH5)*
     &  CS3S3S14S14(ICH5,ICH4)))/16.+self(i,j)
              endif
       enddo 
       enddo 
       enddo 
c
c topo1
c
       do INH3= ihiggs,6
       do INH4= ihiggs,6
       do INH5= ihiggs,6
       self(i,j)=(CS1S1S1S1(i,INH3,INH4,INH5)*
     &  CS1S1S1S1(j,INH3,INH4,INH5)*FD111HHH(1,INH3,INH4,INH5))/96.+
     &  self(i,j)
       enddo 
       enddo 
       enddo 
        
       do ICH3=1,2
       do ICH4=1,2
       do INH3= ihiggs,6
       self(i,j)=(CS1S1S3S3(i,INH3,ICH4,ICH3)*
     &  CS1S1S3S3(j,INH3,ICH3,ICH4)*FD111HHpHp(1,INH3,ICH3,ICH4))/16.+
     &  self(i,j)
       enddo 
       enddo 
       enddo 
c
c topo15
c
        
       do INH3= ihiggs,6
       do INH4= ihiggs,6
       do INH5= ihiggs,6
       do INH6= ihiggs,6
              if( Abs(Mah(INH3) - Mah(INH6)) .gt. 1D-15) then 
       self(i,j)=(CS1S1S1(i,INH3,INH6)*CS1S1S1(INH3,INH4,INH5)*
     &  CS1S1S1S1(j,INH4,INH5,INH6)*(FD111HHH(1,INH3,INH4,INH5)-
     &  FD111HHH(1,INH4,INH6,INH5)))/(32.*(Mah(INH3)**2-Mah(INH6)**2))+
     &  self(i,j)
              else
               if( Abs(Mah(INH3)) .gt. 1D-15) then 
       self(i,j)=(CS1S1S1(i,INH3,INH6)*CS1S1S1(INH3,INH4,INH5)*
     &  CS1S1S1S1(j,INH4,INH5,INH6)*FD211HHH(1,INH6,INH4,INH5))/32.+
     &  self(i,j)
               endif
              endif
       enddo 
       enddo 
       enddo 
       enddo 
        
       do ICH3=1,2
       do ICH4=1,2
       do INH3= ihiggs,6
       do INH4= ihiggs,6
              if( Abs(Mah(INH3) - Mah(INH4)) .gt. 1D-15) then 
       self(i,j)=(CS1S1S1(i,INH3,INH4)*CS1S1S3S3(j,INH4,ICH4,ICH3)*
     &  CS1S3S3(INH3,ICH3,ICH4)*(FD111HHpHp(1,INH3,ICH3,ICH4)-
     &  FD111HHpHp(1,INH4,ICH3,ICH4)))/(16.*(Mah(INH3)**2-Mah(INH4)**2)
     &  )+self(i,j)
              else
               if( Abs(Mah(INH3)) .gt. 1D-15) then 
       self(i,j)=(CS1S1S1(i,INH3,INH4)*CS1S1S3S3(j,INH4,ICH4,ICH3)*
     &  CS1S3S3(INH3,ICH3,ICH4)*FD211HHpHp(1,INH4,ICH3,ICH4))/16.+
     &  self(i,j)
               endif
              endif
       enddo 
       enddo 
       enddo 
       enddo 
        
       do ICH3=1,2
       do ICH4=1,2
       do ICH5=1,2
       do INH3= ihiggs,6
              if( Abs(MassHpm(ICH3) - MassHpm(ICH5)) .gt. 1D-15) then 
       self(i,j)=((CS1S1S3S3(j,INH3,ICH4,ICH5)*CS1S3S3(i,ICH5,ICH3)*
     &  CS1S3S3(INH3,ICH3,ICH4)+CS1S1S3S3(j,INH3,ICH5,ICH4)*
     &  CS1S3S3(i,ICH3,ICH5)*CS1S3S3(INH3,ICH4,ICH3))*
     &  (FD111HHpHp(1,INH3,ICH3,ICH4)-FD111HHpHp(1,INH3,ICH5,ICH4)))
     &  /(16.*(MassHpm(ICH3)**2-MassHpm(ICH5)**2))+self(i,j)
              else
               if( Abs(MassHpm(ICH3)) .gt. 1D-15) then 
       self(i,j)=((CS1S1S3S3(j,INH3,ICH4,ICH5)*CS1S3S3(i,ICH5,ICH3)*
     &  CS1S3S3(INH3,ICH3,ICH4)+CS1S1S3S3(j,INH3,ICH5,ICH4)*
     &  CS1S3S3(i,ICH3,ICH5)*CS1S3S3(INH3,ICH4,ICH3))*
     &  FD211HpHHp(1,ICH5,INH3,ICH4))/16.+self(i,j)
               endif
              endif
       enddo 
       enddo 
       enddo 
       enddo 
        
       do INH3= ihiggs,6
       do INH4= ihiggs,6
       do ISt3=1,2
       do ISt4=1,2
              if( Abs(Mah(INH3) - Mah(INH4)) .gt. 1D-15) then 
       self(i,j)=(3*CS1S1S1(i,INH3,INH4)*CSSS(INH3,ISt3,ISt4)*
     &  CSSSS(j,INH4,ISt4,ISt3)*(FD111HSTST(1,INH3,ISt3,ISt4)-
     &  FD111HSTST(1,INH4,ISt3,ISt4)))/(16.*(Mah(INH3)**2-Mah(INH4)**2)
     &  )+self(i,j)
              else
               if( Abs(Mah(INH3)) .gt. 1D-15) then 
       self(i,j)=(3*CS1S1S1(i,INH3,INH4)*CSSS(INH3,ISt3,ISt4)*
     &  CSSSS(j,INH4,ISt4,ISt3)*FD211HSTST(1,INH4,ISt3,ISt4))/16.+
     &  self(i,j)
               endif
              endif
       enddo 
       enddo 
       enddo 
       enddo 
        
       do ICH3=1,2
       do ICH4=1,2
       do ISt3=1,2
              if( Abs(MassHpm(ICH3) - MassHpm(ICH4)) .gt. 1D-15) then 
       self(i,j)=(3*(CS1S3S3(i,ICH4,ICH3)*CS1S3SSC(j,ICH4,ISt3)*
     &  CS3S13S(ICH3,ISt3)+CS1S3S3(i,ICH3,ICH4)*CS1S3SS(j,ICH4,ISt3)*
     &  CS3S13SC(ICH3,ISt3))*(FD111HpSTSB(1,ICH3,ISt3)-
     &  FD111HpSTSB(1,ICH4,ISt3)))/(16.*(MassHpm(ICH3)**2-MassHpm(ICH4)
     &  **2))+self(i,j)
              else
               if( Abs(MassHpm(ICH3)) .gt. 1D-15) then 
       self(i,j)=(3*(CS1S3S3(i,ICH4,ICH3)*CS1S3SSC(j,ICH4,ISt3)*
     &  CS3S13S(ICH3,ISt3)+CS1S3S3(i,ICH3,ICH4)*CS1S3SS(j,ICH4,ISt3)*
     &  CS3S13SC(ICH3,ISt3))*FD211HpSTSB(1,ICH4,ISt3))/16.+self(i,j)
               endif
              endif
       enddo 
       enddo 
       enddo 
c
c topo2
c
       do INH3= ihiggs,6
       do INH4= ihiggs,6
       do INH5= ihiggs,6
       do INH6= ihiggs,6
              if( Abs(Mah(INH3) - Mah(INH6)) .gt. 1D-15) then 
       self(i,j)=(CS1S1S1(INH3,INH4,INH5)*CS1S1S1(j,INH3,INH6)*
     &  CS1S1S1S1(i,INH4,INH5,INH6)*(FD111HHH(1,INH3,INH4,INH5)-
     &  FD111HHH(1,INH4,INH6,INH5)))/(32.*(Mah(INH3)**2-Mah(INH6)**2))+
     &  self(i,j)
              else
               if( Abs(Mah(INH3)) .gt. 1D-15) then 
       self(i,j)=(CS1S1S1(INH3,INH4,INH5)*CS1S1S1(j,INH3,INH6)*
     &  CS1S1S1S1(i,INH4,INH5,INH6)*FD211HHH(1,INH3,INH4,INH5))/32.+
     &  self(i,j)
               endif
              endif
       enddo 
       enddo 
       enddo 
       enddo 
        
       do ICH3=1,2
       do ICH4=1,2
       do INH3= ihiggs,6
       do INH4= ihiggs,6
              if( Abs(Mah(INH3) - Mah(INH4)) .gt. 1D-15) then 
       self(i,j)=(CS1S1S1(j,INH3,INH4)*CS1S1S3S3(i,INH4,ICH4,ICH3)*
     &  CS1S3S3(INH3,ICH3,ICH4)*(FD111HHpHp(1,INH3,ICH3,ICH4)-
     &  FD111HHpHp(1,INH4,ICH3,ICH4)))/(16.*(Mah(INH3)**2-Mah(INH4)**2)
     &  )+self(i,j)
              else
               if( Abs(Mah(INH3)) .gt. 1D-15) then 
       self(i,j)=(CS1S1S1(j,INH3,INH4)*CS1S1S3S3(i,INH4,ICH4,ICH3)*
     &  CS1S3S3(INH3,ICH3,ICH4)*FD211HHpHp(1,INH3,ICH3,ICH4))/16.+
     &  self(i,j)
               endif
              endif
       enddo 
       enddo 
       enddo 
       enddo 
        
       do ICH3=1,2
       do ICH4=1,2
       do ICH5=1,2
       do INH3= ihiggs,6
              if( Abs(MassHpm(ICH3) - MassHpm(ICH5)) .gt. 1D-15) then 
       self(i,j)=((CS1S1S3S3(i,INH3,ICH5,ICH4)*CS1S3S3(INH3,ICH4,ICH3)*
     &  CS1S3S3(j,ICH3,ICH5)+CS1S1S3S3(i,INH3,ICH4,ICH5)*
     &  CS1S3S3(INH3,ICH3,ICH4)*CS1S3S3(j,ICH5,ICH3))*
     &  (FD111HHpHp(1,INH3,ICH3,ICH4)-FD111HHpHp(1,INH3,ICH5,ICH4)))
     &  /(16.*(MassHpm(ICH3)**2-MassHpm(ICH5)**2))+self(i,j)
              else
               if( Abs(MassHpm(ICH3)) .gt. 1D-15) then 
       self(i,j)=((CS1S1S3S3(i,INH3,ICH5,ICH4)*CS1S3S3(INH3,ICH4,ICH3)*
     &  CS1S3S3(j,ICH3,ICH5)+CS1S1S3S3(i,INH3,ICH4,ICH5)*
     &  CS1S3S3(INH3,ICH3,ICH4)*CS1S3S3(j,ICH5,ICH3))*
     &  FD211HpHHp(1,ICH3,INH3,ICH4))/16.+self(i,j)
               endif
              endif
       enddo 
       enddo 
       enddo 
       enddo 
        
       do INH3= ihiggs,6
       do INH4= ihiggs,6
       do ISt3=1,2
       do ISt4=1,2
              if( Abs(Mah(INH3) - Mah(INH4)) .gt. 1D-15) then 
       self(i,j)=(3*CS1S1S1(j,INH3,INH4)*CSSS(INH3,ISt3,ISt4)*
     &  CSSSS(i,INH4,ISt4,ISt3)*(FD111HSTST(1,INH3,ISt3,ISt4)-
     &  FD111HSTST(1,INH4,ISt3,ISt4)))/(16.*(Mah(INH3)**2-Mah(INH4)**2)
     &  )+self(i,j)
              else
               if( Abs(Mah(INH3)) .gt. 1D-15) then 
       self(i,j)=(3*CS1S1S1(j,INH3,INH4)*CSSS(INH3,ISt3,ISt4)*
     &  CSSSS(i,INH4,ISt4,ISt3)*FD211HSTST(1,INH3,ISt3,ISt4))/16.+
     &  self(i,j)
               endif
              endif
       enddo 
       enddo 
       enddo 
       enddo 
        
       do ICH3=1,2
       do ICH4=1,2
       do ISt3=1,2
              if( Abs(MassHpm(ICH3) - MassHpm(ICH4)) .gt. 1D-15) then 
       self(i,j)=(3*(CS1S3S3(j,ICH4,ICH3)*CS1S3SSC(i,ICH4,ISt3)*
     &  CS3S13S(ICH3,ISt3)+CS1S3S3(j,ICH3,ICH4)*CS1S3SS(i,ICH4,ISt3)*
     &  CS3S13SC(ICH3,ISt3))*(FD111HpSTSB(1,ICH3,ISt3)-
     &  FD111HpSTSB(1,ICH4,ISt3)))/(16.*(MassHpm(ICH3)**2-MassHpm(ICH4)
     &  **2))+self(i,j)
              else
               if( Abs(MassHpm(ICH3)) .gt. 1D-15) then 
       self(i,j)=(3*(CS1S3S3(j,ICH4,ICH3)*CS1S3SSC(i,ICH4,ISt3)*
     &  CS3S13S(ICH3,ISt3)+CS1S3S3(j,ICH3,ICH4)*CS1S3SS(i,ICH4,ISt3)*
     &  CS3S13SC(ICH3,ISt3))*FD211HpSTSB(1,ICH3,ISt3))/16.+self(i,j)
               endif
              endif
       enddo 
       enddo 
       enddo 
c
c topo3
c
       do INH3= ihiggs,6
       do INH4= ihiggs,6
              if( Abs(Mah(INH3) - Mah(INH4)) .gt. 1D-15) then 
       self(i,j)=(CS1S1S1S1(i,j,INH3,INH4)*(CFF12S1L(INH4)*
     &  (CFF12S1R(INH3)*(-FD111ChaChaH(2,INH3)+FD111ChaChaH(2,INH4))+
     &  MCha2*CFF12S1L(INH3)*(-FD111ChaHCha(1,INH3)+
     &  FD111ChaHCha(1,INH4)))+CFF12S1R(INH4)*(CFF12S1L(INH3)*(-
     &  FD111ChaChaH(2,INH3)+FD111ChaChaH(2,INH4))+MCha2*CFF12S1R(INH3)
     &  *(-FD111ChaHCha(1,INH3)+FD111ChaHCha(1,INH4)))+3*
     &  (FD111THT(2,INH3)-FD111THT(2,INH4)-FD111THT(4,INH3)+
     &  FD111THT(4,INH4))*(hy(INH4)*hyc(INH3)+hy(INH3)*hyc(INH4))-3*
     &  M12*FD111THT(1,INH3)*(hy(INH3)*hy(INH4)+hyc(INH3)*hyc(INH4))+3*
     &  M12*FD111THT(1,INH4)*(hy(INH3)*hy(INH4)+hyc(INH3)*hyc(INH4))))
     &  /(16.*(Mah(INH3)**2-Mah(INH4)**2))+self(i,j)
              else
               if( Abs(Mah(INH3)) .gt. 1D-15) then 
       self(i,j)=-(CS1S1S1S1(i,j,INH3,INH4)*(CFF12S1R(INH3)*(MCha2*
     &  CFF12S1R(INH4)*FD211HChaCha(1,INH3)+CFF12S1L(INH4)*(-
     &  FD211HChaCha(2,INH3)+FD211HChaCha(3,INH3)))+CFF12S1L(INH3)*
     &  (MCha2*CFF12S1L(INH4)*FD211HChaCha(1,INH3)+CFF12S1R(INH4)*(-
     &  FD211HChaCha(2,INH3)+FD211HChaCha(3,INH3)))-3*(FD211HTT(2,INH3)
     &  -FD211HTT(3,INH3))*(hy(INH4)*hyc(INH3)+hy(INH3)*hyc(INH4))+3*
     &  M12*FD211HTT(1,INH3)*(hy(INH3)*hy(INH4)+hyc(INH3)*hyc(INH4))))
     &  /16.+self(i,j)
               endif
              endif
       enddo 
       enddo 
        
       do INe3=ineu,3
       do INe4=ineu,3
       do INH3= ihiggs,6
       do INH4= ihiggs,6
              if( Abs(Mah(INH3) - Mah(INH4)) .gt. 1D-15) then 
       self(i,j)=(CS1S1S1S1(i,j,INH3,INH4)*(-((CFF11S1L(INe4,INe3,INH3)
     &  *CFF11S1R(INe3,INe4,INH4)+CFF11S1L(INe3,INe4,INH4)*
     &  CFF11S1R(INe4,INe3,INH3))*(FD111ChiChiH(2,INe3,INe4,INH3)-
     &  FD111ChiChiH(2,INe3,INe4,INH4)))-(CFF11S1L(INe3,INe4,INH4)*
     &  CFF11S1L(INe4,INe3,INH3)+CFF11S1R(INe3,INe4,INH4)*
     &  CFF11S1R(INe4,INe3,INH3))*(FD111ChiChiH(1,INe3,INe4,INH3)-
     &  FD111ChiChiH(1,INe3,INe4,INH4))*MNeu(INe3)*MNeu(INe4)))/(32.*
     &  (Mah(INH3)**2-Mah(INH4)**2))+self(i,j)
              else
               if( Abs(Mah(INH3)) .gt. 1D-15) then 
       self(i,j)=(CS1S1S1S1(i,j,INH3,INH4)*((CFF11S1L(INe4,INe3,INH3)*
     &  CFF11S1R(INe3,INe4,INH4)+CFF11S1L(INe3,INe4,INH4)*
     &  CFF11S1R(INe4,INe3,INH3))*(FD211HNeuNeu(2,INH3,INe4,INe3)-
     &  FD211HNeuNeu(3,INH3,INe4,INe3))-(CFF11S1L(INe3,INe4,INH4)*
     &  CFF11S1L(INe4,INe3,INH3)+CFF11S1R(INe3,INe4,INH4)*
     &  CFF11S1R(INe4,INe3,INH3))*FD211HNeuNeu(1,INH3,INe4,INe3)*
     &  MNeu(INe3)*MNeu(INe4)))/32.+self(i,j)
               endif
              endif
       enddo 
       enddo 
       enddo 
       enddo 
        
       do ICH3=1,2
       do ICH4=1,2
              if( Abs(MassHpm(ICH3) - MassHpm(ICH4)) .gt. 1D-15) then 
       self(i,j)=(3*CS1S1S3S3(i,j,ICH4,ICH3)*CTBS3(ICH3)*CTBS3C(ICH4)*
     &  (FD111THpB(2,ICH3)-FD111THpB(2,ICH4)-FD111THpB(4,ICH3)+
     &  FD111THpB(4,ICH4)))/(8.*(MassHpm(ICH3)**2-MassHpm(ICH4)**2))+
     &  self(i,j)
              else
               if( Abs(MassHpm(ICH3)) .gt. 1D-15) then 
       self(i,j)=(3*CS1S1S3S3(i,j,ICH4,ICH3)*CTBS3(ICH3)*CTBS3C(ICH4)*
     &  (FD211HpTB(2,ICH3)-FD211HpTB(3,ICH3)))/8.+self(i,j)
               endif
              endif
       enddo 
       enddo 
        
       do ICH3=1,2
       do ICH4=1,2
       do INe3=ineu,3
              if( Abs(MassHpm(ICH3) - MassHpm(ICH4)) .gt. 1D-15) then 
       self(i,j)=(CS1S1S3S3(i,j,ICH3,ICH4)*(-((CF11F12S3L(INe3,ICH3)*
     &  DCONJG(CF11F12S3L(INe3,ICH4))+CF11F12S3R(INe3,ICH3)*
     &  DCONJG(CF11F12S3R(INe3,ICH4)))*(FD111ChaChiHp(2,INe3,ICH3)-
     &  FD111ChaChiHp(2,INe3,ICH4)))-MCha*(CF11F12S3R(INe3,ICH3)*
     &  DCONJG(CF11F12S3L(INe3,ICH4))+CF11F12S3L(INe3,ICH3)*
     &  DCONJG(CF11F12S3R(INe3,ICH4)))*(FD111ChaChiHp(1,INe3,ICH3)-
     &  FD111ChaChiHp(1,INe3,ICH4))*MNeu(INe3)))/(8.*(MassHpm(ICH3)**2-
     &  MassHpm(ICH4)**2))+self(i,j)
              else
               if( Abs(MassHpm(ICH3)) .gt. 1D-15) then 
       self(i,j)=(CS1S1S3S3(i,j,ICH3,ICH4)*((CF11F12S3L(INe3,ICH3)*
     &  DCONJG(CF11F12S3L(INe3,ICH4))+CF11F12S3R(INe3,ICH3)*
     &  DCONJG(CF11F12S3R(INe3,ICH4)))*(FD211HpChiCha(2,ICH3,INe3)-
     &  FD211HpChiCha(3,ICH3,INe3))-MCha*(CF11F12S3R(INe3,ICH3)*
     &  DCONJG(CF11F12S3L(INe3,ICH4))+CF11F12S3L(INe3,ICH3)*
     &  DCONJG(CF11F12S3R(INe3,ICH4)))*FD211HpChiCha(1,ICH3,INe3)*
     &  MNeu(INe3)))/8.+self(i,j)
               endif
              endif
       enddo 
       enddo 
       enddo 
c
c topo13
c
       do INH3= ihiggs,6
       do INH4= ihiggs,6
       do INH5= ihiggs,6
       do INH6= ihiggs,6
              if( Abs(Mah(INH5) - Mah(INH6)) .gt. 1D-15) then 
       self(i,j)=(CS1S1S1(INH3,INH4,INH5)*CS1S1S1(INH3,INH4,INH6)*
     &  CS1S1S1S1(i,j,INH5,INH6)*(FD111HHH(1,INH3,INH4,INH5)-
     &  FD111HHH(1,INH3,INH4,INH6)))/(64.*(Mah(INH5)**2-Mah(INH6)**2))+
     &  self(i,j)
              else
               if( Abs(Mah(INH5)) .gt. 1D-15) then 
       self(i,j)=(CS1S1S1(INH3,INH4,INH5)*CS1S1S1(INH3,INH4,INH6)*
     &  CS1S1S1S1(i,j,INH5,INH6)*FD211HHH(1,INH5,INH4,INH3))/64.+
     &  self(i,j)
               endif
              endif
       enddo 
       enddo 
       enddo 
       enddo 
        
       do ICH3=1,2
       do ICH4=1,2
       do INH3= ihiggs,6
       do INH4= ihiggs,6
              if( Abs(Mah(INH3) - Mah(INH4)) .gt. 1D-15) then 
       self(i,j)=(CS1S1S1S1(i,j,INH3,INH4)*CS1S3S3(INH3,ICH3,ICH4)*
     &  CS1S3S3(INH4,ICH4,ICH3)*(FD111HpHpH(1,ICH3,ICH4,INH3)-
     &  FD111HpHpH(1,ICH3,ICH4,INH4)))/(32.*(Mah(INH3)**2-Mah(INH4)**2)
     &  )+self(i,j)
              else
               if( Abs(Mah(INH3)) .gt. 1D-15) then 
       self(i,j)=(CS1S1S1S1(i,j,INH3,INH4)*CS1S3S3(INH3,ICH3,ICH4)*
     &  CS1S3S3(INH4,ICH4,ICH3)*FD211HHpHp(1,INH3,ICH4,ICH3))/32.+
     &  self(i,j)
               endif
              endif
       enddo 
       enddo 
       enddo 
       enddo 
        
       do ICH3=1,2
       do ICH4=1,2
       do ICH5=1,2
       do INH3= ihiggs,6
              if( Abs(MassHpm(ICH4) - MassHpm(ICH5)) .gt. 1D-15) then 
       self(i,j)=(CS1S1S3S3(i,j,ICH4,ICH5)*CS1S3S3(INH3,ICH3,ICH4)*
     &  CS1S3S3(INH3,ICH5,ICH3)*(FD111HHpHp(1,INH3,ICH3,ICH4)-
     &  FD111HHpHp(1,INH3,ICH3,ICH5)))/(16.*(MassHpm(ICH4)**2-
     &  MassHpm(ICH5)**2))+self(i,j)
              else
               if( Abs(MassHpm(ICH4)) .gt. 1D-15) then 
       self(i,j)=(CS1S1S3S3(i,j,ICH4,ICH5)*CS1S3S3(INH3,ICH3,ICH4)*
     &  CS1S3S3(INH3,ICH5,ICH3)*FD211HpHpH(1,ICH4,ICH3,INH3))/16.+
     &  self(i,j)
               endif
              endif
       enddo 
       enddo 
       enddo 
       enddo 
        
       do INH3= ihiggs,6
       do INH4= ihiggs,6
       do ISt3=1,2
       do ISt4=1,2
              if( Abs(Mah(INH3) - Mah(INH4)) .gt. 1D-15) then 
       self(i,j)=(3*CS1S1S1S1(i,j,INH3,INH4)*CSSS(INH3,ISt3,ISt4)*
     &  CSSS(INH4,ISt4,ISt3)*(FD111HSTST(1,INH3,ISt3,ISt4)-
     &  FD111HSTST(1,INH4,ISt3,ISt4)))/(32.*(Mah(INH3)**2-Mah(INH4)**2)
     &  )+self(i,j)
              else
               if( Abs(Mah(INH3)) .gt. 1D-15) then 
       self(i,j)=(3*CS1S1S1S1(i,j,INH3,INH4)*CSSS(INH3,ISt3,ISt4)*
     &  CSSS(INH4,ISt4,ISt3)*FD211HSTST(1,INH3,ISt4,ISt3))/32.+
     &  self(i,j)
               endif
              endif
       enddo 
       enddo 
       enddo 
       enddo 
        
       do ICH3=1,2
       do ICH4=1,2
       do ISt3=1,2
              if( Abs(MassHpm(ICH3) - MassHpm(ICH4)) .gt. 1D-15) then 
       self(i,j)=(3*CS1S1S3S3(i,j,ICH4,ICH3)*CS3S13S(ICH3,ISt3)*
     &  CS3S13SC(ICH4,ISt3)*(FD111HpSTSB(1,ICH3,ISt3)-
     &  FD111HpSTSB(1,ICH4,ISt3)))/(16.*(MassHpm(ICH3)**2-MassHpm(ICH4)
     &  **2))+self(i,j)
              else
               if( Abs(MassHpm(ICH3)) .gt. 1D-15) then 
       self(i,j)=(3*CS1S1S3S3(i,j,ICH4,ICH3)*CS3S13S(ICH3,ISt3)*
     &  CS3S13SC(ICH4,ISt3)*FD211HpSTSB(1,ICH3,ISt3))/16.+self(i,j)
               endif
              endif
       enddo 
       enddo 
       enddo 
c
c topo14
c
       do INe3=ineu,3
       do INe4=ineu,3
       do INe5=ineu,3
       do INe6=ineu,3
       do INH3= ihiggs,6
          if( Abs(-MNeu(INe3) + MNeu(INe5)) .gt. 1D-15) then 
          if( Abs(-MNeu(INe4) + MNeu(INe6)) .gt. 1D-15) then 
       self(i,j)=(CFF11S1L(INe3,INe5,i)*(CFF11S1R(INe6,INe4,j)*
     &  (CFF11S1L(INe5,INe6,INH3)*(CFF11S1L(INe4,INe3,INH3)*(-
     &  FD111ChiChiH(4,INe4,INe3,INH3)+FD111ChiChiH(4,INe4,INe5,INH3)+
     &  FD111ChiChiH(4,INe6,INe3,INH3)-FD111ChiChiH(4,INe6,INe5,INH3))*
     &  MNeu(INe3)+CFF11S1R(INe4,INe3,INH3)*(-
     &  FD111ChiChiH(2,INe3,INe4,INH3)+FD111ChiChiH(2,INe3,INe6,INH3)+
     &  FD111ChiChiH(2,INe4,INe5,INH3)-FD111ChiChiH(2,INe5,INe6,INH3))*
     &  MNeu(INe4))*MNeu(INe5)+CFF11S1R(INe5,INe6,INH3)*
     &  (CFF11S1L(INe4,INe3,INH3)*(-FD111ChiChiH(2,INe3,INe4,INH3)+
     &  FD111ChiChiH(2,INe3,INe6,INH3)+FD111ChiChiH(2,INe4,INe5,INH3)-
     &  FD111ChiChiH(2,INe5,INe6,INH3))*MNeu(INe3)+
     &  CFF11S1R(INe4,INe3,INH3)*(-FD111ChiChiH(4,INe3,INe4,INH3)+
     &  FD111ChiChiH(4,INe3,INe6,INH3)+FD111ChiChiH(4,INe5,INe4,INH3)-
     &  FD111ChiChiH(4,INe5,INe6,INH3))*MNeu(INe4))*MNeu(INe6))+
     &  CFF11S1L(INe6,INe4,j)*(CFF11S1R(INe5,INe6,INH3)*
     &  (CFF11S1R(INe4,INe3,INH3)*(-FD111ChiChiH(6,INe3,INe4,INH3)+
     &  FD111ChiChiH(6,INe3,INe6,INH3)+FD111ChiChiH(6,INe4,INe5,INH3)-
     &  FD111ChiChiH(6,INe5,INe6,INH3))+CFF11S1L(INe4,INe3,INH3)*(-
     &  FD111ChiChiH(2,INe3,INe4,INH3)+FD111ChiChiH(2,INe3,INe6,INH3)+
     &  FD111ChiChiH(2,INe4,INe5,INH3)-FD111ChiChiH(2,INe5,INe6,INH3))*
     &  MNeu(INe3)*MNeu(INe4))+CFF11S1L(INe5,INe6,INH3)*
     &  (CFF11S1R(INe4,INe3,INH3)*(-FD111ChiChiH(2,INe3,INe4,INH3)+
     &  FD111ChiChiH(2,INe3,INe6,INH3)+FD111ChiChiH(2,INe4,INe5,INH3)-
     &  FD111ChiChiH(2,INe5,INe6,INH3))+CFF11S1L(INe4,INe3,INH3)*(-
     &  FD111ChiChiH(1,INe3,INe4,INH3)+FD111ChiChiH(1,INe3,INe6,INH3)+
     &  FD111ChiChiH(1,INe4,INe5,INH3)-FD111ChiChiH(1,INe5,INe6,INH3))*
     &  MNeu(INe3)*MNeu(INe4))*MNeu(INe5)*MNeu(INe6)))+
     &  CFF11S1R(INe3,INe5,i)*(CFF11S1R(INe4,INe3,INH3)*MNeu(INe3)*(-
     &  (CFF11S1L(INe5,INe6,INH3)*(FD111ChiChiH(2,INe3,INe4,INH3)-
     &  FD111ChiChiH(2,INe3,INe6,INH3)-FD111ChiChiH(2,INe4,INe5,INH3)+
     &  FD111ChiChiH(2,INe5,INe6,INH3))*(CFF11S1R(INe6,INe4,j)*
     &  MNeu(INe4)+CFF11S1L(INe6,INe4,j)*MNeu(INe6)))+
     &  CFF11S1R(INe5,INe6,INH3)*MNeu(INe5)*(CFF11S1L(INe6,INe4,j)*(-
     &  FD111ChiChiH(4,INe4,INe3,INH3)+FD111ChiChiH(4,INe4,INe5,INH3)+
     &  FD111ChiChiH(4,INe6,INe3,INH3)-FD111ChiChiH(4,INe6,INe5,INH3))+
     &  CFF11S1R(INe6,INe4,j)*(-FD111ChiChiH(1,INe3,INe4,INH3)+
     &  FD111ChiChiH(1,INe3,INe6,INH3)+FD111ChiChiH(1,INe4,INe5,INH3)-
     &  FD111ChiChiH(1,INe5,INe6,INH3))*MNeu(INe4)*MNeu(INe6)))+
     &  CFF11S1L(INe4,INe3,INH3)*(-(CFF11S1R(INe5,INe6,INH3)*
     &  (FD111ChiChiH(2,INe3,INe4,INH3)-FD111ChiChiH(2,INe3,INe6,INH3)-
     &  FD111ChiChiH(2,INe4,INe5,INH3)+FD111ChiChiH(2,INe5,INe6,INH3))*
     &  MNeu(INe5)*(CFF11S1L(INe6,INe4,j)*MNeu(INe4)+
     &  CFF11S1R(INe6,INe4,j)*MNeu(INe6)))+CFF11S1L(INe5,INe6,INH3)*
     &  (CFF11S1R(INe6,INe4,j)*(-FD111ChiChiH(6,INe3,INe4,INH3)+
     &  FD111ChiChiH(6,INe3,INe6,INH3)+FD111ChiChiH(6,INe4,INe5,INH3)-
     &  FD111ChiChiH(6,INe5,INe6,INH3))+CFF11S1L(INe6,INe4,j)*(-
     &  FD111ChiChiH(4,INe3,INe4,INH3)+FD111ChiChiH(4,INe3,INe6,INH3)+
     &  FD111ChiChiH(4,INe5,INe4,INH3)-FD111ChiChiH(4,INe5,INe6,INH3))*
     &  MNeu(INe4)*MNeu(INe6)))))/(16.*(MNeu(INe3)**2-MNeu(INe5)**2)*
     &  (MNeu(INe4)**2-MNeu(INe6)**2))+self(i,j)
              else
       self(i,j)=(CFF11S1L(INe4,INe3,INH3)*(-((CFF11S1L(INe4,INe4,j)+
     &  CFF11S1R(INe4,INe4,j))*CFF11S1R(INe5,INe4,INH3)*
     &  (FD211ChiChiH(2,INe4,INe3,INH3)-FD211ChiChiH(2,INe4,INe5,INH3))
     &  *MNeu(INe4)*(CFF11S1L(INe3,INe5,i)*MNeu(INe3)+
     &  CFF11S1R(INe3,INe5,i)*MNeu(INe5)))+CFF11S1L(INe5,INe4,INH3)*
     &  (CFF11S1L(INe3,INe5,i)*MNeu(INe3)*MNeu(INe5)*
     &  (CFF11S1R(INe4,INe4,j)*(-FD211ChiChiH(4,INe4,INe3,INH3)+
     &  FD211ChiChiH(4,INe4,INe5,INH3))+CFF11S1L(INe4,INe4,j)*(-
     &  FD211ChiChiH(1,INe4,INe3,INH3)+FD211ChiChiH(1,INe4,INe5,INH3))*
     &  MNeu2(INe4))+CFF11S1R(INe3,INe5,i)*(CFF11S1R(INe4,INe4,j)*(-
     &  FD211ChiChiH(6,INe4,INe3,INH3)+FD211ChiChiH(6,INe4,INe5,INH3))+
     &  CFF11S1L(INe4,INe4,j)*(-FD211ChiChiH(3,INe4,INe3,INH3)+
     &  FD211ChiChiH(3,INe4,INe5,INH3))*MNeu2(INe4))))+
     &  CFF11S1R(INe4,INe3,INH3)*(CFF11S1L(INe3,INe5,i)*
     &  (CFF11S1L(INe4,INe4,j)*(CFF11S1R(INe5,INe4,INH3)*(-
     &  FD211ChiChiH(6,INe4,INe3,INH3)+FD211ChiChiH(6,INe4,INe5,INH3))+
     &  CFF11S1L(INe5,INe4,INH3)*(-FD211ChiChiH(2,INe4,INe3,INH3)+
     &  FD211ChiChiH(2,INe4,INe5,INH3))*MNeu(INe4)*MNeu(INe5))+
     &  CFF11S1R(INe4,INe4,j)*(CFF11S1L(INe5,INe4,INH3)*(-
     &  FD211ChiChiH(2,INe4,INe3,INH3)+FD211ChiChiH(2,INe4,INe5,INH3))*
     &  MNeu(INe4)*MNeu(INe5)+CFF11S1R(INe5,INe4,INH3)*(-
     &  FD211ChiChiH(3,INe4,INe3,INH3)+FD211ChiChiH(3,INe4,INe5,INH3))*
     &  MNeu2(INe4)))+CFF11S1R(INe3,INe5,i)*MNeu(INe3)*
     &  (CFF11S1L(INe4,INe4,j)*(CFF11S1L(INe5,INe4,INH3)*(-
     &  FD211ChiChiH(2,INe4,INe3,INH3)+FD211ChiChiH(2,INe4,INe5,INH3))*
     &  MNeu(INe4)+CFF11S1R(INe5,INe4,INH3)*(-
     &  FD211ChiChiH(4,INe4,INe3,INH3)+FD211ChiChiH(4,INe4,INe5,INH3))*
     &  MNeu(INe5))+CFF11S1R(INe4,INe4,j)*(CFF11S1L(INe5,INe4,INH3)*(-
     &  FD211ChiChiH(2,INe4,INe3,INH3)+FD211ChiChiH(2,INe4,INe5,INH3))*
     &  MNeu(INe4)+CFF11S1R(INe5,INe4,INH3)*(-
     &  FD211ChiChiH(1,INe4,INe3,INH3)+FD211ChiChiH(1,INe4,INe5,INH3))*
     &  MNeu(INe5)*MNeu2(INe4)))))/(16.*(MNeu(INe3)**2-MNeu(INe5)**2))+self(i,j)
              endif
             else
          if( Abs(-MNeu(INe4) + MNeu(INe6)) .gt. 1D-15) then 
       self(i,j)=(CFF11S1R(INe3,INe3,i)*(CFF11S1L(INe3,INe6,INH3)*(-
     &  (CFF11S1R(INe4,INe3,INH3)*(FD211ChiChiH(2,INe3,INe4,INH3)-
     &  FD211ChiChiH(2,INe3,INe6,INH3))*MNeu(INe3)*
     &  (CFF11S1R(INe6,INe4,j)*MNeu(INe4)+CFF11S1L(INe6,INe4,j)*
     &  MNeu(INe6)))+CFF11S1L(INe4,INe3,INH3)*(CFF11S1R(INe6,INe4,j)*(-
     &  FD211ChiChiH(6,INe3,INe4,INH3)+FD211ChiChiH(6,INe3,INe6,INH3))+
     &  CFF11S1L(INe6,INe4,j)*(-FD211ChiChiH(4,INe3,INe4,INH3)+
     &  FD211ChiChiH(4,INe3,INe6,INH3))*MNeu(INe4)*MNeu(INe6)))+
     &  CFF11S1R(INe3,INe6,INH3)*(-(CFF11S1L(INe4,INe3,INH3)*
     &  (FD211ChiChiH(2,INe3,INe4,INH3)-FD211ChiChiH(2,INe3,INe6,INH3))
     &  *MNeu(INe3)*(CFF11S1L(INe6,INe4,j)*MNeu(INe4)+
     &  CFF11S1R(INe6,INe4,j)*MNeu(INe6)))+CFF11S1R(INe4,INe3,INH3)*
     &  (CFF11S1L(INe6,INe4,j)*(-FD211ChiChiH(3,INe3,INe4,INH3)+
     &  FD211ChiChiH(3,INe3,INe6,INH3))+CFF11S1R(INe6,INe4,j)*(-
     &  FD211ChiChiH(1,INe3,INe4,INH3)+FD211ChiChiH(1,INe3,INe6,INH3))*
     &  MNeu(INe4)*MNeu(INe6))*MNeu2(INe3)))+CFF11S1L(INe3,INe3,i)*
     &  (CFF11S1R(INe6,INe4,j)*(CFF11S1R(INe3,INe6,INH3)*
     &  (CFF11S1L(INe4,INe3,INH3)*(-FD211ChiChiH(2,INe3,INe4,INH3)+
     &  FD211ChiChiH(2,INe3,INe6,INH3))*MNeu(INe3)+
     &  CFF11S1R(INe4,INe3,INH3)*(-FD211ChiChiH(4,INe3,INe4,INH3)+
     &  FD211ChiChiH(4,INe3,INe6,INH3))*MNeu(INe4))*MNeu(INe6)+
     &  CFF11S1L(INe3,INe6,INH3)*(CFF11S1R(INe4,INe3,INH3)*(-
     &  FD211ChiChiH(2,INe3,INe4,INH3)+FD211ChiChiH(2,INe3,INe6,INH3))*
     &  MNeu(INe3)*MNeu(INe4)+CFF11S1L(INe4,INe3,INH3)*(-
     &  FD211ChiChiH(3,INe3,INe4,INH3)+FD211ChiChiH(3,INe3,INe6,INH3))*
     &  MNeu2(INe3)))+CFF11S1L(INe6,INe4,j)*(CFF11S1R(INe3,INe6,INH3)*
     &  (CFF11S1R(INe4,INe3,INH3)*(-FD211ChiChiH(6,INe3,INe4,INH3)+
     &  FD211ChiChiH(6,INe3,INe6,INH3))+CFF11S1L(INe4,INe3,INH3)*(-
     &  FD211ChiChiH(2,INe3,INe4,INH3)+FD211ChiChiH(2,INe3,INe6,INH3))*
     &  MNeu(INe3)*MNeu(INe4))+CFF11S1L(INe3,INe6,INH3)*MNeu(INe6)*
     &  (CFF11S1R(INe4,INe3,INH3)*(-FD211ChiChiH(2,INe3,INe4,INH3)+
     &  FD211ChiChiH(2,INe3,INe6,INH3))*MNeu(INe3)+
     &  CFF11S1L(INe4,INe3,INH3)*(-FD211ChiChiH(1,INe3,INe4,INH3)+
     &  FD211ChiChiH(1,INe3,INe6,INH3))*MNeu(INe4)*MNeu2(INe3)))))
     &  /(16.*(MNeu(INe4)**2-MNeu(INe6)**2))+self(i,j)
          else 
       self(i,j)=(-((CFF11S1L(INe3,INe3,i)*CFF11S1L(INe4,INe4,j)*
     &  CFF11S1R(INe3,INe4,INH3)*CFF11S1R(INe4,INe3,INH3)+
     &  CFF11S1L(INe3,INe4,INH3)*CFF11S1L(INe4,INe3,INH3)*
     &  CFF11S1R(INe3,INe3,i)*CFF11S1R(INe4,INe4,j))*
     &  FD221ChiChiH(7,INe3,INe4,INH3))-(CFF11S1L(INe3,INe3,i)+
     &  CFF11S1R(INe3,INe3,i))*(CFF11S1L(INe4,INe3,INH3)*
     &  CFF11S1R(INe3,INe4,INH3)+CFF11S1L(INe3,INe4,INH3)*
     &  CFF11S1R(INe4,INe3,INH3))*(CFF11S1L(INe4,INe4,j)+
     &  CFF11S1R(INe4,INe4,j))*FD221ChiChiH(2,INe3,INe4,INH3)*
     &  MNeu(INe3)*MNeu(INe4)-(CFF11S1L(INe4,INe4,j)*
     &  CFF11S1R(INe3,INe3,i)*CFF11S1R(INe3,INe4,INH3)*
     &  CFF11S1R(INe4,INe3,INH3)+CFF11S1L(INe3,INe3,i)*
     &  CFF11S1L(INe3,INe4,INH3)*CFF11S1L(INe4,INe3,INH3)*
     &  CFF11S1R(INe4,INe4,j))*FD221ChiChiH(3,INe4,INe3,INH3)*
     &  MNeu2(INe3)-(CFF11S1L(INe3,INe4,INH3)*CFF11S1L(INe4,INe3,INH3)*
     &  CFF11S1L(INe4,INe4,j)*CFF11S1R(INe3,INe3,i)+
     &  CFF11S1L(INe3,INe3,i)*CFF11S1R(INe3,INe4,INH3)*
     &  CFF11S1R(INe4,INe3,INH3)*CFF11S1R(INe4,INe4,j))*
     &  FD221ChiChiH(3,INe3,INe4,INH3)*MNeu2(INe4)-
     &  (CFF11S1L(INe3,INe3,i)*CFF11S1L(INe3,INe4,INH3)*
     &  CFF11S1L(INe4,INe3,INH3)*CFF11S1L(INe4,INe4,j)+
     &  CFF11S1R(INe3,INe3,i)*CFF11S1R(INe3,INe4,INH3)*
     &  CFF11S1R(INe4,INe3,INH3)*CFF11S1R(INe4,INe4,j))*
     &  FD221ChiChiH(1,INe3,INe4,INH3)*MNeu2(INe3)*MNeu2(INe4))/16.+self(i,j)
          endif 
              endif
       enddo 
       enddo 
       enddo 
       enddo 
       enddo 
       do INH3= ihiggs,6
       self(i,j)=(MCha2*(-(MCha2*(CFF12S1L(i)*CFF12S1L(INH3)**2*
     &  CFF12S1L(j)+CFF12S1R(i)*CFF12S1R(INH3)**2*CFF12S1R(j))*
     &  FD221ChaChaH(1,INH3))-2*CFF12S1L(INH3)*(CFF12S1L(i)+CFF12S1R(i)
     &  )*CFF12S1R(INH3)*(CFF12S1L(j)+CFF12S1R(j))*FD221ChaChaH(2,INH3)
     &  -(CFF12S1L(INH3)**2+CFF12S1R(INH3)**2)*(CFF12S1L(j)*CFF12S1R(i)
     &  +CFF12S1L(i)*CFF12S1R(j))*FD221ChaChaH(3,INH3))-(CFF12S1L(i)*
     &  CFF12S1L(j)*CFF12S1R(INH3)**2+CFF12S1L(INH3)**2*CFF12S1R(i)*
     &  CFF12S1R(j))*FD221ChaChaH(7,INH3))/8.+self(i,j)
       enddo 
       do ICH3=1,2
       do INe3=ineu,3
       do INe4=ineu,3
          if( Abs(-MNeu(INe3) + MNeu(INe4)) .gt. 1D-15) then 
       self(i,j)=(CF11F12S3R(INe3,ICH3)*(CFF11S1L(INe4,INe3,j)*
     &  (DCONJG(CF11F12S3L(INe4,ICH3))*(MCha2*CFF12S1R(i)*(-
     &  FD211ChaChiHp(3,INe3,ICH3)+FD211ChaChiHp(3,INe4,ICH3))+
     &  CFF12S1L(i)*(-FD211ChaChiHp(6,INe3,ICH3)+
     &  FD211ChaChiHp(6,INe4,ICH3)))-MCha*(CFF12S1L(i)+CFF12S1R(i))*
     &  DCONJG(CF11F12S3R(INe4,ICH3))*(FD211ChaChiHp(2,INe3,ICH3)-
     &  FD211ChaChiHp(2,INe4,ICH3))*MNeu(INe4))+CFF11S1L(INe3,INe4,i)*
     &  (DCONJG(CF11F12S3L(INe4,ICH3))*(MCha2*CFF12S1R(j)*(-
     &  FD211ChaChiHp(3,INe3,ICH3)+FD211ChaChiHp(3,INe4,ICH3))+
     &  CFF12S1L(j)*(-FD211ChaChiHp(6,INe3,ICH3)+
     &  FD211ChaChiHp(6,INe4,ICH3)))-MCha*(CFF12S1L(j)+CFF12S1R(j))*
     &  DCONJG(CF11F12S3R(INe4,ICH3))*(FD211ChaChiHp(2,INe3,ICH3)-
     &  FD211ChaChiHp(2,INe4,ICH3))*MNeu(INe4))+MNeu(INe3)*(-(MCha*
     &  (CFF11S1R(INe4,INe3,j)*(CFF12S1L(i)+CFF12S1R(i))+
     &  CFF11S1R(INe3,INe4,i)*(CFF12S1L(j)+CFF12S1R(j)))*
     &  DCONJG(CF11F12S3R(INe4,ICH3))*(FD211ChaChiHp(2,INe3,ICH3)-
     &  FD211ChaChiHp(2,INe4,ICH3)))+DCONJG(CF11F12S3L(INe4,ICH3))*
     &  (CFF11S1R(INe4,INe3,j)*(MCha2*CFF12S1R(i)*(-
     &  FD211ChaChiHp(1,INe3,ICH3)+FD211ChaChiHp(1,INe4,ICH3))+
     &  CFF12S1L(i)*(-FD211ChaChiHp(4,INe3,ICH3)+
     &  FD211ChaChiHp(4,INe4,ICH3)))+CFF11S1R(INe3,INe4,i)*(MCha2*
     &  CFF12S1R(j)*(-FD211ChaChiHp(1,INe3,ICH3)+
     &  FD211ChaChiHp(1,INe4,ICH3))+CFF12S1L(j)*(-
     &  FD211ChaChiHp(4,INe3,ICH3)+FD211ChaChiHp(4,INe4,ICH3))))*
     &  MNeu(INe4)))+CF11F12S3L(INe3,ICH3)*(CFF11S1R(INe4,INe3,j)*
     &  (DCONJG(CF11F12S3R(INe4,ICH3))*(MCha2*CFF12S1L(i)*(-
     &  FD211ChaChiHp(3,INe3,ICH3)+FD211ChaChiHp(3,INe4,ICH3))+
     &  CFF12S1R(i)*(-FD211ChaChiHp(6,INe3,ICH3)+
     &  FD211ChaChiHp(6,INe4,ICH3)))-MCha*(CFF12S1L(i)+CFF12S1R(i))*
     &  DCONJG(CF11F12S3L(INe4,ICH3))*(FD211ChaChiHp(2,INe3,ICH3)-
     &  FD211ChaChiHp(2,INe4,ICH3))*MNeu(INe4))+CFF11S1R(INe3,INe4,i)*
     &  (DCONJG(CF11F12S3R(INe4,ICH3))*(MCha2*CFF12S1L(j)*(-
     &  FD211ChaChiHp(3,INe3,ICH3)+FD211ChaChiHp(3,INe4,ICH3))+
     &  CFF12S1R(j)*(-FD211ChaChiHp(6,INe3,ICH3)+
     &  FD211ChaChiHp(6,INe4,ICH3)))-MCha*(CFF12S1L(j)+CFF12S1R(j))*
     &  DCONJG(CF11F12S3L(INe4,ICH3))*(FD211ChaChiHp(2,INe3,ICH3)-
     &  FD211ChaChiHp(2,INe4,ICH3))*MNeu(INe4))+MNeu(INe3)*(-(MCha*
     &  (CFF11S1L(INe4,INe3,j)*(CFF12S1L(i)+CFF12S1R(i))+
     &  CFF11S1L(INe3,INe4,i)*(CFF12S1L(j)+CFF12S1R(j)))*
     &  DCONJG(CF11F12S3L(INe4,ICH3))*(FD211ChaChiHp(2,INe3,ICH3)-
     &  FD211ChaChiHp(2,INe4,ICH3)))+DCONJG(CF11F12S3R(INe4,ICH3))*
     &  (CFF11S1L(INe4,INe3,j)*(MCha2*CFF12S1L(i)*(-
     &  FD211ChaChiHp(1,INe3,ICH3)+FD211ChaChiHp(1,INe4,ICH3))+
     &  CFF12S1R(i)*(-FD211ChaChiHp(4,INe3,ICH3)+
     &  FD211ChaChiHp(4,INe4,ICH3)))+CFF11S1L(INe3,INe4,i)*(MCha2*
     &  CFF12S1L(j)*(-FD211ChaChiHp(1,INe3,ICH3)+
     &  FD211ChaChiHp(1,INe4,ICH3))+CFF12S1R(j)*(-
     &  FD211ChaChiHp(4,INe3,ICH3)+FD211ChaChiHp(4,INe4,ICH3))))*MNeu(INe4))))/(8.*(MNeu(INe3)**2-MNeu(INe4)**2))+self(i,j)
              else
       self(i,j)=(CF11F12S3R(INe3,ICH3)*(-(DCONJG(CF11F12S3L(INe3,ICH3)
     &  )*(MCha2*(CFF11S1L(INe3,INe3,j)*CFF12S1R(i)+
     &  CFF11S1L(INe3,INe3,i)*CFF12S1R(j))*FD221ChaChiHp(5,INe3,ICH3)+
     &  (CFF11S1L(INe3,INe3,j)*CFF12S1L(i)+CFF11S1L(INe3,INe3,i)*
     &  CFF12S1L(j))*FD221ChaChiHp(7,INe3,ICH3)))-MCha*
     &  ((CFF11S1L(INe3,INe3,j)+CFF11S1R(INe3,INe3,j))*(CFF12S1L(i)+
     &  CFF12S1R(i))+(CFF11S1L(INe3,INe3,i)+CFF11S1R(INe3,INe3,i))*
     &  (CFF12S1L(j)+CFF12S1R(j)))*DCONJG(CF11F12S3R(INe3,ICH3))*
     &  FD221ChaChiHp(2,INe3,ICH3)*MNeu(INe3)-
     &  DCONJG(CF11F12S3L(INe3,ICH3))*(MCha2*(CFF11S1R(INe3,INe3,j)*
     &  CFF12S1R(i)+CFF11S1R(INe3,INe3,i)*CFF12S1R(j))*
     &  FD221ChaChiHp(1,INe3,ICH3)+(CFF11S1R(INe3,INe3,j)*CFF12S1L(i)+
     &  CFF11S1R(INe3,INe3,i)*CFF12S1L(j))*FD221ChaChiHp(3,INe3,ICH3))*
     &  MNeu2(INe3))+CF11F12S3L(INe3,ICH3)*(-
     &  (DCONJG(CF11F12S3R(INe3,ICH3))*(MCha2*(CFF11S1R(INe3,INe3,j)*
     &  CFF12S1L(i)+CFF11S1R(INe3,INe3,i)*CFF12S1L(j))*
     &  FD221ChaChiHp(5,INe3,ICH3)+(CFF11S1R(INe3,INe3,j)*CFF12S1R(i)+
     &  CFF11S1R(INe3,INe3,i)*CFF12S1R(j))*FD221ChaChiHp(7,INe3,ICH3)))
     &  -MCha*((CFF11S1L(INe3,INe3,j)+CFF11S1R(INe3,INe3,j))*
     &  (CFF12S1L(i)+CFF12S1R(i))+(CFF11S1L(INe3,INe3,i)+
     &  CFF11S1R(INe3,INe3,i))*(CFF12S1L(j)+CFF12S1R(j)))*
     &  DCONJG(CF11F12S3L(INe3,ICH3))*FD221ChaChiHp(2,INe3,ICH3)*
     &  MNeu(INe3)-DCONJG(CF11F12S3R(INe3,ICH3))*(MCha2*
     &  (CFF11S1L(INe3,INe3,j)*CFF12S1L(i)+CFF11S1L(INe3,INe3,i)*
     &  CFF12S1L(j))*FD221ChaChiHp(1,INe3,ICH3)+(CFF11S1L(INe3,INe3,j)*
     &  CFF12S1R(i)+CFF11S1L(INe3,INe3,i)*CFF12S1R(j))*
     &  FD221ChaChiHp(3,INe3,ICH3))*MNeu2(INe3)))/8.+self(i,j)
              endif
       enddo 
       enddo 
       enddo 
       do INe3=ineu,3
       do INe4=ineu,3
       do ISt3=1,2
          if( Abs(-MNeu(INe3) + MNeu(INe4)) .gt. 1D-15) then 
       self(i,j)=(-3*(CF11FSR(INe3,ISt3)*(M1*CF11FSRC(INe4,ISt3)*
     &  (FD211TChiSt(2,INe3,ISt3)-FD211TChiSt(2,INe4,ISt3))*
     &  (CFF11S1R(INe4,INe3,j)*(hy(i)+hyc(i))*MNeu(INe3)+
     &  CFF11S1R(INe3,INe4,i)*(hy(j)+hyc(j))*MNeu(INe3)+
     &  (CFF11S1L(INe4,INe3,j)*(hy(i)+hyc(i))+CFF11S1L(INe3,INe4,i)*
     &  (hy(j)+hyc(j)))*MNeu(INe4))+CF11FSLC(INe4,ISt3)*
     &  (CFF11S1L(INe4,INe3,j)*((FD211TChiSt(6,INe3,ISt3)-
     &  FD211TChiSt(6,INe4,ISt3))*hy(i)+M12*(FD211TChiSt(3,INe3,ISt3)-
     &  FD211TChiSt(3,INe4,ISt3))*hyc(i))+CFF11S1L(INe3,INe4,i)*
     &  ((FD211TChiSt(6,INe3,ISt3)-FD211TChiSt(6,INe4,ISt3))*hy(j)+M12*
     &  (FD211TChiSt(3,INe3,ISt3)-FD211TChiSt(3,INe4,ISt3))*hyc(j))+
     &  (CFF11S1R(INe4,INe3,j)*((FD211TChiSt(4,INe3,ISt3)-
     &  FD211TChiSt(4,INe4,ISt3))*hy(i)+M12*(FD211TChiSt(1,INe3,ISt3)-
     &  FD211TChiSt(1,INe4,ISt3))*hyc(i))+CFF11S1R(INe3,INe4,i)*
     &  ((FD211TChiSt(4,INe3,ISt3)-FD211TChiSt(4,INe4,ISt3))*hy(j)+M12*
     &  (FD211TChiSt(1,INe3,ISt3)-FD211TChiSt(1,INe4,ISt3))*hyc(j)))*
     &  MNeu(INe3)*MNeu(INe4)))+CF11FSL(INe3,ISt3)*(M1*
     &  CF11FSLC(INe4,ISt3)*(FD211TChiSt(2,INe3,ISt3)-
     &  FD211TChiSt(2,INe4,ISt3))*(CFF11S1L(INe4,INe3,j)*(hy(i)+hyc(i))
     &  *MNeu(INe3)+CFF11S1L(INe3,INe4,i)*(hy(j)+hyc(j))*MNeu(INe3)+
     &  (CFF11S1R(INe4,INe3,j)*(hy(i)+hyc(i))+CFF11S1R(INe3,INe4,i)*
     &  (hy(j)+hyc(j)))*MNeu(INe4))+CF11FSRC(INe4,ISt3)*
     &  (CFF11S1R(INe4,INe3,j)*(M12*(FD211TChiSt(3,INe3,ISt3)-
     &  FD211TChiSt(3,INe4,ISt3))*hy(i)+(FD211TChiSt(6,INe3,ISt3)-
     &  FD211TChiSt(6,INe4,ISt3))*hyc(i))+CFF11S1R(INe3,INe4,i)*(M12*
     &  (FD211TChiSt(3,INe3,ISt3)-FD211TChiSt(3,INe4,ISt3))*hy(j)+
     &  (FD211TChiSt(6,INe3,ISt3)-FD211TChiSt(6,INe4,ISt3))*hyc(j))+
     &  (CFF11S1L(INe4,INe3,j)*(M12*(FD211TChiSt(1,INe3,ISt3)-
     &  FD211TChiSt(1,INe4,ISt3))*hy(i)+(FD211TChiSt(4,INe3,ISt3)-
     &  FD211TChiSt(4,INe4,ISt3))*hyc(i))+CFF11S1L(INe3,INe4,i)*(M12*
     &  (FD211TChiSt(1,INe3,ISt3)-FD211TChiSt(1,INe4,ISt3))*hy(j)+
     &  (FD211TChiSt(4,INe3,ISt3)-FD211TChiSt(4,INe4,ISt3))*hyc(j)))*
     &  MNeu(INe3)*MNeu(INe4)))))/(8.*(MNeu(INe3)**2-MNeu(INe4)**2))+self(i,j)
              else
       self(i,j)=(-3*(CF11FSR(INe3,ISt3)*(M1*CF11FSRC(INe3,ISt3)*
     &  FD221TChiSt(2,INe3,ISt3)*((CFF11S1L(INe3,INe3,j)+
     &  CFF11S1R(INe3,INe3,j))*(hy(i)+hyc(i))+(CFF11S1L(INe3,INe3,i)+
     &  CFF11S1R(INe3,INe3,i))*(hy(j)+hyc(j)))*MNeu(INe3)+
     &  CF11FSLC(INe3,ISt3)*(CFF11S1L(INe3,INe3,j)*
     &  (FD221TChiSt(7,INe3,ISt3)*hy(i)+M12*FD221TChiSt(5,INe3,ISt3)*
     &  hyc(i))+CFF11S1L(INe3,INe3,i)*(FD221TChiSt(7,INe3,ISt3)*hy(j)+
     &  M12*FD221TChiSt(5,INe3,ISt3)*hyc(j))+(CFF11S1R(INe3,INe3,j)*
     &  (FD221TChiSt(3,INe3,ISt3)*hy(i)+M12*FD221TChiSt(1,INe3,ISt3)*
     &  hyc(i))+CFF11S1R(INe3,INe3,i)*(FD221TChiSt(3,INe3,ISt3)*hy(j)+
     &  M12*FD221TChiSt(1,INe3,ISt3)*hyc(j)))*MNeu2(INe3)))+
     &  CF11FSL(INe3,ISt3)*(M1*CF11FSLC(INe3,ISt3)*
     &  FD221TChiSt(2,INe3,ISt3)*((CFF11S1L(INe3,INe3,j)+
     &  CFF11S1R(INe3,INe3,j))*(hy(i)+hyc(i))+(CFF11S1L(INe3,INe3,i)+
     &  CFF11S1R(INe3,INe3,i))*(hy(j)+hyc(j)))*MNeu(INe3)+
     &  CF11FSRC(INe3,ISt3)*(CFF11S1R(INe3,INe3,j)*(M12*
     &  FD221TChiSt(5,INe3,ISt3)*hy(i)+FD221TChiSt(7,INe3,ISt3)*hyc(i))
     &  +CFF11S1R(INe3,INe3,i)*(M12*FD221TChiSt(5,INe3,ISt3)*hy(j)+
     &  FD221TChiSt(7,INe3,ISt3)*hyc(j))+(CFF11S1L(INe3,INe3,j)*(M12*
     &  FD221TChiSt(1,INe3,ISt3)*hy(i)+FD221TChiSt(3,INe3,ISt3)*hyc(i))
     &  +CFF11S1L(INe3,INe3,i)*(M12*FD221TChiSt(1,INe3,ISt3)*hy(j)+
     &  FD221TChiSt(3,INe3,ISt3)*hyc(j)))*MNeu2(INe3)))))/8.+self(i,j)
              endif
       enddo 
       enddo 
       enddo 

       self(i,j)=(-3*CF12F3S*CF12F3SC*M1*MCha*FD221TChaSB(2)*
     &  ((CFF12S1L(j)+CFF12S1R(j))*(hy(i)+hyc(i))+(CFF12S1L(i)+
     &  CFF12S1R(i))*(hy(j)+hyc(j))))/8.+self(i,j)
c
c topo4
c
       do INH3= ihiggs,6
       do INH4= ihiggs,6
          if( Abs(-Mah(INH3) + Mah(INH4)) .gt. 1D-15) then 
       self(i,j)=(CS1S1S1(j,INH3,INH4)*(MCha*CFF12S1L(i)*
     &  (CFF12S1R(INH3)*(CFF12S1R(INH4)*(-FD211ChaHCha(4,INH3)+
     &  FD211ChaHCha(4,INH4))+CFF12S1L(INH4)*(FD211ChaHCha(2,INH3)-
     &  FD211ChaHCha(2,INH4)-FD211ChaHCha(4,INH3)+FD211ChaHCha(4,INH4))
     &  )+CFF12S1L(INH3)*(MCha**2*CFF12S1L(INH4)*(-FD211ChaHCha(1,INH3)
     &  +FD211ChaHCha(1,INH4))+CFF12S1R(INH4)*(FD211ChaHCha(2,INH3)-
     &  FD211ChaHCha(2,INH4)-FD211ChaHCha(4,INH3)+FD211ChaHCha(4,INH4))
     &  ))+MCha*CFF12S1R(i)*(CFF12S1R(INH3)*(MCha**2*CFF12S1R(INH4)*(-
     &  FD211ChaHCha(1,INH3)+FD211ChaHCha(1,INH4))+CFF12S1L(INH4)*
     &  (FD211ChaHCha(2,INH3)-FD211ChaHCha(2,INH4)-FD211ChaHCha(4,INH3)
     &  +FD211ChaHCha(4,INH4)))+CFF12S1L(INH3)*(CFF12S1L(INH4)*(-
     &  FD211ChaHCha(4,INH3)+FD211ChaHCha(4,INH4))+CFF12S1R(INH4)*
     &  (FD211ChaHCha(2,INH3)-FD211ChaHCha(2,INH4)-FD211ChaHCha(4,INH3)
     &  +FD211ChaHCha(4,INH4))))+3*M1*hy(INH4)*(hy(INH3)*(M1**2*(-
     &  FD211THT(1,INH3)+FD211THT(1,INH4))*hy(i)+(-FD211THT(4,INH3)+
     &  FD211THT(4,INH4))*hyc(i))+(FD211THT(2,INH3)-FD211THT(2,INH4)-
     &  FD211THT(4,INH3)+FD211THT(4,INH4))*(hy(i)+hyc(i))*hyc(INH3))-3*
     &  M1*(-((FD211THT(2,INH3)-FD211THT(2,INH4)-FD211THT(4,INH3)+
     &  FD211THT(4,INH4))*hy(INH3)*(hy(i)+hyc(i)))+((FD211THT(4,INH3)-
     &  FD211THT(4,INH4))*hy(i)+M1**2*(FD211THT(1,INH3)-
     &  FD211THT(1,INH4))*hyc(i))*hyc(INH3))*hyc(INH4)))/(8.*(Mah(INH3)
     &  **2-Mah(INH4)**2))+self(i,j)
              else
          if( Abs(Mah(INH4)) .gt. 1D-15) then 
       self(i,j)=-(CS1S1S1(j,INH3,INH3)*(MCha*CFF12S1L(i)*
     &  (CFF12S1L(INH3)*(MCha**2*CFF12S1L(INH3)*FD221ChaHCha(1,INH3)-2*
     &  CFF12S1R(INH3)*FD221ChaHCha(2,INH3))+CFF12S1R(INH3)*(2*
     &  CFF12S1L(INH3)+CFF12S1R(INH3))*FD221ChaHCha(3,INH3))+MCha*
     &  CFF12S1R(i)*(CFF12S1R(INH3)*(MCha**2*CFF12S1R(INH3)*
     &  FD221ChaHCha(1,INH3)-2*CFF12S1L(INH3)*FD221ChaHCha(2,INH3))+
     &  CFF12S1L(INH3)*(CFF12S1L(INH3)+2*CFF12S1R(INH3))*
     &  FD221ChaHCha(3,INH3))+3*M1*(hy(INH3)**2*(M1**2*FD221THT(1,INH3)
     &  *hy(i)+FD221THT(3,INH3)*hyc(i))+2*(-FD221THT(2,INH3)+
     &  FD221THT(3,INH3))*hy(INH3)*(hy(i)+hyc(i))*hyc(INH3)+
     &  (FD221THT(3,INH3)*hy(i)+M1**2*FD221THT(1,INH3)*hyc(i))*
     &  hyc(INH3)**2)))/8.+self(i,j)
             endif
              endif
       enddo 
       enddo 

       do INe3=ineu,3
       do INe4=ineu,3
       do INe5=ineu,3
       do INH3= ihiggs,6
       do INH4= ihiggs,6
          if( Abs(-MNeu(INe3) + MNeu(INe5)) .gt. 1D-15) then 
          if( Abs(-Mah(INH3) + Mah(INH4)) .gt. 1D-15) then 
       self(i,j)=(CS1S1S1(j,INH3,INH4)*(CFF11S1R(INe3,INe4,INH3)*
     &  (CFF11S1L(INe4,INe5,INH4)*(FD111ChiHChi(2,INe3,INH3,INe4)-
     &  FD111ChiHChi(2,INe3,INH4,INe4)-FD111ChiHChi(2,INe5,INH3,INe4)+
     &  FD111ChiHChi(2,INe5,INH4,INe4)-FD111ChiHChi(4,INe3,INH3,INe4)+
     &  FD111ChiHChi(4,INe3,INH4,INe4)+FD111ChiHChi(4,INe5,INH3,INe4)-
     &  FD111ChiHChi(4,INe5,INH4,INe4))*(CFF11S1R(INe5,INe3,i)*
     &  MNeu(INe3)+CFF11S1L(INe5,INe3,i)*MNeu(INe5))+
     &  CFF11S1R(INe4,INe5,INH4)*MNeu(INe4)*(CFF11S1L(INe5,INe3,i)*(-
     &  FD111ChiHChi(4,INe3,INH3,INe4)+FD111ChiHChi(4,INe3,INH4,INe4)+
     &  FD111ChiHChi(4,INe5,INH3,INe4)-FD111ChiHChi(4,INe5,INH4,INe4))+
     &  CFF11S1R(INe5,INe3,i)*(-FD111ChiHChi(1,INe3,INH3,INe4)+
     &  FD111ChiHChi(1,INe3,INH4,INe4)+FD111ChiHChi(1,INe5,INH3,INe4)-
     &  FD111ChiHChi(1,INe5,INH4,INe4))*MNeu(INe3)*MNeu(INe5)))+
     &  CFF11S1L(INe3,INe4,INH3)*(CFF11S1L(INe5,INe3,i)*MNeu(INe3)*
     &  (CFF11S1R(INe4,INe5,INH4)*(FD111ChiHChi(2,INe3,INH3,INe4)-
     &  FD111ChiHChi(2,INe3,INH4,INe4)-FD111ChiHChi(2,INe5,INH3,INe4)+
     &  FD111ChiHChi(2,INe5,INH4,INe4)-FD111ChiHChi(4,INe3,INH3,INe4)+
     &  FD111ChiHChi(4,INe3,INH4,INe4)+FD111ChiHChi(4,INe5,INH3,INe4)-
     &  FD111ChiHChi(4,INe5,INH4,INe4))+CFF11S1L(INe4,INe5,INH4)*(-
     &  FD111ChiHChi(1,INe3,INH3,INe4)+FD111ChiHChi(1,INe3,INH4,INe4)+
     &  FD111ChiHChi(1,INe5,INH3,INe4)-FD111ChiHChi(1,INe5,INH4,INe4))*
     &  MNeu(INe4)*MNeu(INe5))+CFF11S1R(INe5,INe3,i)*
     &  (CFF11S1R(INe4,INe5,INH4)*(FD111ChiHChi(2,INe3,INH3,INe4)-
     &  FD111ChiHChi(2,INe3,INH4,INe4)-FD111ChiHChi(2,INe5,INH3,INe4)+
     &  FD111ChiHChi(2,INe5,INH4,INe4))*MNeu(INe5)-
     &  (FD111ChiHChi(4,INe3,INH3,INe4)-FD111ChiHChi(4,INe3,INH4,INe4)-
     &  FD111ChiHChi(4,INe5,INH3,INe4)+FD111ChiHChi(4,INe5,INH4,INe4))*
     &  (CFF11S1L(INe4,INe5,INH4)*MNeu(INe4)+CFF11S1R(INe4,INe5,INH4)*
     &  MNeu(INe5))))))/(16.*(Mah(INH3)**2-Mah(INH4)**2)*(MNeu(INe3)**
     &  2-MNeu(INe5)**2))+self(i,j)
              else
          if( Abs(Mah(INH4)) .gt. 1D-15) then 
       self(i,j)=(CS1S1S1(j,INH3,INH3)*(CFF11S1R(INe3,INe4,INH3)*
     &  (CFF11S1L(INe4,INe5,INH3)*(FD211HNeuNeu(2,INH3,INe3,INe4)-
     &  FD211HNeuNeu(2,INH3,INe5,INe4)-FD211HNeuNeu(3,INH3,INe3,INe4)+
     &  FD211HNeuNeu(3,INH3,INe5,INe4))*(CFF11S1R(INe5,INe3,i)*
     &  MNeu(INe3)+CFF11S1L(INe5,INe3,i)*MNeu(INe5))+
     &  CFF11S1R(INe4,INe5,INH3)*MNeu(INe4)*(CFF11S1L(INe5,INe3,i)*(-
     &  FD211HNeuNeu(3,INH3,INe3,INe4)+FD211HNeuNeu(3,INH3,INe5,INe4))+
     &  CFF11S1R(INe5,INe3,i)*(-FD211HNeuNeu(1,INH3,INe3,INe4)+
     &  FD211HNeuNeu(1,INH3,INe5,INe4))*MNeu(INe3)*MNeu(INe5)))+
     &  CFF11S1L(INe3,INe4,INH3)*(CFF11S1L(INe5,INe3,i)*MNeu(INe3)*
     &  (CFF11S1R(INe4,INe5,INH3)*(FD211HNeuNeu(2,INH3,INe3,INe4)-
     &  FD211HNeuNeu(2,INH3,INe5,INe4)-FD211HNeuNeu(3,INH3,INe3,INe4)+
     &  FD211HNeuNeu(3,INH3,INe5,INe4))+CFF11S1L(INe4,INe5,INH3)*(-
     &  FD211HNeuNeu(1,INH3,INe3,INe4)+FD211HNeuNeu(1,INH3,INe5,INe4))*
     &  MNeu(INe4)*MNeu(INe5))+CFF11S1R(INe5,INe3,i)*
     &  (CFF11S1R(INe4,INe5,INH3)*(FD211HNeuNeu(2,INH3,INe3,INe4)-
     &  FD211HNeuNeu(2,INH3,INe5,INe4))*MNeu(INe5)-
     &  (FD211HNeuNeu(3,INH3,INe3,INe4)-FD211HNeuNeu(3,INH3,INe5,INe4))
     &  *(CFF11S1L(INe4,INe5,INH3)*MNeu(INe4)+CFF11S1R(INe4,INe5,INH3)*
     &  MNeu(INe5))))))/(16.*(MNeu(INe3)**2-MNeu(INe5)**2))+self(i,j)
             endif
              endif
             else
          if( Abs(-Mah(INH3) + Mah(INH4)) .gt. 1D-15) then 
       self(i,j)=(CS1S1S1(j,INH3,INH4)*(CFF11S1L(INe3,INe3,i)*
     &  (CFF11S1R(INe4,INe3,INH4)*(CFF11S1L(INe3,INe4,INH3)*
     &  (FD211ChiHChi(2,INe3,INH3,INe4)-FD211ChiHChi(2,INe3,INH4,INe4)-
     &  FD211ChiHChi(4,INe3,INH3,INe4)+FD211ChiHChi(4,INe3,INH4,INe4))*
     &  MNeu(INe3)+CFF11S1R(INe3,INe4,INH3)*(-
     &  FD211ChiHChi(4,INe3,INH3,INe4)+FD211ChiHChi(4,INe3,INH4,INe4))*
     &  MNeu(INe4))+CFF11S1L(INe4,INe3,INH4)*(CFF11S1R(INe3,INe4,INH3)*
     &  (FD211ChiHChi(2,INe3,INH3,INe4)-FD211ChiHChi(2,INe3,INH4,INe4)-
     &  FD211ChiHChi(4,INe3,INH3,INe4)+FD211ChiHChi(4,INe3,INH4,INe4))*
     &  MNeu(INe3)+CFF11S1L(INe3,INe4,INH3)*(-
     &  FD211ChiHChi(1,INe3,INH3,INe4)+FD211ChiHChi(1,INe3,INH4,INe4))*
     &  MNeu(INe4)*MNeu2(INe3)))+CFF11S1R(INe3,INe3,i)*
     &  (CFF11S1L(INe4,INe3,INH4)*(CFF11S1R(INe3,INe4,INH3)*
     &  (FD211ChiHChi(2,INe3,INH3,INe4)-FD211ChiHChi(2,INe3,INH4,INe4)-
     &  FD211ChiHChi(4,INe3,INH3,INe4)+FD211ChiHChi(4,INe3,INH4,INe4))*
     &  MNeu(INe3)+CFF11S1L(INe3,INe4,INH3)*(-
     &  FD211ChiHChi(4,INe3,INH3,INe4)+FD211ChiHChi(4,INe3,INH4,INe4))*
     &  MNeu(INe4))+CFF11S1R(INe4,INe3,INH4)*(CFF11S1L(INe3,INe4,INH3)*
     &  (FD211ChiHChi(2,INe3,INH3,INe4)-FD211ChiHChi(2,INe3,INH4,INe4)-
     &  FD211ChiHChi(4,INe3,INH3,INe4)+FD211ChiHChi(4,INe3,INH4,INe4))*
     &  MNeu(INe3)+CFF11S1R(INe3,INe4,INH3)*(-
     &  FD211ChiHChi(1,INe3,INH3,INe4)+FD211ChiHChi(1,INe3,INH4,INe4))*
     &  MNeu(INe4)*MNeu2(INe3)))))/(16.*(Mah(INH3)**2-Mah(INH4)**2))+self(i,j)
          else 
          if( Abs(Mah(INH3)) .gt. 1D-15) then 
       self(i,j)=(CS1S1S1(j,INH3,INH3)*(CFF11S1L(INe3,INe3,i)*
     &  (CFF11S1R(INe4,INe3,INH3)*(CFF11S1L(INe3,INe4,INH3)*
     &  (FD221ChiHChi(2,INe3,INH3,INe4)-FD221ChiHChi(3,INe3,INH3,INe4))
     &  *MNeu(INe3)-CFF11S1R(INe3,INe4,INH3)*
     &  FD221ChiHChi(3,INe3,INH3,INe4)*MNeu(INe4))+
     &  CFF11S1L(INe4,INe3,INH3)*(CFF11S1R(INe3,INe4,INH3)*
     &  (FD221ChiHChi(2,INe3,INH3,INe4)-FD221ChiHChi(3,INe3,INH3,INe4))
     &  *MNeu(INe3)-CFF11S1L(INe3,INe4,INH3)*
     &  FD221ChiHChi(1,INe3,INH3,INe4)*MNeu(INe4)*MNeu2(INe3)))+
     &  CFF11S1R(INe3,INe3,i)*(CFF11S1L(INe4,INe3,INH3)*
     &  (CFF11S1R(INe3,INe4,INH3)*(FD221ChiHChi(2,INe3,INH3,INe4)-
     &  FD221ChiHChi(3,INe3,INH3,INe4))*MNeu(INe3)-
     &  CFF11S1L(INe3,INe4,INH3)*FD221ChiHChi(3,INe3,INH3,INe4)*
     &  MNeu(INe4))+CFF11S1R(INe4,INe3,INH3)*(CFF11S1L(INe3,INe4,INH3)*
     &  (FD221ChiHChi(2,INe3,INH3,INe4)-FD221ChiHChi(3,INe3,INH3,INe4))
     &  *MNeu(INe3)-CFF11S1R(INe3,INe4,INH3)*
     &  FD221ChiHChi(1,INe3,INH3,INe4)*MNeu(INe4)*MNeu2(INe3)))))/16.+self(i,j)
             endif
          endif 
              endif
       enddo 
       enddo 
       enddo 
       enddo 
       enddo 
       do ICH3=1,2
       do ICH4=1,2
          if( Abs(-MassHpm(ICH3) + MassHpm(ICH4)) .gt. 1D-15) then 
       self(i,j)=(3*M1*CS1S3S3(j,ICH4,ICH3)*CTBS3(ICH3)*CTBS3C(ICH4)*
     &  (FD211THpB(2,ICH3)-FD211THpB(2,ICH4)-FD211THpB(4,ICH3)+
     &  FD211THpB(4,ICH4))*(hy(i)+hyc(i)))/(8.*(MassHpm(ICH3)**2-
     &  MassHpm(ICH4)**2))+self(i,j)
              else
          if( Abs(MassHpm(ICH4)) .gt. 1D-15) then 
       self(i,j)=(3*M1*CS1S3S3(j,ICH3,ICH3)*CTBS3(ICH3)*CTBS3C(ICH3)*
     &  (FD221THpB(2,ICH3)-FD221THpB(3,ICH3))*(hy(i)+hyc(i)))/8.+
     &  self(i,j)
             endif
              endif
       enddo 
       enddo 
       do ICH3=1,2
       do ICH4=1,2
       do INe3=ineu,3
       do INe4=ineu,3
          if( Abs(-MNeu(INe3) + MNeu(INe4)) .gt. 1D-15) then 
          if( Abs(-MassHpm(ICH3) + MassHpm(ICH4)) .gt. 1D-15) then 
       self(i,j)=(CS1S3S3(j,ICH4,ICH3)*(CF11F12S3R(INe4,ICH4)*
     &  (CFF11S1L(INe4,INe3,i)*(DCONJG(CF11F12S3R(INe3,ICH3))*
     &  (FD111ChiHpCha(2,INe3,ICH3)-FD111ChiHpCha(2,INe3,ICH4)-
     &  FD111ChiHpCha(2,INe4,ICH3)+FD111ChiHpCha(2,INe4,ICH4))*
     &  MNeu(INe3)-(FD111ChiHpCha(4,INe3,ICH3)-
     &  FD111ChiHpCha(4,INe3,ICH4)-FD111ChiHpCha(4,INe4,ICH3)+
     &  FD111ChiHpCha(4,INe4,ICH4))*(MCha*DCONJG(CF11F12S3L(INe3,ICH3))
     &  +DCONJG(CF11F12S3R(INe3,ICH3))*MNeu(INe3)))+
     &  CFF11S1R(INe4,INe3,i)*(DCONJG(CF11F12S3R(INe3,ICH3))*
     &  (FD111ChiHpCha(2,INe3,ICH3)-FD111ChiHpCha(2,INe3,ICH4)-
     &  FD111ChiHpCha(2,INe4,ICH3)+FD111ChiHpCha(2,INe4,ICH4)-
     &  FD111ChiHpCha(4,INe3,ICH3)+FD111ChiHpCha(4,INe3,ICH4)+
     &  FD111ChiHpCha(4,INe4,ICH3)-FD111ChiHpCha(4,INe4,ICH4))+MCha*
     &  DCONJG(CF11F12S3L(INe3,ICH3))*(-FD111ChiHpCha(1,INe3,ICH3)+
     &  FD111ChiHpCha(1,INe3,ICH4)+FD111ChiHpCha(1,INe4,ICH3)-
     &  FD111ChiHpCha(1,INe4,ICH4))*MNeu(INe3))*MNeu(INe4))+
     &  CF11F12S3L(INe4,ICH4)*(CFF11S1R(INe4,INe3,i)*
     &  (DCONJG(CF11F12S3L(INe3,ICH3))*(FD111ChiHpCha(2,INe3,ICH3)-
     &  FD111ChiHpCha(2,INe3,ICH4)-FD111ChiHpCha(2,INe4,ICH3)+
     &  FD111ChiHpCha(2,INe4,ICH4))*MNeu(INe3)-
     &  (FD111ChiHpCha(4,INe3,ICH3)-FD111ChiHpCha(4,INe3,ICH4)-
     &  FD111ChiHpCha(4,INe4,ICH3)+FD111ChiHpCha(4,INe4,ICH4))*(MCha*
     &  DCONJG(CF11F12S3R(INe3,ICH3))+DCONJG(CF11F12S3L(INe3,ICH3))*
     &  MNeu(INe3)))+CFF11S1L(INe4,INe3,i)*
     &  (DCONJG(CF11F12S3L(INe3,ICH3))*(FD111ChiHpCha(2,INe3,ICH3)-
     &  FD111ChiHpCha(2,INe3,ICH4)-FD111ChiHpCha(2,INe4,ICH3)+
     &  FD111ChiHpCha(2,INe4,ICH4)-FD111ChiHpCha(4,INe3,ICH3)+
     &  FD111ChiHpCha(4,INe3,ICH4)+FD111ChiHpCha(4,INe4,ICH3)-
     &  FD111ChiHpCha(4,INe4,ICH4))+MCha*DCONJG(CF11F12S3R(INe3,ICH3))*
     &  (-FD111ChiHpCha(1,INe3,ICH3)+FD111ChiHpCha(1,INe3,ICH4)+
     &  FD111ChiHpCha(1,INe4,ICH3)-FD111ChiHpCha(1,INe4,ICH4))*
     &  MNeu(INe3))*MNeu(INe4))))/(8.*(MassHpm(ICH3)**2-MassHpm(ICH4)**
     &  2)*(MNeu(INe3)**2-MNeu(INe4)**2))+self(i,j)
              else
          if( Abs(MassHpm(ICH4)) .gt. 1D-15) then 
       self(i,j)=(CS1S3S3(j,ICH3,ICH3)*(CF11F12S3R(INe4,ICH3)*
     &  (CFF11S1L(INe4,INe3,i)*(MCha*DCONJG(CF11F12S3L(INe3,ICH3))*(-
     &  FD211HpChiCha(3,ICH3,INe3)+FD211HpChiCha(3,ICH3,INe4))+
     &  DCONJG(CF11F12S3R(INe3,ICH3))*(FD211HpChiCha(2,ICH3,INe3)-
     &  FD211HpChiCha(2,ICH3,INe4)-FD211HpChiCha(3,ICH3,INe3)+
     &  FD211HpChiCha(3,ICH3,INe4))*MNeu(INe3))+CFF11S1R(INe4,INe3,i)*
     &  (DCONJG(CF11F12S3R(INe3,ICH3))*(FD211HpChiCha(2,ICH3,INe3)-
     &  FD211HpChiCha(2,ICH3,INe4)-FD211HpChiCha(3,ICH3,INe3)+
     &  FD211HpChiCha(3,ICH3,INe4))+MCha*DCONJG(CF11F12S3L(INe3,ICH3))*
     &  (-FD211HpChiCha(1,ICH3,INe3)+FD211HpChiCha(1,ICH3,INe4))*
     &  MNeu(INe3))*MNeu(INe4))+CF11F12S3L(INe4,ICH3)*
     &  (CFF11S1R(INe4,INe3,i)*(MCha*DCONJG(CF11F12S3R(INe3,ICH3))*(-
     &  FD211HpChiCha(3,ICH3,INe3)+FD211HpChiCha(3,ICH3,INe4))+
     &  DCONJG(CF11F12S3L(INe3,ICH3))*(FD211HpChiCha(2,ICH3,INe3)-
     &  FD211HpChiCha(2,ICH3,INe4)-FD211HpChiCha(3,ICH3,INe3)+
     &  FD211HpChiCha(3,ICH3,INe4))*MNeu(INe3))+CFF11S1L(INe4,INe3,i)*
     &  (DCONJG(CF11F12S3L(INe3,ICH3))*(FD211HpChiCha(2,ICH3,INe3)-
     &  FD211HpChiCha(2,ICH3,INe4)-FD211HpChiCha(3,ICH3,INe3)+
     &  FD211HpChiCha(3,ICH3,INe4))+MCha*DCONJG(CF11F12S3R(INe3,ICH3))*
     &  (-FD211HpChiCha(1,ICH3,INe3)+FD211HpChiCha(1,ICH3,INe4))*
     &  MNeu(INe3))*MNeu(INe4))))/(8.*(MNeu(INe3)**2-MNeu(INe4)**2))+
     &  self(i,j)
             endif
              endif
             else
          if( Abs(-MassHpm(ICH3) + MassHpm(ICH4)) .gt. 1D-15) then 
       self(i,j)=(CS1S3S3(j,ICH4,ICH3)*(CF11F12S3R(INe3,ICH4)*
     &  (CFF11S1L(INe3,INe3,i)*(MCha*DCONJG(CF11F12S3L(INe3,ICH3))*(-
     &  FD211ChiHpCha(4,INe3,ICH3)+FD211ChiHpCha(4,INe3,ICH4))+
     &  DCONJG(CF11F12S3R(INe3,ICH3))*(FD211ChiHpCha(2,INe3,ICH3)-
     &  FD211ChiHpCha(2,INe3,ICH4)-FD211ChiHpCha(4,INe3,ICH3)+
     &  FD211ChiHpCha(4,INe3,ICH4))*MNeu(INe3))+CFF11S1R(INe3,INe3,i)*
     &  (DCONJG(CF11F12S3R(INe3,ICH3))*(FD211ChiHpCha(2,INe3,ICH3)-
     &  FD211ChiHpCha(2,INe3,ICH4)-FD211ChiHpCha(4,INe3,ICH3)+
     &  FD211ChiHpCha(4,INe3,ICH4))*MNeu(INe3)+MCha*
     &  DCONJG(CF11F12S3L(INe3,ICH3))*(-FD211ChiHpCha(1,INe3,ICH3)+
     &  FD211ChiHpCha(1,INe3,ICH4))*MNeu2(INe3)))+CF11F12S3L(INe3,ICH4)
     &  *(CFF11S1R(INe3,INe3,i)*(MCha*DCONJG(CF11F12S3R(INe3,ICH3))*(-
     &  FD211ChiHpCha(4,INe3,ICH3)+FD211ChiHpCha(4,INe3,ICH4))+
     &  DCONJG(CF11F12S3L(INe3,ICH3))*(FD211ChiHpCha(2,INe3,ICH3)-
     &  FD211ChiHpCha(2,INe3,ICH4)-FD211ChiHpCha(4,INe3,ICH3)+
     &  FD211ChiHpCha(4,INe3,ICH4))*MNeu(INe3))+CFF11S1L(INe3,INe3,i)*
     &  (DCONJG(CF11F12S3L(INe3,ICH3))*(FD211ChiHpCha(2,INe3,ICH3)-
     &  FD211ChiHpCha(2,INe3,ICH4)-FD211ChiHpCha(4,INe3,ICH3)+
     &  FD211ChiHpCha(4,INe3,ICH4))*MNeu(INe3)+MCha*
     &  DCONJG(CF11F12S3R(INe3,ICH3))*(-FD211ChiHpCha(1,INe3,ICH3)+
     &  FD211ChiHpCha(1,INe3,ICH4))*MNeu2(INe3)))))/(8.*(MassHpm(ICH3)*
     &  *2-MassHpm(ICH4)**2))+self(i,j)
          else 
          if( Abs(MassHpm(ICH4)) .gt. 1D-15) then 
       self(i,j)=-(CS1S3S3(j,ICH3,ICH3)*(CF11F12S3R(INe3,ICH3)*
     &  (CFF11S1L(INe3,INe3,i)*(MCha*DCONJG(CF11F12S3L(INe3,ICH3))*
     &  FD221ChiHpCha(3,INe3,ICH3)+DCONJG(CF11F12S3R(INe3,ICH3))*(-
     &  FD221ChiHpCha(2,INe3,ICH3)+FD221ChiHpCha(3,INe3,ICH3))*
     &  MNeu(INe3))+CFF11S1R(INe3,INe3,i)*(DCONJG(CF11F12S3R(INe3,ICH3)
     &  )*(-FD221ChiHpCha(2,INe3,ICH3)+FD221ChiHpCha(3,INe3,ICH3))*
     &  MNeu(INe3)+MCha*DCONJG(CF11F12S3L(INe3,ICH3))*
     &  FD221ChiHpCha(1,INe3,ICH3)*MNeu2(INe3)))+CF11F12S3L(INe3,ICH3)*
     &  (CFF11S1R(INe3,INe3,i)*(MCha*DCONJG(CF11F12S3R(INe3,ICH3))*
     &  FD221ChiHpCha(3,INe3,ICH3)+DCONJG(CF11F12S3L(INe3,ICH3))*(-
     &  FD221ChiHpCha(2,INe3,ICH3)+FD221ChiHpCha(3,INe3,ICH3))*
     &  MNeu(INe3))+CFF11S1L(INe3,INe3,i)*(DCONJG(CF11F12S3L(INe3,ICH3)
     &  )*(-FD221ChiHpCha(2,INe3,ICH3)+FD221ChiHpCha(3,INe3,ICH3))*
     &  MNeu(INe3)+MCha*DCONJG(CF11F12S3R(INe3,ICH3))*
     &  FD221ChiHpCha(1,INe3,ICH3)*MNeu2(INe3)))))/8.+self(i,j)
             endif
          endif 
              endif
       enddo 
       enddo 
       enddo 
       enddo 
       do ICH3=1,2
       do ICH4=1,2
       do INe3=ineu,3
          if( Abs(-MassHpm(ICH3) + MassHpm(ICH4)) .gt. 1D-15) then 
       self(i,j)=(CS1S3S3(j,ICH3,ICH4)*(MCha*(CFF12S1L(i)+CFF12S1R(i))*
     &  (CF11F12S3L(INe3,ICH3)*DCONJG(CF11F12S3L(INe3,ICH4))+
     &  CF11F12S3R(INe3,ICH3)*DCONJG(CF11F12S3R(INe3,ICH4)))*
     &  (FD211ChaHpChi(2,ICH3,INe3)-FD211ChaHpChi(2,ICH4,INe3)-
     &  FD211ChaHpChi(4,ICH3,INe3)+FD211ChaHpChi(4,ICH4,INe3))+
     &  (CF11F12S3R(INe3,ICH3)*DCONJG(CF11F12S3L(INe3,ICH4))*(MCha2*
     &  CFF12S1R(i)*(-FD211ChaHpChi(1,ICH3,INe3)+
     &  FD211ChaHpChi(1,ICH4,INe3))+CFF12S1L(i)*(-
     &  FD211ChaHpChi(4,ICH3,INe3)+FD211ChaHpChi(4,ICH4,INe3)))+
     &  CF11F12S3L(INe3,ICH3)*DCONJG(CF11F12S3R(INe3,ICH4))*(MCha2*
     &  CFF12S1L(i)*(-FD211ChaHpChi(1,ICH3,INe3)+
     &  FD211ChaHpChi(1,ICH4,INe3))+CFF12S1R(i)*(-
     &  FD211ChaHpChi(4,ICH3,INe3)+FD211ChaHpChi(4,ICH4,INe3))))*
     &  MNeu(INe3)))/(8.*(MassHpm(ICH3)**2-MassHpm(ICH4)**2))+self(i,j)
              else
          if( Abs(MassHpm(ICH4)) .gt. 1D-15) then 
       self(i,j)=(CS1S3S3(j,ICH3,ICH3)*(MCha*(CFF12S1L(i)+CFF12S1R(i))*
     &  (CF11F12S3L(INe3,ICH3)*DCONJG(CF11F12S3L(INe3,ICH3))+
     &  CF11F12S3R(INe3,ICH3)*DCONJG(CF11F12S3R(INe3,ICH3)))*
     &  (FD221ChaHpChi(2,ICH3,INe3)-FD221ChaHpChi(3,ICH3,INe3))-
     &  (CF11F12S3R(INe3,ICH3)*DCONJG(CF11F12S3L(INe3,ICH3))*(MCha2*
     &  CFF12S1R(i)*FD221ChaHpChi(1,ICH3,INe3)+CFF12S1L(i)*
     &  FD221ChaHpChi(3,ICH3,INe3))+CF11F12S3L(INe3,ICH3)*
     &  DCONJG(CF11F12S3R(INe3,ICH3))*(MCha2*CFF12S1L(i)*
     &  FD221ChaHpChi(1,ICH3,INe3)+CFF12S1R(i)*
     &  FD221ChaHpChi(3,ICH3,INe3)))*MNeu(INe3)))/8.+self(i,j)
             endif
              endif
       enddo 
       enddo 
       enddo 
       do INe3=ineu,3
       do INe4=ineu,3
       do ISt3=1,2
       do ISt4=1,2
          if( Abs(-MNeu(INe3) + MNeu(INe4)) .gt. 1D-15) then 
          if( Abs(-MassSu(ISt3) + MassSu(ISt4)) .gt. 1D-15) then 
       self(i,j)=(-3*CSSS(j,ISt4,ISt3)*(CF11FSRC(INe3,ISt3)*(-
     &  (CF11FSR(INe4,ISt4)*(FD111ChiStT(2,INe3,ISt3)-
     &  FD111ChiStT(2,INe3,ISt4)-FD111ChiStT(2,INe4,ISt3)+
     &  FD111ChiStT(2,INe4,ISt4)-FD111ChiStT(4,INe3,ISt3)+
     &  FD111ChiStT(4,INe3,ISt4)+FD111ChiStT(4,INe4,ISt3)-
     &  FD111ChiStT(4,INe4,ISt4))*(CFF11S1L(INe4,INe3,i)*MNeu(INe3)+
     &  CFF11S1R(INe4,INe3,i)*MNeu(INe4)))+M1*CF11FSL(INe4,ISt4)*
     &  (CFF11S1R(INe4,INe3,i)*(FD111ChiStT(4,INe3,ISt3)-
     &  FD111ChiStT(4,INe3,ISt4)-FD111ChiStT(4,INe4,ISt3)+
     &  FD111ChiStT(4,INe4,ISt4))+CFF11S1L(INe4,INe3,i)*
     &  (FD111ChiStT(1,INe3,ISt3)-FD111ChiStT(1,INe3,ISt4)-
     &  FD111ChiStT(1,INe4,ISt3)+FD111ChiStT(1,INe4,ISt4))*MNeu(INe3)*
     &  MNeu(INe4)))+CF11FSLC(INe3,ISt3)*(-(CF11FSL(INe4,ISt4)*
     &  (FD111ChiStT(2,INe3,ISt3)-FD111ChiStT(2,INe3,ISt4)-
     &  FD111ChiStT(2,INe4,ISt3)+FD111ChiStT(2,INe4,ISt4)-
     &  FD111ChiStT(4,INe3,ISt3)+FD111ChiStT(4,INe3,ISt4)+
     &  FD111ChiStT(4,INe4,ISt3)-FD111ChiStT(4,INe4,ISt4))*
     &  (CFF11S1R(INe4,INe3,i)*MNeu(INe3)+CFF11S1L(INe4,INe3,i)*
     &  MNeu(INe4)))+M1*CF11FSR(INe4,ISt4)*(CFF11S1L(INe4,INe3,i)*
     &  (FD111ChiStT(4,INe3,ISt3)-FD111ChiStT(4,INe3,ISt4)-
     &  FD111ChiStT(4,INe4,ISt3)+FD111ChiStT(4,INe4,ISt4))+
     &  CFF11S1R(INe4,INe3,i)*(FD111ChiStT(1,INe3,ISt3)-
     &  FD111ChiStT(1,INe3,ISt4)-FD111ChiStT(1,INe4,ISt3)+
     &  FD111ChiStT(1,INe4,ISt4))*MNeu(INe3)*MNeu(INe4)))))/(8.*
     &  (MassSu(ISt3)**2-MassSu(ISt4)**2)*(MNeu(INe3)**2-MNeu(INe4)**2))+self(i,j)
              else
       self(i,j)=(-3*CSSS(j,ISt3,ISt3)*(CF11FSRC(INe3,ISt3)*(-
     &  (CF11FSR(INe4,ISt3)*(FD211StChiT(2,ISt3,INe3)-
     &  FD211StChiT(2,ISt3,INe4)-FD211StChiT(3,ISt3,INe3)+
     &  FD211StChiT(3,ISt3,INe4))*(CFF11S1L(INe4,INe3,i)*MNeu(INe3)+
     &  CFF11S1R(INe4,INe3,i)*MNeu(INe4)))+M1*CF11FSL(INe4,ISt3)*
     &  (CFF11S1R(INe4,INe3,i)*(FD211StChiT(3,ISt3,INe3)-
     &  FD211StChiT(3,ISt3,INe4))+CFF11S1L(INe4,INe3,i)*
     &  (FD211StChiT(1,ISt3,INe3)-FD211StChiT(1,ISt3,INe4))*MNeu(INe3)*
     &  MNeu(INe4)))+CF11FSLC(INe3,ISt3)*(-(CF11FSL(INe4,ISt3)*
     &  (FD211StChiT(2,ISt3,INe3)-FD211StChiT(2,ISt3,INe4)-
     &  FD211StChiT(3,ISt3,INe3)+FD211StChiT(3,ISt3,INe4))*
     &  (CFF11S1R(INe4,INe3,i)*MNeu(INe3)+CFF11S1L(INe4,INe3,i)*
     &  MNeu(INe4)))+M1*CF11FSR(INe4,ISt3)*(CFF11S1L(INe4,INe3,i)*
     &  (FD211StChiT(3,ISt3,INe3)-FD211StChiT(3,ISt3,INe4))+
     &  CFF11S1R(INe4,INe3,i)*(FD211StChiT(1,ISt3,INe3)-
     &  FD211StChiT(1,ISt3,INe4))*MNeu(INe3)*MNeu(INe4)))))/(8.*
     &  (MNeu(INe3)**2-MNeu(INe4)**2))+self(i,j)
              endif
             else
          if( Abs(-MassSu(ISt3) + MassSu(ISt4)) .gt. 1D-15) then 
       self(i,j)=(-3*CSSS(j,ISt4,ISt3)*(CF11FSRC(INe3,ISt3)*(-
     &  (CF11FSR(INe3,ISt4)*(CFF11S1L(INe3,INe3,i)+
     &  CFF11S1R(INe3,INe3,i))*(FD211ChiSTT(2,INe3,ISt3)-
     &  FD211ChiSTT(2,INe3,ISt4)-FD211ChiSTT(4,INe3,ISt3)+
     &  FD211ChiSTT(4,INe3,ISt4))*MNeu(INe3))+M1*CF11FSL(INe3,ISt4)*
     &  (CFF11S1R(INe3,INe3,i)*(FD211ChiSTT(4,INe3,ISt3)-
     &  FD211ChiSTT(4,INe3,ISt4))+CFF11S1L(INe3,INe3,i)*
     &  (FD211ChiSTT(1,INe3,ISt3)-FD211ChiSTT(1,INe3,ISt4))*MNeu2(INe3)
     &  ))+CF11FSLC(INe3,ISt3)*(-(CF11FSL(INe3,ISt4)*
     &  (CFF11S1L(INe3,INe3,i)+CFF11S1R(INe3,INe3,i))*
     &  (FD211ChiSTT(2,INe3,ISt3)-FD211ChiSTT(2,INe3,ISt4)-
     &  FD211ChiSTT(4,INe3,ISt3)+FD211ChiSTT(4,INe3,ISt4))*MNeu(INe3))+
     &  M1*CF11FSR(INe3,ISt4)*(CFF11S1L(INe3,INe3,i)*
     &  (FD211ChiSTT(4,INe3,ISt3)-FD211ChiSTT(4,INe3,ISt4))+
     &  CFF11S1R(INe3,INe3,i)*(FD211ChiSTT(1,INe3,ISt3)-
     &  FD211ChiSTT(1,INe3,ISt4))*MNeu2(INe3)))))/(8.*(MassSu(ISt3)**2-
     &  MassSu(ISt4)**2))+self(i,j)
          else 
       self(i,j)=(-3*CSSS(j,ISt3,ISt3)*(CF11FSRC(INe3,ISt3)*(-
     &  (CF11FSR(INe3,ISt3)*(CFF11S1L(INe3,INe3,i)+
     &  CFF11S1R(INe3,INe3,i))*(FD221ChiStT(2,INe3,ISt3)-
     &  FD221ChiStT(3,INe3,ISt3))*MNeu(INe3))+M1*CF11FSL(INe3,ISt3)*
     &  (CFF11S1R(INe3,INe3,i)*FD221ChiStT(3,INe3,ISt3)+
     &  CFF11S1L(INe3,INe3,i)*FD221ChiStT(1,INe3,ISt3)*MNeu2(INe3)))+
     &  CF11FSLC(INe3,ISt3)*(-(CF11FSL(INe3,ISt3)*
     &  (CFF11S1L(INe3,INe3,i)+CFF11S1R(INe3,INe3,i))*
     &  (FD221ChiStT(2,INe3,ISt3)-FD221ChiStT(3,INe3,ISt3))*MNeu(INe3))
     &  +M1*CF11FSR(INe3,ISt3)*(CFF11S1L(INe3,INe3,i)*
     &  FD221ChiStT(3,INe3,ISt3)+CFF11S1R(INe3,INe3,i)*
     &  FD221ChiStT(1,INe3,ISt3)*MNeu2(INe3)))))/8.+self(i,j)
          endif 
              endif
       enddo 
       enddo 
       enddo 
       enddo 
       do ISt3=1,2
       do ISt4=1,2
          if( Abs(-MassSu(ISt3) + MassSu(ISt4)) .gt. 1D-15) then 
       self(i,j)=(3*MCha*CF12F4S(ISt4)*CF12F4SC(ISt3)*(CFF12S1L(i)+
     &  CFF12S1R(i))*CSSS(j,ISt4,ISt3)*(FD211ChaStB(2,ISt3)-
     &  FD211ChaStB(2,ISt4)-FD211ChaStB(4,ISt3)+FD211ChaStB(4,ISt4)))
     &  /(8.*(MassSu(ISt3)**2-MassSu(ISt4)**2))+self(i,j)
              else
       self(i,j)=(3*MCha*CF12F4S(ISt3)*CF12F4SC(ISt3)*(CFF12S1L(i)+
     &  CFF12S1R(i))*CSSS(j,ISt3,ISt3)*(FD221ChaStSb(2,ISt3)-
     &  FD221ChaStSb(3,ISt3)))/8.+self(i,j)
              endif
       enddo 
       enddo 
c
c topo5
c
       do INH3= ihiggs,6
       do INH4= ihiggs,6

          if( Abs(-Mah(INH3) + Mah(INH4)) .gt. 1D-15) then 
       self(i,j)=(CS1S1S1(i,INH3,INH4)*(MCha*CFF12S1L(j)*
     &  (CFF12S1R(INH3)*(CFF12S1R(INH4)*(-FD211ChaHCha(4,INH3)+
     &  FD211ChaHCha(4,INH4))+CFF12S1L(INH4)*(FD211ChaHCha(2,INH3)-
     &  FD211ChaHCha(2,INH4)-FD211ChaHCha(4,INH3)+FD211ChaHCha(4,INH4))
     &  )+CFF12S1L(INH3)*(MCha**2*CFF12S1L(INH4)*(-FD211ChaHCha(1,INH3)
     &  +FD211ChaHCha(1,INH4))+CFF12S1R(INH4)*(FD211ChaHCha(2,INH3)-
     &  FD211ChaHCha(2,INH4)-FD211ChaHCha(4,INH3)+FD211ChaHCha(4,INH4))
     &  ))+MCha*CFF12S1R(j)*(CFF12S1R(INH3)*(MCha**2*CFF12S1R(INH4)*(-
     &  FD211ChaHCha(1,INH3)+FD211ChaHCha(1,INH4))+CFF12S1L(INH4)*
     &  (FD211ChaHCha(2,INH3)-FD211ChaHCha(2,INH4)-FD211ChaHCha(4,INH3)
     &  +FD211ChaHCha(4,INH4)))+CFF12S1L(INH3)*(CFF12S1L(INH4)*(-
     &  FD211ChaHCha(4,INH3)+FD211ChaHCha(4,INH4))+CFF12S1R(INH4)*
     &  (FD211ChaHCha(2,INH3)-FD211ChaHCha(2,INH4)-FD211ChaHCha(4,INH3)
     &  +FD211ChaHCha(4,INH4))))+3*M1*hy(INH4)*(hy(INH3)*(M1**2*(-
     &  FD211THT(1,INH3)+FD211THT(1,INH4))*hy(j)+(-FD211THT(4,INH3)+
     &  FD211THT(4,INH4))*hyc(j))+(FD211THT(2,INH3)-FD211THT(2,INH4)-
     &  FD211THT(4,INH3)+FD211THT(4,INH4))*(hy(j)+hyc(j))*hyc(INH3))-3*
     &  M1*(-((FD211THT(2,INH3)-FD211THT(2,INH4)-FD211THT(4,INH3)+
     &  FD211THT(4,INH4))*hy(INH3)*(hy(j)+hyc(j)))+((FD211THT(4,INH3)-
     &  FD211THT(4,INH4))*hy(j)+M1**2*(FD211THT(1,INH3)-
     &  FD211THT(1,INH4))*hyc(j))*hyc(INH3))*hyc(INH4)))/(8.*(Mah(INH3)
     &  **2-Mah(INH4)**2))+self(i,j)
              else
          if( Abs(Mah(INH4)) .gt. 1D-15) then 
       self(i,j)=-(CS1S1S1(i,INH3,INH3)*(MCha*CFF12S1L(j)*
     &  (CFF12S1L(INH3)*(MCha**2*CFF12S1L(INH3)*FD221ChaHCha(1,INH3)-2*
     &  CFF12S1R(INH3)*FD221ChaHCha(2,INH3))+CFF12S1R(INH3)*(2*
     &  CFF12S1L(INH3)+CFF12S1R(INH3))*FD221ChaHCha(3,INH3))+MCha*
     &  CFF12S1R(j)*(CFF12S1R(INH3)*(MCha**2*CFF12S1R(INH3)*
     &  FD221ChaHCha(1,INH3)-2*CFF12S1L(INH3)*FD221ChaHCha(2,INH3))+
     &  CFF12S1L(INH3)*(CFF12S1L(INH3)+2*CFF12S1R(INH3))*
     &  FD221ChaHCha(3,INH3))+3*M1*(hy(INH3)**2*(M1**2*FD221THT(1,INH3)
     &  *hy(j)+FD221THT(3,INH3)*hyc(j))+2*(-FD221THT(2,INH3)+
     &  FD221THT(3,INH3))*hy(INH3)*(hy(j)+hyc(j))*hyc(INH3)+
     &  (FD221THT(3,INH3)*hy(j)+M1**2*FD221THT(1,INH3)*hyc(j))*
     &  hyc(INH3)**2)))/8.+self(i,j)
             endif
              endif
       enddo 
       enddo 

       do INe3=ineu,3
       do INe4=ineu,3
       do INe5=ineu,3
       do INH3= ihiggs,6
       do INH4= ihiggs,6
          if( Abs(-MNeu(INe3) + MNeu(INe5)) .gt. 1D-15) then 
          if( Abs(-Mah(INH3) + Mah(INH4)) .gt. 1D-15) then 
       self(i,j)=(CS1S1S1(i,INH3,INH4)*(CFF11S1R(INe3,INe4,INH3)*
     &  (CFF11S1L(INe4,INe5,INH4)*(FD111ChiHChi(2,INe3,INH3,INe4)-
     &  FD111ChiHChi(2,INe3,INH4,INe4)-FD111ChiHChi(2,INe5,INH3,INe4)+
     &  FD111ChiHChi(2,INe5,INH4,INe4)-FD111ChiHChi(4,INe3,INH3,INe4)+
     &  FD111ChiHChi(4,INe3,INH4,INe4)+FD111ChiHChi(4,INe5,INH3,INe4)-
     &  FD111ChiHChi(4,INe5,INH4,INe4))*(CFF11S1R(INe5,INe3,j)*
     &  MNeu(INe3)+CFF11S1L(INe5,INe3,j)*MNeu(INe5))+
     &  CFF11S1R(INe4,INe5,INH4)*MNeu(INe4)*(CFF11S1L(INe5,INe3,j)*(-
     &  FD111ChiHChi(4,INe3,INH3,INe4)+FD111ChiHChi(4,INe3,INH4,INe4)+
     &  FD111ChiHChi(4,INe5,INH3,INe4)-FD111ChiHChi(4,INe5,INH4,INe4))+
     &  CFF11S1R(INe5,INe3,j)*(-FD111ChiHChi(1,INe3,INH3,INe4)+
     &  FD111ChiHChi(1,INe3,INH4,INe4)+FD111ChiHChi(1,INe5,INH3,INe4)-
     &  FD111ChiHChi(1,INe5,INH4,INe4))*MNeu(INe3)*MNeu(INe5)))+
     &  CFF11S1L(INe3,INe4,INH3)*(CFF11S1L(INe5,INe3,j)*MNeu(INe3)*
     &  (CFF11S1R(INe4,INe5,INH4)*(FD111ChiHChi(2,INe3,INH3,INe4)-
     &  FD111ChiHChi(2,INe3,INH4,INe4)-FD111ChiHChi(2,INe5,INH3,INe4)+
     &  FD111ChiHChi(2,INe5,INH4,INe4)-FD111ChiHChi(4,INe3,INH3,INe4)+
     &  FD111ChiHChi(4,INe3,INH4,INe4)+FD111ChiHChi(4,INe5,INH3,INe4)-
     &  FD111ChiHChi(4,INe5,INH4,INe4))+CFF11S1L(INe4,INe5,INH4)*(-
     &  FD111ChiHChi(1,INe3,INH3,INe4)+FD111ChiHChi(1,INe3,INH4,INe4)+
     &  FD111ChiHChi(1,INe5,INH3,INe4)-FD111ChiHChi(1,INe5,INH4,INe4))*
     &  MNeu(INe4)*MNeu(INe5))+CFF11S1R(INe5,INe3,j)*
     &  (CFF11S1R(INe4,INe5,INH4)*(FD111ChiHChi(2,INe3,INH3,INe4)-
     &  FD111ChiHChi(2,INe3,INH4,INe4)-FD111ChiHChi(2,INe5,INH3,INe4)+
     &  FD111ChiHChi(2,INe5,INH4,INe4))*MNeu(INe5)-
     &  (FD111ChiHChi(4,INe3,INH3,INe4)-FD111ChiHChi(4,INe3,INH4,INe4)-
     &  FD111ChiHChi(4,INe5,INH3,INe4)+FD111ChiHChi(4,INe5,INH4,INe4))*
     &  (CFF11S1L(INe4,INe5,INH4)*MNeu(INe4)+CFF11S1R(INe4,INe5,INH4)*
     &  MNeu(INe5))))))/(16.*(Mah(INH3)**2-Mah(INH4)**2)*(MNeu(INe3)**
     &  2-MNeu(INe5)**2))+self(i,j)
              else
          if( Abs(Mah(INH4)) .gt. 1D-15) then 
       self(i,j)=(CS1S1S1(i,INH3,INH3)*(CFF11S1R(INe3,INe4,INH3)*
     &  (CFF11S1L(INe4,INe5,INH3)*(FD211HNeuNeu(2,INH3,INe3,INe4)-
     &  FD211HNeuNeu(2,INH3,INe5,INe4)-FD211HNeuNeu(3,INH3,INe3,INe4)+
     &  FD211HNeuNeu(3,INH3,INe5,INe4))*(CFF11S1R(INe5,INe3,j)*
     &  MNeu(INe3)+CFF11S1L(INe5,INe3,j)*MNeu(INe5))+
     &  CFF11S1R(INe4,INe5,INH3)*MNeu(INe4)*(CFF11S1L(INe5,INe3,j)*(-
     &  FD211HNeuNeu(3,INH3,INe3,INe4)+FD211HNeuNeu(3,INH3,INe5,INe4))+
     &  CFF11S1R(INe5,INe3,j)*(-FD211HNeuNeu(1,INH3,INe3,INe4)+
     &  FD211HNeuNeu(1,INH3,INe5,INe4))*MNeu(INe3)*MNeu(INe5)))+
     &  CFF11S1L(INe3,INe4,INH3)*(CFF11S1L(INe5,INe3,j)*MNeu(INe3)*
     &  (CFF11S1R(INe4,INe5,INH3)*(FD211HNeuNeu(2,INH3,INe3,INe4)-
     &  FD211HNeuNeu(2,INH3,INe5,INe4)-FD211HNeuNeu(3,INH3,INe3,INe4)+
     &  FD211HNeuNeu(3,INH3,INe5,INe4))+CFF11S1L(INe4,INe5,INH3)*(-
     &  FD211HNeuNeu(1,INH3,INe3,INe4)+FD211HNeuNeu(1,INH3,INe5,INe4))*
     &  MNeu(INe4)*MNeu(INe5))+CFF11S1R(INe5,INe3,j)*
     &  (CFF11S1R(INe4,INe5,INH3)*(FD211HNeuNeu(2,INH3,INe3,INe4)-
     &  FD211HNeuNeu(2,INH3,INe5,INe4))*MNeu(INe5)-
     &  (FD211HNeuNeu(3,INH3,INe3,INe4)-FD211HNeuNeu(3,INH3,INe5,INe4))
     &  *(CFF11S1L(INe4,INe5,INH3)*MNeu(INe4)+CFF11S1R(INe4,INe5,INH3)*
     &  MNeu(INe5))))))/(16.*(MNeu(INe3)**2-MNeu(INe5)**2))+self(i,j)
             endif
              endif
             else
          if( Abs(-Mah(INH3) + Mah(INH4)) .gt. 1D-15) then 
       self(i,j)=(CS1S1S1(i,INH3,INH4)*(CFF11S1L(INe3,INe3,j)*
     &  (CFF11S1R(INe4,INe3,INH4)*(CFF11S1L(INe3,INe4,INH3)*
     &  (FD211ChiHChi(2,INe3,INH3,INe4)-FD211ChiHChi(2,INe3,INH4,INe4)-
     &  FD211ChiHChi(4,INe3,INH3,INe4)+FD211ChiHChi(4,INe3,INH4,INe4))*
     &  MNeu(INe3)+CFF11S1R(INe3,INe4,INH3)*(-
     &  FD211ChiHChi(4,INe3,INH3,INe4)+FD211ChiHChi(4,INe3,INH4,INe4))*
     &  MNeu(INe4))+CFF11S1L(INe4,INe3,INH4)*(CFF11S1R(INe3,INe4,INH3)*
     &  (FD211ChiHChi(2,INe3,INH3,INe4)-FD211ChiHChi(2,INe3,INH4,INe4)-
     &  FD211ChiHChi(4,INe3,INH3,INe4)+FD211ChiHChi(4,INe3,INH4,INe4))*
     &  MNeu(INe3)+CFF11S1L(INe3,INe4,INH3)*(-
     &  FD211ChiHChi(1,INe3,INH3,INe4)+FD211ChiHChi(1,INe3,INH4,INe4))*
     &  MNeu(INe4)*MNeu2(INe3)))+CFF11S1R(INe3,INe3,j)*
     &  (CFF11S1L(INe4,INe3,INH4)*(CFF11S1R(INe3,INe4,INH3)*
     &  (FD211ChiHChi(2,INe3,INH3,INe4)-FD211ChiHChi(2,INe3,INH4,INe4)-
     &  FD211ChiHChi(4,INe3,INH3,INe4)+FD211ChiHChi(4,INe3,INH4,INe4))*
     &  MNeu(INe3)+CFF11S1L(INe3,INe4,INH3)*(-
     &  FD211ChiHChi(4,INe3,INH3,INe4)+FD211ChiHChi(4,INe3,INH4,INe4))*
     &  MNeu(INe4))+CFF11S1R(INe4,INe3,INH4)*(CFF11S1L(INe3,INe4,INH3)*
     &  (FD211ChiHChi(2,INe3,INH3,INe4)-FD211ChiHChi(2,INe3,INH4,INe4)-
     &  FD211ChiHChi(4,INe3,INH3,INe4)+FD211ChiHChi(4,INe3,INH4,INe4))*
     &  MNeu(INe3)+CFF11S1R(INe3,INe4,INH3)*(-
     &  FD211ChiHChi(1,INe3,INH3,INe4)+FD211ChiHChi(1,INe3,INH4,INe4))*
     &  MNeu(INe4)*MNeu2(INe3)))))/(16.*(Mah(INH3)**2-Mah(INH4)**2))+self(i,j)
          else 
          if( Abs(Mah(INH3)) .gt. 1D-15) then 
       self(i,j)=(CS1S1S1(i,INH3,INH3)*(CFF11S1L(INe3,INe3,j)*
     &  (CFF11S1R(INe4,INe3,INH3)*(CFF11S1L(INe3,INe4,INH3)*
     &  (FD221ChiHChi(2,INe3,INH3,INe4)-FD221ChiHChi(3,INe3,INH3,INe4))
     &  *MNeu(INe3)-CFF11S1R(INe3,INe4,INH3)*
     &  FD221ChiHChi(3,INe3,INH3,INe4)*MNeu(INe4))+
     &  CFF11S1L(INe4,INe3,INH3)*(CFF11S1R(INe3,INe4,INH3)*
     &  (FD221ChiHChi(2,INe3,INH3,INe4)-FD221ChiHChi(3,INe3,INH3,INe4))
     &  *MNeu(INe3)-CFF11S1L(INe3,INe4,INH3)*
     &  FD221ChiHChi(1,INe3,INH3,INe4)*MNeu(INe4)*MNeu2(INe3)))+
     &  CFF11S1R(INe3,INe3,j)*(CFF11S1L(INe4,INe3,INH3)*
     &  (CFF11S1R(INe3,INe4,INH3)*(FD221ChiHChi(2,INe3,INH3,INe4)-
     &  FD221ChiHChi(3,INe3,INH3,INe4))*MNeu(INe3)-
     &  CFF11S1L(INe3,INe4,INH3)*FD221ChiHChi(3,INe3,INH3,INe4)*
     &  MNeu(INe4))+CFF11S1R(INe4,INe3,INH3)*(CFF11S1L(INe3,INe4,INH3)*
     &  (FD221ChiHChi(2,INe3,INH3,INe4)-FD221ChiHChi(3,INe3,INH3,INe4))
     &  *MNeu(INe3)-CFF11S1R(INe3,INe4,INH3)*
     &  FD221ChiHChi(1,INe3,INH3,INe4)*MNeu(INe4)*MNeu2(INe3)))))/16.+self(i,j)
             endif
          endif 
              endif
       enddo 
       enddo 
       enddo 
       enddo 
       enddo 
       do ICH3=1,2
       do ICH4=1,2
          if( Abs(-MassHpm(ICH3) + MassHpm(ICH4)) .gt. 1D-15) then 
       self(i,j)=(3*M1*CS1S3S3(i,ICH4,ICH3)*CTBS3(ICH3)*CTBS3C(ICH4)*
     &  (FD211THpB(2,ICH3)-FD211THpB(2,ICH4)-FD211THpB(4,ICH3)+
     &  FD211THpB(4,ICH4))*(hy(j)+hyc(j)))/(8.*(MassHpm(ICH3)**2-
     &  MassHpm(ICH4)**2))+self(i,j)
              else
          if( Abs(MassHpm(ICH4)) .gt. 1D-15) then 
       self(i,j)=(3*M1*CS1S3S3(i,ICH3,ICH3)*CTBS3(ICH3)*CTBS3C(ICH3)*
     &  (FD221THpB(2,ICH3)-FD221THpB(3,ICH3))*(hy(j)+hyc(j)))/8.+
     &  self(i,j)
             endif
              endif
       enddo 
       enddo 
       do ICH3=1,2
       do ICH4=1,2
       do INe3=ineu,3
       do INe4=ineu,3
          if( Abs(-MNeu(INe3) + MNeu(INe4)) .gt. 1D-15) then 
          if( Abs(-MassHpm(ICH3) + MassHpm(ICH4)) .gt. 1D-15) then 
       self(i,j)=(CS1S3S3(i,ICH4,ICH3)*(CF11F12S3R(INe4,ICH4)*
     &  (CFF11S1L(INe4,INe3,j)*(DCONJG(CF11F12S3R(INe3,ICH3))*
     &  (FD111ChiHpCha(2,INe3,ICH3)-FD111ChiHpCha(2,INe3,ICH4)-
     &  FD111ChiHpCha(2,INe4,ICH3)+FD111ChiHpCha(2,INe4,ICH4))*
     &  MNeu(INe3)-(FD111ChiHpCha(4,INe3,ICH3)-
     &  FD111ChiHpCha(4,INe3,ICH4)-FD111ChiHpCha(4,INe4,ICH3)+
     &  FD111ChiHpCha(4,INe4,ICH4))*(MCha*DCONJG(CF11F12S3L(INe3,ICH3))
     &  +DCONJG(CF11F12S3R(INe3,ICH3))*MNeu(INe3)))+
     &  CFF11S1R(INe4,INe3,j)*(DCONJG(CF11F12S3R(INe3,ICH3))*
     &  (FD111ChiHpCha(2,INe3,ICH3)-FD111ChiHpCha(2,INe3,ICH4)-
     &  FD111ChiHpCha(2,INe4,ICH3)+FD111ChiHpCha(2,INe4,ICH4)-
     &  FD111ChiHpCha(4,INe3,ICH3)+FD111ChiHpCha(4,INe3,ICH4)+
     &  FD111ChiHpCha(4,INe4,ICH3)-FD111ChiHpCha(4,INe4,ICH4))+MCha*
     &  DCONJG(CF11F12S3L(INe3,ICH3))*(-FD111ChiHpCha(1,INe3,ICH3)+
     &  FD111ChiHpCha(1,INe3,ICH4)+FD111ChiHpCha(1,INe4,ICH3)-
     &  FD111ChiHpCha(1,INe4,ICH4))*MNeu(INe3))*MNeu(INe4))+
     &  CF11F12S3L(INe4,ICH4)*(CFF11S1R(INe4,INe3,j)*
     &  (DCONJG(CF11F12S3L(INe3,ICH3))*(FD111ChiHpCha(2,INe3,ICH3)-
     &  FD111ChiHpCha(2,INe3,ICH4)-FD111ChiHpCha(2,INe4,ICH3)+
     &  FD111ChiHpCha(2,INe4,ICH4))*MNeu(INe3)-
     &  (FD111ChiHpCha(4,INe3,ICH3)-FD111ChiHpCha(4,INe3,ICH4)-
     &  FD111ChiHpCha(4,INe4,ICH3)+FD111ChiHpCha(4,INe4,ICH4))*(MCha*
     &  DCONJG(CF11F12S3R(INe3,ICH3))+DCONJG(CF11F12S3L(INe3,ICH3))*
     &  MNeu(INe3)))+CFF11S1L(INe4,INe3,j)*
     &  (DCONJG(CF11F12S3L(INe3,ICH3))*(FD111ChiHpCha(2,INe3,ICH3)-
     &  FD111ChiHpCha(2,INe3,ICH4)-FD111ChiHpCha(2,INe4,ICH3)+
     &  FD111ChiHpCha(2,INe4,ICH4)-FD111ChiHpCha(4,INe3,ICH3)+
     &  FD111ChiHpCha(4,INe3,ICH4)+FD111ChiHpCha(4,INe4,ICH3)-
     &  FD111ChiHpCha(4,INe4,ICH4))+MCha*DCONJG(CF11F12S3R(INe3,ICH3))*
     &  (-FD111ChiHpCha(1,INe3,ICH3)+FD111ChiHpCha(1,INe3,ICH4)+
     &  FD111ChiHpCha(1,INe4,ICH3)-FD111ChiHpCha(1,INe4,ICH4))*
     &  MNeu(INe3))*MNeu(INe4))))/(8.*(MassHpm(ICH3)**2-MassHpm(ICH4)**
     &  2)*(MNeu(INe3)**2-MNeu(INe4)**2))+self(i,j)
              else
          if( Abs(MassHpm(ICH4)) .gt. 1D-15) then 
       self(i,j)=(CS1S3S3(i,ICH3,ICH3)*(CF11F12S3R(INe4,ICH3)*
     &  (CFF11S1L(INe4,INe3,j)*(MCha*DCONJG(CF11F12S3L(INe3,ICH3))*(-
     &  FD211HpChiCha(3,ICH3,INe3)+FD211HpChiCha(3,ICH3,INe4))+
     &  DCONJG(CF11F12S3R(INe3,ICH3))*(FD211HpChiCha(2,ICH3,INe3)-
     &  FD211HpChiCha(2,ICH3,INe4)-FD211HpChiCha(3,ICH3,INe3)+
     &  FD211HpChiCha(3,ICH3,INe4))*MNeu(INe3))+CFF11S1R(INe4,INe3,j)*
     &  (DCONJG(CF11F12S3R(INe3,ICH3))*(FD211HpChiCha(2,ICH3,INe3)-
     &  FD211HpChiCha(2,ICH3,INe4)-FD211HpChiCha(3,ICH3,INe3)+
     &  FD211HpChiCha(3,ICH3,INe4))+MCha*DCONJG(CF11F12S3L(INe3,ICH3))*
     &  (-FD211HpChiCha(1,ICH3,INe3)+FD211HpChiCha(1,ICH3,INe4))*
     &  MNeu(INe3))*MNeu(INe4))+CF11F12S3L(INe4,ICH3)*
     &  (CFF11S1R(INe4,INe3,j)*(MCha*DCONJG(CF11F12S3R(INe3,ICH3))*(-
     &  FD211HpChiCha(3,ICH3,INe3)+FD211HpChiCha(3,ICH3,INe4))+
     &  DCONJG(CF11F12S3L(INe3,ICH3))*(FD211HpChiCha(2,ICH3,INe3)-
     &  FD211HpChiCha(2,ICH3,INe4)-FD211HpChiCha(3,ICH3,INe3)+
     &  FD211HpChiCha(3,ICH3,INe4))*MNeu(INe3))+CFF11S1L(INe4,INe3,j)*
     &  (DCONJG(CF11F12S3L(INe3,ICH3))*(FD211HpChiCha(2,ICH3,INe3)-
     &  FD211HpChiCha(2,ICH3,INe4)-FD211HpChiCha(3,ICH3,INe3)+
     &  FD211HpChiCha(3,ICH3,INe4))+MCha*DCONJG(CF11F12S3R(INe3,ICH3))*
     &  (-FD211HpChiCha(1,ICH3,INe3)+FD211HpChiCha(1,ICH3,INe4))*
     &  MNeu(INe3))*MNeu(INe4))))/(8.*(MNeu(INe3)**2-MNeu(INe4)**2))+
     &  self(i,j)
             endif
              endif
             else
          if( Abs(-MassHpm(ICH3) + MassHpm(ICH4)) .gt. 1D-15) then 
       self(i,j)=(CS1S3S3(i,ICH4,ICH3)*(CF11F12S3R(INe3,ICH4)*
     &  (CFF11S1L(INe3,INe3,j)*(MCha*DCONJG(CF11F12S3L(INe3,ICH3))*(-
     &  FD211ChiHpCha(4,INe3,ICH3)+FD211ChiHpCha(4,INe3,ICH4))+
     &  DCONJG(CF11F12S3R(INe3,ICH3))*(FD211ChiHpCha(2,INe3,ICH3)-
     &  FD211ChiHpCha(2,INe3,ICH4)-FD211ChiHpCha(4,INe3,ICH3)+
     &  FD211ChiHpCha(4,INe3,ICH4))*MNeu(INe3))+CFF11S1R(INe3,INe3,j)*
     &  (DCONJG(CF11F12S3R(INe3,ICH3))*(FD211ChiHpCha(2,INe3,ICH3)-
     &  FD211ChiHpCha(2,INe3,ICH4)-FD211ChiHpCha(4,INe3,ICH3)+
     &  FD211ChiHpCha(4,INe3,ICH4))*MNeu(INe3)+MCha*
     &  DCONJG(CF11F12S3L(INe3,ICH3))*(-FD211ChiHpCha(1,INe3,ICH3)+
     &  FD211ChiHpCha(1,INe3,ICH4))*MNeu2(INe3)))+CF11F12S3L(INe3,ICH4)
     &  *(CFF11S1R(INe3,INe3,j)*(MCha*DCONJG(CF11F12S3R(INe3,ICH3))*(-
     &  FD211ChiHpCha(4,INe3,ICH3)+FD211ChiHpCha(4,INe3,ICH4))+
     &  DCONJG(CF11F12S3L(INe3,ICH3))*(FD211ChiHpCha(2,INe3,ICH3)-
     &  FD211ChiHpCha(2,INe3,ICH4)-FD211ChiHpCha(4,INe3,ICH3)+
     &  FD211ChiHpCha(4,INe3,ICH4))*MNeu(INe3))+CFF11S1L(INe3,INe3,j)*
     &  (DCONJG(CF11F12S3L(INe3,ICH3))*(FD211ChiHpCha(2,INe3,ICH3)-
     &  FD211ChiHpCha(2,INe3,ICH4)-FD211ChiHpCha(4,INe3,ICH3)+
     &  FD211ChiHpCha(4,INe3,ICH4))*MNeu(INe3)+MCha*
     &  DCONJG(CF11F12S3R(INe3,ICH3))*(-FD211ChiHpCha(1,INe3,ICH3)+
     &  FD211ChiHpCha(1,INe3,ICH4))*MNeu2(INe3)))))/(8.*(MassHpm(ICH3)*
     &  *2-MassHpm(ICH4)**2))+self(i,j)
          else 
          if( Abs(MassHpm(ICH4)) .gt. 1D-15) then 
       self(i,j)=-(CS1S3S3(i,ICH3,ICH3)*(CF11F12S3R(INe3,ICH3)*
     &  (CFF11S1L(INe3,INe3,j)*(MCha*DCONJG(CF11F12S3L(INe3,ICH3))*
     &  FD221ChiHpCha(3,INe3,ICH3)+DCONJG(CF11F12S3R(INe3,ICH3))*(-
     &  FD221ChiHpCha(2,INe3,ICH3)+FD221ChiHpCha(3,INe3,ICH3))*
     &  MNeu(INe3))+CFF11S1R(INe3,INe3,j)*(DCONJG(CF11F12S3R(INe3,ICH3)
     &  )*(-FD221ChiHpCha(2,INe3,ICH3)+FD221ChiHpCha(3,INe3,ICH3))*
     &  MNeu(INe3)+MCha*DCONJG(CF11F12S3L(INe3,ICH3))*
     &  FD221ChiHpCha(1,INe3,ICH3)*MNeu2(INe3)))+CF11F12S3L(INe3,ICH3)*
     &  (CFF11S1R(INe3,INe3,j)*(MCha*DCONJG(CF11F12S3R(INe3,ICH3))*
     &  FD221ChiHpCha(3,INe3,ICH3)+DCONJG(CF11F12S3L(INe3,ICH3))*(-
     &  FD221ChiHpCha(2,INe3,ICH3)+FD221ChiHpCha(3,INe3,ICH3))*
     &  MNeu(INe3))+CFF11S1L(INe3,INe3,j)*(DCONJG(CF11F12S3L(INe3,ICH3)
     &  )*(-FD221ChiHpCha(2,INe3,ICH3)+FD221ChiHpCha(3,INe3,ICH3))*
     &  MNeu(INe3)+MCha*DCONJG(CF11F12S3R(INe3,ICH3))*
     &  FD221ChiHpCha(1,INe3,ICH3)*MNeu2(INe3)))))/8.+self(i,j)
             endif
          endif 
              endif
       enddo 
       enddo 
       enddo 
       enddo 
       do ICH3=1,2
       do ICH4=1,2
       do INe3=ineu,3
          if( Abs(-MassHpm(ICH3) + MassHpm(ICH4)) .gt. 1D-15) then 
       self(i,j)=(CS1S3S3(i,ICH3,ICH4)*(MCha*(CFF12S1L(j)+CFF12S1R(j))*
     &  (CF11F12S3L(INe3,ICH3)*DCONJG(CF11F12S3L(INe3,ICH4))+
     &  CF11F12S3R(INe3,ICH3)*DCONJG(CF11F12S3R(INe3,ICH4)))*
     &  (FD211ChaHpChi(2,ICH3,INe3)-FD211ChaHpChi(2,ICH4,INe3)-
     &  FD211ChaHpChi(4,ICH3,INe3)+FD211ChaHpChi(4,ICH4,INe3))+
     &  (CF11F12S3R(INe3,ICH3)*DCONJG(CF11F12S3L(INe3,ICH4))*(MCha2*
     &  CFF12S1R(j)*(-FD211ChaHpChi(1,ICH3,INe3)+
     &  FD211ChaHpChi(1,ICH4,INe3))+CFF12S1L(j)*(-
     &  FD211ChaHpChi(4,ICH3,INe3)+FD211ChaHpChi(4,ICH4,INe3)))+
     &  CF11F12S3L(INe3,ICH3)*DCONJG(CF11F12S3R(INe3,ICH4))*(MCha2*
     &  CFF12S1L(j)*(-FD211ChaHpChi(1,ICH3,INe3)+
     &  FD211ChaHpChi(1,ICH4,INe3))+CFF12S1R(j)*(-
     &  FD211ChaHpChi(4,ICH3,INe3)+FD211ChaHpChi(4,ICH4,INe3))))*
     &  MNeu(INe3)))/(8.*(MassHpm(ICH3)**2-MassHpm(ICH4)**2))+self(i,j)
              else
          if( Abs(MassHpm(ICH4)) .gt. 1D-15) then 
       self(i,j)=(CS1S3S3(i,ICH3,ICH3)*(MCha*(CFF12S1L(j)+CFF12S1R(j))*
     &  (CF11F12S3L(INe3,ICH3)*DCONJG(CF11F12S3L(INe3,ICH3))+
     &  CF11F12S3R(INe3,ICH3)*DCONJG(CF11F12S3R(INe3,ICH3)))*
     &  (FD221ChaHpChi(2,ICH3,INe3)-FD221ChaHpChi(3,ICH3,INe3))-
     &  (CF11F12S3R(INe3,ICH3)*DCONJG(CF11F12S3L(INe3,ICH3))*(MCha2*
     &  CFF12S1R(j)*FD221ChaHpChi(1,ICH3,INe3)+CFF12S1L(j)*
     &  FD221ChaHpChi(3,ICH3,INe3))+CF11F12S3L(INe3,ICH3)*
     &  DCONJG(CF11F12S3R(INe3,ICH3))*(MCha2*CFF12S1L(j)*
     &  FD221ChaHpChi(1,ICH3,INe3)+CFF12S1R(j)*
     &  FD221ChaHpChi(3,ICH3,INe3)))*MNeu(INe3)))/8.+self(i,j)
             endif
              endif
       enddo 
       enddo 
       enddo 
       do INe3=ineu,3
       do INe4=ineu,3
       do ISt3=1,2
       do ISt4=1,2
          if( Abs(-MNeu(INe3) + MNeu(INe4)) .gt. 1D-15) then 
          if( Abs(-MassSu(ISt3) + MassSu(ISt4)) .gt. 1D-15) then 
       self(i,j)=(-3*CSSS(i,ISt4,ISt3)*(CF11FSRC(INe3,ISt3)*(-
     &  (CF11FSR(INe4,ISt4)*(FD111ChiStT(2,INe3,ISt3)-
     &  FD111ChiStT(2,INe3,ISt4)-FD111ChiStT(2,INe4,ISt3)+
     &  FD111ChiStT(2,INe4,ISt4)-FD111ChiStT(4,INe3,ISt3)+
     &  FD111ChiStT(4,INe3,ISt4)+FD111ChiStT(4,INe4,ISt3)-
     &  FD111ChiStT(4,INe4,ISt4))*(CFF11S1L(INe4,INe3,j)*MNeu(INe3)+
     &  CFF11S1R(INe4,INe3,j)*MNeu(INe4)))+M1*CF11FSL(INe4,ISt4)*
     &  (CFF11S1R(INe4,INe3,j)*(FD111ChiStT(4,INe3,ISt3)-
     &  FD111ChiStT(4,INe3,ISt4)-FD111ChiStT(4,INe4,ISt3)+
     &  FD111ChiStT(4,INe4,ISt4))+CFF11S1L(INe4,INe3,j)*
     &  (FD111ChiStT(1,INe3,ISt3)-FD111ChiStT(1,INe3,ISt4)-
     &  FD111ChiStT(1,INe4,ISt3)+FD111ChiStT(1,INe4,ISt4))*MNeu(INe3)*
     &  MNeu(INe4)))+CF11FSLC(INe3,ISt3)*(-(CF11FSL(INe4,ISt4)*
     &  (FD111ChiStT(2,INe3,ISt3)-FD111ChiStT(2,INe3,ISt4)-
     &  FD111ChiStT(2,INe4,ISt3)+FD111ChiStT(2,INe4,ISt4)-
     &  FD111ChiStT(4,INe3,ISt3)+FD111ChiStT(4,INe3,ISt4)+
     &  FD111ChiStT(4,INe4,ISt3)-FD111ChiStT(4,INe4,ISt4))*
     &  (CFF11S1R(INe4,INe3,j)*MNeu(INe3)+CFF11S1L(INe4,INe3,j)*
     &  MNeu(INe4)))+M1*CF11FSR(INe4,ISt4)*(CFF11S1L(INe4,INe3,j)*
     &  (FD111ChiStT(4,INe3,ISt3)-FD111ChiStT(4,INe3,ISt4)-
     &  FD111ChiStT(4,INe4,ISt3)+FD111ChiStT(4,INe4,ISt4))+
     &  CFF11S1R(INe4,INe3,j)*(FD111ChiStT(1,INe3,ISt3)-
     &  FD111ChiStT(1,INe3,ISt4)-FD111ChiStT(1,INe4,ISt3)+
     &  FD111ChiStT(1,INe4,ISt4))*MNeu(INe3)*MNeu(INe4)))))/(8.*
     &  (MassSu(ISt3)**2-MassSu(ISt4)**2)*(MNeu(INe3)**2-MNeu(INe4)**2))+self(i,j)
              else
       self(i,j)=(-3*CSSS(i,ISt3,ISt3)*(CF11FSRC(INe3,ISt3)*(-
     &  (CF11FSR(INe4,ISt3)*(FD211StChiT(2,ISt3,INe3)-
     &  FD211StChiT(2,ISt3,INe4)-FD211StChiT(3,ISt3,INe3)+
     &  FD211StChiT(3,ISt3,INe4))*(CFF11S1L(INe4,INe3,j)*MNeu(INe3)+
     &  CFF11S1R(INe4,INe3,j)*MNeu(INe4)))+M1*CF11FSL(INe4,ISt3)*
     &  (CFF11S1R(INe4,INe3,j)*(FD211StChiT(3,ISt3,INe3)-
     &  FD211StChiT(3,ISt3,INe4))+CFF11S1L(INe4,INe3,j)*
     &  (FD211StChiT(1,ISt3,INe3)-FD211StChiT(1,ISt3,INe4))*MNeu(INe3)*
     &  MNeu(INe4)))+CF11FSLC(INe3,ISt3)*(-(CF11FSL(INe4,ISt3)*
     &  (FD211StChiT(2,ISt3,INe3)-FD211StChiT(2,ISt3,INe4)-
     &  FD211StChiT(3,ISt3,INe3)+FD211StChiT(3,ISt3,INe4))*
     &  (CFF11S1R(INe4,INe3,j)*MNeu(INe3)+CFF11S1L(INe4,INe3,j)*
     &  MNeu(INe4)))+M1*CF11FSR(INe4,ISt3)*(CFF11S1L(INe4,INe3,j)*
     &  (FD211StChiT(3,ISt3,INe3)-FD211StChiT(3,ISt3,INe4))+
     &  CFF11S1R(INe4,INe3,j)*(FD211StChiT(1,ISt3,INe3)-
     &  FD211StChiT(1,ISt3,INe4))*MNeu(INe3)*MNeu(INe4)))))/(8.*
     &  (MNeu(INe3)**2-MNeu(INe4)**2))+self(i,j)
              endif
             else
          if( Abs(-MassSu(ISt3) + MassSu(ISt4)) .gt. 1D-15) then 
       self(i,j)=(-3*CSSS(i,ISt4,ISt3)*(CF11FSRC(INe3,ISt3)*(-
     &  (CF11FSR(INe3,ISt4)*(CFF11S1L(INe3,INe3,j)+
     &  CFF11S1R(INe3,INe3,j))*(FD211ChiSTT(2,INe3,ISt3)-
     &  FD211ChiSTT(2,INe3,ISt4)-FD211ChiSTT(4,INe3,ISt3)+
     &  FD211ChiSTT(4,INe3,ISt4))*MNeu(INe3))+M1*CF11FSL(INe3,ISt4)*
     &  (CFF11S1R(INe3,INe3,j)*(FD211ChiSTT(4,INe3,ISt3)-
     &  FD211ChiSTT(4,INe3,ISt4))+CFF11S1L(INe3,INe3,j)*
     &  (FD211ChiSTT(1,INe3,ISt3)-FD211ChiSTT(1,INe3,ISt4))*MNeu2(INe3)
     &  ))+CF11FSLC(INe3,ISt3)*(-(CF11FSL(INe3,ISt4)*
     &  (CFF11S1L(INe3,INe3,j)+CFF11S1R(INe3,INe3,j))*
     &  (FD211ChiSTT(2,INe3,ISt3)-FD211ChiSTT(2,INe3,ISt4)-
     &  FD211ChiSTT(4,INe3,ISt3)+FD211ChiSTT(4,INe3,ISt4))*MNeu(INe3))+
     &  M1*CF11FSR(INe3,ISt4)*(CFF11S1L(INe3,INe3,j)*
     &  (FD211ChiSTT(4,INe3,ISt3)-FD211ChiSTT(4,INe3,ISt4))+
     &  CFF11S1R(INe3,INe3,j)*(FD211ChiSTT(1,INe3,ISt3)-
     &  FD211ChiSTT(1,INe3,ISt4))*MNeu2(INe3)))))/(8.*(MassSu(ISt3)**2-
     &  MassSu(ISt4)**2))+self(i,j)
          else 
       self(i,j)=(-3*CSSS(i,ISt3,ISt3)*(CF11FSRC(INe3,ISt3)*(-
     &  (CF11FSR(INe3,ISt3)*(CFF11S1L(INe3,INe3,j)+
     &  CFF11S1R(INe3,INe3,j))*(FD221ChiStT(2,INe3,ISt3)-
     &  FD221ChiStT(3,INe3,ISt3))*MNeu(INe3))+M1*CF11FSL(INe3,ISt3)*
     &  (CFF11S1R(INe3,INe3,j)*FD221ChiStT(3,INe3,ISt3)+
     &  CFF11S1L(INe3,INe3,j)*FD221ChiStT(1,INe3,ISt3)*MNeu2(INe3)))+
     &  CF11FSLC(INe3,ISt3)*(-(CF11FSL(INe3,ISt3)*
     &  (CFF11S1L(INe3,INe3,j)+CFF11S1R(INe3,INe3,j))*
     &  (FD221ChiStT(2,INe3,ISt3)-FD221ChiStT(3,INe3,ISt3))*MNeu(INe3))
     &  +M1*CF11FSR(INe3,ISt3)*(CFF11S1L(INe3,INe3,j)*
     &  FD221ChiStT(3,INe3,ISt3)+CFF11S1R(INe3,INe3,j)*
     &  FD221ChiStT(1,INe3,ISt3)*MNeu2(INe3)))))/8.+self(i,j)
          endif 
              endif
       enddo 
       enddo 
       enddo 
       enddo 
       do ISt3=1,2
       do ISt4=1,2
          if( Abs(-MassSu(ISt3) + MassSu(ISt4)) .gt. 1D-15) then 
       self(i,j)=(3*MCha*CF12F4S(ISt4)*CF12F4SC(ISt3)*(CFF12S1L(j)+
     &  CFF12S1R(j))*CSSS(i,ISt4,ISt3)*(FD211ChaStB(2,ISt3)-
     &  FD211ChaStB(2,ISt4)-FD211ChaStB(4,ISt3)+FD211ChaStB(4,ISt4)))
     &  /(8.*(MassSu(ISt3)**2-MassSu(ISt4)**2))+self(i,j)
              else
       self(i,j)=(3*MCha*CF12F4S(ISt3)*CF12F4SC(ISt3)*(CFF12S1L(j)+
     &  CFF12S1R(j))*CSSS(i,ISt3,ISt3)*(FD221ChaStSb(2,ISt3)-
     &  FD221ChaStSb(3,ISt3)))/8.+self(i,j)
              endif
       enddo 
       enddo 
c
c topo6
c
       do INH3= ihiggs,6
       do INH4= ihiggs,6
       do INH5= ihiggs,6
       do INH6= ihiggs,6
       do INH7= ihiggs,6
          if( Abs(-Mah(INH3) + Mah(INH6)) .gt. 1D-15) then 
             if( Abs(-Mah(INH4) + Mah(INH7)) .gt. 1D-15) then 
       self(i,j)=(CS1S1S1(i,INH3,INH6)*CS1S1S1(INH3,INH4,INH5)*
     &  CS1S1S1(INH5,INH6,INH7)*CS1S1S1(j,INH4,INH7)*
     &  (FD111HHH(1,INH3,INH4,INH5)-FD111HHH(1,INH3,INH7,INH5)-
     &  FD111HHH(1,INH4,INH6,INH5)+FD111HHH(1,INH6,INH7,INH5)))/(32.*
     &  (Mah(INH3)**2-Mah(INH6)**2)*(Mah(INH4)**2-Mah(INH7)**2))+
     &  self(i,j)
              else
                if( Abs(Mah(INH7)) .gt. 1D-15) then
       self(i,j)=(CS1S1S1(i,INH3,INH6)*CS1S1S1(INH3,INH4,INH5)*
     &  CS1S1S1(INH5,INH6,INH4)*CS1S1S1(j,INH4,INH4)*
     &  (FD211HHH(1,INH4,INH3,INH5)-FD211HHH(1,INH4,INH6,INH5)))/(32.*
     &  (Mah(INH3)**2-Mah(INH6)**2))+self(i,j)
               endif
              endif
          else
             if( Abs(-Mah(INH4) + Mah(INH7)) .gt. 1D-15) then 
               if( Abs(Mah(INH6)) .gt. 1D-15) then
       self(i,j)=(CS1S1S1(i,INH3,INH3)*CS1S1S1(INH3,INH4,INH5)*
     &  CS1S1S1(INH5,INH3,INH7)*CS1S1S1(j,INH4,INH7)*
     &  (FD211HHH(1,INH3,INH4,INH5)-FD211HHH(1,INH3,INH7,INH5)))/(32.*
     &  (Mah(INH4)**2-Mah(INH7)**2))+self(i,j)
               endif
            else 
              if( Abs(Mah(INH3)) .gt. 1D-15) then 
              if( Abs(Mah(INH4)) .gt. 1D-15) then 
       self(i,j)=(CS1S1S1(i,INH3,INH3)*CS1S1S1(INH3,INH4,INH5)*
     &  CS1S1S1(INH5,INH3,INH4)*CS1S1S1(j,INH4,INH4)*
     &  FD221HHH(1,INH3,INH4,INH5))/32.+self(i,j)
              endif
              endif 
            endif
         endif
       enddo 
       enddo 
       enddo 
       enddo 
       enddo 

       do ICH3=1,2
       do ICH4=1,2
       do ICH5=1,2
       do INH3= ihiggs,6
       do INH4= ihiggs,6
          if( Abs(-Mah(INH3) + Mah(INH4)) .gt. 1D-15) then 
          if( Abs(-MassHpm(ICH3) + MassHpm(ICH5)) .gt. 1D-15) then 
       self(i,j)=(CS1S3S3(INH3,ICH3,ICH4)*CS1S3S3(INH4,ICH4,ICH5)*
     &  (CS1S1S1(j,INH3,INH4)*CS1S3S3(i,ICH5,ICH3)+CS1S1S1(i,INH3,INH4)
     &  *CS1S3S3(j,ICH5,ICH3))*(FD111HHpHp(1,INH3,ICH3,ICH4)-
     &  FD111HHpHp(1,INH3,ICH5,ICH4)-FD111HHpHp(1,INH4,ICH3,ICH4)+
     &  FD111HHpHp(1,INH4,ICH5,ICH4)))/(16.*(Mah(INH3)**2-Mah(INH4)**2)
     &  *(MassHpm(ICH3)**2-MassHpm(ICH5)**2))+self(i,j)
              else
          if( Abs(MassHpm(ICH5)) .gt. 1D-15) then 
       self(i,j)=(CS1S3S3(INH3,ICH3,ICH4)*CS1S3S3(INH4,ICH4,ICH3)*
     &  (CS1S1S1(j,INH3,INH4)*CS1S3S3(i,ICH3,ICH3)+CS1S1S1(i,INH3,INH4)
     &  *CS1S3S3(j,ICH3,ICH3))*(FD211HpHHp(1,ICH3,INH3,ICH4)-
     &  FD211HpHHp(1,ICH3,INH4,ICH4)))/(16.*(Mah(INH3)**2-Mah(INH4)**2)
     &  )+self(i,j)
             endif
              endif
             else
          if( Abs(-MassHpm(ICH3) + MassHpm(ICH5)) .gt. 1D-15) then 
            if( Abs(Mah(INH4)) .gt. 1D-15) then 
       self(i,j)=(CS1S3S3(INH3,ICH3,ICH4)*CS1S3S3(INH3,ICH4,ICH5)*
     &  (CS1S1S1(j,INH3,INH3)*CS1S3S3(i,ICH5,ICH3)+CS1S1S1(i,INH3,INH3)
     &  *CS1S3S3(j,ICH5,ICH3))*(FD211HHpHp(1,INH3,ICH3,ICH4)-
     &  FD211HHpHp(1,INH3,ICH5,ICH4)))/(16.*(MassHpm(ICH3)**2-
     &  MassHpm(ICH5)**2))+self(i,j)
             endif
          else 
            if( Abs(Mah(INH3)) .gt. 1D-15) then 
            if( Abs(MassHpm(ICH5)) .gt. 1D-15) then
       self(i,j)=(CS1S3S3(INH3,ICH3,ICH4)*CS1S3S3(INH3,ICH4,ICH3)*
     &  (CS1S1S1(j,INH3,INH3)*CS1S3S3(i,ICH3,ICH3)+CS1S1S1(i,INH3,INH3)
     &  *CS1S3S3(j,ICH3,ICH3))*FD221HHpHp(1,INH3,ICH3,ICH4))/16.+
     &  self(i,j)
             endif
             endif 
           endif
            endif
       enddo 
       enddo 
       enddo 
       enddo 
       enddo 


       do ICH3=1,2
       do ICH4=1,2
       do ICH5=1,2
       do ICH6=1,2
       do INH3= ihiggs,6
          if( Abs(-MassHpm(ICH3) + MassHpm(ICH5)) .gt. 1D-15) then 
             if( Abs(-MassHpm(ICH4) + MassHpm(ICH6)) .gt. 1D-15) then
       self(i,j)=(CS1S3S3(i,ICH5,ICH3)*CS1S3S3(INH3,ICH3,ICH4)*
     &  CS1S3S3(INH3,ICH6,ICH5)*CS1S3S3(j,ICH4,ICH6)*
     &  (FD111HpHpH(1,ICH3,ICH4,INH3)-FD111HpHpH(1,ICH3,ICH6,INH3)-
     &  FD111HpHpH(1,ICH4,ICH5,INH3)+FD111HpHpH(1,ICH5,ICH6,INH3)))
     &  /(16.*(MassHpm(ICH3)**2-MassHpm(ICH5)**2)*(MassHpm(ICH4)**2-
     &  MassHpm(ICH6)**2))+self(i,j)
             else
              if( Abs(MassHpm(ICH6)) .gt. 1D-15) then
       self(i,j)=(CS1S3S3(i,ICH5,ICH3)*CS1S3S3(INH3,ICH3,ICH4)*
     &  CS1S3S3(INH3,ICH4,ICH5)*CS1S3S3(j,ICH4,ICH4)*
     &  (FD211HpHpH(1,ICH4,ICH3,INH3)-FD211HpHpH(1,ICH4,ICH5,INH3)))
     &  /(16.*(MassHpm(ICH3)**2-MassHpm(ICH5)**2))+self(i,j)
              endif
             endif
          else
           if( Abs(-MassHpm(ICH4) + MassHpm(ICH6)) .gt. 1D-15) then 
              if( Abs(MassHpm(ICH5)) .gt. 1D-15) then
       self(i,j)=(CS1S3S3(i,ICH3,ICH3)*CS1S3S3(INH3,ICH3,ICH4)*
     &  CS1S3S3(INH3,ICH6,ICH3)*CS1S3S3(j,ICH4,ICH6)*
     &  (FD211HpHpH(1,ICH3,ICH4,INH3)-FD211HpHpH(1,ICH3,ICH6,INH3)))
     &  /(16.*(MassHpm(ICH4)**2-MassHpm(ICH6)**2))+self(i,j)
              endif
           else 
              if( Abs(MassHpm(ICH5)) .gt. 1D-15) then 
              if( Abs(MassHpm(ICH6)) .gt. 1D-15) then
       self(i,j)=(CS1S3S3(i,ICH3,ICH3)*CS1S3S3(INH3,ICH3,ICH4)*
     &  CS1S3S3(INH3,ICH4,ICH3)*CS1S3S3(j,ICH4,ICH4)*
     &  FD221HpHpH(1,ICH3,ICH4,INH3))/16.+self(i,j)
              endif
              endif 
           endif
         endif
       enddo 
       enddo 
       enddo 
       enddo 
       enddo 

       do INH3= ihiggs,6
       do INH4= ihiggs,6
       do ISt3=1,2
       do ISt4=1,2
       do ISt5=1,2
          if( Abs(-Mah(INH3) + Mah(INH4)) .gt. 1D-15) then 
              if( Abs(-MassSu(ISt3) + MassSu(ISt5)) .gt. 1D-15) then 
       self(i,j)=(3*CSSS(INH3,ISt3,ISt4)*CSSS(INH4,ISt4,ISt5)*
     &  (CS1S1S1(j,INH3,INH4)*CSSS(i,ISt5,ISt3)+CS1S1S1(i,INH3,INH4)*
     &  CSSS(j,ISt5,ISt3))*(FD111HSTST(1,INH3,ISt3,ISt4)-
     &  FD111HSTST(1,INH3,ISt5,ISt4)-FD111HSTST(1,INH4,ISt3,ISt4)+
     &  FD111HSTST(1,INH4,ISt5,ISt4)))/(16.*(Mah(INH3)**2-Mah(INH4)**2)
     &  *(MassSu(ISt3)**2-MassSu(ISt5)**2))+self(i,j)
              else
       selfDP(i,j)=0+selfDP(i,j)
       selfSP(i,j)=0+selfSP(i,j)
       self(i,j)=(3*CSSS(INH3,ISt3,ISt4)*CSSS(INH4,ISt4,ISt3)*
     &  (CS1S1S1(j,INH3,INH4)*CSSS(i,ISt3,ISt3)+CS1S1S1(i,INH3,INH4)*
     &  CSSS(j,ISt3,ISt3))*(FD211StHSt(1,ISt3,INH3,ISt4)-
     &  FD211StHSt(1,ISt3,INH4,ISt4)))/(16.*(Mah(INH3)**2-Mah(INH4)**2)
     &  )+self(i,j)
              endif
         else
             if( Abs(-MassSu(ISt3) + MassSu(ISt5)) .gt. 1D-15) then 
                if( Abs(Mah(INH4)) .gt. 1D-15) then 
       self(i,j)=(3*CSSS(INH3,ISt3,ISt4)*CSSS(INH3,ISt4,ISt5)*
     &  (CS1S1S1(j,INH3,INH3)*CSSS(i,ISt5,ISt3)+CS1S1S1(i,INH3,INH3)*
     &  CSSS(j,ISt5,ISt3))*(FD211HSTST(1,INH3,ISt3,ISt4)-
     &  FD211HSTST(1,INH3,ISt5,ISt4)))/(16.*(MassSu(ISt3)**2-
     &  MassSu(ISt5)**2))+self(i,j)
                endif
             else 
                if( Abs(Mah(INH3)) .gt. 1D-15) then
       self(i,j)=(3*CSSS(INH3,ISt3,ISt4)*CSSS(INH3,ISt4,ISt3)*
     &  (CS1S1S1(j,INH3,INH3)*CSSS(i,ISt3,ISt3)+CS1S1S1(i,INH3,INH3)*
     &  CSSS(j,ISt3,ISt3))*FD221HStSt(1,INH3,ISt3,ISt4))/16.+self(i,j)
                endif 
             endif
         endif
       enddo 
       enddo 
       enddo 
       enddo 
       enddo 

       do ICH3=1,2
       do ICH4=1,2
       do ISt3=1,2
       do ISt4=1,2
          if( Abs(-MassHpm(ICH3) + MassHpm(ICH4)) .gt. 1D-15) then 
              if( Abs(-MassSu(ISt3) + MassSu(ISt4)) .gt. 1D-15) then 
       self(i,j)=(3*CS3S13S(ICH3,ISt3)*CS3S13SC(ICH4,ISt4)*
     &  (CS1S3S3(j,ICH4,ICH3)*CSSS(i,ISt4,ISt3)+CS1S3S3(i,ICH4,ICH3)*
     &  CSSS(j,ISt4,ISt3))*(FD111HpSTSB(1,ICH3,ISt3)-
     &  FD111HpSTSB(1,ICH3,ISt4)-FD111HpSTSB(1,ICH4,ISt3)+
     &  FD111HpSTSB(1,ICH4,ISt4)))/(16.*(MassHpm(ICH3)**2-MassHpm(ICH4)
     &  **2)*(MassSu(ISt3)**2-MassSu(ISt4)**2))+self(i,j)
              else
       self(i,j)=(3*CS3S13S(ICH3,ISt3)*CS3S13SC(ICH4,ISt3)*
     &  (CS1S3S3(j,ICH4,ICH3)*CSSS(i,ISt3,ISt3)+CS1S3S3(i,ICH4,ICH3)*
     &  CSSS(j,ISt3,ISt3))*(FD211StHpSb(1,ISt3,ICH3)-
     &  FD211StHpSb(1,ISt3,ICH4)))/(16.*(MassHpm(ICH3)**2-MassHpm(ICH4)
     &  **2))+self(i,j)
              endif
         else
               if( Abs(-MassSu(ISt3) + MassSu(ISt4)) .gt. 1D-15) then 
                 if( Abs(MassHpm(ICH4)) .gt. 1D-15) then
       self(i,j)=(3*CS3S13S(ICH3,ISt3)*CS3S13SC(ICH3,ISt4)*
     &  (CS1S3S3(j,ICH3,ICH3)*CSSS(i,ISt4,ISt3)+CS1S3S3(i,ICH3,ICH3)*
     &  CSSS(j,ISt4,ISt3))*(FD211HpSTSB(1,ICH3,ISt3)-
     &  FD211HpSTSB(1,ICH3,ISt4)))/(16.*(MassSu(ISt3)**2-MassSu(ISt4)**
     &  2))+self(i,j)
                endif
              else 
                if( Abs(MassHpm(ICH4)) .gt. 1D-15) then 
       selfDP(i,j)=0+selfDP(i,j)
       selfSP(i,j)=0+selfSP(i,j)
       self(i,j)=(3*CS3S13S(ICH3,ISt3)*CS3S13SC(ICH3,ISt3)*
     &  (CS1S3S3(j,ICH3,ICH3)*CSSS(i,ISt3,ISt3)+CS1S3S3(i,ICH3,ICH3)*
     &  CSSS(j,ISt3,ISt3))*FD221HpStSb(1,ICH3,ISt3))/16.+self(i,j)
                endif 
              endif
          endif
       enddo 
       enddo 
       enddo 
       enddo 

c
c topo7
c

       do INe3=ineu,3
       do INe4=ineu,3
       do INe5=ineu,3
       do INe6=ineu,3
       do INH3= ihiggs,6
          if( Abs(-MNeu(INe3) + MNeu(INe4))*Abs(-MNeu(INe3) + MNeu(INe6))*Abs(-MNeu(INe4) + MNeu(INe6)) .gt. 1D-15) then 
       self(i,j)=(CFF11S1L(INe4,INe5,INH3)*(CFF11S1R(INe6,INe3,j)*
     &  (CFF11S1R(INe3,INe4,i)*MNeu(INe3)+CFF11S1L(INe3,INe4,i)*
     &  MNeu(INe4))*(CFF11S1R(INe5,INe6,INH3)*MNeu(INe6)*
     &  (FD111ChiChiH(2,INe5,INe6,INH3)*(-MNeu(INe3)**2+MNeu(INe4)**2)+
     &  FD111ChiChiH(2,INe4,INe5,INH3)*(MNeu(INe3)**2-MNeu(INe6)**2)+
     &  FD111ChiChiH(2,INe3,INe5,INH3)*(-MNeu(INe4)**2+MNeu(INe6)**2))+
     &  CFF11S1L(INe5,INe6,INH3)*MNeu(INe5)*
     &  (FD111ChiChiH(4,INe6,INe5,INH3)*(-MNeu(INe3)**2+MNeu(INe4)**2)+
     &  FD111ChiChiH(4,INe4,INe5,INH3)*(MNeu(INe3)**2-MNeu(INe6)**2)+
     &  FD111ChiChiH(4,INe3,INe5,INH3)*(-MNeu(INe4)**2+MNeu(INe6)**2)))
     &  +CFF11S1L(INe6,INe3,j)*(CFF11S1L(INe3,INe4,i)*MNeu(INe3)*
     &  MNeu(INe4)*(CFF11S1L(INe5,INe6,INH3)*MNeu(INe5)*MNeu(INe6)*
     &  (FD111ChiChiH(1,INe5,INe6,INH3)*(-MNeu(INe3)**2+MNeu(INe4)**2)+
     &  FD111ChiChiH(1,INe4,INe5,INH3)*(MNeu(INe3)**2-MNeu(INe6)**2)+
     &  FD111ChiChiH(1,INe3,INe5,INH3)*(-MNeu(INe4)**2+MNeu(INe6)**2))+
     &  CFF11S1R(INe5,INe6,INH3)*(FD111ChiChiH(2,INe5,INe6,INH3)*(-
     &  MNeu(INe3)**2+MNeu(INe4)**2)+FD111ChiChiH(2,INe4,INe5,INH3)*
     &  (MNeu(INe3)**2-MNeu(INe6)**2)+FD111ChiChiH(2,INe3,INe5,INH3)*(-
     &  MNeu(INe4)**2+MNeu(INe6)**2)))+CFF11S1R(INe3,INe4,i)*
     &  (CFF11S1L(INe5,INe6,INH3)*MNeu(INe5)*MNeu(INe6)*
     &  (FD111ChiChiH(4,INe6,INe5,INH3)*(-MNeu(INe3)**2+MNeu(INe4)**2)+
     &  FD111ChiChiH(4,INe4,INe5,INH3)*(MNeu(INe3)**2-MNeu(INe6)**2)+
     &  FD111ChiChiH(4,INe3,INe5,INH3)*(-MNeu(INe4)**2+MNeu(INe6)**2))+
     &  CFF11S1R(INe5,INe6,INH3)*(FD111ChiChiH(5,INe6,INe5,INH3)*(-
     &  MNeu(INe3)**2+MNeu(INe4)**2)+FD111ChiChiH(5,INe4,INe5,INH3)*
     &  (MNeu(INe3)**2-MNeu(INe6)**2)+FD111ChiChiH(5,INe3,INe5,INH3)*(-
     &  MNeu(INe4)**2+MNeu(INe6)**2)))))+CFF11S1R(INe4,INe5,INH3)*
     &  (CFF11S1R(INe3,INe4,i)*MNeu(INe4)*(CFF11S1L(INe5,INe6,INH3)*
     &  (CFF11S1R(INe6,INe3,j)*MNeu(INe3)+CFF11S1L(INe6,INe3,j)*
     &  MNeu(INe6))*(FD111ChiChiH(2,INe5,INe6,INH3)*(-MNeu(INe3)**2+
     &  MNeu(INe4)**2)+FD111ChiChiH(2,INe4,INe5,INH3)*(MNeu(INe3)**2-
     &  MNeu(INe6)**2)+FD111ChiChiH(2,INe3,INe5,INH3)*(-MNeu(INe4)**2+
     &  MNeu(INe6)**2))+CFF11S1R(INe5,INe6,INH3)*MNeu(INe5)*
     &  (CFF11S1R(INe6,INe3,j)*MNeu(INe3)*MNeu(INe6)*
     &  (FD111ChiChiH(1,INe5,INe6,INH3)*(-MNeu(INe3)**2+MNeu(INe4)**2)+
     &  FD111ChiChiH(1,INe4,INe5,INH3)*(MNeu(INe3)**2-MNeu(INe6)**2)+
     &  FD111ChiChiH(1,INe3,INe5,INH3)*(-MNeu(INe4)**2+MNeu(INe6)**2))+
     &  CFF11S1L(INe6,INe3,j)*(FD111ChiChiH(4,INe6,INe5,INH3)*(-
     &  MNeu(INe3)**2+MNeu(INe4)**2)+FD111ChiChiH(4,INe4,INe5,INH3)*
     &  (MNeu(INe3)**2-MNeu(INe6)**2)+FD111ChiChiH(4,INe3,INe5,INH3)*(-
     &  MNeu(INe4)**2+MNeu(INe6)**2))))+CFF11S1L(INe3,INe4,i)*
     &  (CFF11S1R(INe5,INe6,INH3)*MNeu(INe5)*(CFF11S1L(INe6,INe3,j)*
     &  MNeu(INe3)+CFF11S1R(INe6,INe3,j)*MNeu(INe6))*
     &  (FD111ChiChiH(4,INe6,INe5,INH3)*(-MNeu(INe3)**2+MNeu(INe4)**2)+
     &  FD111ChiChiH(4,INe4,INe5,INH3)*(MNeu(INe3)**2-MNeu(INe6)**2)+
     &  FD111ChiChiH(4,INe3,INe5,INH3)*(-MNeu(INe4)**2+MNeu(INe6)**2))+
     &  CFF11S1L(INe5,INe6,INH3)*(CFF11S1L(INe6,INe3,j)*MNeu(INe3)*
     &  MNeu(INe6)*(FD111ChiChiH(2,INe5,INe6,INH3)*(-MNeu(INe3)**2+
     &  MNeu(INe4)**2)+FD111ChiChiH(2,INe4,INe5,INH3)*(MNeu(INe3)**2-
     &  MNeu(INe6)**2)+FD111ChiChiH(2,INe3,INe5,INH3)*(-MNeu(INe4)**2+
     &  MNeu(INe6)**2))+CFF11S1R(INe6,INe3,j)*
     &  (FD111ChiChiH(5,INe6,INe5,INH3)*(-MNeu(INe3)**2+MNeu(INe4)**2)+
     &  FD111ChiChiH(5,INe4,INe5,INH3)*(MNeu(INe3)**2-MNeu(INe6)**2)+
     &  FD111ChiChiH(5,INe3,INe5,INH3)*(-MNeu(INe4)**2+MNeu(INe6)**2)))
     &  )))/(8.*(MNeu(INe3)-MNeu(INe4))*(MNeu(INe3)+MNeu(INe4))*
     &  (MNeu(INe3)-MNeu(INe6))*(MNeu(INe4)-MNeu(INe6))*(MNeu(INe3)+
     &  MNeu(INe6))*(MNeu(INe4)+MNeu(INe6)))+self(i,j)
           else
             if( Abs(-MNeu(INe3) + MNeu(INe6))*Abs(-MNeu(INe4) + MNeu(INe6)) .gt. 1D-15) then 
       self(i,j)=(CFF11S1R(INe3,INe5,INH3)*(CFF11S1L(INe3,INe3,i)*
     &  (CFF11S1R(INe5,INe6,INH3)*MNeu(INe5)*(CFF11S1L(INe6,INe3,j)*
     &  MNeu(INe3)+CFF11S1R(INe6,INe3,j)*MNeu(INe6))*
     &  (FD111ChiChiH(4,INe3,INe5,INH3)-FD111ChiChiH(4,INe6,INe5,INH3)+
     &  FD211ChiChiH(4,INe3,INe5,INH3)*(-MNeu(INe3)**2+MNeu(INe6)**2))+
     &  CFF11S1L(INe5,INe6,INH3)*(CFF11S1L(INe6,INe3,j)*MNeu(INe3)*
     &  MNeu(INe6)*(FD111ChiChiH(2,INe3,INe5,INH3)-
     &  FD111ChiChiH(2,INe5,INe6,INH3)+FD211ChiChiH(2,INe3,INe5,INH3)*
     &  (-MNeu(INe3)**2+MNeu(INe6)**2))+CFF11S1R(INe6,INe3,j)*
     &  (FD111ChiChiH(5,INe3,INe5,INH3)-FD111ChiChiH(5,INe6,INe5,INH3)+
     &  FD211ChiChiH(5,INe3,INe5,INH3)*(-MNeu(INe3)**2+MNeu(INe6)**2)))
     &  )+CFF11S1R(INe3,INe3,i)*(CFF11S1L(INe5,INe6,INH3)*MNeu(INe3)*
     &  (CFF11S1R(INe6,INe3,j)*MNeu(INe3)+CFF11S1L(INe6,INe3,j)*
     &  MNeu(INe6))*(FD111ChiChiH(2,INe3,INe5,INH3)-
     &  FD111ChiChiH(2,INe5,INe6,INH3)+FD211ChiChiH(2,INe3,INe5,INH3)*
     &  (-MNeu(INe3)**2+MNeu(INe6)**2))+CFF11S1R(INe5,INe6,INH3)*
     &  MNeu(INe5)*(CFF11S1L(INe6,INe3,j)*MNeu(INe3)*
     &  (FD111ChiChiH(4,INe3,INe5,INH3)-FD111ChiChiH(4,INe6,INe5,INH3)+
     &  FD211ChiChiH(4,INe3,INe5,INH3)*(-MNeu(INe3)**2+MNeu(INe6)**2))+
     &  CFF11S1R(INe6,INe3,j)*MNeu(INe6)*
     &  (FD111ChiChiH(1,INe3,INe5,INH3)-FD111ChiChiH(1,INe5,INe6,INH3)+
     &  FD211ChiChiH(1,INe3,INe5,INH3)*(-MNeu(INe3)**2+MNeu(INe6)**2))*
     &  MNeu2(INe3))))+CFF11S1L(INe3,INe5,INH3)*((CFF11S1L(INe3,INe3,i)
     &  +CFF11S1R(INe3,INe3,i))*CFF11S1R(INe6,INe3,j)*MNeu(INe3)*
     &  (CFF11S1R(INe5,INe6,INH3)*MNeu(INe6)*
     &  (FD111ChiChiH(2,INe3,INe5,INH3)-FD111ChiChiH(2,INe5,INe6,INH3)+
     &  FD211ChiChiH(2,INe3,INe5,INH3)*(-MNeu(INe3)**2+MNeu(INe6)**2))+
     &  CFF11S1L(INe5,INe6,INH3)*MNeu(INe5)*
     &  (FD111ChiChiH(4,INe3,INe5,INH3)-FD111ChiChiH(4,INe6,INe5,INH3)+
     &  FD211ChiChiH(4,INe3,INe5,INH3)*(-MNeu(INe3)**2+MNeu(INe6)**2)))
     &  +CFF11S1L(INe6,INe3,j)*(CFF11S1R(INe3,INe3,i)*
     &  (CFF11S1L(INe5,INe6,INH3)*MNeu(INe5)*MNeu(INe6)*
     &  (FD111ChiChiH(4,INe3,INe5,INH3)-FD111ChiChiH(4,INe6,INe5,INH3)+
     &  FD211ChiChiH(4,INe3,INe5,INH3)*(-MNeu(INe3)**2+MNeu(INe6)**2))+
     &  CFF11S1R(INe5,INe6,INH3)*(FD111ChiChiH(5,INe3,INe5,INH3)-
     &  FD111ChiChiH(5,INe6,INe5,INH3)+FD211ChiChiH(5,INe3,INe5,INH3)*
     &  (-MNeu(INe3)**2+MNeu(INe6)**2)))+CFF11S1L(INe3,INe3,i)*
     &  (CFF11S1R(INe5,INe6,INH3)*MNeu(INe3)**2*
     &  (FD111ChiChiH(2,INe3,INe5,INH3)-FD111ChiChiH(2,INe5,INe6,INH3)+
     &  FD211ChiChiH(2,INe3,INe5,INH3)*(-MNeu(INe3)**2+MNeu(INe6)**2))+
     &  CFF11S1L(INe5,INe6,INH3)*MNeu(INe5)*MNeu(INe6)*
     &  (FD111ChiChiH(1,INe3,INe5,INH3)-FD111ChiChiH(1,INe5,INe6,INH3)+
     &  FD211ChiChiH(1,INe3,INe5,INH3)*(-MNeu(INe3)**2+MNeu(INe6)**2))*
     &  MNeu2(INe3)))))/(8.*(MNeu(INe3)**2-MNeu(INe6)**2)**2)+self(i,j)
             endif
             if( Abs(-MNeu(INe3) + MNeu(INe4))*Abs(-MNeu(INe4) + MNeu(INe6)) .gt. 1D-15) then 
       self(i,j)=(CFF11S1R(INe3,INe4,i)*(CFF11S1L(INe3,INe3,j)*
     &  (CFF11S1R(INe4,INe5,INH3)*MNeu(INe4)*(CFF11S1L(INe5,INe3,INH3)*
     &  MNeu(INe3)*(FD111ChiChiH(2,INe3,INe5,INH3)-
     &  FD111ChiChiH(2,INe4,INe5,INH3)+FD211ChiChiH(2,INe3,INe5,INH3)*
     &  (-MNeu(INe3)**2+MNeu(INe4)**2))+CFF11S1R(INe5,INe3,INH3)*
     &  (FD111ChiChiH(4,INe3,INe5,INH3)-FD111ChiChiH(4,INe4,INe5,INH3)+
     &  FD211ChiChiH(4,INe3,INe5,INH3)*(-MNeu(INe3)**2+MNeu(INe4)**2))*
     &  MNeu(INe5))+CFF11S1L(INe4,INe5,INH3)*(CFF11S1R(INe5,INe3,INH3)*
     &  (FD111ChiChiH(5,INe3,INe5,INH3)-FD111ChiChiH(5,INe4,INe5,INH3)+
     &  FD211ChiChiH(5,INe3,INe5,INH3)*(-MNeu(INe3)**2+MNeu(INe4)**2))+
     &  CFF11S1L(INe5,INe3,INH3)*MNeu(INe3)*
     &  (FD111ChiChiH(4,INe3,INe5,INH3)-FD111ChiChiH(4,INe4,INe5,INH3)+
     &  FD211ChiChiH(4,INe3,INe5,INH3)*(-MNeu(INe3)**2+MNeu(INe4)**2))*
     &  MNeu(INe5)))+CFF11S1R(INe3,INe3,j)*(CFF11S1L(INe4,INe5,INH3)*
     &  MNeu(INe3)*(CFF11S1R(INe5,INe3,INH3)*MNeu(INe3)*
     &  (FD111ChiChiH(2,INe3,INe5,INH3)-FD111ChiChiH(2,INe4,INe5,INH3)+
     &  FD211ChiChiH(2,INe3,INe5,INH3)*(-MNeu(INe3)**2+MNeu(INe4)**2))+
     &  CFF11S1L(INe5,INe3,INH3)*(FD111ChiChiH(4,INe3,INe5,INH3)-
     &  FD111ChiChiH(4,INe4,INe5,INH3)+FD211ChiChiH(4,INe3,INe5,INH3)*
     &  (-MNeu(INe3)**2+MNeu(INe4)**2))*MNeu(INe5))+
     &  CFF11S1R(INe4,INe5,INH3)*MNeu(INe4)*(CFF11S1L(INe5,INe3,INH3)*
     &  MNeu(INe3)*(FD111ChiChiH(2,INe3,INe5,INH3)-
     &  FD111ChiChiH(2,INe4,INe5,INH3)+FD211ChiChiH(2,INe3,INe5,INH3)*
     &  (-MNeu(INe3)**2+MNeu(INe4)**2))+CFF11S1R(INe5,INe3,INH3)*
     &  (FD111ChiChiH(1,INe3,INe5,INH3)-FD111ChiChiH(1,INe4,INe5,INH3)+
     &  FD211ChiChiH(1,INe3,INe5,INH3)*(-MNeu(INe3)**2+MNeu(INe4)**2))*
     &  MNeu(INe5)*MNeu2(INe3))))+CFF11S1L(INe3,INe4,i)*
     &  ((CFF11S1L(INe3,INe3,j)+CFF11S1R(INe3,INe3,j))*
     &  CFF11S1R(INe5,INe3,INH3)*MNeu(INe3)*(CFF11S1L(INe4,INe5,INH3)*
     &  MNeu(INe4)*(FD111ChiChiH(2,INe3,INe5,INH3)-
     &  FD111ChiChiH(2,INe4,INe5,INH3)+FD211ChiChiH(2,INe3,INe5,INH3)*
     &  (-MNeu(INe3)**2+MNeu(INe4)**2))+CFF11S1R(INe4,INe5,INH3)*
     &  (FD111ChiChiH(4,INe3,INe5,INH3)-FD111ChiChiH(4,INe4,INe5,INH3)+
     &  FD211ChiChiH(4,INe3,INe5,INH3)*(-MNeu(INe3)**2+MNeu(INe4)**2))*
     &  MNeu(INe5))+CFF11S1L(INe5,INe3,INH3)*(CFF11S1R(INe3,INe3,j)*
     &  (CFF11S1R(INe4,INe5,INH3)*(FD111ChiChiH(5,INe3,INe5,INH3)-
     &  FD111ChiChiH(5,INe4,INe5,INH3)+FD211ChiChiH(5,INe3,INe5,INH3)*
     &  (-MNeu(INe3)**2+MNeu(INe4)**2))+CFF11S1L(INe4,INe5,INH3)*
     &  MNeu(INe4)*(FD111ChiChiH(4,INe3,INe5,INH3)-
     &  FD111ChiChiH(4,INe4,INe5,INH3)+FD211ChiChiH(4,INe3,INe5,INH3)*
     &  (-MNeu(INe3)**2+MNeu(INe4)**2))*MNeu(INe5))+
     &  CFF11S1L(INe3,INe3,j)*(CFF11S1R(INe4,INe5,INH3)*MNeu(INe3)**2*
     &  (FD111ChiChiH(2,INe3,INe5,INH3)-FD111ChiChiH(2,INe4,INe5,INH3)+
     &  FD211ChiChiH(2,INe3,INe5,INH3)*(-MNeu(INe3)**2+MNeu(INe4)**2))+
     &  CFF11S1L(INe4,INe5,INH3)*MNeu(INe4)*
     &  (FD111ChiChiH(1,INe3,INe5,INH3)-FD111ChiChiH(1,INe4,INe5,INH3)+
     &  FD211ChiChiH(1,INe3,INe5,INH3)*(-MNeu(INe3)**2+MNeu(INe4)**2))*
     &  MNeu(INe5)*MNeu2(INe3)))))/(8.*(MNeu(INe3)**2-MNeu(INe4)**2)**2)+self(i,j)
             endif
             if( Abs(MNeu(INe3) - MNeu(INe4))*Abs(-MNeu(INe3) + MNeu(INe6)) .gt. 1D-15) then 
       self(i,j)=(CFF11S1L(INe3,INe4,i)*(CFF11S1R(INe5,INe4,INH3)*
     &  (CFF11S1L(INe4,INe3,j)*MNeu(INe3)+CFF11S1R(INe4,INe3,j)*
     &  MNeu(INe4))*(CFF11S1L(INe4,INe5,INH3)*MNeu(INe4)*(-
     &  FD111ChiChiH(2,INe3,INe5,INH3)+FD111ChiChiH(2,INe4,INe5,INH3)+
     &  FD211ChiChiH(2,INe4,INe5,INH3)*(MNeu(INe3)**2-MNeu(INe4)**2))+
     &  CFF11S1R(INe4,INe5,INH3)*(-FD111ChiChiH(4,INe3,INe5,INH3)+
     &  FD111ChiChiH(4,INe4,INe5,INH3)+FD211ChiChiH(4,INe4,INe5,INH3)*
     &  (MNeu(INe3)**2-MNeu(INe4)**2))*MNeu(INe5))+
     &  CFF11S1L(INe5,INe4,INH3)*(CFF11S1R(INe4,INe3,j)*
     &  (CFF11S1R(INe4,INe5,INH3)*(-FD111ChiChiH(5,INe3,INe5,INH3)+
     &  FD111ChiChiH(5,INe4,INe5,INH3)+FD211ChiChiH(5,INe4,INe5,INH3)*
     &  (MNeu(INe3)**2-MNeu(INe4)**2))+CFF11S1L(INe4,INe5,INH3)*
     &  MNeu(INe4)*(-FD111ChiChiH(4,INe3,INe5,INH3)+
     &  FD111ChiChiH(4,INe4,INe5,INH3)+FD211ChiChiH(4,INe4,INe5,INH3)*
     &  (MNeu(INe3)**2-MNeu(INe4)**2))*MNeu(INe5))+
     &  CFF11S1L(INe4,INe3,j)*MNeu(INe3)*(CFF11S1R(INe4,INe5,INH3)*
     &  MNeu(INe4)*(-FD111ChiChiH(2,INe3,INe5,INH3)+
     &  FD111ChiChiH(2,INe4,INe5,INH3)+FD211ChiChiH(2,INe4,INe5,INH3)*
     &  (MNeu(INe3)**2-MNeu(INe4)**2))+CFF11S1L(INe4,INe5,INH3)*(-
     &  FD111ChiChiH(1,INe3,INe5,INH3)+FD111ChiChiH(1,INe4,INe5,INH3)+
     &  FD211ChiChiH(1,INe4,INe5,INH3)*(MNeu(INe3)**2-MNeu(INe4)**2))*
     &  MNeu(INe5)*MNeu2(INe4))))+CFF11S1R(INe3,INe4,i)*
     &  (CFF11S1L(INe4,INe3,j)*(CFF11S1R(INe4,INe5,INH3)*MNeu(INe4)*
     &  (CFF11S1L(INe5,INe4,INH3)*MNeu(INe4)*(-
     &  FD111ChiChiH(2,INe3,INe5,INH3)+FD111ChiChiH(2,INe4,INe5,INH3)+
     &  FD211ChiChiH(2,INe4,INe5,INH3)*(MNeu(INe3)**2-MNeu(INe4)**2))+
     &  CFF11S1R(INe5,INe4,INH3)*(-FD111ChiChiH(4,INe3,INe5,INH3)+
     &  FD111ChiChiH(4,INe4,INe5,INH3)+FD211ChiChiH(4,INe4,INe5,INH3)*
     &  (MNeu(INe3)**2-MNeu(INe4)**2))*MNeu(INe5))+
     &  CFF11S1L(INe4,INe5,INH3)*(CFF11S1R(INe5,INe4,INH3)*(-
     &  FD111ChiChiH(5,INe3,INe5,INH3)+FD111ChiChiH(5,INe4,INe5,INH3)+
     &  FD211ChiChiH(5,INe4,INe5,INH3)*(MNeu(INe3)**2-MNeu(INe4)**2))+
     &  CFF11S1L(INe5,INe4,INH3)*MNeu(INe4)*(-
     &  FD111ChiChiH(4,INe3,INe5,INH3)+FD111ChiChiH(4,INe4,INe5,INH3)+
     &  FD211ChiChiH(4,INe4,INe5,INH3)*(MNeu(INe3)**2-MNeu(INe4)**2))*
     &  MNeu(INe5)))+CFF11S1R(INe4,INe3,j)*MNeu(INe3)*
     &  (CFF11S1L(INe5,INe4,INH3)*(CFF11S1R(INe4,INe5,INH3)*MNeu(INe4)*
     &  (-FD111ChiChiH(2,INe3,INe5,INH3)+FD111ChiChiH(2,INe4,INe5,INH3)
     &  +FD211ChiChiH(2,INe4,INe5,INH3)*(MNeu(INe3)**2-MNeu(INe4)**2))+
     &  CFF11S1L(INe4,INe5,INH3)*(-FD111ChiChiH(4,INe3,INe5,INH3)+
     &  FD111ChiChiH(4,INe4,INe5,INH3)+FD211ChiChiH(4,INe4,INe5,INH3)*
     &  (MNeu(INe3)**2-MNeu(INe4)**2))*MNeu(INe5))+
     &  CFF11S1R(INe5,INe4,INH3)*(CFF11S1L(INe4,INe5,INH3)*MNeu(INe4)*
     &  (-FD111ChiChiH(2,INe3,INe5,INH3)+FD111ChiChiH(2,INe4,INe5,INH3)
     &  +FD211ChiChiH(2,INe4,INe5,INH3)*(MNeu(INe3)**2-MNeu(INe4)**2))+
     &  CFF11S1R(INe4,INe5,INH3)*(-FD111ChiChiH(1,INe3,INe5,INH3)+
     &  FD111ChiChiH(1,INe4,INe5,INH3)+FD211ChiChiH(1,INe4,INe5,INH3)*
     &  (MNeu(INe3)**2-MNeu(INe4)**2))*MNeu(INe5)*MNeu2(INe4)))))/(8.*
     &  (MNeu(INe3)**2-MNeu(INe4)**2)**2)+self(i,j)
             endif
             if( Abs(-MNeu(INe3) + MNeu(INe6)) .lt. 1D-15 .AND. Abs(MNeu(INe3) - MNeu(INe4)) .lt. 1D-15) then 
       self(i,j)=(-(CFF11S1L(INe3,INe3,i)*((CFF11S1L(INe3,INe3,j)+
     &  CFF11S1R(INe3,INe3,j))*CFF11S1R(INe5,INe3,INH3)*
     &  (CFF11S1R(INe3,INe5,INH3)*FD311ChiChiH(3,INe3,INe5,INH3)*
     &  MNeu(INe3)*MNeu(INe5)+CFF11S1L(INe3,INe5,INH3)*
     &  FD311ChiChiH(2,INe3,INe5,INH3)*MNeu2(INe3))+
     &  CFF11S1L(INe5,INe3,INH3)*(CFF11S1R(INe3,INe3,j)*
     &  (CFF11S1R(INe3,INe5,INH3)*FD311ChiChiH(4,INe3,INe5,INH3)+
     &  CFF11S1L(INe3,INe5,INH3)*FD311ChiChiH(3,INe3,INe5,INH3)*
     &  MNeu(INe3)*MNeu(INe5))+CFF11S1L(INe3,INe3,j)*
     &  (CFF11S1L(INe3,INe5,INH3)*FD311ChiChiH(1,INe3,INe5,INH3)*
     &  MNeu(INe3)**3*MNeu(INe5)+CFF11S1R(INe3,INe5,INH3)*
     &  FD311ChiChiH(2,INe3,INe5,INH3)*MNeu2(INe3)))))-
     &  CFF11S1R(INe3,INe3,i)*(CFF11S1L(INe3,INe3,j)*
     &  (CFF11S1L(INe3,INe5,INH3)*(CFF11S1R(INe5,INe3,INH3)*
     &  FD311ChiChiH(4,INe3,INe5,INH3)+CFF11S1L(INe5,INe3,INH3)*
     &  FD311ChiChiH(3,INe3,INe5,INH3)*MNeu(INe3)*MNeu(INe5))+
     &  CFF11S1R(INe3,INe5,INH3)*(CFF11S1R(INe5,INe3,INH3)*
     &  FD311ChiChiH(3,INe3,INe5,INH3)*MNeu(INe3)*MNeu(INe5)+
     &  CFF11S1L(INe5,INe3,INH3)*FD311ChiChiH(2,INe3,INe5,INH3)*
     &  MNeu2(INe3)))+CFF11S1R(INe3,INe3,j)*(CFF11S1R(INe3,INe5,INH3)*
     &  (CFF11S1R(INe5,INe3,INH3)*FD311ChiChiH(1,INe3,INe5,INH3)*
     &  MNeu(INe3)**3*MNeu(INe5)+CFF11S1L(INe5,INe3,INH3)*
     &  FD311ChiChiH(2,INe3,INe5,INH3)*MNeu2(INe3))+
     &  CFF11S1L(INe3,INe5,INH3)*(CFF11S1L(INe5,INe3,INH3)*
     &  FD311ChiChiH(3,INe3,INe5,INH3)*MNeu(INe3)*MNeu(INe5)+
     &  CFF11S1R(INe5,INe3,INH3)*FD311ChiChiH(2,INe3,INe5,INH3)*MNeu2(INe3)))))/8.+self(i,j)
             endif
           endif
       enddo 
       enddo 
       enddo 
       enddo 
       enddo 
c 2
       do INH3= ihiggs,6
       self(i,j)=(-(CFF12S1R(i)*(MCha2*CFF12S1L(INH3)**2*(CFF12S1L(j)+
     &  CFF12S1R(j))*FD311ChaChaH(3,INH3)+MCha2*CFF12S1R(INH3)**2*
     &  (MCha2*CFF12S1R(j)*FD311ChaChaH(1,INH3)+CFF12S1L(j)*
     &  FD311ChaChaH(3,INH3))+CFF12S1L(INH3)*CFF12S1R(INH3)*(2*MCha2*
     &  CFF12S1R(j)*FD311ChaChaH(2,INH3)+CFF12S1L(j)*(MCha2*
     &  FD311ChaChaH(2,INH3)+FD311ChaChaH(4,INH3)))))-CFF12S1L(i)*
     &  (MCha2*CFF12S1R(INH3)**2*(CFF12S1L(j)+CFF12S1R(j))*
     &  FD311ChaChaH(3,INH3)+MCha2*CFF12S1L(INH3)**2*(MCha2*CFF12S1L(j)
     &  *FD311ChaChaH(1,INH3)+CFF12S1R(j)*FD311ChaChaH(3,INH3))+
     &  CFF12S1L(INH3)*CFF12S1R(INH3)*(2*MCha2*CFF12S1L(j)*
     &  FD311ChaChaH(2,INH3)+CFF12S1R(j)*(MCha2*FD311ChaChaH(2,INH3)+
     &  FD311ChaChaH(4,INH3)))))/4.+self(i,j)
       enddo 


       do ICH3=1,2
       do INe3=ineu,3
       do INe4=ineu,3
       do INe5=ineu,3
          if( Abs(-MNeu(INe3) + MNeu(INe4))*Abs(-MNeu(INe3) + MNeu(INe5))*Abs(-MNeu(INe4) + MNeu(INe5)) .gt. 1D-15) then 
       self(i,j)=(-(((CF11F12S3L(INe5,ICH3)*CFF11S1L(INe3,INe4,i)*
     &  CFF11S1R(INe5,INe3,j)*DCONJG(CF11F12S3L(INe4,ICH3))+
     &  CF11F12S3R(INe5,ICH3)*CFF11S1L(INe5,INe3,j)*
     &  CFF11S1R(INe3,INe4,i)*DCONJG(CF11F12S3R(INe4,ICH3)))*
     &  FD111ChaChiHp(8,INe3,ICH3))/((MNeu(INe3)-MNeu(INe4))*
     &  (MNeu(INe3)+MNeu(INe4))*(MNeu(INe3)-MNeu(INe5))*(MNeu(INe3)+
     &  MNeu(INe5))))-((CF11F12S3L(INe4,ICH3)*CFF11S1L(INe5,INe3,j)*
     &  CFF11S1R(INe3,INe4,i)*DCONJG(CF11F12S3L(INe5,ICH3))+
     &  CF11F12S3R(INe4,ICH3)*CFF11S1L(INe3,INe4,i)*
     &  CFF11S1R(INe5,INe3,j)*DCONJG(CF11F12S3R(INe5,ICH3)))*
     &  FD111ChaChiHp(8,INe3,ICH3))/((MNeu(INe3)-MNeu(INe4))*
     &  (MNeu(INe3)+MNeu(INe4))*(MNeu(INe3)-MNeu(INe5))*(MNeu(INe3)+
     &  MNeu(INe5)))-(MCha*(CF11F12S3R(INe5,ICH3)*CFF11S1R(INe3,INe4,i)
     &  *CFF11S1R(INe5,INe3,j)*DCONJG(CF11F12S3L(INe4,ICH3))+
     &  CF11F12S3L(INe5,ICH3)*CFF11S1L(INe3,INe4,i)*
     &  CFF11S1L(INe5,INe3,j)*DCONJG(CF11F12S3R(INe4,ICH3)))*
     &  FD111ChaChiHp(1,INe3,ICH3)*MNeu(INe3)*MNeu(INe4)*MNeu(INe5))
     &  /((MNeu(INe3)-MNeu(INe4))*(MNeu(INe3)+MNeu(INe4))*(MNeu(INe3)-
     &  MNeu(INe5))*(MNeu(INe3)+MNeu(INe5)))-(MCha*
     &  (CF11F12S3R(INe4,ICH3)*CFF11S1R(INe3,INe4,i)*
     &  CFF11S1R(INe5,INe3,j)*DCONJG(CF11F12S3L(INe5,ICH3))+
     &  CF11F12S3L(INe4,ICH3)*CFF11S1L(INe3,INe4,i)*
     &  CFF11S1L(INe5,INe3,j)*DCONJG(CF11F12S3R(INe5,ICH3)))*
     &  FD111ChaChiHp(1,INe3,ICH3)*MNeu(INe3)*MNeu(INe4)*MNeu(INe5))
     &  /((MNeu(INe3)-MNeu(INe4))*(MNeu(INe3)+MNeu(INe4))*(MNeu(INe3)-
     &  MNeu(INe5))*(MNeu(INe3)+MNeu(INe5)))+((CF11F12S3L(INe5,ICH3)*
     &  CFF11S1L(INe3,INe4,i)*CFF11S1R(INe5,INe3,j)*
     &  DCONJG(CF11F12S3L(INe4,ICH3))+CF11F12S3R(INe5,ICH3)*
     &  CFF11S1L(INe5,INe3,j)*CFF11S1R(INe3,INe4,i)*
     &  DCONJG(CF11F12S3R(INe4,ICH3)))*FD111ChaChiHp(8,INe4,ICH3))
     &  /((MNeu(INe3)-MNeu(INe4))*(MNeu(INe3)+MNeu(INe4))*(MNeu(INe4)-
     &  MNeu(INe5))*(MNeu(INe4)+MNeu(INe5)))+((CF11F12S3L(INe4,ICH3)*
     &  CFF11S1L(INe5,INe3,j)*CFF11S1R(INe3,INe4,i)*
     &  DCONJG(CF11F12S3L(INe5,ICH3))+CF11F12S3R(INe4,ICH3)*
     &  CFF11S1L(INe3,INe4,i)*CFF11S1R(INe5,INe3,j)*
     &  DCONJG(CF11F12S3R(INe5,ICH3)))*FD111ChaChiHp(8,INe4,ICH3))
     &  /((MNeu(INe3)-MNeu(INe4))*(MNeu(INe3)+MNeu(INe4))*(MNeu(INe4)-
     &  MNeu(INe5))*(MNeu(INe4)+MNeu(INe5)))+(MCha*
     &  (CF11F12S3R(INe5,ICH3)*CFF11S1R(INe3,INe4,i)*
     &  CFF11S1R(INe5,INe3,j)*DCONJG(CF11F12S3L(INe4,ICH3))+
     &  CF11F12S3L(INe5,ICH3)*CFF11S1L(INe3,INe4,i)*
     &  CFF11S1L(INe5,INe3,j)*DCONJG(CF11F12S3R(INe4,ICH3)))*
     &  FD111ChaChiHp(1,INe4,ICH3)*MNeu(INe3)*MNeu(INe4)*MNeu(INe5))
     &  /((MNeu(INe3)-MNeu(INe4))*(MNeu(INe3)+MNeu(INe4))*(MNeu(INe4)-
     &  MNeu(INe5))*(MNeu(INe4)+MNeu(INe5)))+(MCha*
     &  (CF11F12S3R(INe4,ICH3)*CFF11S1R(INe3,INe4,i)*
     &  CFF11S1R(INe5,INe3,j)*DCONJG(CF11F12S3L(INe5,ICH3))+
     &  CF11F12S3L(INe4,ICH3)*CFF11S1L(INe3,INe4,i)*
     &  CFF11S1L(INe5,INe3,j)*DCONJG(CF11F12S3R(INe5,ICH3)))*
     &  FD111ChaChiHp(1,INe4,ICH3)*MNeu(INe3)*MNeu(INe4)*MNeu(INe5))
     &  /((MNeu(INe3)-MNeu(INe4))*(MNeu(INe3)+MNeu(INe4))*(MNeu(INe4)-
     &  MNeu(INe5))*(MNeu(INe4)+MNeu(INe5)))+((CF11F12S3L(INe5,ICH3)*
     &  CFF11S1L(INe3,INe4,i)*CFF11S1R(INe5,INe3,j)*
     &  DCONJG(CF11F12S3L(INe4,ICH3))+CF11F12S3R(INe5,ICH3)*
     &  CFF11S1L(INe5,INe3,j)*CFF11S1R(INe3,INe4,i)*
     &  DCONJG(CF11F12S3R(INe4,ICH3)))*FD111ChaChiHp(8,INe5,ICH3))
     &  /((MNeu(INe3)-MNeu(INe5))*(MNeu(INe3)+MNeu(INe5))*(-MNeu(INe4)+
     &  MNeu(INe5))*(MNeu(INe4)+MNeu(INe5)))+((CF11F12S3L(INe4,ICH3)*
     &  CFF11S1L(INe5,INe3,j)*CFF11S1R(INe3,INe4,i)*
     &  DCONJG(CF11F12S3L(INe5,ICH3))+CF11F12S3R(INe4,ICH3)*
     &  CFF11S1L(INe3,INe4,i)*CFF11S1R(INe5,INe3,j)*
     &  DCONJG(CF11F12S3R(INe5,ICH3)))*FD111ChaChiHp(8,INe5,ICH3))
     &  /((MNeu(INe3)-MNeu(INe5))*(MNeu(INe3)+MNeu(INe5))*(-MNeu(INe4)+
     &  MNeu(INe5))*(MNeu(INe4)+MNeu(INe5)))+(MCha*
     &  (CF11F12S3R(INe5,ICH3)*CFF11S1R(INe3,INe4,i)*
     &  CFF11S1R(INe5,INe3,j)*DCONJG(CF11F12S3L(INe4,ICH3))+
     &  CF11F12S3L(INe5,ICH3)*CFF11S1L(INe3,INe4,i)*
     &  CFF11S1L(INe5,INe3,j)*DCONJG(CF11F12S3R(INe4,ICH3)))*
     &  FD111ChaChiHp(1,INe5,ICH3)*MNeu(INe3)*MNeu(INe4)*MNeu(INe5))
     &  /((MNeu(INe3)-MNeu(INe5))*(MNeu(INe3)+MNeu(INe5))*(-MNeu(INe4)+
     &  MNeu(INe5))*(MNeu(INe4)+MNeu(INe5)))+(MCha*
     &  (CF11F12S3R(INe4,ICH3)*CFF11S1R(INe3,INe4,i)*
     &  CFF11S1R(INe5,INe3,j)*DCONJG(CF11F12S3L(INe5,ICH3))+
     &  CF11F12S3L(INe4,ICH3)*CFF11S1L(INe3,INe4,i)*
     &  CFF11S1L(INe5,INe3,j)*DCONJG(CF11F12S3R(INe5,ICH3)))*
     &  FD111ChaChiHp(1,INe5,ICH3)*MNeu(INe3)*MNeu(INe4)*MNeu(INe5))
     &  /((MNeu(INe3)-MNeu(INe5))*(MNeu(INe3)+MNeu(INe5))*(-MNeu(INe4)+
     &  MNeu(INe5))*(MNeu(INe4)+MNeu(INe5)))-(MCha*
     &  FD111ChiChaHp(4,INe3,ICH3)*(CF11F12S3L(INe5,ICH3)*
     &  DCONJG(CF11F12S3R(INe4,ICH3))*(CFF11S1L(INe3,INe4,i)*
     &  CFF11S1R(INe5,INe3,j)*MNeu(INe4)+CFF11S1R(INe3,INe4,i)*
     &  (CFF11S1R(INe5,INe3,j)*MNeu(INe3)+CFF11S1L(INe5,INe3,j)*
     &  MNeu(INe5)))+CF11F12S3R(INe5,ICH3)*DCONJG(CF11F12S3L(INe4,ICH3)
     &  )*(CFF11S1L(INe5,INe3,j)*CFF11S1R(INe3,INe4,i)*MNeu(INe4)+
     &  CFF11S1L(INe3,INe4,i)*(CFF11S1L(INe5,INe3,j)*MNeu(INe3)+
     &  CFF11S1R(INe5,INe3,j)*MNeu(INe5)))))/((MNeu(INe3)-MNeu(INe4))*
     &  (MNeu(INe3)+MNeu(INe4))*(MNeu(INe3)-MNeu(INe5))*(MNeu(INe3)+
     &  MNeu(INe5)))+(MCha*FD111ChiChaHp(4,INe4,ICH3)*
     &  (CF11F12S3L(INe5,ICH3)*DCONJG(CF11F12S3R(INe4,ICH3))*
     &  (CFF11S1L(INe3,INe4,i)*CFF11S1R(INe5,INe3,j)*MNeu(INe4)+
     &  CFF11S1R(INe3,INe4,i)*(CFF11S1R(INe5,INe3,j)*MNeu(INe3)+
     &  CFF11S1L(INe5,INe3,j)*MNeu(INe5)))+CF11F12S3R(INe5,ICH3)*
     &  DCONJG(CF11F12S3L(INe4,ICH3))*(CFF11S1L(INe5,INe3,j)*
     &  CFF11S1R(INe3,INe4,i)*MNeu(INe4)+CFF11S1L(INe3,INe4,i)*
     &  (CFF11S1L(INe5,INe3,j)*MNeu(INe3)+CFF11S1R(INe5,INe3,j)*
     &  MNeu(INe5)))))/((MNeu(INe3)-MNeu(INe4))*(MNeu(INe3)+MNeu(INe4))
     &  *(MNeu(INe4)-MNeu(INe5))*(MNeu(INe4)+MNeu(INe5)))+(MCha*
     &  FD111ChiChaHp(4,INe5,ICH3)*(CF11F12S3L(INe5,ICH3)*
     &  DCONJG(CF11F12S3R(INe4,ICH3))*(CFF11S1L(INe3,INe4,i)*
     &  CFF11S1R(INe5,INe3,j)*MNeu(INe4)+CFF11S1R(INe3,INe4,i)*
     &  (CFF11S1R(INe5,INe3,j)*MNeu(INe3)+CFF11S1L(INe5,INe3,j)*
     &  MNeu(INe5)))+CF11F12S3R(INe5,ICH3)*DCONJG(CF11F12S3L(INe4,ICH3)
     &  )*(CFF11S1L(INe5,INe3,j)*CFF11S1R(INe3,INe4,i)*MNeu(INe4)+
     &  CFF11S1L(INe3,INe4,i)*(CFF11S1L(INe5,INe3,j)*MNeu(INe3)+
     &  CFF11S1R(INe5,INe3,j)*MNeu(INe5)))))/((MNeu(INe3)-MNeu(INe5))*
     &  (MNeu(INe3)+MNeu(INe5))*(-MNeu(INe4)+MNeu(INe5))*(MNeu(INe4)+
     &  MNeu(INe5)))-(MCha*FD111ChiChaHp(4,INe3,ICH3)*
     &  (CF11F12S3L(INe4,ICH3)*DCONJG(CF11F12S3R(INe5,ICH3))*
     &  (CFF11S1L(INe3,INe4,i)*CFF11S1R(INe5,INe3,j)*MNeu(INe4)+
     &  CFF11S1R(INe3,INe4,i)*(CFF11S1R(INe5,INe3,j)*MNeu(INe3)+
     &  CFF11S1L(INe5,INe3,j)*MNeu(INe5)))+CF11F12S3R(INe4,ICH3)*
     &  DCONJG(CF11F12S3L(INe5,ICH3))*(CFF11S1L(INe5,INe3,j)*
     &  CFF11S1R(INe3,INe4,i)*MNeu(INe4)+CFF11S1L(INe3,INe4,i)*
     &  (CFF11S1L(INe5,INe3,j)*MNeu(INe3)+CFF11S1R(INe5,INe3,j)*
     &  MNeu(INe5)))))/((MNeu(INe3)-MNeu(INe4))*(MNeu(INe3)+MNeu(INe4))
     &  *(MNeu(INe3)-MNeu(INe5))*(MNeu(INe3)+MNeu(INe5)))+(MCha*
     &  FD111ChiChaHp(4,INe4,ICH3)*(CF11F12S3L(INe4,ICH3)*
     &  DCONJG(CF11F12S3R(INe5,ICH3))*(CFF11S1L(INe3,INe4,i)*
     &  CFF11S1R(INe5,INe3,j)*MNeu(INe4)+CFF11S1R(INe3,INe4,i)*
     &  (CFF11S1R(INe5,INe3,j)*MNeu(INe3)+CFF11S1L(INe5,INe3,j)*
     &  MNeu(INe5)))+CF11F12S3R(INe4,ICH3)*DCONJG(CF11F12S3L(INe5,ICH3)
     &  )*(CFF11S1L(INe5,INe3,j)*CFF11S1R(INe3,INe4,i)*MNeu(INe4)+
     &  CFF11S1L(INe3,INe4,i)*(CFF11S1L(INe5,INe3,j)*MNeu(INe3)+
     &  CFF11S1R(INe5,INe3,j)*MNeu(INe5)))))/((MNeu(INe3)-MNeu(INe4))*
     &  (MNeu(INe3)+MNeu(INe4))*(MNeu(INe4)-MNeu(INe5))*(MNeu(INe4)+
     &  MNeu(INe5)))+(MCha*FD111ChiChaHp(4,INe5,ICH3)*
     &  (CF11F12S3L(INe4,ICH3)*DCONJG(CF11F12S3R(INe5,ICH3))*
     &  (CFF11S1L(INe3,INe4,i)*CFF11S1R(INe5,INe3,j)*MNeu(INe4)+
     &  CFF11S1R(INe3,INe4,i)*(CFF11S1R(INe5,INe3,j)*MNeu(INe3)+
     &  CFF11S1L(INe5,INe3,j)*MNeu(INe5)))+CF11F12S3R(INe4,ICH3)*
     &  DCONJG(CF11F12S3L(INe5,ICH3))*(CFF11S1L(INe5,INe3,j)*
     &  CFF11S1R(INe3,INe4,i)*MNeu(INe4)+CFF11S1L(INe3,INe4,i)*
     &  (CFF11S1L(INe5,INe3,j)*MNeu(INe3)+CFF11S1R(INe5,INe3,j)*
     &  MNeu(INe5)))))/((MNeu(INe3)-MNeu(INe5))*(MNeu(INe3)+MNeu(INe5))
     &  *(-MNeu(INe4)+MNeu(INe5))*(MNeu(INe4)+MNeu(INe5)))-
     &  (FD111ChaChiHp(2,INe3,ICH3)*(CF11F12S3R(INe4,ICH3)*
     &  DCONJG(CF11F12S3R(INe5,ICH3))*(CFF11S1L(INe3,INe4,i)*
     &  CFF11S1L(INe5,INe3,j)*MNeu(INe3)*MNeu(INe5)+
     &  CFF11S1R(INe3,INe4,i)*MNeu(INe4)*(CFF11S1R(INe5,INe3,j)*
     &  MNeu(INe3)+CFF11S1L(INe5,INe3,j)*MNeu(INe5)))+
     &  CF11F12S3L(INe4,ICH3)*DCONJG(CF11F12S3L(INe5,ICH3))*
     &  (CFF11S1R(INe3,INe4,i)*CFF11S1R(INe5,INe3,j)*MNeu(INe3)*
     &  MNeu(INe5)+CFF11S1L(INe3,INe4,i)*MNeu(INe4)*
     &  (CFF11S1L(INe5,INe3,j)*MNeu(INe3)+CFF11S1R(INe5,INe3,j)*
     &  MNeu(INe5)))))/((MNeu(INe3)-MNeu(INe4))*(MNeu(INe3)+MNeu(INe4))
     &  *(MNeu(INe3)-MNeu(INe5))*(MNeu(INe3)+MNeu(INe5)))+
     &  (FD111ChaChiHp(2,INe4,ICH3)*(CF11F12S3R(INe4,ICH3)*
     &  DCONJG(CF11F12S3R(INe5,ICH3))*(CFF11S1L(INe3,INe4,i)*
     &  CFF11S1L(INe5,INe3,j)*MNeu(INe3)*MNeu(INe5)+
     &  CFF11S1R(INe3,INe4,i)*MNeu(INe4)*(CFF11S1R(INe5,INe3,j)*
     &  MNeu(INe3)+CFF11S1L(INe5,INe3,j)*MNeu(INe5)))+
     &  CF11F12S3L(INe4,ICH3)*DCONJG(CF11F12S3L(INe5,ICH3))*
     &  (CFF11S1R(INe3,INe4,i)*CFF11S1R(INe5,INe3,j)*MNeu(INe3)*
     &  MNeu(INe5)+CFF11S1L(INe3,INe4,i)*MNeu(INe4)*
     &  (CFF11S1L(INe5,INe3,j)*MNeu(INe3)+CFF11S1R(INe5,INe3,j)*
     &  MNeu(INe5)))))/((MNeu(INe3)-MNeu(INe4))*(MNeu(INe3)+MNeu(INe4))
     &  *(MNeu(INe4)-MNeu(INe5))*(MNeu(INe4)+MNeu(INe5)))+
     &  (FD111ChaChiHp(2,INe5,ICH3)*(CF11F12S3R(INe4,ICH3)*
     &  DCONJG(CF11F12S3R(INe5,ICH3))*(CFF11S1L(INe3,INe4,i)*
     &  CFF11S1L(INe5,INe3,j)*MNeu(INe3)*MNeu(INe5)+
     &  CFF11S1R(INe3,INe4,i)*MNeu(INe4)*(CFF11S1R(INe5,INe3,j)*
     &  MNeu(INe3)+CFF11S1L(INe5,INe3,j)*MNeu(INe5)))+
     &  CF11F12S3L(INe4,ICH3)*DCONJG(CF11F12S3L(INe5,ICH3))*
     &  (CFF11S1R(INe3,INe4,i)*CFF11S1R(INe5,INe3,j)*MNeu(INe3)*
     &  MNeu(INe5)+CFF11S1L(INe3,INe4,i)*MNeu(INe4)*
     &  (CFF11S1L(INe5,INe3,j)*MNeu(INe3)+CFF11S1R(INe5,INe3,j)*
     &  MNeu(INe5)))))/((MNeu(INe3)-MNeu(INe5))*(MNeu(INe3)+MNeu(INe5))
     &  *(-MNeu(INe4)+MNeu(INe5))*(MNeu(INe4)+MNeu(INe5)))-
     &  (FD111ChaChiHp(2,INe3,ICH3)*(CF11F12S3L(INe5,ICH3)*
     &  DCONJG(CF11F12S3L(INe4,ICH3))*(CFF11S1L(INe3,INe4,i)*
     &  CFF11S1L(INe5,INe3,j)*MNeu(INe3)*MNeu(INe5)+
     &  CFF11S1R(INe3,INe4,i)*MNeu(INe4)*(CFF11S1R(INe5,INe3,j)*
     &  MNeu(INe3)+CFF11S1L(INe5,INe3,j)*MNeu(INe5)))+
     &  CF11F12S3R(INe5,ICH3)*DCONJG(CF11F12S3R(INe4,ICH3))*
     &  (CFF11S1R(INe3,INe4,i)*CFF11S1R(INe5,INe3,j)*MNeu(INe3)*
     &  MNeu(INe5)+CFF11S1L(INe3,INe4,i)*MNeu(INe4)*
     &  (CFF11S1L(INe5,INe3,j)*MNeu(INe3)+CFF11S1R(INe5,INe3,j)*
     &  MNeu(INe5)))))/((MNeu(INe3)-MNeu(INe4))*(MNeu(INe3)+MNeu(INe4))
     &  *(MNeu(INe3)-MNeu(INe5))*(MNeu(INe3)+MNeu(INe5)))+
     &  (FD111ChaChiHp(2,INe4,ICH3)*(CF11F12S3L(INe5,ICH3)*
     &  DCONJG(CF11F12S3L(INe4,ICH3))*(CFF11S1L(INe3,INe4,i)*
     &  CFF11S1L(INe5,INe3,j)*MNeu(INe3)*MNeu(INe5)+
     &  CFF11S1R(INe3,INe4,i)*MNeu(INe4)*(CFF11S1R(INe5,INe3,j)*
     &  MNeu(INe3)+CFF11S1L(INe5,INe3,j)*MNeu(INe5)))+
     &  CF11F12S3R(INe5,ICH3)*DCONJG(CF11F12S3R(INe4,ICH3))*
     &  (CFF11S1R(INe3,INe4,i)*CFF11S1R(INe5,INe3,j)*MNeu(INe3)*
     &  MNeu(INe5)+CFF11S1L(INe3,INe4,i)*MNeu(INe4)*
     &  (CFF11S1L(INe5,INe3,j)*MNeu(INe3)+CFF11S1R(INe5,INe3,j)*
     &  MNeu(INe5)))))/((MNeu(INe3)-MNeu(INe4))*(MNeu(INe3)+MNeu(INe4))
     &  *(MNeu(INe4)-MNeu(INe5))*(MNeu(INe4)+MNeu(INe5)))+
     &  (FD111ChaChiHp(2,INe5,ICH3)*(CF11F12S3L(INe5,ICH3)*
     &  DCONJG(CF11F12S3L(INe4,ICH3))*(CFF11S1L(INe3,INe4,i)*
     &  CFF11S1L(INe5,INe3,j)*MNeu(INe3)*MNeu(INe5)+
     &  CFF11S1R(INe3,INe4,i)*MNeu(INe4)*(CFF11S1R(INe5,INe3,j)*
     &  MNeu(INe3)+CFF11S1L(INe5,INe3,j)*MNeu(INe5)))+
     &  CF11F12S3R(INe5,ICH3)*DCONJG(CF11F12S3R(INe4,ICH3))*
     & (CFF11S1R(INe3,INe4,i)*CFF11S1R(INe5,INe3,j)*MNeu(INe3)*MNeu(INe5)+
     & CFF11S1L(INe3,INe4,i)*MNeu(INe4)*(CFF11S1L(INe5,INe3,j)*
     &  MNeu(INe3)+CFF11S1R(INe5,INe3,j)*MNeu(INe5)))))/((MNeu(INe3)
     & -MNeu(INe5))*(MNeu(INe3)+MNeu(INe5))*(-MNeu(INe4)+MNeu(INe5))*
     &  (MNeu(INe4)+MNeu(INe5))))/8.+self(i,j)
           else
             if( Abs(-MNeu(INe3) + MNeu(INe5))*Abs(-MNeu(INe4) + MNeu(INe5)) .gt. 1D-15) then 
       self(i,j)=(CF11F12S3R(INe5,ICH3)*CFF11S1L(INe5,INe3,j)*
     &  CFF11S1R(INe3,INe3,i)*DCONJG(CF11F12S3R(INe3,ICH3))*
     &  FD111ChaChiHp(8,INe3,ICH3)+CF11F12S3R(INe3,ICH3)*
     &  CFF11S1L(INe3,INe3,i)*CFF11S1R(INe5,INe3,j)*
     &  DCONJG(CF11F12S3R(INe5,ICH3))*FD111ChaChiHp(8,INe3,ICH3)-
     &  CF11F12S3R(INe5,ICH3)*CFF11S1L(INe5,INe3,j)*
     &  CFF11S1R(INe3,INe3,i)*DCONJG(CF11F12S3R(INe3,ICH3))*
     &  FD111ChaChiHp(8,INe5,ICH3)-CF11F12S3R(INe3,ICH3)*
     &  CFF11S1L(INe3,INe3,i)*CFF11S1R(INe5,INe3,j)*
     &  DCONJG(CF11F12S3R(INe5,ICH3))*FD111ChaChiHp(8,INe5,ICH3)+MCha*
     &  CF11F12S3R(INe5,ICH3)*CFF11S1L(INe3,INe3,i)*
     &  CFF11S1L(INe5,INe3,j)*DCONJG(CF11F12S3L(INe3,ICH3))*
     &  FD111ChiChaHp(4,INe3,ICH3)*MNeu(INe3)+MCha*
     &  CF11F12S3R(INe5,ICH3)*CFF11S1L(INe5,INe3,j)*
     &  CFF11S1R(INe3,INe3,i)*DCONJG(CF11F12S3L(INe3,ICH3))*
     &  FD111ChiChaHp(4,INe3,ICH3)*MNeu(INe3)+MCha*
     &  CF11F12S3R(INe3,ICH3)*CFF11S1L(INe3,INe3,i)*
     &  CFF11S1L(INe5,INe3,j)*DCONJG(CF11F12S3L(INe5,ICH3))*
     &  FD111ChiChaHp(4,INe3,ICH3)*MNeu(INe3)+MCha*
     &  CF11F12S3R(INe3,ICH3)*CFF11S1L(INe5,INe3,j)*
     &  CFF11S1R(INe3,INe3,i)*DCONJG(CF11F12S3L(INe5,ICH3))*
     &  FD111ChiChaHp(4,INe3,ICH3)*MNeu(INe3)-MCha*
     &  CF11F12S3R(INe5,ICH3)*CFF11S1L(INe3,INe3,i)*
     &  CFF11S1L(INe5,INe3,j)*DCONJG(CF11F12S3L(INe3,ICH3))*
     &  FD111ChiChaHp(4,INe5,ICH3)*MNeu(INe3)-MCha*
     &  CF11F12S3R(INe5,ICH3)*CFF11S1L(INe5,INe3,j)*
     &  CFF11S1R(INe3,INe3,i)*DCONJG(CF11F12S3L(INe3,ICH3))*
     &  FD111ChiChaHp(4,INe5,ICH3)*MNeu(INe3)-MCha*
     &  CF11F12S3R(INe3,ICH3)*CFF11S1L(INe3,INe3,i)*
     &  CFF11S1L(INe5,INe3,j)*DCONJG(CF11F12S3L(INe5,ICH3))*
     &  FD111ChiChaHp(4,INe5,ICH3)*MNeu(INe3)-MCha*
     &  CF11F12S3R(INe3,ICH3)*CFF11S1L(INe5,INe3,j)*
     &  CFF11S1R(INe3,INe3,i)*DCONJG(CF11F12S3L(INe5,ICH3))*
     &  FD111ChiChaHp(4,INe5,ICH3)*MNeu(INe3)+CF11F12S3R(INe5,ICH3)*
     &  CFF11S1L(INe3,INe3,i)*CFF11S1L(INe5,INe3,j)*
     &  DCONJG(CF11F12S3R(INe3,ICH3))*FD111ChaChiHp(2,INe3,ICH3)*
     &  MNeu(INe3)**2+CF11F12S3R(INe3,ICH3)*CFF11S1R(INe3,INe3,i)*
     &  CFF11S1R(INe5,INe3,j)*DCONJG(CF11F12S3R(INe5,ICH3))*
     &  FD111ChaChiHp(2,INe3,ICH3)*MNeu(INe3)**2-CF11F12S3R(INe5,ICH3)*
     &  CFF11S1L(INe3,INe3,i)*CFF11S1L(INe5,INe3,j)*
     &  DCONJG(CF11F12S3R(INe3,ICH3))*FD111ChaChiHp(2,INe5,ICH3)*
     &  MNeu(INe3)**2-CF11F12S3R(INe3,ICH3)*CFF11S1R(INe3,INe3,i)*
     &  CFF11S1R(INe5,INe3,j)*DCONJG(CF11F12S3R(INe5,ICH3))*
     &  FD111ChaChiHp(2,INe5,ICH3)*MNeu(INe3)**2-CF11F12S3R(INe5,ICH3)*
     &  CFF11S1L(INe5,INe3,j)*CFF11S1R(INe3,INe3,i)*
     &  DCONJG(CF11F12S3R(INe3,ICH3))*FD211ChiChaHpm(5,INe3,ICH3)*
     &  MNeu(INe3)**2-CF11F12S3R(INe3,ICH3)*CFF11S1L(INe3,INe3,i)*
     &  CFF11S1R(INe5,INe3,j)*DCONJG(CF11F12S3R(INe5,ICH3))*
     &  FD211ChiChaHpm(5,INe3,ICH3)*MNeu(INe3)**2-MCha*
     &  CF11F12S3R(INe5,ICH3)*CFF11S1L(INe3,INe3,i)*
     &  CFF11S1L(INe5,INe3,j)*DCONJG(CF11F12S3L(INe3,ICH3))*
     &  FD211ChiChaHpm(4,INe3,ICH3)*MNeu(INe3)**3-MCha*
     &  CF11F12S3R(INe5,ICH3)*CFF11S1L(INe5,INe3,j)*
     &  CFF11S1R(INe3,INe3,i)*DCONJG(CF11F12S3L(INe3,ICH3))*
     &  FD211ChiChaHpm(4,INe3,ICH3)*MNeu(INe3)**3-MCha*
     &  CF11F12S3R(INe3,ICH3)*CFF11S1L(INe3,INe3,i)*
     &  CFF11S1L(INe5,INe3,j)*DCONJG(CF11F12S3L(INe5,ICH3))*
     &  FD211ChiChaHpm(4,INe3,ICH3)*MNeu(INe3)**3-MCha*
     &  CF11F12S3R(INe3,ICH3)*CFF11S1L(INe5,INe3,j)*
     &  CFF11S1R(INe3,INe3,i)*DCONJG(CF11F12S3L(INe5,ICH3))*
     &  FD211ChiChaHpm(4,INe3,ICH3)*MNeu(INe3)**3-CF11F12S3R(INe5,ICH3)
     &  *CFF11S1L(INe3,INe3,i)*CFF11S1L(INe5,INe3,j)*
     &  DCONJG(CF11F12S3R(INe3,ICH3))*FD211ChiChaHpm(2,INe3,ICH3)*
     &  MNeu(INe3)**4-CF11F12S3R(INe3,ICH3)*CFF11S1R(INe3,INe3,i)*
     &  CFF11S1R(INe5,INe3,j)*DCONJG(CF11F12S3R(INe5,ICH3))*
     &  FD211ChiChaHpm(2,INe3,ICH3)*MNeu(INe3)**4+MCha*
     &  CF11F12S3R(INe5,ICH3)*CFF11S1L(INe3,INe3,i)*
     &  CFF11S1R(INe5,INe3,j)*DCONJG(CF11F12S3L(INe3,ICH3))*
     &  FD111ChiChaHp(4,INe3,ICH3)*MNeu(INe5)+MCha*
     &  CF11F12S3R(INe3,ICH3)*CFF11S1L(INe3,INe3,i)*
     &  CFF11S1R(INe5,INe3,j)*DCONJG(CF11F12S3L(INe5,ICH3))*
     &  FD111ChiChaHp(4,INe3,ICH3)*MNeu(INe5)-MCha*
     &  CF11F12S3R(INe5,ICH3)*CFF11S1L(INe3,INe3,i)*
     &  CFF11S1R(INe5,INe3,j)*DCONJG(CF11F12S3L(INe3,ICH3))*
     &  FD111ChiChaHp(4,INe5,ICH3)*MNeu(INe5)-MCha*
     &  CF11F12S3R(INe3,ICH3)*CFF11S1L(INe3,INe3,i)*
     &  CFF11S1R(INe5,INe3,j)*DCONJG(CF11F12S3L(INe5,ICH3))*
     &  FD111ChiChaHp(4,INe5,ICH3)*MNeu(INe5)+CF11F12S3R(INe5,ICH3)*
     &  CFF11S1L(INe3,INe3,i)*CFF11S1R(INe5,INe3,j)*
     &  DCONJG(CF11F12S3R(INe3,ICH3))*FD111ChaChiHp(2,INe3,ICH3)*
     &  MNeu(INe3)*MNeu(INe5)+CF11F12S3R(INe5,ICH3)*
     &  CFF11S1R(INe3,INe3,i)*CFF11S1R(INe5,INe3,j)*
     &  DCONJG(CF11F12S3R(INe3,ICH3))*FD111ChaChiHp(2,INe3,ICH3)*
     &  MNeu(INe3)*MNeu(INe5)+CF11F12S3R(INe3,ICH3)*
     &  CFF11S1L(INe3,INe3,i)*CFF11S1L(INe5,INe3,j)*
     &  DCONJG(CF11F12S3R(INe5,ICH3))*FD111ChaChiHp(2,INe3,ICH3)*
     &  MNeu(INe3)*MNeu(INe5)+CF11F12S3R(INe3,ICH3)*
     &  CFF11S1L(INe5,INe3,j)*CFF11S1R(INe3,INe3,i)*
     &  DCONJG(CF11F12S3R(INe5,ICH3))*FD111ChaChiHp(2,INe3,ICH3)*
     &  MNeu(INe3)*MNeu(INe5)-CF11F12S3R(INe5,ICH3)*
     &  CFF11S1L(INe3,INe3,i)*CFF11S1R(INe5,INe3,j)*
     &  DCONJG(CF11F12S3R(INe3,ICH3))*FD111ChaChiHp(2,INe5,ICH3)*
     &  MNeu(INe3)*MNeu(INe5)-CF11F12S3R(INe5,ICH3)*
     &  CFF11S1R(INe3,INe3,i)*CFF11S1R(INe5,INe3,j)*
     &  DCONJG(CF11F12S3R(INe3,ICH3))*FD111ChaChiHp(2,INe5,ICH3)*
     &  MNeu(INe3)*MNeu(INe5)-CF11F12S3R(INe3,ICH3)*
     &  CFF11S1L(INe3,INe3,i)*CFF11S1L(INe5,INe3,j)*
     &  DCONJG(CF11F12S3R(INe5,ICH3))*FD111ChaChiHp(2,INe5,ICH3)*
     &  MNeu(INe3)*MNeu(INe5)-CF11F12S3R(INe3,ICH3)*
     &  CFF11S1L(INe5,INe3,j)*CFF11S1R(INe3,INe3,i)*
     &  DCONJG(CF11F12S3R(INe5,ICH3))*FD111ChaChiHp(2,INe5,ICH3)*
     &  MNeu(INe3)*MNeu(INe5)-MCha*CF11F12S3R(INe5,ICH3)*
     &  CFF11S1L(INe3,INe3,i)*CFF11S1R(INe5,INe3,j)*
     &  DCONJG(CF11F12S3L(INe3,ICH3))*FD211ChiChaHpm(4,INe3,ICH3)*
     &  MNeu(INe3)**2*MNeu(INe5)-MCha*CF11F12S3R(INe3,ICH3)*
     &  CFF11S1L(INe3,INe3,i)*CFF11S1R(INe5,INe3,j)*
     &  DCONJG(CF11F12S3L(INe5,ICH3))*FD211ChiChaHpm(4,INe3,ICH3)*
     &  MNeu(INe3)**2*MNeu(INe5)-CF11F12S3R(INe5,ICH3)*
     &  CFF11S1L(INe3,INe3,i)*CFF11S1R(INe5,INe3,j)*
     &  DCONJG(CF11F12S3R(INe3,ICH3))*FD211ChiChaHpm(2,INe3,ICH3)*
     &  MNeu(INe3)**3*MNeu(INe5)-CF11F12S3R(INe5,ICH3)*
     &  CFF11S1R(INe3,INe3,i)*CFF11S1R(INe5,INe3,j)*
     &  DCONJG(CF11F12S3R(INe3,ICH3))*FD211ChiChaHpm(2,INe3,ICH3)*
     &  MNeu(INe3)**3*MNeu(INe5)-CF11F12S3R(INe3,ICH3)*
     &  CFF11S1L(INe3,INe3,i)*CFF11S1L(INe5,INe3,j)*
     &  DCONJG(CF11F12S3R(INe5,ICH3))*FD211ChiChaHpm(2,INe3,ICH3)*
     &  MNeu(INe3)**3*MNeu(INe5)-CF11F12S3R(INe3,ICH3)*
     &  CFF11S1L(INe5,INe3,j)*CFF11S1R(INe3,INe3,i)*
     &  DCONJG(CF11F12S3R(INe5,ICH3))*FD211ChiChaHpm(2,INe3,ICH3)*
     &  MNeu(INe3)**3*MNeu(INe5)+CF11F12S3R(INe5,ICH3)*
     &  CFF11S1L(INe5,INe3,j)*CFF11S1R(INe3,INe3,i)*
     &  DCONJG(CF11F12S3R(INe3,ICH3))*FD211ChiChaHpm(5,INe3,ICH3)*
     &  MNeu(INe5)**2+CF11F12S3R(INe3,ICH3)*CFF11S1L(INe3,INe3,i)*
     &  CFF11S1R(INe5,INe3,j)*DCONJG(CF11F12S3R(INe5,ICH3))*
     &  FD211ChiChaHpm(5,INe3,ICH3)*MNeu(INe5)**2+MCha*
     &  CF11F12S3R(INe5,ICH3)*CFF11S1L(INe3,INe3,i)*
     &  CFF11S1L(INe5,INe3,j)*DCONJG(CF11F12S3L(INe3,ICH3))*
     &  FD211ChiChaHpm(4,INe3,ICH3)*MNeu(INe3)*MNeu(INe5)**2+MCha*
     &  CF11F12S3R(INe5,ICH3)*CFF11S1L(INe5,INe3,j)*
     &  CFF11S1R(INe3,INe3,i)*DCONJG(CF11F12S3L(INe3,ICH3))*
     &  FD211ChiChaHpm(4,INe3,ICH3)*MNeu(INe3)*MNeu(INe5)**2+MCha*
     &  CF11F12S3R(INe3,ICH3)*CFF11S1L(INe3,INe3,i)*
     &  CFF11S1L(INe5,INe3,j)*DCONJG(CF11F12S3L(INe5,ICH3))*
     &  FD211ChiChaHpm(4,INe3,ICH3)*MNeu(INe3)*MNeu(INe5)**2+MCha*
     &  CF11F12S3R(INe3,ICH3)*CFF11S1L(INe5,INe3,j)*
     &  CFF11S1R(INe3,INe3,i)*DCONJG(CF11F12S3L(INe5,ICH3))*
     &  FD211ChiChaHpm(4,INe3,ICH3)*MNeu(INe3)*MNeu(INe5)**2+
     &  CF11F12S3R(INe5,ICH3)*CFF11S1L(INe3,INe3,i)*
     &  CFF11S1L(INe5,INe3,j)*DCONJG(CF11F12S3R(INe3,ICH3))*
     &  FD211ChiChaHpm(2,INe3,ICH3)*MNeu(INe3)**2*MNeu(INe5)**2+
     &  CF11F12S3R(INe3,ICH3)*CFF11S1R(INe3,INe3,i)*
     &  CFF11S1R(INe5,INe3,j)*DCONJG(CF11F12S3R(INe5,ICH3))*
     &  FD211ChiChaHpm(2,INe3,ICH3)*MNeu(INe3)**2*MNeu(INe5)**2+MCha*
     &  CF11F12S3R(INe5,ICH3)*CFF11S1L(INe3,INe3,i)*
     &  CFF11S1R(INe5,INe3,j)*DCONJG(CF11F12S3L(INe3,ICH3))*
     &  FD211ChiChaHpm(4,INe3,ICH3)*MNeu(INe5)**3+MCha*
     &  CF11F12S3R(INe3,ICH3)*CFF11S1L(INe3,INe3,i)*
     &  CFF11S1R(INe5,INe3,j)*DCONJG(CF11F12S3L(INe5,ICH3))*
     &  FD211ChiChaHpm(4,INe3,ICH3)*MNeu(INe5)**3+CF11F12S3R(INe5,ICH3)
     &  *CFF11S1L(INe3,INe3,i)*CFF11S1R(INe5,INe3,j)*
     &  DCONJG(CF11F12S3R(INe3,ICH3))*FD211ChiChaHpm(2,INe3,ICH3)*
     &  MNeu(INe3)*MNeu(INe5)**3+CF11F12S3R(INe5,ICH3)*
     &  CFF11S1R(INe3,INe3,i)*CFF11S1R(INe5,INe3,j)*
     &  DCONJG(CF11F12S3R(INe3,ICH3))*FD211ChiChaHpm(2,INe3,ICH3)*
     &  MNeu(INe3)*MNeu(INe5)**3+CF11F12S3R(INe3,ICH3)*
     &  CFF11S1L(INe3,INe3,i)*CFF11S1L(INe5,INe3,j)*
     &  DCONJG(CF11F12S3R(INe5,ICH3))*FD211ChiChaHpm(2,INe3,ICH3)*
     &  MNeu(INe3)*MNeu(INe5)**3+CF11F12S3R(INe3,ICH3)*
     &  CFF11S1L(INe5,INe3,j)*CFF11S1R(INe3,INe3,i)*
     &  DCONJG(CF11F12S3R(INe5,ICH3))*FD211ChiChaHpm(2,INe3,ICH3)*
     &  MNeu(INe3)*MNeu(INe5)**3+MCha*CF11F12S3R(INe5,ICH3)*
     &  CFF11S1R(INe3,INe3,i)*CFF11S1R(INe5,INe3,j)*
     &  DCONJG(CF11F12S3L(INe3,ICH3))*FD111ChaChiHp(1,INe3,ICH3)*
     &  MNeu(INe5)*MNeu2(INe3)+MCha*CF11F12S3R(INe3,ICH3)*
     &  CFF11S1R(INe3,INe3,i)*CFF11S1R(INe5,INe3,j)*
     &  DCONJG(CF11F12S3L(INe5,ICH3))*FD111ChaChiHp(1,INe3,ICH3)*
     &  MNeu(INe5)*MNeu2(INe3)-MCha*CF11F12S3R(INe5,ICH3)*
     &  CFF11S1R(INe3,INe3,i)*CFF11S1R(INe5,INe3,j)*
     &  DCONJG(CF11F12S3L(INe3,ICH3))*FD111ChaChiHp(1,INe5,ICH3)*
     &  MNeu(INe5)*MNeu2(INe3)-MCha*CF11F12S3R(INe3,ICH3)*
     &  CFF11S1R(INe3,INe3,i)*CFF11S1R(INe5,INe3,j)*
     &  DCONJG(CF11F12S3L(INe5,ICH3))*FD111ChaChiHp(1,INe5,ICH3)*
     &  MNeu(INe5)*MNeu2(INe3)-MCha*CF11F12S3R(INe5,ICH3)*
     &  CFF11S1R(INe3,INe3,i)*CFF11S1R(INe5,INe3,j)*
     &  DCONJG(CF11F12S3L(INe3,ICH3))*FD211ChiChaHpm(1,INe3,ICH3)*
     &  MNeu(INe3)**2*MNeu(INe5)*MNeu2(INe3)-MCha*CF11F12S3R(INe3,ICH3)
     &  *CFF11S1R(INe3,INe3,i)*CFF11S1R(INe5,INe3,j)*
     &  DCONJG(CF11F12S3L(INe5,ICH3))*FD211ChiChaHpm(1,INe3,ICH3)*
     &  MNeu(INe3)**2*MNeu(INe5)*MNeu2(INe3)+MCha*CF11F12S3R(INe5,ICH3)
     &  *CFF11S1R(INe3,INe3,i)*CFF11S1R(INe5,INe3,j)*
     &  DCONJG(CF11F12S3L(INe3,ICH3))*FD211ChiChaHpm(1,INe3,ICH3)*
     &  MNeu(INe5)**3*MNeu2(INe3)+MCha*CF11F12S3R(INe3,ICH3)*
     &  CFF11S1R(INe3,INe3,i)*CFF11S1R(INe5,INe3,j)*
     &  DCONJG(CF11F12S3L(INe5,ICH3))*FD211ChiChaHpm(1,INe3,ICH3)*
     &  MNeu(INe5)**3*MNeu2(INe3)+CF11F12S3L(INe5,ICH3)*
     &  (CFF11S1R(INe3,INe3,i)*(CFF11S1R(INe5,INe3,j)*MNeu(INe3)+
     &  CFF11S1L(INe5,INe3,j)*MNeu(INe5))*(DCONJG(CF11F12S3L(INe3,ICH3)
     &  )*MNeu(INe3)*(FD111ChaChiHp(2,INe3,ICH3)-
     &  FD111ChaChiHp(2,INe5,ICH3)+FD211ChiChaHpm(2,INe3,ICH3)*(-
     &  MNeu(INe3)**2+MNeu(INe5)**2))+MCha*DCONJG(CF11F12S3R(INe3,ICH3)
     &  )*(FD111ChiChaHp(4,INe3,ICH3)-FD111ChiChaHp(4,INe5,ICH3)+
     &  FD211ChiChaHpm(4,INe3,ICH3)*(-MNeu(INe3)**2+MNeu(INe5)**2)))+
     &  CFF11S1L(INe3,INe3,i)*(CFF11S1R(INe5,INe3,j)*(MCha*
     &  DCONJG(CF11F12S3R(INe3,ICH3))*MNeu(INe3)*
     &  (FD111ChiChaHp(4,INe3,ICH3)-FD111ChiChaHp(4,INe5,ICH3)+
     &  FD211ChiChaHpm(4,INe3,ICH3)*(-MNeu(INe3)**2+MNeu(INe5)**2))+
     &  DCONJG(CF11F12S3L(INe3,ICH3))*(FD111ChaChiHp(8,INe3,ICH3)-
     &  FD111ChaChiHp(8,INe5,ICH3)+FD211ChiChaHpm(5,INe3,ICH3)*(-
     &  MNeu(INe3)**2+MNeu(INe5)**2)))+CFF11S1L(INe5,INe3,j)*MNeu(INe5)
     &  *(DCONJG(CF11F12S3L(INe3,ICH3))*MNeu(INe3)*
     &  (FD111ChaChiHp(2,INe3,ICH3)-FD111ChaChiHp(2,INe5,ICH3)+
     &  FD211ChiChaHpm(2,INe3,ICH3)*(-MNeu(INe3)**2+MNeu(INe5)**2))+
     &  MCha*DCONJG(CF11F12S3R(INe3,ICH3))*(FD111ChaChiHp(1,INe3,ICH3)-
     &  FD111ChaChiHp(1,INe5,ICH3)+FD211ChiChaHpm(1,INe3,ICH3)*(-
     &  MNeu(INe3)**2+MNeu(INe5)**2))*MNeu2(INe3))))+
     &  CF11F12S3L(INe3,ICH3)*((CFF11S1L(INe3,INe3,i)+
     &  CFF11S1R(INe3,INe3,i))*CFF11S1R(INe5,INe3,j)*MNeu(INe3)*
     &  (DCONJG(CF11F12S3L(INe5,ICH3))*MNeu(INe5)*
     &  (FD111ChaChiHp(2,INe3,ICH3)-FD111ChaChiHp(2,INe5,ICH3)+
     &  FD211ChiChaHpm(2,INe3,ICH3)*(-MNeu(INe3)**2+MNeu(INe5)**2))+
     &  MCha*DCONJG(CF11F12S3R(INe5,ICH3))*(FD111ChiChaHp(4,INe3,ICH3)-
     &  FD111ChiChaHp(4,INe5,ICH3)+FD211ChiChaHpm(4,INe3,ICH3)*(-
     &  MNeu(INe3)**2+MNeu(INe5)**2)))+CFF11S1L(INe5,INe3,j)*
     &  (CFF11S1R(INe3,INe3,i)*(MCha*DCONJG(CF11F12S3R(INe5,ICH3))*
     &  MNeu(INe5)*(FD111ChiChaHp(4,INe3,ICH3)-
     &  FD111ChiChaHp(4,INe5,ICH3)+FD211ChiChaHpm(4,INe3,ICH3)*(-
     &  MNeu(INe3)**2+MNeu(INe5)**2))+DCONJG(CF11F12S3L(INe5,ICH3))*
     &  (FD111ChaChiHp(8,INe3,ICH3)-FD111ChaChiHp(8,INe5,ICH3)+
     &  FD211ChiChaHpm(5,INe3,ICH3)*(-MNeu(INe3)**2+MNeu(INe5)**2)))+
     &  CFF11S1L(INe3,INe3,i)*(DCONJG(CF11F12S3L(INe5,ICH3))*MNeu(INe3)
     &  **2*(FD111ChaChiHp(2,INe3,ICH3)-FD111ChaChiHp(2,INe5,ICH3)
     &  +FD211ChiChaHpm(2,INe3,ICH3)*(-MNeu(INe3)**2+MNeu(INe5)**2))
     &   +MCha*DCONJG(CF11F12S3R(INe5,ICH3))*MNeu(INe5)*(
     &   FD111ChaChiHp(1,INe3,ICH3)-FD111ChaChiHp(1,INe5,ICH3)+
     &  FD211ChiChaHpm(1,INe3,ICH3)*(-MNeu(INe3)**2+MNeu(INe5)**2))*
     &  MNeu2(INe3)))))/(8.*(MNeu(INe3)**2-MNeu(INe5)**2)**2)+self(i,j)
             endif
             if( Abs(-MNeu(INe3) + MNeu(INe4))*Abs(-MNeu(INe4) + MNeu(INe5)) .gt. 1D-15) then 

       self(i,j)=(CF11F12S3R(INe4,ICH3)*CFF11S1L(INe3,INe4,i)*
     &  CFF11S1R(INe3,INe3,j)*DCONJG(CF11F12S3R(INe3,ICH3))*
     &  FD111ChaChiHp(8,INe3,ICH3)+CF11F12S3R(INe3,ICH3)*
     &  CFF11S1L(INe3,INe3,j)*CFF11S1R(INe3,INe4,i)*
     &  DCONJG(CF11F12S3R(INe4,ICH3))*FD111ChaChiHp(8,INe3,ICH3)-
     &  CF11F12S3R(INe4,ICH3)*CFF11S1L(INe3,INe4,i)*
     &  CFF11S1R(INe3,INe3,j)*DCONJG(CF11F12S3R(INe3,ICH3))*
     &  FD111ChaChiHp(8,INe4,ICH3)-CF11F12S3R(INe3,ICH3)*
     &  CFF11S1L(INe3,INe3,j)*CFF11S1R(INe3,INe4,i)*
     &  DCONJG(CF11F12S3R(INe4,ICH3))*FD111ChaChiHp(8,INe4,ICH3)+MCha*
     &  CF11F12S3R(INe4,ICH3)*CFF11S1L(INe3,INe3,j)*
     &  CFF11S1L(INe3,INe4,i)*DCONJG(CF11F12S3L(INe3,ICH3))*
     &  FD111ChiChaHp(4,INe3,ICH3)*MNeu(INe3)+MCha*
     &  CF11F12S3R(INe4,ICH3)*CFF11S1L(INe3,INe4,i)*
     &  CFF11S1R(INe3,INe3,j)*DCONJG(CF11F12S3L(INe3,ICH3))*
     &  FD111ChiChaHp(4,INe3,ICH3)*MNeu(INe3)+MCha*
     &  CF11F12S3R(INe3,ICH3)*CFF11S1L(INe3,INe3,j)*
     &  CFF11S1L(INe3,INe4,i)*DCONJG(CF11F12S3L(INe4,ICH3))*
     &  FD111ChiChaHp(4,INe3,ICH3)*MNeu(INe3)+MCha*
     &  CF11F12S3R(INe3,ICH3)*CFF11S1L(INe3,INe4,i)*
     &  CFF11S1R(INe3,INe3,j)*DCONJG(CF11F12S3L(INe4,ICH3))*
     &  FD111ChiChaHp(4,INe3,ICH3)*MNeu(INe3)-MCha*
     &  CF11F12S3R(INe4,ICH3)*CFF11S1L(INe3,INe3,j)*
     &  CFF11S1L(INe3,INe4,i)*DCONJG(CF11F12S3L(INe3,ICH3))*
     &  FD111ChiChaHp(4,INe4,ICH3)*MNeu(INe3)-MCha*
     &  CF11F12S3R(INe4,ICH3)*CFF11S1L(INe3,INe4,i)*
     &  CFF11S1R(INe3,INe3,j)*DCONJG(CF11F12S3L(INe3,ICH3))*
     &  FD111ChiChaHp(4,INe4,ICH3)*MNeu(INe3)-MCha*
     &  CF11F12S3R(INe3,ICH3)*CFF11S1L(INe3,INe3,j)*
     &  CFF11S1L(INe3,INe4,i)*DCONJG(CF11F12S3L(INe4,ICH3))*
     &  FD111ChiChaHp(4,INe4,ICH3)*MNeu(INe3)-MCha*
     &  CF11F12S3R(INe3,ICH3)*CFF11S1L(INe3,INe4,i)*
     &  CFF11S1R(INe3,INe3,j)*DCONJG(CF11F12S3L(INe4,ICH3))*
     &  FD111ChiChaHp(4,INe4,ICH3)*MNeu(INe3)+CF11F12S3R(INe4,ICH3)*
     &  CFF11S1L(INe3,INe3,j)*CFF11S1L(INe3,INe4,i)*
     &  DCONJG(CF11F12S3R(INe3,ICH3))*FD111ChaChiHp(2,INe3,ICH3)*
     &  MNeu(INe3)**2+CF11F12S3R(INe3,ICH3)*CFF11S1R(INe3,INe3,j)*
     &  CFF11S1R(INe3,INe4,i)*DCONJG(CF11F12S3R(INe4,ICH3))*
     &  FD111ChaChiHp(2,INe3,ICH3)*MNeu(INe3)**2-CF11F12S3R(INe4,ICH3)*
     &  CFF11S1L(INe3,INe3,j)*CFF11S1L(INe3,INe4,i)*
     &  DCONJG(CF11F12S3R(INe3,ICH3))*FD111ChaChiHp(2,INe4,ICH3)*
     &  MNeu(INe3)**2-CF11F12S3R(INe3,ICH3)*CFF11S1R(INe3,INe3,j)*
     &  CFF11S1R(INe3,INe4,i)*DCONJG(CF11F12S3R(INe4,ICH3))*
     &  FD111ChaChiHp(2,INe4,ICH3)*MNeu(INe3)**2-CF11F12S3R(INe4,ICH3)*
     &  CFF11S1L(INe3,INe4,i)*CFF11S1R(INe3,INe3,j)*
     &  DCONJG(CF11F12S3R(INe3,ICH3))*FD211ChiChaHpm(5,INe3,ICH3)*
     &  MNeu(INe3)**2-CF11F12S3R(INe3,ICH3)*CFF11S1L(INe3,INe3,j)*
     &  CFF11S1R(INe3,INe4,i)*DCONJG(CF11F12S3R(INe4,ICH3))*
     &  FD211ChiChaHpm(5,INe3,ICH3)*MNeu(INe3)**2-MCha*
     &  CF11F12S3R(INe4,ICH3)*CFF11S1L(INe3,INe3,j)*
     &  CFF11S1L(INe3,INe4,i)*DCONJG(CF11F12S3L(INe3,ICH3))*
     &  FD211ChiChaHpm(4,INe3,ICH3)*MNeu(INe3)**3-MCha*
     &  CF11F12S3R(INe4,ICH3)*CFF11S1L(INe3,INe4,i)*
     &  CFF11S1R(INe3,INe3,j)*DCONJG(CF11F12S3L(INe3,ICH3))*
     &  FD211ChiChaHpm(4,INe3,ICH3)*MNeu(INe3)**3-MCha*
     &  CF11F12S3R(INe3,ICH3)*CFF11S1L(INe3,INe3,j)*
     &  CFF11S1L(INe3,INe4,i)*DCONJG(CF11F12S3L(INe4,ICH3))*
     &  FD211ChiChaHpm(4,INe3,ICH3)*MNeu(INe3)**3-MCha*
     &  CF11F12S3R(INe3,ICH3)*CFF11S1L(INe3,INe4,i)*
     &  CFF11S1R(INe3,INe3,j)*DCONJG(CF11F12S3L(INe4,ICH3))*
     &  FD211ChiChaHpm(4,INe3,ICH3)*MNeu(INe3)**3-CF11F12S3R(INe4,ICH3)
     &  *CFF11S1L(INe3,INe3,j)*CFF11S1L(INe3,INe4,i)*
     &  DCONJG(CF11F12S3R(INe3,ICH3))*FD211ChiChaHpm(2,INe3,ICH3)*
     &  MNeu(INe3)**4-CF11F12S3R(INe3,ICH3)*CFF11S1R(INe3,INe3,j)*
     &  CFF11S1R(INe3,INe4,i)*DCONJG(CF11F12S3R(INe4,ICH3))*
     &  FD211ChiChaHpm(2,INe3,ICH3)*MNeu(INe3)**4+MCha*
     &  CF11F12S3R(INe4,ICH3)*CFF11S1L(INe3,INe3,j)*
     &  CFF11S1R(INe3,INe4,i)*DCONJG(CF11F12S3L(INe3,ICH3))*
     &  FD111ChiChaHp(4,INe3,ICH3)*MNeu(INe4)+MCha*
     &  CF11F12S3R(INe3,ICH3)*CFF11S1L(INe3,INe3,j)*
     &  CFF11S1R(INe3,INe4,i)*DCONJG(CF11F12S3L(INe4,ICH3))*
     &  FD111ChiChaHp(4,INe3,ICH3)*MNeu(INe4)-MCha*
     &  CF11F12S3R(INe4,ICH3)*CFF11S1L(INe3,INe3,j)*
     &  CFF11S1R(INe3,INe4,i)*DCONJG(CF11F12S3L(INe3,ICH3))*
     &  FD111ChiChaHp(4,INe4,ICH3)*MNeu(INe4)-MCha*
     &  CF11F12S3R(INe3,ICH3)*CFF11S1L(INe3,INe3,j)*
     &  CFF11S1R(INe3,INe4,i)*DCONJG(CF11F12S3L(INe4,ICH3))*
     &  FD111ChiChaHp(4,INe4,ICH3)*MNeu(INe4)+CF11F12S3R(INe4,ICH3)*
     &  CFF11S1L(INe3,INe3,j)*CFF11S1R(INe3,INe4,i)*
     &  DCONJG(CF11F12S3R(INe3,ICH3))*FD111ChaChiHp(2,INe3,ICH3)*
     &  MNeu(INe3)*MNeu(INe4)+CF11F12S3R(INe4,ICH3)*
     &  CFF11S1R(INe3,INe3,j)*CFF11S1R(INe3,INe4,i)*
     &  DCONJG(CF11F12S3R(INe3,ICH3))*FD111ChaChiHp(2,INe3,ICH3)*
     &  MNeu(INe3)*MNeu(INe4)+CF11F12S3R(INe3,ICH3)*
     &  CFF11S1L(INe3,INe3,j)*CFF11S1L(INe3,INe4,i)*
     &  DCONJG(CF11F12S3R(INe4,ICH3))*FD111ChaChiHp(2,INe3,ICH3)*
     &  MNeu(INe3)*MNeu(INe4)+CF11F12S3R(INe3,ICH3)*
     &  CFF11S1L(INe3,INe4,i)*CFF11S1R(INe3,INe3,j)*
     &  DCONJG(CF11F12S3R(INe4,ICH3))*FD111ChaChiHp(2,INe3,ICH3)*
     &  MNeu(INe3)*MNeu(INe4)-CF11F12S3R(INe4,ICH3)*
     &  CFF11S1L(INe3,INe3,j)*CFF11S1R(INe3,INe4,i)*
     &  DCONJG(CF11F12S3R(INe3,ICH3))*FD111ChaChiHp(2,INe4,ICH3)*
     &  MNeu(INe3)*MNeu(INe4)-CF11F12S3R(INe4,ICH3)*
     &  CFF11S1R(INe3,INe3,j)*CFF11S1R(INe3,INe4,i)*
     &  DCONJG(CF11F12S3R(INe3,ICH3))*FD111ChaChiHp(2,INe4,ICH3)*
     &  MNeu(INe3)*MNeu(INe4)-CF11F12S3R(INe3,ICH3)*
     &  CFF11S1L(INe3,INe3,j)*CFF11S1L(INe3,INe4,i)*
     &  DCONJG(CF11F12S3R(INe4,ICH3))*FD111ChaChiHp(2,INe4,ICH3)*
     &  MNeu(INe3)*MNeu(INe4)-CF11F12S3R(INe3,ICH3)*
     &  CFF11S1L(INe3,INe4,i)*CFF11S1R(INe3,INe3,j)*
     &  DCONJG(CF11F12S3R(INe4,ICH3))*FD111ChaChiHp(2,INe4,ICH3)*
     &  MNeu(INe3)*MNeu(INe4)-MCha*CF11F12S3R(INe4,ICH3)*
     &  CFF11S1L(INe3,INe3,j)*CFF11S1R(INe3,INe4,i)*
     &  DCONJG(CF11F12S3L(INe3,ICH3))*FD211ChiChaHpm(4,INe3,ICH3)*
     &  MNeu(INe3)**2*MNeu(INe4)-MCha*CF11F12S3R(INe3,ICH3)*
     &  CFF11S1L(INe3,INe3,j)*CFF11S1R(INe3,INe4,i)*
     &  DCONJG(CF11F12S3L(INe4,ICH3))*FD211ChiChaHpm(4,INe3,ICH3)*
     &  MNeu(INe3)**2*MNeu(INe4)-CF11F12S3R(INe4,ICH3)*
     &  CFF11S1L(INe3,INe3,j)*CFF11S1R(INe3,INe4,i)*
     &  DCONJG(CF11F12S3R(INe3,ICH3))*FD211ChiChaHpm(2,INe3,ICH3)*
     &  MNeu(INe3)**3*MNeu(INe4)-CF11F12S3R(INe4,ICH3)*
     &  CFF11S1R(INe3,INe3,j)*CFF11S1R(INe3,INe4,i)*
     &  DCONJG(CF11F12S3R(INe3,ICH3))*FD211ChiChaHpm(2,INe3,ICH3)*
     &  MNeu(INe3)**3*MNeu(INe4)-CF11F12S3R(INe3,ICH3)*
     &  CFF11S1L(INe3,INe3,j)*CFF11S1L(INe3,INe4,i)*
     &  DCONJG(CF11F12S3R(INe4,ICH3))*FD211ChiChaHpm(2,INe3,ICH3)*
     &  MNeu(INe3)**3*MNeu(INe4)-CF11F12S3R(INe3,ICH3)*
     &  CFF11S1L(INe3,INe4,i)*CFF11S1R(INe3,INe3,j)*
     &  DCONJG(CF11F12S3R(INe4,ICH3))*FD211ChiChaHpm(2,INe3,ICH3)*
     &  MNeu(INe3)**3*MNeu(INe4)+CF11F12S3R(INe4,ICH3)*
     &  CFF11S1L(INe3,INe4,i)*CFF11S1R(INe3,INe3,j)*
     &  DCONJG(CF11F12S3R(INe3,ICH3))*FD211ChiChaHpm(5,INe3,ICH3)*
     &  MNeu(INe4)**2+CF11F12S3R(INe3,ICH3)*CFF11S1L(INe3,INe3,j)*
     &  CFF11S1R(INe3,INe4,i)*DCONJG(CF11F12S3R(INe4,ICH3))*
     &  FD211ChiChaHpm(5,INe3,ICH3)*MNeu(INe4)**2+MCha*
     &  CF11F12S3R(INe4,ICH3)*CFF11S1L(INe3,INe3,j)*
     &  CFF11S1L(INe3,INe4,i)*DCONJG(CF11F12S3L(INe3,ICH3))*
     &  FD211ChiChaHpm(4,INe3,ICH3)*MNeu(INe3)*MNeu(INe4)**2+MCha*
     &  CF11F12S3R(INe4,ICH3)*CFF11S1L(INe3,INe4,i)*
     &  CFF11S1R(INe3,INe3,j)*DCONJG(CF11F12S3L(INe3,ICH3))*
     &  FD211ChiChaHpm(4,INe3,ICH3)*MNeu(INe3)*MNeu(INe4)**2+MCha*
     &  CF11F12S3R(INe3,ICH3)*CFF11S1L(INe3,INe3,j)*
     &  CFF11S1L(INe3,INe4,i)*DCONJG(CF11F12S3L(INe4,ICH3))*
     &  FD211ChiChaHpm(4,INe3,ICH3)*MNeu(INe3)*MNeu(INe4)**2+MCha*
     &  CF11F12S3R(INe3,ICH3)*CFF11S1L(INe3,INe4,i)*
     &  CFF11S1R(INe3,INe3,j)*DCONJG(CF11F12S3L(INe4,ICH3))*
     &  FD211ChiChaHpm(4,INe3,ICH3)*MNeu(INe3)*MNeu(INe4)**2+
     &  CF11F12S3R(INe4,ICH3)*CFF11S1L(INe3,INe3,j)*
     &  CFF11S1L(INe3,INe4,i)*DCONJG(CF11F12S3R(INe3,ICH3))*
     &  FD211ChiChaHpm(2,INe3,ICH3)*MNeu(INe3)**2*MNeu(INe4)**2+
     &  CF11F12S3R(INe3,ICH3)*CFF11S1R(INe3,INe3,j)*
     &  CFF11S1R(INe3,INe4,i)*DCONJG(CF11F12S3R(INe4,ICH3))*
     &  FD211ChiChaHpm(2,INe3,ICH3)*MNeu(INe3)**2*MNeu(INe4)**2+MCha*
     &  CF11F12S3R(INe4,ICH3)*CFF11S1L(INe3,INe3,j)*
     &  CFF11S1R(INe3,INe4,i)*DCONJG(CF11F12S3L(INe3,ICH3))*
     &  FD211ChiChaHpm(4,INe3,ICH3)*MNeu(INe4)**3+MCha*
     &  CF11F12S3R(INe3,ICH3)*CFF11S1L(INe3,INe3,j)*
     &  CFF11S1R(INe3,INe4,i)*DCONJG(CF11F12S3L(INe4,ICH3))*
     &  FD211ChiChaHpm(4,INe3,ICH3)*MNeu(INe4)**3+CF11F12S3R(INe4,ICH3)
     &  *CFF11S1L(INe3,INe3,j)*CFF11S1R(INe3,INe4,i)*
     &  DCONJG(CF11F12S3R(INe3,ICH3))*FD211ChiChaHpm(2,INe3,ICH3)*
     &  MNeu(INe3)*MNeu(INe4)**3+CF11F12S3R(INe4,ICH3)*
     &  CFF11S1R(INe3,INe3,j)*CFF11S1R(INe3,INe4,i)*
     &  DCONJG(CF11F12S3R(INe3,ICH3))*FD211ChiChaHpm(2,INe3,ICH3)*
     &  MNeu(INe3)*MNeu(INe4)**3+CF11F12S3R(INe3,ICH3)*
     &  CFF11S1L(INe3,INe3,j)*CFF11S1L(INe3,INe4,i)*
     &  DCONJG(CF11F12S3R(INe4,ICH3))*FD211ChiChaHpm(2,INe3,ICH3)*
     &  MNeu(INe3)*MNeu(INe4)**3+CF11F12S3R(INe3,ICH3)*
     &  CFF11S1L(INe3,INe4,i)*CFF11S1R(INe3,INe3,j)*
     &  DCONJG(CF11F12S3R(INe4,ICH3))*FD211ChiChaHpm(2,INe3,ICH3)*
     &  MNeu(INe3)*MNeu(INe4)**3+MCha*CF11F12S3R(INe4,ICH3)*
     &  CFF11S1R(INe3,INe3,j)*CFF11S1R(INe3,INe4,i)*
     &  DCONJG(CF11F12S3L(INe3,ICH3))*FD111ChaChiHp(1,INe3,ICH3)*
     &  MNeu(INe4)*MNeu2(INe3)+MCha*CF11F12S3R(INe3,ICH3)*
     &  CFF11S1R(INe3,INe3,j)*CFF11S1R(INe3,INe4,i)*
     &  DCONJG(CF11F12S3L(INe4,ICH3))*FD111ChaChiHp(1,INe3,ICH3)*
     &  MNeu(INe4)*MNeu2(INe3)-MCha*CF11F12S3R(INe4,ICH3)*
     &  CFF11S1R(INe3,INe3,j)*CFF11S1R(INe3,INe4,i)*
     &  DCONJG(CF11F12S3L(INe3,ICH3))*FD111ChaChiHp(1,INe4,ICH3)*
     &  MNeu(INe4)*MNeu2(INe3)-MCha*CF11F12S3R(INe3,ICH3)*
     &  CFF11S1R(INe3,INe3,j)*CFF11S1R(INe3,INe4,i)*
     &  DCONJG(CF11F12S3L(INe4,ICH3))*FD111ChaChiHp(1,INe4,ICH3)*
     &  MNeu(INe4)*MNeu2(INe3)-MCha*CF11F12S3R(INe4,ICH3)*
     &  CFF11S1R(INe3,INe3,j)*CFF11S1R(INe3,INe4,i)*
     &  DCONJG(CF11F12S3L(INe3,ICH3))*FD211ChiChaHpm(1,INe3,ICH3)*
     &  MNeu(INe3)**2*MNeu(INe4)*MNeu2(INe3)-MCha*CF11F12S3R(INe3,ICH3)
     &  *CFF11S1R(INe3,INe3,j)*CFF11S1R(INe3,INe4,i)*
     &  DCONJG(CF11F12S3L(INe4,ICH3))*FD211ChiChaHpm(1,INe3,ICH3)*
     &  MNeu(INe3)**2*MNeu(INe4)*MNeu2(INe3)+MCha*CF11F12S3R(INe4,ICH3)
     &  *CFF11S1R(INe3,INe3,j)*CFF11S1R(INe3,INe4,i)*
     &  DCONJG(CF11F12S3L(INe3,ICH3))*FD211ChiChaHpm(1,INe3,ICH3)*
     &  MNeu(INe4)**3*MNeu2(INe3)+MCha*CF11F12S3R(INe3,ICH3)*
     &  CFF11S1R(INe3,INe3,j)*CFF11S1R(INe3,INe4,i)*
     &  DCONJG(CF11F12S3L(INe4,ICH3))*FD211ChiChaHpm(1,INe3,ICH3)*
     &  MNeu(INe4)**3*MNeu2(INe3)+CF11F12S3L(INe4,ICH3)*
     &  (CFF11S1R(INe3,INe3,j)*(CFF11S1R(INe3,INe4,i)*MNeu(INe3)+
     &  CFF11S1L(INe3,INe4,i)*MNeu(INe4))*(DCONJG(CF11F12S3L(INe3,ICH3)
     &  )*MNeu(INe3)*(FD111ChaChiHp(2,INe3,ICH3)-
     &  FD111ChaChiHp(2,INe4,ICH3)+FD211ChiChaHpm(2,INe3,ICH3)*(-
     &  MNeu(INe3)**2+MNeu(INe4)**2))+MCha*DCONJG(CF11F12S3R(INe3,ICH3)
     &  )*(FD111ChiChaHp(4,INe3,ICH3)-FD111ChiChaHp(4,INe4,ICH3)+
     &  FD211ChiChaHpm(4,INe3,ICH3)*(-MNeu(INe3)**2+MNeu(INe4)**2)))+
     &  CFF11S1L(INe3,INe3,j)*(CFF11S1R(INe3,INe4,i)*(MCha*
     &  DCONJG(CF11F12S3R(INe3,ICH3))*MNeu(INe3)*
     &  (FD111ChiChaHp(4,INe3,ICH3)-FD111ChiChaHp(4,INe4,ICH3)+
     &  FD211ChiChaHpm(4,INe3,ICH3)*(-MNeu(INe3)**2+MNeu(INe4)**2))+
     &  DCONJG(CF11F12S3L(INe3,ICH3))*(FD111ChaChiHp(8,INe3,ICH3)-
     &  FD111ChaChiHp(8,INe4,ICH3)+FD211ChiChaHpm(5,INe3,ICH3)*(-
     &  MNeu(INe3)**2+MNeu(INe4)**2)))+CFF11S1L(INe3,INe4,i)*MNeu(INe4)
     &  *(DCONJG(CF11F12S3L(INe3,ICH3))*MNeu(INe3)*
     &  (FD111ChaChiHp(2,INe3,ICH3)-FD111ChaChiHp(2,INe4,ICH3)+
     &  FD211ChiChaHpm(2,INe3,ICH3)*(-MNeu(INe3)**2+MNeu(INe4)**2))+
     &  MCha*DCONJG(CF11F12S3R(INe3,ICH3))*(FD111ChaChiHp(1,INe3,ICH3)-
     &  FD111ChaChiHp(1,INe4,ICH3)+FD211ChiChaHpm(1,INe3,ICH3)*(-
     &  MNeu(INe3)**2+MNeu(INe4)**2))*MNeu2(INe3))))+
     &  CF11F12S3L(INe3,ICH3)*((CFF11S1L(INe3,INe3,j)+
     &  CFF11S1R(INe3,INe3,j))*CFF11S1R(INe3,INe4,i)*MNeu(INe3)*
     &  (DCONJG(CF11F12S3L(INe4,ICH3))*MNeu(INe4)*
     &  (FD111ChaChiHp(2,INe3,ICH3)-FD111ChaChiHp(2,INe4,ICH3)+
     &  FD211ChiChaHpm(2,INe3,ICH3)*(-MNeu(INe3)**2+MNeu(INe4)**2))+
     &  MCha*DCONJG(CF11F12S3R(INe4,ICH3))*(FD111ChiChaHp(4,INe3,ICH3)-
     &  FD111ChiChaHp(4,INe4,ICH3)+FD211ChiChaHpm(4,INe3,ICH3)*(-
     &  MNeu(INe3)**2+MNeu(INe4)**2)))+CFF11S1L(INe3,INe4,i)*
     &  (CFF11S1R(INe3,INe3,j)*(MCha*DCONJG(CF11F12S3R(INe4,ICH3))*
     &  MNeu(INe4)*(FD111ChiChaHp(4,INe3,ICH3)-
     &  FD111ChiChaHp(4,INe4,ICH3)+FD211ChiChaHpm(4,INe3,ICH3)*(-
     &  MNeu(INe3)**2+MNeu(INe4)**2))+DCONJG(CF11F12S3L(INe4,ICH3))*
     &  (FD111ChaChiHp(8,INe3,ICH3)-FD111ChaChiHp(8,INe4,ICH3)+
     &  FD211ChiChaHpm(5,INe3,ICH3)*(-MNeu(INe3)**2+MNeu(INe4)**2)))+
     &  CFF11S1L(INe3,INe3,j)*(DCONJG(CF11F12S3L(INe4,ICH3))*MNeu(INe3)
     &  **2*(FD111ChaChiHp(2,INe3,ICH3)-FD111ChaChiHp(2,INe4,ICH3)+
     &  FD211ChiChaHpm(2,INe3,ICH3)*(-MNeu(INe3)**2+MNeu(INe4)**2)) 
     &  +MCha*DCONJG(CF11F12S3R(INe4,ICH3))*MNeu(INe4)*(FD111ChaChiHp(1,INe3,ICH3)-
     & FD111ChaChiHp(1,INe4,ICH3)+FD211ChiChaHpm(1,INe3,ICH3)*
     &  (-MNeu(INe3)**2+MNeu(INe4)**2))*MNeu2(INe3)))))/(8.*(MNeu(INe3)**2-MNeu(INe4)**2)**2)+self(i,j)
             endif
             if( Abs(MNeu(INe3) - MNeu(INe4))*Abs(-MNeu(INe3) + MNeu(INe5)) .gt. 1D-15) then 

       self(i,j)=(CF11F12S3R(INe4,ICH3)*(CFF11S1L(INe4,INe3,j)*(2*
     &  CFF11S1L(INe3,INe4,i)*MNeu(INe3)*(DCONJG(CF11F12S3R(INe4,ICH3))
     &  *MNeu(INe4)*(-FD111ChaChiHp(2,INe3,ICH3)+
     &  FD111ChaChiHp(2,INe4,ICH3)+FD211ChiChaHpm(2,INe4,ICH3)*
     &  (MNeu(INe3)**2-MNeu(INe4)**2))+MCha*
     &  DCONJG(CF11F12S3L(INe4,ICH3))*(-FD111ChiChaHp(4,INe3,ICH3)+
     &  FD111ChiChaHp(4,INe4,ICH3)+FD211ChiChaHpm(4,INe4,ICH3)*
     &  (MNeu(INe3)**2-MNeu(INe4)**2)))+CFF11S1R(INe3,INe4,i)*
     &  (DCONJG(CF11F12S3R(INe4,ICH3))*(-FD111ChaChiHp(8,INe3,ICH3)+
     &  FD111ChaChiHp(8,INe4,ICH3)+FD211ChiChaHpm(5,INe4,ICH3)*
     &  MNeu(INe3)**2-FD111ChaChiHp(2,INe3,ICH3)*MNeu(INe4)**2+
     &  FD111ChaChiHp(2,INe4,ICH3)*MNeu(INe4)**2-
     &  FD211ChiChaHpm(5,INe4,ICH3)*MNeu(INe4)**2+
     &  FD211ChiChaHpm(2,INe4,ICH3)*MNeu(INe3)**2*MNeu(INe4)**2-
     &  FD211ChiChaHpm(2,INe4,ICH3)*MNeu(INe4)**4)+2*MCha*
     &  DCONJG(CF11F12S3L(INe4,ICH3))*MNeu(INe4)*(-
     &  FD111ChiChaHp(4,INe3,ICH3)+FD111ChiChaHp(4,INe4,ICH3)+
     &  FD211ChiChaHpm(4,INe4,ICH3)*(MNeu(INe3)**2-MNeu(INe4)**2))))+
     &  CFF11S1R(INe4,INe3,j)*(CFF11S1L(INe3,INe4,i)*
     &  (DCONJG(CF11F12S3R(INe4,ICH3))*(-FD111ChaChiHp(8,INe3,ICH3)+
     &  FD111ChaChiHp(8,INe4,ICH3)+FD211ChiChaHpm(5,INe4,ICH3)*
     &  MNeu(INe3)**2-FD111ChaChiHp(2,INe3,ICH3)*MNeu(INe4)**2+
     &  FD111ChaChiHp(2,INe4,ICH3)*MNeu(INe4)**2-
     &  FD211ChiChaHpm(5,INe4,ICH3)*MNeu(INe4)**2+
     &  FD211ChiChaHpm(2,INe4,ICH3)*MNeu(INe3)**2*MNeu(INe4)**2-
     &  FD211ChiChaHpm(2,INe4,ICH3)*MNeu(INe4)**4)+2*MCha*
     &  DCONJG(CF11F12S3L(INe4,ICH3))*MNeu(INe4)*(-
     &  FD111ChiChaHp(4,INe3,ICH3)+FD111ChiChaHp(4,INe4,ICH3)+
     &  FD211ChiChaHpm(4,INe4,ICH3)*(MNeu(INe3)**2-MNeu(INe4)**2)))+2*
     &  CFF11S1R(INe3,INe4,i)*MNeu(INe3)*(DCONJG(CF11F12S3R(INe4,ICH3))
     &  *MNeu(INe4)*(-FD111ChaChiHp(2,INe3,ICH3)+
     &  FD111ChaChiHp(2,INe4,ICH3)+FD211ChiChaHpm(2,INe4,ICH3)*
     &  (MNeu(INe3)**2-MNeu(INe4)**2))+MCha*
     &  DCONJG(CF11F12S3L(INe4,ICH3))*(-FD111ChaChiHp(1,INe3,ICH3)+
     &  FD111ChaChiHp(1,INe4,ICH3)+FD211ChiChaHpm(1,INe4,ICH3)*
     &  (MNeu(INe3)**2-MNeu(INe4)**2))*MNeu2(INe4))))+
     &  CF11F12S3L(INe4,ICH3)*(CFF11S1R(INe4,INe3,j)*(2*
     &  CFF11S1R(INe3,INe4,i)*MNeu(INe3)*(DCONJG(CF11F12S3L(INe4,ICH3))
     &  *MNeu(INe4)*(-FD111ChaChiHp(2,INe3,ICH3)+
     &  FD111ChaChiHp(2,INe4,ICH3)+FD211ChiChaHpm(2,INe4,ICH3)*
     &  (MNeu(INe3)**2-MNeu(INe4)**2))+MCha*
     &  DCONJG(CF11F12S3R(INe4,ICH3))*(-FD111ChiChaHp(4,INe3,ICH3)+
     &  FD111ChiChaHp(4,INe4,ICH3)+FD211ChiChaHpm(4,INe4,ICH3)*
     &  (MNeu(INe3)**2-MNeu(INe4)**2)))+CFF11S1L(INe3,INe4,i)*
     &  (DCONJG(CF11F12S3L(INe4,ICH3))*(-FD111ChaChiHp(8,INe3,ICH3)+
     &  FD111ChaChiHp(8,INe4,ICH3)+FD211ChiChaHpm(5,INe4,ICH3)*
     &  MNeu(INe3)**2-FD111ChaChiHp(2,INe3,ICH3)*MNeu(INe4)**2+
     &  FD111ChaChiHp(2,INe4,ICH3)*MNeu(INe4)**2-
     &  FD211ChiChaHpm(5,INe4,ICH3)*MNeu(INe4)**2+
     &  FD211ChiChaHpm(2,INe4,ICH3)*MNeu(INe3)**2*MNeu(INe4)**2-
     &  FD211ChiChaHpm(2,INe4,ICH3)*MNeu(INe4)**4)+2*MCha*
     &  DCONJG(CF11F12S3R(INe4,ICH3))*MNeu(INe4)*(-
     &  FD111ChiChaHp(4,INe3,ICH3)+FD111ChiChaHp(4,INe4,ICH3)+
     &  FD211ChiChaHpm(4,INe4,ICH3)*(MNeu(INe3)**2-MNeu(INe4)**2))))+
     &  CFF11S1L(INe4,INe3,j)*(CFF11S1R(INe3,INe4,i)*
     &  (DCONJG(CF11F12S3L(INe4,ICH3))*(-FD111ChaChiHp(8,INe3,ICH3)+
     &  FD111ChaChiHp(8,INe4,ICH3)+FD211ChiChaHpm(5,INe4,ICH3)*
     &  MNeu(INe3)**2-FD111ChaChiHp(2,INe3,ICH3)*MNeu(INe4)**2+
     &  FD111ChaChiHp(2,INe4,ICH3)*MNeu(INe4)**2-
     &  FD211ChiChaHpm(5,INe4,ICH3)*MNeu(INe4)**2+
     &  FD211ChiChaHpm(2,INe4,ICH3)*MNeu(INe3)**2*MNeu(INe4)**2-
     &  FD211ChiChaHpm(2,INe4,ICH3)*MNeu(INe4)**4)+2*MCha*
     &  DCONJG(CF11F12S3R(INe4,ICH3))*MNeu(INe4)*(-
     &  FD111ChiChaHp(4,INe3,ICH3)+FD111ChiChaHp(4,INe4,ICH3)+
     &  FD211ChiChaHpm(4,INe4,ICH3)*(MNeu(INe3)**2-MNeu(INe4)**2)))+2*
     &  CFF11S1L(INe3,INe4,i)*MNeu(INe3)*(DCONJG(CF11F12S3L(INe4,ICH3))
     &  *MNeu(INe4)*(-FD111ChaChiHp(2,INe3,ICH3)+
     &  FD111ChaChiHp(2,INe4,ICH3)+FD211ChiChaHpm(2,INe4,ICH3)*
     &  (MNeu(INe3)**2-MNeu(INe4)**2))+MCha*
     &  DCONJG(CF11F12S3R(INe4,ICH3))*(-FD111ChaChiHp(1,INe3,ICH3)+
     &  FD111ChaChiHp(1,INe4,ICH3)+FD211ChiChaHpm(1,INe4,ICH3)*
     &  (MNeu(INe3)**2-MNeu(INe4)**2))*MNeu2(INe4)))))/(8.*(MNeu(INe3)**2-MNeu(INe4)**2)**2)+self(i,j)
             endif
             if( Abs(-MNeu(INe3) + MNeu(INe5)) .lt. 1D-15 .AND. Abs(MNeu(INe3) - MNeu(INe4)) .lt. 1D-15) then 
       self(i,j)=(-(CF11F12S3L(INe3,ICH3)*(CFF11S1R(INe3,INe3,j)*(2*
     &  CFF11S1R(INe3,INe3,i)*(MCha*DCONJG(CF11F12S3R(INe3,ICH3))*
     &  FD311ChiChaHp(3,INe3,ICH3)*MNeu(INe3)+
     &  DCONJG(CF11F12S3L(INe3,ICH3))*FD311ChiChaHp(2,INe3,ICH3)*
     &  MNeu2(INe3))+CFF11S1L(INe3,INe3,i)*(2*MCha*
     &  DCONJG(CF11F12S3R(INe3,ICH3))*FD311ChiChaHp(3,INe3,ICH3)*
     &  MNeu(INe3)+DCONJG(CF11F12S3L(INe3,ICH3))*
     &  (FD311ChiChaHp(4,INe3,ICH3)+FD311ChiChaHp(2,INe3,ICH3)*
     &  MNeu2(INe3))))+CFF11S1L(INe3,INe3,j)*(2*CFF11S1L(INe3,INe3,i)*
     &  (MCha*DCONJG(CF11F12S3R(INe3,ICH3))*FD311ChiChaHp(1,INe3,ICH3)*
     &  MNeu(INe3)**3+DCONJG(CF11F12S3L(INe3,ICH3))*
     &  FD311ChiChaHp(2,INe3,ICH3)*MNeu2(INe3))+CFF11S1R(INe3,INe3,i)*
     &  (2*MCha*DCONJG(CF11F12S3R(INe3,ICH3))*
     &  FD311ChiChaHp(3,INe3,ICH3)*MNeu(INe3)+
     &  DCONJG(CF11F12S3L(INe3,ICH3))*(FD311ChiChaHp(4,INe3,ICH3)+
     &  FD311ChiChaHp(2,INe3,ICH3)*MNeu2(INe3))))))-
     &  CF11F12S3R(INe3,ICH3)*(CFF11S1R(INe3,INe3,j)*(2*
     &  CFF11S1R(INe3,INe3,i)*(MCha*DCONJG(CF11F12S3L(INe3,ICH3))*
     &  FD311ChiChaHp(1,INe3,ICH3)*MNeu(INe3)**3+
     &  DCONJG(CF11F12S3R(INe3,ICH3))*FD311ChiChaHp(2,INe3,ICH3)*
     &  MNeu2(INe3))+CFF11S1L(INe3,INe3,i)*(2*MCha*
     &  DCONJG(CF11F12S3L(INe3,ICH3))*FD311ChiChaHp(3,INe3,ICH3)*
     &  MNeu(INe3)+DCONJG(CF11F12S3R(INe3,ICH3))*
     &  (FD311ChiChaHp(4,INe3,ICH3)+FD311ChiChaHp(2,INe3,ICH3)*
     &  MNeu2(INe3))))+CFF11S1L(INe3,INe3,j)*(2*CFF11S1L(INe3,INe3,i)*
     &  (MCha*DCONJG(CF11F12S3L(INe3,ICH3))*FD311ChiChaHp(3,INe3,ICH3)*
     &  MNeu(INe3)+DCONJG(CF11F12S3R(INe3,ICH3))*
     &  FD311ChiChaHp(2,INe3,ICH3)*MNeu2(INe3))+CFF11S1R(INe3,INe3,i)*
     &  (2*MCha*DCONJG(CF11F12S3L(INe3,ICH3))*
     &  FD311ChiChaHp(3,INe3,ICH3)*MNeu(INe3)+
     &  DCONJG(CF11F12S3R(INe3,ICH3))*(FD311ChiChaHp(4,INe3,ICH3)
     &  +FD311ChiChaHp(2,INe3,ICH3)*MNeu2(INe3))))))/8.+self(i,j)

             endif
           endif
       enddo 
       enddo 
       enddo 
       enddo 


       do ICH3=1,2
       do INe3=ineu,3


       self(i,j)=(-(CF11F12S3R(INe3,ICH3)*(CFF12S1R(i)*(2*CFF12S1R(j)*
     &  (MCha2*DCONJG(CF11F12S3R(INe3,ICH3))*FD311ChaChiHp(2,INe3,ICH3)
     &  +MCha**3*DCONJG(CF11F12S3L(INe3,ICH3))*
     &  FD311ChaChiHp(1,INe3,ICH3)*MNeu(INe3))+CFF12S1L(j)*
     &  (DCONJG(CF11F12S3R(INe3,ICH3))*(MCha2*
     &  FD311ChaChiHp(2,INe3,ICH3)+FD311ChaChiHp(4,INe3,ICH3))+2*MCha*
     &  DCONJG(CF11F12S3L(INe3,ICH3))*FD311ChaChiHp(3,INe3,ICH3)*
     &  MNeu(INe3)))+CFF12S1L(i)*(2*CFF12S1L(j)*(MCha2*
     &  DCONJG(CF11F12S3R(INe3,ICH3))*FD311ChaChiHp(2,INe3,ICH3)+MCha*
     &  DCONJG(CF11F12S3L(INe3,ICH3))*FD311ChaChiHp(3,INe3,ICH3)*
     &  MNeu(INe3))+CFF12S1R(j)*(DCONJG(CF11F12S3R(INe3,ICH3))*(MCha2*
     &  FD311ChaChiHp(2,INe3,ICH3)+FD311ChaChiHp(4,INe3,ICH3))+2*MCha*
     &  DCONJG(CF11F12S3L(INe3,ICH3))*FD311ChaChiHp(3,INe3,ICH3)*
     &  MNeu(INe3)))))-CF11F12S3L(INe3,ICH3)*(CFF12S1R(i)*(2*
     &  CFF12S1R(j)*(MCha2*DCONJG(CF11F12S3L(INe3,ICH3))*
     &  FD311ChaChiHp(2,INe3,ICH3)+MCha*DCONJG(CF11F12S3R(INe3,ICH3))*
     &  FD311ChaChiHp(3,INe3,ICH3)*MNeu(INe3))+CFF12S1L(j)*
     &  (DCONJG(CF11F12S3L(INe3,ICH3))*(MCha2*
     &  FD311ChaChiHp(2,INe3,ICH3)+FD311ChaChiHp(4,INe3,ICH3))+2*MCha*
     &  DCONJG(CF11F12S3R(INe3,ICH3))*FD311ChaChiHp(3,INe3,ICH3)*
     &  MNeu(INe3)))+CFF12S1L(i)*(2*CFF12S1L(j)*(MCha2*
     &  DCONJG(CF11F12S3L(INe3,ICH3))*FD311ChaChiHp(2,INe3,ICH3)+MCha**
     &  3*DCONJG(CF11F12S3R(INe3,ICH3))*FD311ChaChiHp(1,INe3,ICH3)*
     &  MNeu(INe3))+CFF12S1R(j)*(DCONJG(CF11F12S3L(INe3,ICH3))*(MCha2*
     &  FD311ChaChiHp(2,INe3,ICH3)+FD311ChaChiHp(4,INe3,ICH3))+2*MCha*
     &  DCONJG(CF11F12S3R(INe3,ICH3))*FD311ChaChiHp(3,INe3,ICH3)*
     &  MNeu(INe3)))))/8.+self(i,j)


       enddo 
       enddo 


       do INe3=ineu,3
       do INe4=ineu,3
       do INe5=ineu,3
       do ISt3=1,2
          if( Abs(-MNeu(INe3) + MNeu(INe4))*Abs(-MNeu(INe3) + MNeu(INe5))*Abs(-MNeu(INe4) + MNeu(INe5)) .gt. 1D-15) then 
       self(i,j)=(3*(-(((CF11FSR(INe5,ISt3)*CF11FSRC(INe4,ISt3)*
     &  CFF11S1L(INe5,INe3,j)*CFF11S1R(INe3,INe4,i)+CF11FSL(INe5,ISt3)*
     &  CF11FSLC(INe4,ISt3)*CFF11S1L(INe3,INe4,i)*CFF11S1R(INe5,INe3,j)
     &  )*FD111ChiTST(5,INe3,ISt3))/((MNeu(INe3)-MNeu(INe4))*
     &  (MNeu(INe3)+MNeu(INe4))*(MNeu(INe3)-MNeu(INe5))*(MNeu(INe3)+
     &  MNeu(INe5))))-((CF11FSL(INe4,ISt3)*CF11FSLC(INe5,ISt3)*
     &  CFF11S1L(INe5,INe3,j)*CFF11S1R(INe3,INe4,i)+CF11FSR(INe4,ISt3)*
     &  CF11FSRC(INe5,ISt3)*CFF11S1L(INe3,INe4,i)*CFF11S1R(INe5,INe3,j)
     &  )*FD111ChiTST(5,INe3,ISt3))/((MNeu(INe3)-MNeu(INe4))*
     &  (MNeu(INe3)+MNeu(INe4))*(MNeu(INe3)-MNeu(INe5))*(MNeu(INe3)+
     &  MNeu(INe5)))-(M1*(CF11FSL(INe4,ISt3)*CF11FSRC(INe5,ISt3)*
     &  CFF11S1L(INe3,INe4,i)*CFF11S1L(INe5,INe3,j)+CF11FSLC(INe5,ISt3)
     &  *CF11FSR(INe4,ISt3)*CFF11S1R(INe3,INe4,i)*CFF11S1R(INe5,INe3,j)
     &  )*FD111TChiST(1,INe3,ISt3)*MNeu(INe3)*MNeu(INe4)*MNeu(INe5))
     &  /((MNeu(INe3)-MNeu(INe4))*(MNeu(INe3)+MNeu(INe4))*(MNeu(INe3)-
     &  MNeu(INe5))*(MNeu(INe3)+MNeu(INe5)))-(M1*(CF11FSL(INe5,ISt3)*
     &  CF11FSRC(INe4,ISt3)*CFF11S1L(INe3,INe4,i)*CFF11S1L(INe5,INe3,j)
     &  +CF11FSLC(INe4,ISt3)*CF11FSR(INe5,ISt3)*CFF11S1R(INe3,INe4,i)*
     &  CFF11S1R(INe5,INe3,j))*FD111TChiST(1,INe3,ISt3)*MNeu(INe3)*
     &  MNeu(INe4)*MNeu(INe5))/((MNeu(INe3)-MNeu(INe4))*(MNeu(INe3)+
     &  MNeu(INe4))*(MNeu(INe3)-MNeu(INe5))*(MNeu(INe3)+MNeu(INe5)))+
     &  ((CF11FSR(INe5,ISt3)*CF11FSRC(INe4,ISt3)*CFF11S1L(INe5,INe3,j)*
     &  CFF11S1R(INe3,INe4,i)+CF11FSL(INe5,ISt3)*CF11FSLC(INe4,ISt3)*
     &  CFF11S1L(INe3,INe4,i)*CFF11S1R(INe5,INe3,j))*
     &  FD111ChiTST(5,INe4,ISt3))/((MNeu(INe3)-MNeu(INe4))*(MNeu(INe3)+
     &  MNeu(INe4))*(MNeu(INe4)-MNeu(INe5))*(MNeu(INe4)+MNeu(INe5)))+
     &  ((CF11FSL(INe4,ISt3)*CF11FSLC(INe5,ISt3)*CFF11S1L(INe5,INe3,j)*
     &  CFF11S1R(INe3,INe4,i)+CF11FSR(INe4,ISt3)*CF11FSRC(INe5,ISt3)*
     &  CFF11S1L(INe3,INe4,i)*CFF11S1R(INe5,INe3,j))*
     &  FD111ChiTST(5,INe4,ISt3))/((MNeu(INe3)-MNeu(INe4))*(MNeu(INe3)+
     &  MNeu(INe4))*(MNeu(INe4)-MNeu(INe5))*(MNeu(INe4)+MNeu(INe5)))+
     &  (M1*(CF11FSL(INe4,ISt3)*CF11FSRC(INe5,ISt3)*
     &  CFF11S1L(INe3,INe4,i)*CFF11S1L(INe5,INe3,j)+CF11FSLC(INe5,ISt3)
     &  *CF11FSR(INe4,ISt3)*CFF11S1R(INe3,INe4,i)*CFF11S1R(INe5,INe3,j)
     &  )*FD111TChiST(1,INe4,ISt3)*MNeu(INe3)*MNeu(INe4)*MNeu(INe5))
     &  /((MNeu(INe3)-MNeu(INe4))*(MNeu(INe3)+MNeu(INe4))*(MNeu(INe4)-
     &  MNeu(INe5))*(MNeu(INe4)+MNeu(INe5)))+(M1*(CF11FSL(INe5,ISt3)*
     &  CF11FSRC(INe4,ISt3)*CFF11S1L(INe3,INe4,i)*CFF11S1L(INe5,INe3,j)
     &  +CF11FSLC(INe4,ISt3)*CF11FSR(INe5,ISt3)*CFF11S1R(INe3,INe4,i)*
     &  CFF11S1R(INe5,INe3,j))*FD111TChiST(1,INe4,ISt3)*MNeu(INe3)*
     &  MNeu(INe4)*MNeu(INe5))/((MNeu(INe3)-MNeu(INe4))*(MNeu(INe3)+
     &  MNeu(INe4))*(MNeu(INe4)-MNeu(INe5))*(MNeu(INe4)+MNeu(INe5)))+
     &  ((CF11FSR(INe5,ISt3)*CF11FSRC(INe4,ISt3)*CFF11S1L(INe5,INe3,j)*
     &  CFF11S1R(INe3,INe4,i)+CF11FSL(INe5,ISt3)*CF11FSLC(INe4,ISt3)*
     &  CFF11S1L(INe3,INe4,i)*CFF11S1R(INe5,INe3,j))*
     &  FD111ChiTST(5,INe5,ISt3))/((MNeu(INe3)-MNeu(INe5))*(MNeu(INe3)+
     &  MNeu(INe5))*(-MNeu(INe4)+MNeu(INe5))*(MNeu(INe4)+MNeu(INe5)))+
     &  ((CF11FSL(INe4,ISt3)*CF11FSLC(INe5,ISt3)*CFF11S1L(INe5,INe3,j)*
     &  CFF11S1R(INe3,INe4,i)+CF11FSR(INe4,ISt3)*CF11FSRC(INe5,ISt3)*
     &  CFF11S1L(INe3,INe4,i)*CFF11S1R(INe5,INe3,j))*
     &  FD111ChiTST(5,INe5,ISt3))/((MNeu(INe3)-MNeu(INe5))*(MNeu(INe3)+
     &  MNeu(INe5))*(-MNeu(INe4)+MNeu(INe5))*(MNeu(INe4)+MNeu(INe5)))+
     &  (M1*(CF11FSL(INe4,ISt3)*CF11FSRC(INe5,ISt3)*
     &  CFF11S1L(INe3,INe4,i)*CFF11S1L(INe5,INe3,j)+CF11FSLC(INe5,ISt3)
     &  *CF11FSR(INe4,ISt3)*CFF11S1R(INe3,INe4,i)*CFF11S1R(INe5,INe3,j)
     &  )*FD111TChiST(1,INe5,ISt3)*MNeu(INe3)*MNeu(INe4)*MNeu(INe5))
     &  /((MNeu(INe3)-MNeu(INe5))*(MNeu(INe3)+MNeu(INe5))*(-MNeu(INe4)+
     &  MNeu(INe5))*(MNeu(INe4)+MNeu(INe5)))+(M1*(CF11FSL(INe5,ISt3)*
     &  CF11FSRC(INe4,ISt3)*CFF11S1L(INe3,INe4,i)*CFF11S1L(INe5,INe3,j)
     &  +CF11FSLC(INe4,ISt3)*CF11FSR(INe5,ISt3)*CFF11S1R(INe3,INe4,i)*
     &  CFF11S1R(INe5,INe3,j))*FD111TChiST(1,INe5,ISt3)*MNeu(INe3)*
     &  MNeu(INe4)*MNeu(INe5))/((MNeu(INe3)-MNeu(INe5))*(MNeu(INe3)+
     &  MNeu(INe5))*(-MNeu(INe4)+MNeu(INe5))*(MNeu(INe4)+MNeu(INe5)))-
     &  (M1*FD111ChiTST(4,INe3,ISt3)*(CF11FSL(INe4,ISt3)*
     &  CF11FSRC(INe5,ISt3)*(CFF11S1L(INe3,INe4,i)*
     &  CFF11S1R(INe5,INe3,j)*MNeu(INe4)+CFF11S1R(INe3,INe4,i)*
     &  (CFF11S1R(INe5,INe3,j)*MNeu(INe3)+CFF11S1L(INe5,INe3,j)*
     &  MNeu(INe5)))+CF11FSLC(INe5,ISt3)*CF11FSR(INe4,ISt3)*
     &  (CFF11S1L(INe5,INe3,j)*CFF11S1R(INe3,INe4,i)*MNeu(INe4)+
     &  CFF11S1L(INe3,INe4,i)*(CFF11S1L(INe5,INe3,j)*MNeu(INe3)+
     &  CFF11S1R(INe5,INe3,j)*MNeu(INe5)))))/((MNeu(INe3)-MNeu(INe4))*
     &  (MNeu(INe3)+MNeu(INe4))*(MNeu(INe3)-MNeu(INe5))*(MNeu(INe3)+
     &  MNeu(INe5)))+(M1*FD111ChiTST(4,INe4,ISt3)*(CF11FSL(INe4,ISt3)*
     &  CF11FSRC(INe5,ISt3)*(CFF11S1L(INe3,INe4,i)*
     &  CFF11S1R(INe5,INe3,j)*MNeu(INe4)+CFF11S1R(INe3,INe4,i)*
     &  (CFF11S1R(INe5,INe3,j)*MNeu(INe3)+CFF11S1L(INe5,INe3,j)*
     &  MNeu(INe5)))+CF11FSLC(INe5,ISt3)*CF11FSR(INe4,ISt3)*
     &  (CFF11S1L(INe5,INe3,j)*CFF11S1R(INe3,INe4,i)*MNeu(INe4)+
     &  CFF11S1L(INe3,INe4,i)*(CFF11S1L(INe5,INe3,j)*MNeu(INe3)+
     &  CFF11S1R(INe5,INe3,j)*MNeu(INe5)))))/((MNeu(INe3)-MNeu(INe4))*
     &  (MNeu(INe3)+MNeu(INe4))*(MNeu(INe4)-MNeu(INe5))*(MNeu(INe4)+
     &  MNeu(INe5)))+(M1*FD111ChiTST(4,INe5,ISt3)*(CF11FSL(INe4,ISt3)*
     &  CF11FSRC(INe5,ISt3)*(CFF11S1L(INe3,INe4,i)*
     &  CFF11S1R(INe5,INe3,j)*MNeu(INe4)+CFF11S1R(INe3,INe4,i)*
     &  (CFF11S1R(INe5,INe3,j)*MNeu(INe3)+CFF11S1L(INe5,INe3,j)*
     &  MNeu(INe5)))+CF11FSLC(INe5,ISt3)*CF11FSR(INe4,ISt3)*
     &  (CFF11S1L(INe5,INe3,j)*CFF11S1R(INe3,INe4,i)*MNeu(INe4)+
     &  CFF11S1L(INe3,INe4,i)*(CFF11S1L(INe5,INe3,j)*MNeu(INe3)+
     &  CFF11S1R(INe5,INe3,j)*MNeu(INe5)))))/((MNeu(INe3)-MNeu(INe5))*
     &  (MNeu(INe3)+MNeu(INe5))*(-MNeu(INe4)+MNeu(INe5))*(MNeu(INe4)+
     &  MNeu(INe5)))-(M1*FD111ChiTST(4,INe3,ISt3)*(CF11FSL(INe5,ISt3)*
     &  CF11FSRC(INe4,ISt3)*(CFF11S1L(INe3,INe4,i)*
     &  CFF11S1R(INe5,INe3,j)*MNeu(INe4)+CFF11S1R(INe3,INe4,i)*
     &  (CFF11S1R(INe5,INe3,j)*MNeu(INe3)+CFF11S1L(INe5,INe3,j)*
     &  MNeu(INe5)))+CF11FSLC(INe4,ISt3)*CF11FSR(INe5,ISt3)*
     &  (CFF11S1L(INe5,INe3,j)*CFF11S1R(INe3,INe4,i)*MNeu(INe4)+
     &  CFF11S1L(INe3,INe4,i)*(CFF11S1L(INe5,INe3,j)*MNeu(INe3)+
     &  CFF11S1R(INe5,INe3,j)*MNeu(INe5)))))/((MNeu(INe3)-MNeu(INe4))*
     &  (MNeu(INe3)+MNeu(INe4))*(MNeu(INe3)-MNeu(INe5))*(MNeu(INe3)+
     &  MNeu(INe5)))+(M1*FD111ChiTST(4,INe4,ISt3)*(CF11FSL(INe5,ISt3)*
     &  CF11FSRC(INe4,ISt3)*(CFF11S1L(INe3,INe4,i)*
     &  CFF11S1R(INe5,INe3,j)*MNeu(INe4)+CFF11S1R(INe3,INe4,i)*
     &  (CFF11S1R(INe5,INe3,j)*MNeu(INe3)+CFF11S1L(INe5,INe3,j)*
     &  MNeu(INe5)))+CF11FSLC(INe4,ISt3)*CF11FSR(INe5,ISt3)*
     &  (CFF11S1L(INe5,INe3,j)*CFF11S1R(INe3,INe4,i)*MNeu(INe4)+
     &  CFF11S1L(INe3,INe4,i)*(CFF11S1L(INe5,INe3,j)*MNeu(INe3)+
     &  CFF11S1R(INe5,INe3,j)*MNeu(INe5)))))/((MNeu(INe3)-MNeu(INe4))*
     &  (MNeu(INe3)+MNeu(INe4))*(MNeu(INe4)-MNeu(INe5))*(MNeu(INe4)+
     &  MNeu(INe5)))+(M1*FD111ChiTST(4,INe5,ISt3)*(CF11FSL(INe5,ISt3)*
     &  CF11FSRC(INe4,ISt3)*(CFF11S1L(INe3,INe4,i)*
     &  CFF11S1R(INe5,INe3,j)*MNeu(INe4)+CFF11S1R(INe3,INe4,i)*
     &  (CFF11S1R(INe5,INe3,j)*MNeu(INe3)+CFF11S1L(INe5,INe3,j)*
     &  MNeu(INe5)))+CF11FSLC(INe4,ISt3)*CF11FSR(INe5,ISt3)*
     &  (CFF11S1L(INe5,INe3,j)*CFF11S1R(INe3,INe4,i)*MNeu(INe4)+
     &  CFF11S1L(INe3,INe4,i)*(CFF11S1L(INe5,INe3,j)*MNeu(INe3)+
     &  CFF11S1R(INe5,INe3,j)*MNeu(INe5)))))/((MNeu(INe3)-MNeu(INe5))*
     &  (MNeu(INe3)+MNeu(INe5))*(-MNeu(INe4)+MNeu(INe5))*(MNeu(INe4)+
     &  MNeu(INe5)))-(FD111TChiST(2,INe3,ISt3)*(CF11FSR(INe4,ISt3)*
     &  CF11FSRC(INe5,ISt3)*(CFF11S1L(INe3,INe4,i)*
     &  CFF11S1L(INe5,INe3,j)*MNeu(INe3)*MNeu(INe5)+
     &  CFF11S1R(INe3,INe4,i)*MNeu(INe4)*(CFF11S1R(INe5,INe3,j)*
     &  MNeu(INe3)+CFF11S1L(INe5,INe3,j)*MNeu(INe5)))+
     &  CF11FSL(INe4,ISt3)*CF11FSLC(INe5,ISt3)*(CFF11S1R(INe3,INe4,i)*
     &  CFF11S1R(INe5,INe3,j)*MNeu(INe3)*MNeu(INe5)+
     &  CFF11S1L(INe3,INe4,i)*MNeu(INe4)*(CFF11S1L(INe5,INe3,j)*
     &  MNeu(INe3)+CFF11S1R(INe5,INe3,j)*MNeu(INe5)))))/((MNeu(INe3)-
     &  MNeu(INe4))*(MNeu(INe3)+MNeu(INe4))*(MNeu(INe3)-MNeu(INe5))*
     &  (MNeu(INe3)+MNeu(INe5)))+(FD111TChiST(2,INe4,ISt3)*
     &  (CF11FSR(INe4,ISt3)*CF11FSRC(INe5,ISt3)*(CFF11S1L(INe3,INe4,i)*
     &  CFF11S1L(INe5,INe3,j)*MNeu(INe3)*MNeu(INe5)+
     &  CFF11S1R(INe3,INe4,i)*MNeu(INe4)*(CFF11S1R(INe5,INe3,j)*
     &  MNeu(INe3)+CFF11S1L(INe5,INe3,j)*MNeu(INe5)))+
     &  CF11FSL(INe4,ISt3)*CF11FSLC(INe5,ISt3)*(CFF11S1R(INe3,INe4,i)*
     &  CFF11S1R(INe5,INe3,j)*MNeu(INe3)*MNeu(INe5)+
     &  CFF11S1L(INe3,INe4,i)*MNeu(INe4)*(CFF11S1L(INe5,INe3,j)*
     &  MNeu(INe3)+CFF11S1R(INe5,INe3,j)*MNeu(INe5)))))/((MNeu(INe3)-
     &  MNeu(INe4))*(MNeu(INe3)+MNeu(INe4))*(MNeu(INe4)-MNeu(INe5))*
     &  (MNeu(INe4)+MNeu(INe5)))+(FD111TChiST(2,INe5,ISt3)*
     &  (CF11FSR(INe4,ISt3)*CF11FSRC(INe5,ISt3)*(CFF11S1L(INe3,INe4,i)*
     &  CFF11S1L(INe5,INe3,j)*MNeu(INe3)*MNeu(INe5)+
     &  CFF11S1R(INe3,INe4,i)*MNeu(INe4)*(CFF11S1R(INe5,INe3,j)*
     &  MNeu(INe3)+CFF11S1L(INe5,INe3,j)*MNeu(INe5)))+
     &  CF11FSL(INe4,ISt3)*CF11FSLC(INe5,ISt3)*(CFF11S1R(INe3,INe4,i)*
     &  CFF11S1R(INe5,INe3,j)*MNeu(INe3)*MNeu(INe5)+
     &  CFF11S1L(INe3,INe4,i)*MNeu(INe4)*(CFF11S1L(INe5,INe3,j)*
     &  MNeu(INe3)+CFF11S1R(INe5,INe3,j)*MNeu(INe5)))))/((MNeu(INe3)-
     &  MNeu(INe5))*(MNeu(INe3)+MNeu(INe5))*(-MNeu(INe4)+MNeu(INe5))*
     &  (MNeu(INe4)+MNeu(INe5)))-(FD111TChiST(2,INe3,ISt3)*
     &  (CF11FSL(INe5,ISt3)*CF11FSLC(INe4,ISt3)*(CFF11S1L(INe3,INe4,i)*
     &  CFF11S1L(INe5,INe3,j)*MNeu(INe3)*MNeu(INe5)+
     &  CFF11S1R(INe3,INe4,i)*MNeu(INe4)*(CFF11S1R(INe5,INe3,j)*
     &  MNeu(INe3)+CFF11S1L(INe5,INe3,j)*MNeu(INe5)))+
     &  CF11FSR(INe5,ISt3)*CF11FSRC(INe4,ISt3)*(CFF11S1R(INe3,INe4,i)*
     &  CFF11S1R(INe5,INe3,j)*MNeu(INe3)*MNeu(INe5)+
     &  CFF11S1L(INe3,INe4,i)*MNeu(INe4)*(CFF11S1L(INe5,INe3,j)*
     &  MNeu(INe3)+CFF11S1R(INe5,INe3,j)*MNeu(INe5)))))/((MNeu(INe3)-
     &  MNeu(INe4))*(MNeu(INe3)+MNeu(INe4))*(MNeu(INe3)-MNeu(INe5))*
     &  (MNeu(INe3)+MNeu(INe5)))+(FD111TChiST(2,INe4,ISt3)*
     &  (CF11FSL(INe5,ISt3)*CF11FSLC(INe4,ISt3)*(CFF11S1L(INe3,INe4,i)*
     &  CFF11S1L(INe5,INe3,j)*MNeu(INe3)*MNeu(INe5)+
     &  CFF11S1R(INe3,INe4,i)*MNeu(INe4)*(CFF11S1R(INe5,INe3,j)*
     &  MNeu(INe3)+CFF11S1L(INe5,INe3,j)*MNeu(INe5)))+
     &  CF11FSR(INe5,ISt3)*CF11FSRC(INe4,ISt3)*(CFF11S1R(INe3,INe4,i)*
     &  CFF11S1R(INe5,INe3,j)*MNeu(INe3)*MNeu(INe5)+
     &  CFF11S1L(INe3,INe4,i)*MNeu(INe4)*(CFF11S1L(INe5,INe3,j)*
     &  MNeu(INe3)+CFF11S1R(INe5,INe3,j)*MNeu(INe5)))))/((MNeu(INe3)-
     &  MNeu(INe4))*(MNeu(INe3)+MNeu(INe4))*(MNeu(INe4)-MNeu(INe5))*
     &  (MNeu(INe4)+MNeu(INe5)))+(FD111TChiST(2,INe5,ISt3)*
     &  (CF11FSL(INe5,ISt3)*CF11FSLC(INe4,ISt3)*(CFF11S1L(INe3,INe4,i)*
     &  CFF11S1L(INe5,INe3,j)*MNeu(INe3)*MNeu(INe5)+
     &  CFF11S1R(INe3,INe4,i)*MNeu(INe4)*(CFF11S1R(INe5,INe3,j)*
     &  MNeu(INe3)+CFF11S1L(INe5,INe3,j)*MNeu(INe5)))+
     &  CF11FSR(INe5,ISt3)*CF11FSRC(INe4,ISt3)*(CFF11S1R(INe3,INe4,i)*
     &  CFF11S1R(INe5,INe3,j)*MNeu(INe3)*MNeu(INe5)+
     &  CFF11S1L(INe3,INe4,i)*MNeu(INe4)*(CFF11S1L(INe5,INe3,j)*
     &  MNeu(INe3)+CFF11S1R(INe5,INe3,j)*MNeu(INe5)))))/((MNeu(INe3)-MNeu(INe5))
     &  *(MNeu(INe3)+MNeu(INe5))*(-MNeu(INe4)+MNeu(INe5))*(MNeu(INe4)+MNeu(INe5)))))/8.+self(i,j)
           else
             if( Abs(-MNeu(INe3) + MNeu(INe5))*Abs(-MNeu(INe4) + MNeu(INe5)) .gt. 1D-15) then 
       self(i,j)=(3*(CF11FSL(INe5,ISt3)*CF11FSLC(INe3,ISt3)*
     &  CFF11S1L(INe3,INe3,i)*CFF11S1R(INe5,INe3,j)*
     &  FD111ChiTST(5,INe3,ISt3)+CF11FSR(INe3,ISt3)*CF11FSRC(INe5,ISt3)
     &  *CFF11S1L(INe3,INe3,i)*CFF11S1R(INe5,INe3,j)*
     &  FD111ChiTST(5,INe3,ISt3)-CF11FSL(INe5,ISt3)*CF11FSLC(INe3,ISt3)
     &  *CFF11S1L(INe3,INe3,i)*CFF11S1R(INe5,INe3,j)*
     &  FD111ChiTST(5,INe5,ISt3)-CF11FSR(INe3,ISt3)*CF11FSRC(INe5,ISt3)
     &  *CFF11S1L(INe3,INe3,i)*CFF11S1R(INe5,INe3,j)*
     &  FD111ChiTST(5,INe5,ISt3)+M1*CF11FSLC(INe5,ISt3)*
     &  CF11FSR(INe3,ISt3)*CFF11S1L(INe3,INe3,i)*CFF11S1L(INe5,INe3,j)*
     &  FD111ChiTST(4,INe3,ISt3)*MNeu(INe3)+M1*CF11FSLC(INe5,ISt3)*
     &  CF11FSR(INe3,ISt3)*CFF11S1L(INe5,INe3,j)*CFF11S1R(INe3,INe3,i)*
     &  FD111ChiTST(4,INe3,ISt3)*MNeu(INe3)+M1*CF11FSL(INe5,ISt3)*
     &  CF11FSRC(INe3,ISt3)*CFF11S1L(INe3,INe3,i)*CFF11S1R(INe5,INe3,j)
     &  *FD111ChiTST(4,INe3,ISt3)*MNeu(INe3)+M1*CF11FSL(INe5,ISt3)*
     &  CF11FSRC(INe3,ISt3)*CFF11S1R(INe3,INe3,i)*CFF11S1R(INe5,INe3,j)
     &  *FD111ChiTST(4,INe3,ISt3)*MNeu(INe3)-M1*CF11FSLC(INe5,ISt3)*
     &  CF11FSR(INe3,ISt3)*CFF11S1L(INe3,INe3,i)*CFF11S1L(INe5,INe3,j)*
     &  FD111ChiTST(4,INe5,ISt3)*MNeu(INe3)-M1*CF11FSLC(INe5,ISt3)*
     &  CF11FSR(INe3,ISt3)*CFF11S1L(INe5,INe3,j)*CFF11S1R(INe3,INe3,i)*
     &  FD111ChiTST(4,INe5,ISt3)*MNeu(INe3)-M1*CF11FSL(INe5,ISt3)*
     &  CF11FSRC(INe3,ISt3)*CFF11S1L(INe3,INe3,i)*CFF11S1R(INe5,INe3,j)
     &  *FD111ChiTST(4,INe5,ISt3)*MNeu(INe3)-M1*CF11FSL(INe5,ISt3)*
     &  CF11FSRC(INe3,ISt3)*CFF11S1R(INe3,INe3,i)*CFF11S1R(INe5,INe3,j)
     &  *FD111ChiTST(4,INe5,ISt3)*MNeu(INe3)+CF11FSL(INe5,ISt3)*
     &  CF11FSLC(INe3,ISt3)*CFF11S1R(INe3,INe3,i)*CFF11S1R(INe5,INe3,j)
     &  *FD111TChiST(2,INe3,ISt3)*MNeu(INe3)**2+CF11FSR(INe3,ISt3)*
     &  CF11FSRC(INe5,ISt3)*CFF11S1R(INe3,INe3,i)*CFF11S1R(INe5,INe3,j)
     &  *FD111TChiST(2,INe3,ISt3)*MNeu(INe3)**2-CF11FSL(INe5,ISt3)*
     &  CF11FSLC(INe3,ISt3)*CFF11S1R(INe3,INe3,i)*CFF11S1R(INe5,INe3,j)
     &  *FD111TChiST(2,INe5,ISt3)*MNeu(INe3)**2-CF11FSR(INe3,ISt3)*
     &  CF11FSRC(INe5,ISt3)*CFF11S1R(INe3,INe3,i)*CFF11S1R(INe5,INe3,j)
     &  *FD111TChiST(2,INe5,ISt3)*MNeu(INe3)**2-CF11FSL(INe5,ISt3)*
     &  CF11FSLC(INe3,ISt3)*CFF11S1L(INe3,INe3,i)*CFF11S1R(INe5,INe3,j)
     &  *FD211ChiTST(5,INe3,ISt3)*MNeu(INe3)**2-CF11FSR(INe3,ISt3)*
     &  CF11FSRC(INe5,ISt3)*CFF11S1L(INe3,INe3,i)*CFF11S1R(INe5,INe3,j)
     &  *FD211ChiTST(5,INe3,ISt3)*MNeu(INe3)**2-M1*CF11FSLC(INe5,ISt3)*
     &  CF11FSR(INe3,ISt3)*CFF11S1L(INe3,INe3,i)*CFF11S1L(INe5,INe3,j)*
     &  FD211ChiTST(4,INe3,ISt3)*MNeu(INe3)**3-M1*CF11FSLC(INe5,ISt3)*
     &  CF11FSR(INe3,ISt3)*CFF11S1L(INe5,INe3,j)*CFF11S1R(INe3,INe3,i)*
     &  FD211ChiTST(4,INe3,ISt3)*MNeu(INe3)**3-M1*CF11FSL(INe5,ISt3)*
     &  CF11FSRC(INe3,ISt3)*CFF11S1L(INe3,INe3,i)*CFF11S1R(INe5,INe3,j)
     &  *FD211ChiTST(4,INe3,ISt3)*MNeu(INe3)**3-M1*CF11FSL(INe5,ISt3)*
     &  CF11FSRC(INe3,ISt3)*CFF11S1R(INe3,INe3,i)*CFF11S1R(INe5,INe3,j)
     &  *FD211ChiTST(4,INe3,ISt3)*MNeu(INe3)**3-CF11FSL(INe5,ISt3)*
     &  CF11FSLC(INe3,ISt3)*CFF11S1R(INe3,INe3,i)*CFF11S1R(INe5,INe3,j)
     &  *FD211ChiTST(2,INe3,ISt3)*MNeu(INe3)**4-CF11FSR(INe3,ISt3)*
     &  CF11FSRC(INe5,ISt3)*CFF11S1R(INe3,INe3,i)*CFF11S1R(INe5,INe3,j)
     &  *FD211ChiTST(2,INe3,ISt3)*MNeu(INe3)**4+M1*CF11FSL(INe5,ISt3)*
     &  CF11FSRC(INe3,ISt3)*CFF11S1L(INe5,INe3,j)*CFF11S1R(INe3,INe3,i)
     &  *FD111ChiTST(4,INe3,ISt3)*MNeu(INe5)+M1*CF11FSLC(INe5,ISt3)*
     &  CF11FSR(INe3,ISt3)*CFF11S1L(INe3,INe3,i)*CFF11S1R(INe5,INe3,j)*
     &  FD111ChiTST(4,INe3,ISt3)*MNeu(INe5)-M1*CF11FSL(INe5,ISt3)*
     &  CF11FSRC(INe3,ISt3)*CFF11S1L(INe5,INe3,j)*CFF11S1R(INe3,INe3,i)
     &  *FD111ChiTST(4,INe5,ISt3)*MNeu(INe5)-M1*CF11FSLC(INe5,ISt3)*
     &  CF11FSR(INe3,ISt3)*CFF11S1L(INe3,INe3,i)*CFF11S1R(INe5,INe3,j)*
     &  FD111ChiTST(4,INe5,ISt3)*MNeu(INe5)+CF11FSL(INe5,ISt3)*
     &  CF11FSLC(INe3,ISt3)*CFF11S1L(INe3,INe3,i)*CFF11S1L(INe5,INe3,j)
     &  *FD111TChiST(2,INe3,ISt3)*MNeu(INe3)*MNeu(INe5)+
     &  CF11FSR(INe3,ISt3)*CF11FSRC(INe5,ISt3)*CFF11S1L(INe3,INe3,i)*
     &  CFF11S1L(INe5,INe3,j)*FD111TChiST(2,INe3,ISt3)*MNeu(INe3)*
     &  MNeu(INe5)+CF11FSL(INe5,ISt3)*CF11FSLC(INe3,ISt3)*
     &  CFF11S1L(INe5,INe3,j)*CFF11S1R(INe3,INe3,i)*
     &  FD111TChiST(2,INe3,ISt3)*MNeu(INe3)*MNeu(INe5)+
     &  CF11FSR(INe3,ISt3)*CF11FSRC(INe5,ISt3)*CFF11S1L(INe5,INe3,j)*
     &  CFF11S1R(INe3,INe3,i)*FD111TChiST(2,INe3,ISt3)*MNeu(INe3)*
     &  MNeu(INe5)-CF11FSL(INe5,ISt3)*CF11FSLC(INe3,ISt3)*
     &  CFF11S1L(INe3,INe3,i)*CFF11S1L(INe5,INe3,j)*
     &  FD111TChiST(2,INe5,ISt3)*MNeu(INe3)*MNeu(INe5)-
     &  CF11FSR(INe3,ISt3)*CF11FSRC(INe5,ISt3)*CFF11S1L(INe3,INe3,i)*
     &  CFF11S1L(INe5,INe3,j)*FD111TChiST(2,INe5,ISt3)*MNeu(INe3)*
     &  MNeu(INe5)-CF11FSL(INe5,ISt3)*CF11FSLC(INe3,ISt3)*
     &  CFF11S1L(INe5,INe3,j)*CFF11S1R(INe3,INe3,i)*
     &  FD111TChiST(2,INe5,ISt3)*MNeu(INe3)*MNeu(INe5)-
     &  CF11FSR(INe3,ISt3)*CF11FSRC(INe5,ISt3)*CFF11S1L(INe5,INe3,j)*
     &  CFF11S1R(INe3,INe3,i)*FD111TChiST(2,INe5,ISt3)*MNeu(INe3)*
     &  MNeu(INe5)-M1*CF11FSL(INe5,ISt3)*CF11FSRC(INe3,ISt3)*
     &  CFF11S1L(INe5,INe3,j)*CFF11S1R(INe3,INe3,i)*
     &  FD211ChiTST(4,INe3,ISt3)*MNeu(INe3)**2*MNeu(INe5)-M1*
     &  CF11FSLC(INe5,ISt3)*CF11FSR(INe3,ISt3)*CFF11S1L(INe3,INe3,i)*
     &  CFF11S1R(INe5,INe3,j)*FD211ChiTST(4,INe3,ISt3)*MNeu(INe3)**2*
     &  MNeu(INe5)-CF11FSL(INe5,ISt3)*CF11FSLC(INe3,ISt3)*
     &  CFF11S1L(INe3,INe3,i)*CFF11S1L(INe5,INe3,j)*
     &  FD211ChiTST(2,INe3,ISt3)*MNeu(INe3)**3*MNeu(INe5)-
     &  CF11FSR(INe3,ISt3)*CF11FSRC(INe5,ISt3)*CFF11S1L(INe3,INe3,i)*
     &  CFF11S1L(INe5,INe3,j)*FD211ChiTST(2,INe3,ISt3)*MNeu(INe3)**3*
     &  MNeu(INe5)-CF11FSL(INe5,ISt3)*CF11FSLC(INe3,ISt3)*
     &  CFF11S1L(INe5,INe3,j)*CFF11S1R(INe3,INe3,i)*
     &  FD211ChiTST(2,INe3,ISt3)*MNeu(INe3)**3*MNeu(INe5)-
     &  CF11FSR(INe3,ISt3)*CF11FSRC(INe5,ISt3)*CFF11S1L(INe5,INe3,j)*
     &  CFF11S1R(INe3,INe3,i)*FD211ChiTST(2,INe3,ISt3)*MNeu(INe3)**3*
     &  MNeu(INe5)+CF11FSL(INe5,ISt3)*CF11FSLC(INe3,ISt3)*
     &  CFF11S1L(INe3,INe3,i)*CFF11S1R(INe5,INe3,j)*
     &  FD211ChiTST(5,INe3,ISt3)*MNeu(INe5)**2+CF11FSR(INe3,ISt3)*
     &  CF11FSRC(INe5,ISt3)*CFF11S1L(INe3,INe3,i)*CFF11S1R(INe5,INe3,j)
     &  *FD211ChiTST(5,INe3,ISt3)*MNeu(INe5)**2+M1*CF11FSLC(INe5,ISt3)*
     &  CF11FSR(INe3,ISt3)*CFF11S1L(INe3,INe3,i)*CFF11S1L(INe5,INe3,j)*
     &  FD211ChiTST(4,INe3,ISt3)*MNeu(INe3)*MNeu(INe5)**2+M1*
     &  CF11FSLC(INe5,ISt3)*CF11FSR(INe3,ISt3)*CFF11S1L(INe5,INe3,j)*
     &  CFF11S1R(INe3,INe3,i)*FD211ChiTST(4,INe3,ISt3)*MNeu(INe3)*
     &  MNeu(INe5)**2+M1*CF11FSL(INe5,ISt3)*CF11FSRC(INe3,ISt3)*
     &  CFF11S1L(INe3,INe3,i)*CFF11S1R(INe5,INe3,j)*
     &  FD211ChiTST(4,INe3,ISt3)*MNeu(INe3)*MNeu(INe5)**2+M1*
     &  CF11FSL(INe5,ISt3)*CF11FSRC(INe3,ISt3)*CFF11S1R(INe3,INe3,i)*
     &  CFF11S1R(INe5,INe3,j)*FD211ChiTST(4,INe3,ISt3)*MNeu(INe3)*
     &  MNeu(INe5)**2+CF11FSL(INe5,ISt3)*CF11FSLC(INe3,ISt3)*
     &  CFF11S1R(INe3,INe3,i)*CFF11S1R(INe5,INe3,j)*
     &  FD211ChiTST(2,INe3,ISt3)*MNeu(INe3)**2*MNeu(INe5)**2+
     &  CF11FSR(INe3,ISt3)*CF11FSRC(INe5,ISt3)*CFF11S1R(INe3,INe3,i)*
     &  CFF11S1R(INe5,INe3,j)*FD211ChiTST(2,INe3,ISt3)*MNeu(INe3)**2*
     &  MNeu(INe5)**2+M1*CF11FSL(INe5,ISt3)*CF11FSRC(INe3,ISt3)*
     &  CFF11S1L(INe5,INe3,j)*CFF11S1R(INe3,INe3,i)*
     &  FD211ChiTST(4,INe3,ISt3)*MNeu(INe5)**3+M1*CF11FSLC(INe5,ISt3)*
     &  CF11FSR(INe3,ISt3)*CFF11S1L(INe3,INe3,i)*CFF11S1R(INe5,INe3,j)*
     &  FD211ChiTST(4,INe3,ISt3)*MNeu(INe5)**3+CF11FSL(INe5,ISt3)*
     &  CF11FSLC(INe3,ISt3)*CFF11S1L(INe3,INe3,i)*CFF11S1L(INe5,INe3,j)
     &  *FD211ChiTST(2,INe3,ISt3)*MNeu(INe3)*MNeu(INe5)**3+
     &  CF11FSR(INe3,ISt3)*CF11FSRC(INe5,ISt3)*CFF11S1L(INe3,INe3,i)*
     &  CFF11S1L(INe5,INe3,j)*FD211ChiTST(2,INe3,ISt3)*MNeu(INe3)*
     &  MNeu(INe5)**3+CF11FSL(INe5,ISt3)*CF11FSLC(INe3,ISt3)*
     &  CFF11S1L(INe5,INe3,j)*CFF11S1R(INe3,INe3,i)*
     &  FD211ChiTST(2,INe3,ISt3)*MNeu(INe3)*MNeu(INe5)**3+
     &  CF11FSR(INe3,ISt3)*CF11FSRC(INe5,ISt3)*CFF11S1L(INe5,INe3,j)*
     &  CFF11S1R(INe3,INe3,i)*FD211ChiTST(2,INe3,ISt3)*MNeu(INe3)*
     &  MNeu(INe5)**3+M1*CF11FSL(INe5,ISt3)*CF11FSRC(INe3,ISt3)*
     &  CFF11S1L(INe3,INe3,i)*CFF11S1L(INe5,INe3,j)*
     &  FD111TChiST(1,INe3,ISt3)*MNeu(INe5)*MNeu2(INe3)+M1*
     &  CF11FSLC(INe5,ISt3)*CF11FSR(INe3,ISt3)*CFF11S1R(INe3,INe3,i)*
     &  CFF11S1R(INe5,INe3,j)*FD111TChiST(1,INe3,ISt3)*MNeu(INe5)*
     &  MNeu2(INe3)-M1*CF11FSL(INe5,ISt3)*CF11FSRC(INe3,ISt3)*
     &  CFF11S1L(INe3,INe3,i)*CFF11S1L(INe5,INe3,j)*
     &  FD111TChiST(1,INe5,ISt3)*MNeu(INe5)*MNeu2(INe3)-M1*
     &  CF11FSLC(INe5,ISt3)*CF11FSR(INe3,ISt3)*CFF11S1R(INe3,INe3,i)*
     &  CFF11S1R(INe5,INe3,j)*FD111TChiST(1,INe5,ISt3)*MNeu(INe5)*
     &  MNeu2(INe3)-M1*CF11FSL(INe5,ISt3)*CF11FSRC(INe3,ISt3)*
     &  CFF11S1L(INe3,INe3,i)*CFF11S1L(INe5,INe3,j)*
     &  FD211ChiTST(1,INe3,ISt3)*MNeu(INe3)**2*MNeu(INe5)*MNeu2(INe3)-
     &  M1*CF11FSLC(INe5,ISt3)*CF11FSR(INe3,ISt3)*CFF11S1R(INe3,INe3,i)
     &  *CFF11S1R(INe5,INe3,j)*FD211ChiTST(1,INe3,ISt3)*MNeu(INe3)**2*
     &  MNeu(INe5)*MNeu2(INe3)+M1*CF11FSL(INe5,ISt3)*
     &  CF11FSRC(INe3,ISt3)*CFF11S1L(INe3,INe3,i)*CFF11S1L(INe5,INe3,j)
     &  *FD211ChiTST(1,INe3,ISt3)*MNeu(INe5)**3*MNeu2(INe3)+M1*
     &  CF11FSLC(INe5,ISt3)*CF11FSR(INe3,ISt3)*CFF11S1R(INe3,INe3,i)*
     &  CFF11S1R(INe5,INe3,j)*FD211ChiTST(1,INe3,ISt3)*MNeu(INe5)**3*
     &  MNeu2(INe3)+CF11FSL(INe3,ISt3)*(CF11FSLC(INe5,ISt3)*
     &  ((CFF11S1L(INe3,INe3,i)+CFF11S1R(INe3,INe3,i))*
     &  CFF11S1R(INe5,INe3,j)*MNeu(INe3)*MNeu(INe5)*
     &  (FD111TChiST(2,INe3,ISt3)-FD111TChiST(2,INe5,ISt3)+
     &  FD211ChiTST(2,INe3,ISt3)*(-MNeu(INe3)**2+MNeu(INe5)**2))+
     &  CFF11S1L(INe5,INe3,j)*(CFF11S1L(INe3,INe3,i)*MNeu(INe3)**2*
     &  (FD111TChiST(2,INe3,ISt3)-FD111TChiST(2,INe5,ISt3)+
     &  FD211ChiTST(2,INe3,ISt3)*(-MNeu(INe3)**2+MNeu(INe5)**2))+
     &  CFF11S1R(INe3,INe3,i)*(FD111ChiTST(5,INe3,ISt3)-
     &  FD111ChiTST(5,INe5,ISt3)+FD211ChiTST(5,INe3,ISt3)*(-MNeu(INe3)*
     &  *2+MNeu(INe5)**2))))+M1*CF11FSRC(INe5,ISt3)*
     &  (CFF11S1R(INe3,INe3,i)*(CFF11S1R(INe5,INe3,j)*MNeu(INe3)+
     &  CFF11S1L(INe5,INe3,j)*MNeu(INe5))*(FD111ChiTST(4,INe3,ISt3)-
     &  FD111ChiTST(4,INe5,ISt3)+FD211ChiTST(4,INe3,ISt3)*(-MNeu(INe3)*
     &  *2+MNeu(INe5)**2))+CFF11S1L(INe3,INe3,i)*(CFF11S1R(INe5,INe3,j)
     &  *MNeu(INe3)*(FD111ChiTST(4,INe3,ISt3)-FD111ChiTST(4,INe5,ISt3)+
     &  FD211ChiTST(4,INe3,ISt3)*(-MNeu(INe3)**2+MNeu(INe5)**2))+
     &  CFF11S1L(INe5,INe3,j)*MNeu(INe5)*(FD111TChiST(1,INe3,ISt3)-
     &  FD111TChiST(1,INe5,ISt3)+FD211ChiTST(1,INe3,ISt3)*(-MNeu(INe3)*
     &  *2+MNeu(INe5)**2))*MNeu2(INe3))))+CF11FSR(INe5,ISt3)*
     &  (CF11FSRC(INe3,ISt3)*((CFF11S1L(INe3,INe3,i)+
     &  CFF11S1R(INe3,INe3,i))*CFF11S1R(INe5,INe3,j)*MNeu(INe3)*
     &  MNeu(INe5)*(FD111TChiST(2,INe3,ISt3)-FD111TChiST(2,INe5,ISt3)+
     &  FD211ChiTST(2,INe3,ISt3)*(-MNeu(INe3)**2+MNeu(INe5)**2))+
     &  CFF11S1L(INe5,INe3,j)*(CFF11S1L(INe3,INe3,i)*MNeu(INe3)**2*
     &  (FD111TChiST(2,INe3,ISt3)-FD111TChiST(2,INe5,ISt3)+
     &  FD211ChiTST(2,INe3,ISt3)*(-MNeu(INe3)**2+MNeu(INe5)**2))+
     &  CFF11S1R(INe3,INe3,i)*(FD111ChiTST(5,INe3,ISt3)-
     &  FD111ChiTST(5,INe5,ISt3)+FD211ChiTST(5,INe3,ISt3)*(-MNeu(INe3)*
     &  *2+MNeu(INe5)**2))))+M1*CF11FSLC(INe3,ISt3)*
     &  (CFF11S1L(INe3,INe3,i)*(CFF11S1L(INe5,INe3,j)*MNeu(INe3)+
     &  CFF11S1R(INe5,INe3,j)*MNeu(INe5))*(FD111ChiTST(4,INe3,ISt3)-
     &  FD111ChiTST(4,INe5,ISt3)+FD211ChiTST(4,INe3,ISt3)*(-MNeu(INe3)*
     &  *2+MNeu(INe5)**2))+CFF11S1R(INe3,INe3,i)*(CFF11S1L(INe5,INe3,j)
     &  *MNeu(INe3)*(FD111ChiTST(4,INe3,ISt3)-FD111ChiTST(4,INe5,ISt3)+
     &  FD211ChiTST(4,INe3,ISt3)*(-MNeu(INe3)**2+MNeu(INe5)**2))+
     &  CFF11S1R(INe5,INe3,j)*MNeu(INe5)*(FD111TChiST(1,INe3,ISt3)-
     &  FD111TChiST(1,INe5,ISt3)+FD211ChiTST(1,INe3,ISt3)*(-MNeu(INe3)**2+MNeu(INe5)**2))
     &  *MNeu2(INe3))))))/(8.*(MNeu(INe3)**2-MNeu(INe5)**2)**2)+self(i,j)
             endif
             if( Abs(-MNeu(INe3) + MNeu(INe4))*Abs(-MNeu(INe4) + MNeu(INe5)) .gt. 1D-15) then 
       self(i,j)=(3*(CF11FSL(INe4,ISt3)*CF11FSLC(INe3,ISt3)*
     &  CFF11S1L(INe3,INe3,j)*CFF11S1R(INe3,INe4,i)*
     &  FD111ChiTST(5,INe3,ISt3)+CF11FSR(INe3,ISt3)*CF11FSRC(INe4,ISt3)
     &  *CFF11S1L(INe3,INe3,j)*CFF11S1R(INe3,INe4,i)*
     &  FD111ChiTST(5,INe3,ISt3)-CF11FSL(INe4,ISt3)*CF11FSLC(INe3,ISt3)
     &  *CFF11S1L(INe3,INe3,j)*CFF11S1R(INe3,INe4,i)*
     &  FD111ChiTST(5,INe4,ISt3)-CF11FSR(INe3,ISt3)*CF11FSRC(INe4,ISt3)
     &  *CFF11S1L(INe3,INe3,j)*CFF11S1R(INe3,INe4,i)*
     &  FD111ChiTST(5,INe4,ISt3)+M1*CF11FSLC(INe4,ISt3)*
     &  CF11FSR(INe3,ISt3)*CFF11S1L(INe3,INe3,j)*CFF11S1L(INe3,INe4,i)*
     &  FD111ChiTST(4,INe3,ISt3)*MNeu(INe3)+M1*CF11FSLC(INe4,ISt3)*
     &  CF11FSR(INe3,ISt3)*CFF11S1L(INe3,INe4,i)*CFF11S1R(INe3,INe3,j)*
     &  FD111ChiTST(4,INe3,ISt3)*MNeu(INe3)+M1*CF11FSL(INe4,ISt3)*
     &  CF11FSRC(INe3,ISt3)*CFF11S1L(INe3,INe3,j)*CFF11S1R(INe3,INe4,i)
     &  *FD111ChiTST(4,INe3,ISt3)*MNeu(INe3)+M1*CF11FSL(INe4,ISt3)*
     &  CF11FSRC(INe3,ISt3)*CFF11S1R(INe3,INe3,j)*CFF11S1R(INe3,INe4,i)
     &  *FD111ChiTST(4,INe3,ISt3)*MNeu(INe3)-M1*CF11FSLC(INe4,ISt3)*
     &  CF11FSR(INe3,ISt3)*CFF11S1L(INe3,INe3,j)*CFF11S1L(INe3,INe4,i)*
     &  FD111ChiTST(4,INe4,ISt3)*MNeu(INe3)-M1*CF11FSLC(INe4,ISt3)*
     &  CF11FSR(INe3,ISt3)*CFF11S1L(INe3,INe4,i)*CFF11S1R(INe3,INe3,j)*
     &  FD111ChiTST(4,INe4,ISt3)*MNeu(INe3)-M1*CF11FSL(INe4,ISt3)*
     &  CF11FSRC(INe3,ISt3)*CFF11S1L(INe3,INe3,j)*CFF11S1R(INe3,INe4,i)
     &  *FD111ChiTST(4,INe4,ISt3)*MNeu(INe3)-M1*CF11FSL(INe4,ISt3)*
     &  CF11FSRC(INe3,ISt3)*CFF11S1R(INe3,INe3,j)*CFF11S1R(INe3,INe4,i)
     &  *FD111ChiTST(4,INe4,ISt3)*MNeu(INe3)+CF11FSL(INe4,ISt3)*
     &  CF11FSLC(INe3,ISt3)*CFF11S1R(INe3,INe3,j)*CFF11S1R(INe3,INe4,i)
     &  *FD111TChiST(2,INe3,ISt3)*MNeu(INe3)**2+CF11FSR(INe3,ISt3)*
     &  CF11FSRC(INe4,ISt3)*CFF11S1R(INe3,INe3,j)*CFF11S1R(INe3,INe4,i)
     &  *FD111TChiST(2,INe3,ISt3)*MNeu(INe3)**2-CF11FSL(INe4,ISt3)*
     &  CF11FSLC(INe3,ISt3)*CFF11S1R(INe3,INe3,j)*CFF11S1R(INe3,INe4,i)
     &  *FD111TChiST(2,INe4,ISt3)*MNeu(INe3)**2-CF11FSR(INe3,ISt3)*
     &  CF11FSRC(INe4,ISt3)*CFF11S1R(INe3,INe3,j)*CFF11S1R(INe3,INe4,i)
     &  *FD111TChiST(2,INe4,ISt3)*MNeu(INe3)**2-CF11FSL(INe4,ISt3)*
     &  CF11FSLC(INe3,ISt3)*CFF11S1L(INe3,INe3,j)*CFF11S1R(INe3,INe4,i)
     &  *FD211ChiTST(5,INe3,ISt3)*MNeu(INe3)**2-CF11FSR(INe3,ISt3)*
     &  CF11FSRC(INe4,ISt3)*CFF11S1L(INe3,INe3,j)*CFF11S1R(INe3,INe4,i)
     &  *FD211ChiTST(5,INe3,ISt3)*MNeu(INe3)**2-M1*CF11FSLC(INe4,ISt3)*
     &  CF11FSR(INe3,ISt3)*CFF11S1L(INe3,INe3,j)*CFF11S1L(INe3,INe4,i)*
     &  FD211ChiTST(4,INe3,ISt3)*MNeu(INe3)**3-M1*CF11FSLC(INe4,ISt3)*
     &  CF11FSR(INe3,ISt3)*CFF11S1L(INe3,INe4,i)*CFF11S1R(INe3,INe3,j)*
     &  FD211ChiTST(4,INe3,ISt3)*MNeu(INe3)**3-M1*CF11FSL(INe4,ISt3)*
     &  CF11FSRC(INe3,ISt3)*CFF11S1L(INe3,INe3,j)*CFF11S1R(INe3,INe4,i)
     &  *FD211ChiTST(4,INe3,ISt3)*MNeu(INe3)**3-M1*CF11FSL(INe4,ISt3)*
     &  CF11FSRC(INe3,ISt3)*CFF11S1R(INe3,INe3,j)*CFF11S1R(INe3,INe4,i)
     &  *FD211ChiTST(4,INe3,ISt3)*MNeu(INe3)**3-CF11FSL(INe4,ISt3)*
     &  CF11FSLC(INe3,ISt3)*CFF11S1R(INe3,INe3,j)*CFF11S1R(INe3,INe4,i)
     &  *FD211ChiTST(2,INe3,ISt3)*MNeu(INe3)**4-CF11FSR(INe3,ISt3)*
     &  CF11FSRC(INe4,ISt3)*CFF11S1R(INe3,INe3,j)*CFF11S1R(INe3,INe4,i)
     &  *FD211ChiTST(2,INe3,ISt3)*MNeu(INe3)**4+M1*CF11FSL(INe4,ISt3)*
     &  CF11FSRC(INe3,ISt3)*CFF11S1L(INe3,INe4,i)*CFF11S1R(INe3,INe3,j)
     &  *FD111ChiTST(4,INe3,ISt3)*MNeu(INe4)+M1*CF11FSLC(INe4,ISt3)*
     &  CF11FSR(INe3,ISt3)*CFF11S1L(INe3,INe3,j)*CFF11S1R(INe3,INe4,i)*
     &  FD111ChiTST(4,INe3,ISt3)*MNeu(INe4)-M1*CF11FSL(INe4,ISt3)*
     &  CF11FSRC(INe3,ISt3)*CFF11S1L(INe3,INe4,i)*CFF11S1R(INe3,INe3,j)
     &  *FD111ChiTST(4,INe4,ISt3)*MNeu(INe4)-M1*CF11FSLC(INe4,ISt3)*
     &  CF11FSR(INe3,ISt3)*CFF11S1L(INe3,INe3,j)*CFF11S1R(INe3,INe4,i)*
     &  FD111ChiTST(4,INe4,ISt3)*MNeu(INe4)+CF11FSL(INe4,ISt3)*
     &  CF11FSLC(INe3,ISt3)*CFF11S1L(INe3,INe3,j)*CFF11S1L(INe3,INe4,i)
     &  *FD111TChiST(2,INe3,ISt3)*MNeu(INe3)*MNeu(INe4)+
     &  CF11FSR(INe3,ISt3)*CF11FSRC(INe4,ISt3)*CFF11S1L(INe3,INe3,j)*
     &  CFF11S1L(INe3,INe4,i)*FD111TChiST(2,INe3,ISt3)*MNeu(INe3)*
     &  MNeu(INe4)+CF11FSL(INe4,ISt3)*CF11FSLC(INe3,ISt3)*
     &  CFF11S1L(INe3,INe4,i)*CFF11S1R(INe3,INe3,j)*
     &  FD111TChiST(2,INe3,ISt3)*MNeu(INe3)*MNeu(INe4)+
     &  CF11FSR(INe3,ISt3)*CF11FSRC(INe4,ISt3)*CFF11S1L(INe3,INe4,i)*
     &  CFF11S1R(INe3,INe3,j)*FD111TChiST(2,INe3,ISt3)*MNeu(INe3)*
     &  MNeu(INe4)-CF11FSL(INe4,ISt3)*CF11FSLC(INe3,ISt3)*
     &  CFF11S1L(INe3,INe3,j)*CFF11S1L(INe3,INe4,i)*
     &  FD111TChiST(2,INe4,ISt3)*MNeu(INe3)*MNeu(INe4)-
     &  CF11FSR(INe3,ISt3)*CF11FSRC(INe4,ISt3)*CFF11S1L(INe3,INe3,j)*
     &  CFF11S1L(INe3,INe4,i)*FD111TChiST(2,INe4,ISt3)*MNeu(INe3)*
     &  MNeu(INe4)-CF11FSL(INe4,ISt3)*CF11FSLC(INe3,ISt3)*
     &  CFF11S1L(INe3,INe4,i)*CFF11S1R(INe3,INe3,j)*
     &  FD111TChiST(2,INe4,ISt3)*MNeu(INe3)*MNeu(INe4)-
     &  CF11FSR(INe3,ISt3)*CF11FSRC(INe4,ISt3)*CFF11S1L(INe3,INe4,i)*
     &  CFF11S1R(INe3,INe3,j)*FD111TChiST(2,INe4,ISt3)*MNeu(INe3)*
     &  MNeu(INe4)-M1*CF11FSL(INe4,ISt3)*CF11FSRC(INe3,ISt3)*
     &  CFF11S1L(INe3,INe4,i)*CFF11S1R(INe3,INe3,j)*
     &  FD211ChiTST(4,INe3,ISt3)*MNeu(INe3)**2*MNeu(INe4)-M1*
     &  CF11FSLC(INe4,ISt3)*CF11FSR(INe3,ISt3)*CFF11S1L(INe3,INe3,j)*
     &  CFF11S1R(INe3,INe4,i)*FD211ChiTST(4,INe3,ISt3)*MNeu(INe3)**2*
     &  MNeu(INe4)-CF11FSL(INe4,ISt3)*CF11FSLC(INe3,ISt3)*
     &  CFF11S1L(INe3,INe3,j)*CFF11S1L(INe3,INe4,i)*
     &  FD211ChiTST(2,INe3,ISt3)*MNeu(INe3)**3*MNeu(INe4)-
     &  CF11FSR(INe3,ISt3)*CF11FSRC(INe4,ISt3)*CFF11S1L(INe3,INe3,j)*
     &  CFF11S1L(INe3,INe4,i)*FD211ChiTST(2,INe3,ISt3)*MNeu(INe3)**3*
     &  MNeu(INe4)-CF11FSL(INe4,ISt3)*CF11FSLC(INe3,ISt3)*
     &  CFF11S1L(INe3,INe4,i)*CFF11S1R(INe3,INe3,j)*
     &  FD211ChiTST(2,INe3,ISt3)*MNeu(INe3)**3*MNeu(INe4)-
     &  CF11FSR(INe3,ISt3)*CF11FSRC(INe4,ISt3)*CFF11S1L(INe3,INe4,i)*
     &  CFF11S1R(INe3,INe3,j)*FD211ChiTST(2,INe3,ISt3)*MNeu(INe3)**3*
     &  MNeu(INe4)+CF11FSL(INe4,ISt3)*CF11FSLC(INe3,ISt3)*
     &  CFF11S1L(INe3,INe3,j)*CFF11S1R(INe3,INe4,i)*
     &  FD211ChiTST(5,INe3,ISt3)*MNeu(INe4)**2+CF11FSR(INe3,ISt3)*
     &  CF11FSRC(INe4,ISt3)*CFF11S1L(INe3,INe3,j)*CFF11S1R(INe3,INe4,i)
     &  *FD211ChiTST(5,INe3,ISt3)*MNeu(INe4)**2+M1*CF11FSLC(INe4,ISt3)*
     &  CF11FSR(INe3,ISt3)*CFF11S1L(INe3,INe3,j)*CFF11S1L(INe3,INe4,i)*
     &  FD211ChiTST(4,INe3,ISt3)*MNeu(INe3)*MNeu(INe4)**2+M1*
     &  CF11FSLC(INe4,ISt3)*CF11FSR(INe3,ISt3)*CFF11S1L(INe3,INe4,i)*
     &  CFF11S1R(INe3,INe3,j)*FD211ChiTST(4,INe3,ISt3)*MNeu(INe3)*
     &  MNeu(INe4)**2+M1*CF11FSL(INe4,ISt3)*CF11FSRC(INe3,ISt3)*
     &  CFF11S1L(INe3,INe3,j)*CFF11S1R(INe3,INe4,i)*
     &  FD211ChiTST(4,INe3,ISt3)*MNeu(INe3)*MNeu(INe4)**2+M1*
     &  CF11FSL(INe4,ISt3)*CF11FSRC(INe3,ISt3)*CFF11S1R(INe3,INe3,j)*
     &  CFF11S1R(INe3,INe4,i)*FD211ChiTST(4,INe3,ISt3)*MNeu(INe3)*
     &  MNeu(INe4)**2+CF11FSL(INe4,ISt3)*CF11FSLC(INe3,ISt3)*
     &  CFF11S1R(INe3,INe3,j)*CFF11S1R(INe3,INe4,i)*
     &  FD211ChiTST(2,INe3,ISt3)*MNeu(INe3)**2*MNeu(INe4)**2+
     &  CF11FSR(INe3,ISt3)*CF11FSRC(INe4,ISt3)*CFF11S1R(INe3,INe3,j)*
     &  CFF11S1R(INe3,INe4,i)*FD211ChiTST(2,INe3,ISt3)*MNeu(INe3)**2*
     &  MNeu(INe4)**2+M1*CF11FSL(INe4,ISt3)*CF11FSRC(INe3,ISt3)*
     &  CFF11S1L(INe3,INe4,i)*CFF11S1R(INe3,INe3,j)*
     &  FD211ChiTST(4,INe3,ISt3)*MNeu(INe4)**3+M1*CF11FSLC(INe4,ISt3)*
     &  CF11FSR(INe3,ISt3)*CFF11S1L(INe3,INe3,j)*CFF11S1R(INe3,INe4,i)*
     &  FD211ChiTST(4,INe3,ISt3)*MNeu(INe4)**3+CF11FSL(INe4,ISt3)*
     &  CF11FSLC(INe3,ISt3)*CFF11S1L(INe3,INe3,j)*CFF11S1L(INe3,INe4,i)
     &  *FD211ChiTST(2,INe3,ISt3)*MNeu(INe3)*MNeu(INe4)**3+
     &  CF11FSR(INe3,ISt3)*CF11FSRC(INe4,ISt3)*CFF11S1L(INe3,INe3,j)*
     &  CFF11S1L(INe3,INe4,i)*FD211ChiTST(2,INe3,ISt3)*MNeu(INe3)*
     &  MNeu(INe4)**3+CF11FSL(INe4,ISt3)*CF11FSLC(INe3,ISt3)*
     &  CFF11S1L(INe3,INe4,i)*CFF11S1R(INe3,INe3,j)*
     &  FD211ChiTST(2,INe3,ISt3)*MNeu(INe3)*MNeu(INe4)**3+
     &  CF11FSR(INe3,ISt3)*CF11FSRC(INe4,ISt3)*CFF11S1L(INe3,INe4,i)*
     &  CFF11S1R(INe3,INe3,j)*FD211ChiTST(2,INe3,ISt3)*MNeu(INe3)*
     &  MNeu(INe4)**3+M1*CF11FSL(INe4,ISt3)*CF11FSRC(INe3,ISt3)*
     &  CFF11S1L(INe3,INe3,j)*CFF11S1L(INe3,INe4,i)*
     &  FD111TChiST(1,INe3,ISt3)*MNeu(INe4)*MNeu2(INe3)+M1*
     &  CF11FSLC(INe4,ISt3)*CF11FSR(INe3,ISt3)*CFF11S1R(INe3,INe3,j)*
     &  CFF11S1R(INe3,INe4,i)*FD111TChiST(1,INe3,ISt3)*MNeu(INe4)*
     &  MNeu2(INe3)-M1*CF11FSL(INe4,ISt3)*CF11FSRC(INe3,ISt3)*
     &  CFF11S1L(INe3,INe3,j)*CFF11S1L(INe3,INe4,i)*
     &  FD111TChiST(1,INe4,ISt3)*MNeu(INe4)*MNeu2(INe3)-M1*
     &  CF11FSLC(INe4,ISt3)*CF11FSR(INe3,ISt3)*CFF11S1R(INe3,INe3,j)*
     &  CFF11S1R(INe3,INe4,i)*FD111TChiST(1,INe4,ISt3)*MNeu(INe4)*
     &  MNeu2(INe3)-M1*CF11FSL(INe4,ISt3)*CF11FSRC(INe3,ISt3)*
     &  CFF11S1L(INe3,INe3,j)*CFF11S1L(INe3,INe4,i)*
     &  FD211ChiTST(1,INe3,ISt3)*MNeu(INe3)**2*MNeu(INe4)*MNeu2(INe3)-
     &  M1*CF11FSLC(INe4,ISt3)*CF11FSR(INe3,ISt3)*CFF11S1R(INe3,INe3,j)
     &  *CFF11S1R(INe3,INe4,i)*FD211ChiTST(1,INe3,ISt3)*MNeu(INe3)**2*
     &  MNeu(INe4)*MNeu2(INe3)+M1*CF11FSL(INe4,ISt3)*
     &  CF11FSRC(INe3,ISt3)*CFF11S1L(INe3,INe3,j)*CFF11S1L(INe3,INe4,i)
     &  *FD211ChiTST(1,INe3,ISt3)*MNeu(INe4)**3*MNeu2(INe3)+M1*
     &  CF11FSLC(INe4,ISt3)*CF11FSR(INe3,ISt3)*CFF11S1R(INe3,INe3,j)*
     &  CFF11S1R(INe3,INe4,i)*FD211ChiTST(1,INe3,ISt3)*MNeu(INe4)**3*
     &  MNeu2(INe3)+CF11FSL(INe3,ISt3)*(CF11FSLC(INe4,ISt3)*
     &  ((CFF11S1L(INe3,INe3,j)+CFF11S1R(INe3,INe3,j))*
     &  CFF11S1R(INe3,INe4,i)*MNeu(INe3)*MNeu(INe4)*
     &  (FD111TChiST(2,INe3,ISt3)-FD111TChiST(2,INe4,ISt3)+
     &  FD211ChiTST(2,INe3,ISt3)*(-MNeu(INe3)**2+MNeu(INe4)**2))+
     &  CFF11S1L(INe3,INe4,i)*(CFF11S1L(INe3,INe3,j)*MNeu(INe3)**2*
     &  (FD111TChiST(2,INe3,ISt3)-FD111TChiST(2,INe4,ISt3)+
     &  FD211ChiTST(2,INe3,ISt3)*(-MNeu(INe3)**2+MNeu(INe4)**2))+
     &  CFF11S1R(INe3,INe3,j)*(FD111ChiTST(5,INe3,ISt3)-
     &  FD111ChiTST(5,INe4,ISt3)+FD211ChiTST(5,INe3,ISt3)*(-MNeu(INe3)*
     &  *2+MNeu(INe4)**2))))+M1*CF11FSRC(INe4,ISt3)*
     &  (CFF11S1R(INe3,INe3,j)*(CFF11S1R(INe3,INe4,i)*MNeu(INe3)+
     &  CFF11S1L(INe3,INe4,i)*MNeu(INe4))*(FD111ChiTST(4,INe3,ISt3)-
     &  FD111ChiTST(4,INe4,ISt3)+FD211ChiTST(4,INe3,ISt3)*(-MNeu(INe3)*
     &  *2+MNeu(INe4)**2))+CFF11S1L(INe3,INe3,j)*(CFF11S1R(INe3,INe4,i)
     &  *MNeu(INe3)*(FD111ChiTST(4,INe3,ISt3)-FD111ChiTST(4,INe4,ISt3)+
     &  FD211ChiTST(4,INe3,ISt3)*(-MNeu(INe3)**2+MNeu(INe4)**2))+
     &  CFF11S1L(INe3,INe4,i)*MNeu(INe4)*(FD111TChiST(1,INe3,ISt3)-
     &  FD111TChiST(1,INe4,ISt3)+FD211ChiTST(1,INe3,ISt3)*(-MNeu(INe3)*
     &  *2+MNeu(INe4)**2))*MNeu2(INe3))))+CF11FSR(INe4,ISt3)*
     &  (CF11FSRC(INe3,ISt3)*((CFF11S1L(INe3,INe3,j)+
     &  CFF11S1R(INe3,INe3,j))*CFF11S1R(INe3,INe4,i)*MNeu(INe3)*
     &  MNeu(INe4)*(FD111TChiST(2,INe3,ISt3)-FD111TChiST(2,INe4,ISt3)+
     &  FD211ChiTST(2,INe3,ISt3)*(-MNeu(INe3)**2+MNeu(INe4)**2))+
     &  CFF11S1L(INe3,INe4,i)*(CFF11S1L(INe3,INe3,j)*MNeu(INe3)**2*
     &  (FD111TChiST(2,INe3,ISt3)-FD111TChiST(2,INe4,ISt3)+
     &  FD211ChiTST(2,INe3,ISt3)*(-MNeu(INe3)**2+MNeu(INe4)**2))+
     &  CFF11S1R(INe3,INe3,j)*(FD111ChiTST(5,INe3,ISt3)-
     &  FD111ChiTST(5,INe4,ISt3)+FD211ChiTST(5,INe3,ISt3)*(-MNeu(INe3)*
     &  *2+MNeu(INe4)**2))))+M1*CF11FSLC(INe3,ISt3)*
     &  (CFF11S1L(INe3,INe3,j)*(CFF11S1L(INe3,INe4,i)*MNeu(INe3)+
     &  CFF11S1R(INe3,INe4,i)*MNeu(INe4))*(FD111ChiTST(4,INe3,ISt3)-
     &  FD111ChiTST(4,INe4,ISt3)+FD211ChiTST(4,INe3,ISt3)*(-MNeu(INe3)*
     &  *2+MNeu(INe4)**2))+CFF11S1R(INe3,INe3,j)*(CFF11S1L(INe3,INe4,i)
     &  *MNeu(INe3)*(FD111ChiTST(4,INe3,ISt3)-FD111ChiTST(4,INe4,ISt3)+
     &  FD211ChiTST(4,INe3,ISt3)*(-MNeu(INe3)**2+MNeu(INe4)**2))+
     &  CFF11S1R(INe3,INe4,i)*MNeu(INe4)*(FD111TChiST(1,INe3,ISt3)-
     &  FD111TChiST(1,INe4,ISt3)+FD211ChiTST(1,INe3,ISt3)*(-MNeu(INe3)**2
     &  +MNeu(INe4)**2))*MNeu2(INe3))))))/(8.*(MNeu(INe3)**2-MNeu(INe4)**2)**2)+self(i,j)
             endif
             if( Abs(MNeu(INe3) - MNeu(INe4))*Abs(-MNeu(INe3) + MNeu(INe5)) .gt. 1D-15) then 
       self(i,j)=(-3*(CF11FSL(INe4,ISt3)*(CF11FSLC(INe4,ISt3)*
     &  (CFF11S1L(INe4,INe3,j)*(CFF11S1R(INe3,INe4,i)*
     &  (FD111ChiTST(5,INe3,ISt3)-FD111ChiTST(5,INe4,ISt3)-
     &  FD211ChiTST(5,INe4,ISt3)*MNeu(INe3)**2+FD111TChiST(2,INe3,ISt3)
     &  *MNeu(INe4)**2-FD111TChiST(2,INe4,ISt3)*MNeu(INe4)**2+
     &  FD211ChiTST(5,INe4,ISt3)*MNeu(INe4)**2-FD211ChiTST(2,INe4,ISt3)
     &  *MNeu(INe3)**2*MNeu(INe4)**2+FD211ChiTST(2,INe4,ISt3)*
     &  MNeu(INe4)**4)+2*CFF11S1L(INe3,INe4,i)*MNeu(INe3)*MNeu(INe4)*
     &  (FD111TChiST(2,INe3,ISt3)-FD111TChiST(2,INe4,ISt3)+
     &  FD211ChiTST(2,INe4,ISt3)*(-MNeu(INe3)**2+MNeu(INe4)**2)))+
     &  CFF11S1R(INe4,INe3,j)*(CFF11S1L(INe3,INe4,i)*
     &  (FD111ChiTST(5,INe3,ISt3)-FD111ChiTST(5,INe4,ISt3)-
     &  FD211ChiTST(5,INe4,ISt3)*MNeu(INe3)**2+FD111TChiST(2,INe3,ISt3)
     &  *MNeu(INe4)**2-FD111TChiST(2,INe4,ISt3)*MNeu(INe4)**2+
     &  FD211ChiTST(5,INe4,ISt3)*MNeu(INe4)**2-FD211ChiTST(2,INe4,ISt3)
     &  *MNeu(INe3)**2*MNeu(INe4)**2+FD211ChiTST(2,INe4,ISt3)*
     &  MNeu(INe4)**4)+2*CFF11S1R(INe3,INe4,i)*MNeu(INe3)*MNeu(INe4)*
     &  (FD111TChiST(2,INe3,ISt3)-FD111TChiST(2,INe4,ISt3)+
     &  FD211ChiTST(2,INe4,ISt3)*(-MNeu(INe3)**2+MNeu(INe4)**2))))+2*
     &  M1*CF11FSRC(INe4,ISt3)*(CFF11S1R(INe3,INe4,i)*
     &  (CFF11S1R(INe4,INe3,j)*MNeu(INe3)+CFF11S1L(INe4,INe3,j)*
     &  MNeu(INe4))*(FD111ChiTST(4,INe3,ISt3)-FD111ChiTST(4,INe4,ISt3)+
     &  FD211ChiTST(4,INe4,ISt3)*(-MNeu(INe3)**2+MNeu(INe4)**2))+
     &  CFF11S1L(INe3,INe4,i)*(CFF11S1R(INe4,INe3,j)*MNeu(INe4)*
     &  (FD111ChiTST(4,INe3,ISt3)-FD111ChiTST(4,INe4,ISt3)+
     &  FD211ChiTST(4,INe4,ISt3)*(-MNeu(INe3)**2+MNeu(INe4)**2))+
     &  CFF11S1L(INe4,INe3,j)*MNeu(INe3)*(FD111TChiST(1,INe3,ISt3)-
     &  FD111TChiST(1,INe4,ISt3)+FD211ChiTST(1,INe4,ISt3)*(-MNeu(INe3)*
     &  *2+MNeu(INe4)**2))*MNeu2(INe4))))+CF11FSR(INe4,ISt3)*
     &  (CF11FSRC(INe4,ISt3)*(CFF11S1L(INe4,INe3,j)*
     &  (CFF11S1R(INe3,INe4,i)*(FD111ChiTST(5,INe3,ISt3)-
     &  FD111ChiTST(5,INe4,ISt3)-FD211ChiTST(5,INe4,ISt3)*MNeu(INe3)**
     &  2+FD111TChiST(2,INe3,ISt3)*MNeu(INe4)**2-
     &  FD111TChiST(2,INe4,ISt3)*MNeu(INe4)**2+FD211ChiTST(5,INe4,ISt3)
     &  *MNeu(INe4)**2-FD211ChiTST(2,INe4,ISt3)*MNeu(INe3)**2*
     &  MNeu(INe4)**2+FD211ChiTST(2,INe4,ISt3)*MNeu(INe4)**4)+2*
     &  CFF11S1L(INe3,INe4,i)*MNeu(INe3)*MNeu(INe4)*
     &  (FD111TChiST(2,INe3,ISt3)-FD111TChiST(2,INe4,ISt3)+
     &  FD211ChiTST(2,INe4,ISt3)*(-MNeu(INe3)**2+MNeu(INe4)**2)))+
     &  CFF11S1R(INe4,INe3,j)*(CFF11S1L(INe3,INe4,i)*
     &  (FD111ChiTST(5,INe3,ISt3)-FD111ChiTST(5,INe4,ISt3)-
     &  FD211ChiTST(5,INe4,ISt3)*MNeu(INe3)**2+FD111TChiST(2,INe3,ISt3)
     &  *MNeu(INe4)**2-FD111TChiST(2,INe4,ISt3)*MNeu(INe4)**2+
     &  FD211ChiTST(5,INe4,ISt3)*MNeu(INe4)**2-FD211ChiTST(2,INe4,ISt3)
     &  *MNeu(INe3)**2*MNeu(INe4)**2+FD211ChiTST(2,INe4,ISt3)*
     &  MNeu(INe4)**4)+2*CFF11S1R(INe3,INe4,i)*MNeu(INe3)*MNeu(INe4)*
     &  (FD111TChiST(2,INe3,ISt3)-FD111TChiST(2,INe4,ISt3)+
     &  FD211ChiTST(2,INe4,ISt3)*(-MNeu(INe3)**2+MNeu(INe4)**2))))+2*
     &  M1*CF11FSLC(INe4,ISt3)*(CFF11S1L(INe3,INe4,i)*
     &  (CFF11S1L(INe4,INe3,j)*MNeu(INe3)+CFF11S1R(INe4,INe3,j)*
     &  MNeu(INe4))*(FD111ChiTST(4,INe3,ISt3)-FD111ChiTST(4,INe4,ISt3)+
     &  FD211ChiTST(4,INe4,ISt3)*(-MNeu(INe3)**2+MNeu(INe4)**2))+
     &  CFF11S1R(INe3,INe4,i)*(CFF11S1L(INe4,INe3,j)*MNeu(INe4)*
     &  (FD111ChiTST(4,INe3,ISt3)-FD111ChiTST(4,INe4,ISt3)+
     &  FD211ChiTST(4,INe4,ISt3)*(-MNeu(INe3)**2+MNeu(INe4)**2))+
     &  CFF11S1R(INe4,INe3,j)*MNeu(INe3)*(FD111TChiST(1,INe3,ISt3)-
     &  FD111TChiST(1,INe4,ISt3)+FD211ChiTST(1,INe4,ISt3)*(-MNeu(INe3)*
     &  *2+MNeu(INe4)**2))*MNeu2(INe4))))))/(8.*(MNeu(INe3)**2-MNeu(INe4)**2)**2)+self(i,j)
             endif
             if( Abs(-MNeu(INe3) + MNeu(INe5)) .lt. 1D-15 .AND. Abs(MNeu(INe3) - MNeu(INe4)) .lt. 1D-15) then 
       self(i,j)=(-3*(CF11FSL(INe3,ISt3)*(2*M1*CF11FSRC(INe3,ISt3)*
     &  MNeu(INe3)*((CFF11S1L(INe3,INe3,i)+CFF11S1R(INe3,INe3,i))*
     &  CFF11S1R(INe3,INe3,j)*FD311ChiTST(3,INe3,ISt3)+
     &  CFF11S1L(INe3,INe3,j)*(CFF11S1R(INe3,INe3,i)*
     &  FD311ChiTST(3,INe3,ISt3)+CFF11S1L(INe3,INe3,i)*
     &  FD311ChiTST(1,INe3,ISt3)*MNeu(INe3)**2))+CF11FSLC(INe3,ISt3)*
     &  (CFF11S1R(INe3,INe3,j)*(2*CFF11S1R(INe3,INe3,i)*
     &  FD311ChiTST(2,INe3,ISt3)*MNeu2(INe3)+CFF11S1L(INe3,INe3,i)*
     &  (FD311ChiTST(4,INe3,ISt3)+FD311ChiTST(2,INe3,ISt3)*MNeu2(INe3))
     &  )+CFF11S1L(INe3,INe3,j)*(2*CFF11S1L(INe3,INe3,i)*
     &  FD311ChiTST(2,INe3,ISt3)*MNeu2(INe3)+CFF11S1R(INe3,INe3,i)*
     &  (FD311ChiTST(4,INe3,ISt3)+FD311ChiTST(2,INe3,ISt3)*MNeu2(INe3))
     &  )))+CF11FSR(INe3,ISt3)*(2*M1*CF11FSLC(INe3,ISt3)*MNeu(INe3)*
     &  (CFF11S1L(INe3,INe3,i)*(CFF11S1L(INe3,INe3,j)+
     &  CFF11S1R(INe3,INe3,j))*FD311ChiTST(3,INe3,ISt3)+
     &  CFF11S1R(INe3,INe3,i)*(CFF11S1L(INe3,INe3,j)*
     &  FD311ChiTST(3,INe3,ISt3)+CFF11S1R(INe3,INe3,j)*
     &  FD311ChiTST(1,INe3,ISt3)*MNeu(INe3)**2))+CF11FSRC(INe3,ISt3)*
     &  (CFF11S1R(INe3,INe3,j)*(2*CFF11S1R(INe3,INe3,i)*
     &  FD311ChiTST(2,INe3,ISt3)*MNeu2(INe3)+CFF11S1L(INe3,INe3,i)*
     &  (FD311ChiTST(4,INe3,ISt3)+FD311ChiTST(2,INe3,ISt3)*MNeu2(INe3))
     &  )+CFF11S1L(INe3,INe3,j)*(2*CFF11S1L(INe3,INe3,i)*
     &  FD311ChiTST(2,INe3,ISt3)*MNeu2(INe3)+CFF11S1R(INe3,INe3,i)*
     &  (FD311ChiTST(4,INe3,ISt3)+FD311ChiTST(2,INe3,ISt3)*MNeu2(INe3))
     &  )))))/8.+self(i,j)
             endif
           endif
       enddo 
       enddo 
       enddo 
       enddo 


       do ISt3=1,2
       self(i,j)=(-3*CF12F4S(ISt3)*CF12F4SC(ISt3)*(CFF12S1R(i)*(2*
     &  MCha2*CFF12S1R(j)*FD311ChaBST(2,ISt3)+CFF12S1L(j)*(MCha2*
     &  FD311ChaBST(2,ISt3)+FD311ChaBST(4,ISt3)))+CFF12S1L(i)*(2*MCha2*
     &  CFF12S1L(j)*FD311ChaBST(2,ISt3)+CFF12S1R(j)*(MCha2*
     &  FD311ChaBST(2,ISt3)+FD311ChaBST(4,ISt3)))))/8.+self(i,j)
       enddo 
       self(i,j)=(-3*CF12F3S*CF12F3SC*(CFF12S1R(i)*(2*MCha2*CFF12S1R(j)
     &  *FD311ChaTSB(2)+CFF12S1L(j)*(MCha2*FD311ChaTSB(2)+
     &  FD311ChaTSB(4)))+CFF12S1L(i)*(2*MCha2*CFF12S1L(j)*
     &  FD311ChaTSB(2)+CFF12S1R(j)*(MCha2*FD311ChaTSB(2)+FD311ChaTSB(4)
     &  ))))/8.+self(i,j)

c
c topo8
c
       do INH3= ihiggs,6
       do INH4= ihiggs,6
       do INH5= ihiggs,6
          if( Abs(-Mah(INH3) + Mah(INH4))*Abs(-Mah(INH3) + Mah(INH5))*Abs(-Mah(INH4) + Mah(INH5)) .gt. epsi) then 
         
       self(i,j)=(CS1S1S1(i,INH3,INH4)*CS1S1S1(j,INH3,INH5)*(3*(-
     &  (FD111THT(2,INH4)*hy(INH5)*hyc(INH4)*Mah(INH3)**2)+
     &  FD111THT(2,INH5)*hy(INH5)*hyc(INH4)*Mah(INH3)**2+
     &  FD111THT(4,INH4)*hy(INH5)*hyc(INH4)*Mah(INH3)**2-
     &  FD111THT(4,INH5)*hy(INH5)*hyc(INH4)*Mah(INH3)**2-
     &  FD111THT(2,INH4)*hy(INH4)*hyc(INH5)*Mah(INH3)**2+
     &  FD111THT(2,INH5)*hy(INH4)*hyc(INH5)*Mah(INH3)**2+
     &  FD111THT(4,INH4)*hy(INH4)*hyc(INH5)*Mah(INH3)**2-
     &  FD111THT(4,INH5)*hy(INH4)*hyc(INH5)*Mah(INH3)**2-M12*
     &  FD111THT(1,INH3)*hy(INH4)*hy(INH5)*Mah(INH4)**2+
     &  FD111THT(2,INH3)*hy(INH5)*hyc(INH4)*Mah(INH4)**2-
     &  FD111THT(2,INH5)*hy(INH5)*hyc(INH4)*Mah(INH4)**2-
     &  FD111THT(4,INH3)*hy(INH5)*hyc(INH4)*Mah(INH4)**2+
     &  FD111THT(4,INH5)*hy(INH5)*hyc(INH4)*Mah(INH4)**2+
     &  FD111THT(2,INH3)*hy(INH4)*hyc(INH5)*Mah(INH4)**2-
     &  FD111THT(2,INH5)*hy(INH4)*hyc(INH5)*Mah(INH4)**2-
     &  FD111THT(4,INH3)*hy(INH4)*hyc(INH5)*Mah(INH4)**2+
     &  FD111THT(4,INH5)*hy(INH4)*hyc(INH5)*Mah(INH4)**2-M12*
     &  FD111THT(1,INH3)*hyc(INH4)*hyc(INH5)*Mah(INH4)**2-M12*
     &  FD111THT(1,INH5)*(hy(INH4)*hy(INH5)+hyc(INH4)*hyc(INH5))*
     &  (Mah(INH3)**2-Mah(INH4)**2)+M12*FD111THT(1,INH3)*hy(INH4)*
     &  hy(INH5)*Mah(INH5)**2-FD111THT(2,INH3)*hy(INH5)*hyc(INH4)*
     &  Mah(INH5)**2+FD111THT(2,INH4)*hy(INH5)*hyc(INH4)*Mah(INH5)**2+
     &  FD111THT(4,INH3)*hy(INH5)*hyc(INH4)*Mah(INH5)**2-
     &  FD111THT(4,INH4)*hy(INH5)*hyc(INH4)*Mah(INH5)**2-
     &  FD111THT(2,INH3)*hy(INH4)*hyc(INH5)*Mah(INH5)**2+
     &  FD111THT(2,INH4)*hy(INH4)*hyc(INH5)*Mah(INH5)**2+
     &  FD111THT(4,INH3)*hy(INH4)*hyc(INH5)*Mah(INH5)**2-
     &  FD111THT(4,INH4)*hy(INH4)*hyc(INH5)*Mah(INH5)**2+M12*
     &  FD111THT(1,INH3)*hyc(INH4)*hyc(INH5)*Mah(INH5)**2+M12*
     &  FD111THT(1,INH4)*(hy(INH4)*hy(INH5)+hyc(INH4)*hyc(INH5))*
     &  (Mah(INH3)**2-Mah(INH5)**2))+CFF12S1L(INH4)*(CFF12S1R(INH5)*
     &  (FD111ChaHCha(4,INH4)*Mah(INH3)**2-FD111ChaHCha(4,INH5)*
     &  Mah(INH3)**2+FD111ChaHCha(2,INH3)*Mah(INH4)**2-
     &  FD111ChaHCha(4,INH3)*Mah(INH4)**2+FD111ChaHCha(4,INH5)*
     &  Mah(INH4)**2+FD111ChaHCha(2,INH5)*(Mah(INH3)**2-Mah(INH4)**2)-
     &  FD111ChaHCha(2,INH3)*Mah(INH5)**2+FD111ChaHCha(4,INH3)*
     &  Mah(INH5)**2-FD111ChaHCha(4,INH4)*Mah(INH5)**2+
     &  FD111ChaHCha(2,INH4)*(-Mah(INH3)**2+Mah(INH5)**2))+MCha2*
     &  CFF12S1L(INH5)*(FD111ChaHCha(1,INH5)*(-Mah(INH3)**2+Mah(INH4)**
     &  2)+FD111ChaHCha(1,INH4)*(Mah(INH3)**2-Mah(INH5)**2)+
     &  FD111ChaHCha(1,INH3)*(-Mah(INH4)**2+Mah(INH5)**2)))+
     &  CFF12S1R(INH4)*(CFF12S1L(INH5)*(FD111ChaHCha(4,INH4)*Mah(INH3)*
     &  *2-FD111ChaHCha(4,INH5)*Mah(INH3)**2+FD111ChaHCha(2,INH3)*
     &  Mah(INH4)**2-FD111ChaHCha(4,INH3)*Mah(INH4)**2+
     &  FD111ChaHCha(4,INH5)*Mah(INH4)**2+FD111ChaHCha(2,INH5)*
     &  (Mah(INH3)**2-Mah(INH4)**2)-FD111ChaHCha(2,INH3)*Mah(INH5)**2+
     &  FD111ChaHCha(4,INH3)*Mah(INH5)**2-FD111ChaHCha(4,INH4)*
     &  Mah(INH5)**2+FD111ChaHCha(2,INH4)*(-Mah(INH3)**2+Mah(INH5)**2))
     &  +MCha2*CFF12S1R(INH5)*(FD111ChaHCha(1,INH5)*(-Mah(INH3)**2+
     &  Mah(INH4)**2)+FD111ChaHCha(1,INH4)*(Mah(INH3)**2-Mah(INH5)**2)+
     &  FD111ChaHCha(1,INH3)*(-Mah(INH4)**2+Mah(INH5)**2)))))/(8.*
     &  (Mah(INH3)-Mah(INH4))*(Mah(INH3)+Mah(INH4))*(Mah(INH3)-
     &  Mah(INH5))*(Mah(INH4)-Mah(INH5))*(Mah(INH3)+Mah(INH5))*(Mah(INH4)+Mah(INH5)))+self(i,j)

           else
             if( Abs(-Mah(INH3) + Mah(INH5))*Abs(-Mah(INH4) + Mah(INH5)) .gt. epsi) then 
              if( Abs(Mah(INH3)) .gt. epsi) then 
       self(i,j)=(CS1S1S1(i,INH3,INH3)*CS1S1S1(j,INH3,INH5)*(3*(-
     &  (FD111THT(2,INH3)*hy(INH5)*hyc(INH3))+FD111THT(2,INH5)*hy(INH5)
     &  *hyc(INH3)+FD111THT(4,INH3)*hy(INH5)*hyc(INH3)-FD111THT(4,INH5)
     &  *hy(INH5)*hyc(INH3)-FD111THT(2,INH3)*hy(INH3)*hyc(INH5)+
     &  FD111THT(2,INH5)*hy(INH3)*hyc(INH5)+FD111THT(4,INH3)*hy(INH3)*
     &  hyc(INH5)-FD111THT(4,INH5)*hy(INH3)*hyc(INH5)+M12*
     &  FD111THT(1,INH3)*(hy(INH3)*hy(INH5)+hyc(INH3)*hyc(INH5))-M12*
     &  FD111THT(1,INH5)*(hy(INH3)*hy(INH5)+hyc(INH3)*hyc(INH5))-M12*
     &  FD211HTT(1,INH3)*hy(INH3)*hy(INH5)*Mah(INH3)**2+
     &  FD211HTT(2,INH3)*hy(INH5)*hyc(INH3)*Mah(INH3)**2-
     &  FD211HTT(3,INH3)*hy(INH5)*hyc(INH3)*Mah(INH3)**2+
     &  FD211HTT(2,INH3)*hy(INH3)*hyc(INH5)*Mah(INH3)**2-
     &  FD211HTT(3,INH3)*hy(INH3)*hyc(INH5)*Mah(INH3)**2-M12*
     &  FD211HTT(1,INH3)*hyc(INH3)*hyc(INH5)*Mah(INH3)**2+M12*
     &  FD211HTT(1,INH3)*hy(INH3)*hy(INH5)*Mah(INH5)**2-
     &  FD211HTT(2,INH3)*hy(INH5)*hyc(INH3)*Mah(INH5)**2+
     &  FD211HTT(3,INH3)*hy(INH5)*hyc(INH3)*Mah(INH5)**2-
     &  FD211HTT(2,INH3)*hy(INH3)*hyc(INH5)*Mah(INH5)**2+
     &  FD211HTT(3,INH3)*hy(INH3)*hyc(INH5)*Mah(INH5)**2+M12*
     &  FD211HTT(1,INH3)*hyc(INH3)*hyc(INH5)*Mah(INH5)**2)+
     &  CFF12S1L(INH3)*(CFF12S1R(INH5)*(-FD111ChaHCha(2,INH3)+
     &  FD111ChaHCha(2,INH5)+FD111ChaHCha(4,INH3)-FD111ChaHCha(4,INH5)+
     &  FD211HChaCha(2,INH3)*Mah(INH3)**2-FD211HChaCha(3,INH3)*
     &  Mah(INH3)**2-FD211HChaCha(2,INH3)*Mah(INH5)**2+
     &  FD211HChaCha(3,INH3)*Mah(INH5)**2)+MCha2*CFF12S1L(INH5)*
     &  (FD111ChaHCha(1,INH3)-FD111ChaHCha(1,INH5)+FD211HChaCha(1,INH3)
     &  *(-Mah(INH3)**2+Mah(INH5)**2)))+CFF12S1R(INH3)*(CFF12S1L(INH5)*
     &  (-FD111ChaHCha(2,INH3)+FD111ChaHCha(2,INH5)+
     &  FD111ChaHCha(4,INH3)-FD111ChaHCha(4,INH5)+FD211HChaCha(2,INH3)*
     &  Mah(INH3)**2-FD211HChaCha(3,INH3)*Mah(INH3)**2-
     &  FD211HChaCha(2,INH3)*Mah(INH5)**2+FD211HChaCha(3,INH3)*
     &  Mah(INH5)**2)+MCha2*CFF12S1R(INH5)*(FD111ChaHCha(1,INH3)-
     &  FD111ChaHCha(1,INH5)+FD211HChaCha(1,INH3)*(-Mah(INH3)**2+
     &  Mah(INH5)**2)))))/(8.*(Mah(INH3)**2-Mah(INH5)**2)**2)+self(i,j)
              endif
             endif
             if( Abs(-Mah(INH3) + Mah(INH4))*Abs(-Mah(INH4) + Mah(INH5)) .gt.epsi) then 
              if( Abs(Mah(INH3)) .gt. epsi) then 
       self(i,j)=(CS1S1S1(i,INH3,INH4)*CS1S1S1(j,INH3,INH3)*(3*(-
     &  (FD111THT(2,INH3)*hy(INH4)*hyc(INH3))+FD111THT(2,INH4)*hy(INH4)
     &  *hyc(INH3)+FD111THT(4,INH3)*hy(INH4)*hyc(INH3)-FD111THT(4,INH4)
     &  *hy(INH4)*hyc(INH3)-FD111THT(2,INH3)*hy(INH3)*hyc(INH4)+
     &  FD111THT(2,INH4)*hy(INH3)*hyc(INH4)+FD111THT(4,INH3)*hy(INH3)*
     &  hyc(INH4)-FD111THT(4,INH4)*hy(INH3)*hyc(INH4)+M12*
     &  FD111THT(1,INH3)*(hy(INH3)*hy(INH4)+hyc(INH3)*hyc(INH4))-M12*
     &  FD111THT(1,INH4)*(hy(INH3)*hy(INH4)+hyc(INH3)*hyc(INH4))-M12*
     &  FD211HTT(1,INH3)*hy(INH3)*hy(INH4)*Mah(INH3)**2+
     &  FD211HTT(2,INH3)*hy(INH4)*hyc(INH3)*Mah(INH3)**2-
     &  FD211HTT(3,INH3)*hy(INH4)*hyc(INH3)*Mah(INH3)**2+
     &  FD211HTT(2,INH3)*hy(INH3)*hyc(INH4)*Mah(INH3)**2-
     &  FD211HTT(3,INH3)*hy(INH3)*hyc(INH4)*Mah(INH3)**2-M12*
     &  FD211HTT(1,INH3)*hyc(INH3)*hyc(INH4)*Mah(INH3)**2+M12*
     &  FD211HTT(1,INH3)*hy(INH3)*hy(INH4)*Mah(INH4)**2-
     &  FD211HTT(2,INH3)*hy(INH4)*hyc(INH3)*Mah(INH4)**2+
     &  FD211HTT(3,INH3)*hy(INH4)*hyc(INH3)*Mah(INH4)**2-
     &  FD211HTT(2,INH3)*hy(INH3)*hyc(INH4)*Mah(INH4)**2+
     &  FD211HTT(3,INH3)*hy(INH3)*hyc(INH4)*Mah(INH4)**2+M12*
     &  FD211HTT(1,INH3)*hyc(INH3)*hyc(INH4)*Mah(INH4)**2)+
     &  CFF12S1L(INH3)*(CFF12S1R(INH4)*(-FD111ChaHCha(2,INH3)+
     &  FD111ChaHCha(2,INH4)+FD111ChaHCha(4,INH3)-FD111ChaHCha(4,INH4)+
     &  FD211HChaCha(2,INH3)*Mah(INH3)**2-FD211HChaCha(3,INH3)*
     &  Mah(INH3)**2-FD211HChaCha(2,INH3)*Mah(INH4)**2+
     &  FD211HChaCha(3,INH3)*Mah(INH4)**2)+MCha2*CFF12S1L(INH4)*
     &  (FD111ChaHCha(1,INH3)-FD111ChaHCha(1,INH4)+FD211HChaCha(1,INH3)
     &  *(-Mah(INH3)**2+Mah(INH4)**2)))+CFF12S1R(INH3)*(CFF12S1L(INH4)*
     &  (-FD111ChaHCha(2,INH3)+FD111ChaHCha(2,INH4)+
     &  FD111ChaHCha(4,INH3)-FD111ChaHCha(4,INH4)+FD211HChaCha(2,INH3)*
     &  Mah(INH3)**2-FD211HChaCha(3,INH3)*Mah(INH3)**2-
     &  FD211HChaCha(2,INH3)*Mah(INH4)**2+FD211HChaCha(3,INH3)*
     &  Mah(INH4)**2)+MCha2*CFF12S1R(INH4)*(FD111ChaHCha(1,INH3)-
     &  FD111ChaHCha(1,INH4)+FD211HChaCha(1,INH3)*(-Mah(INH3)**2+
     &  Mah(INH4)**2)))))/(8.*(Mah(INH3)**2-Mah(INH4)**2)**2)+self(i,j)

              endif
             endif
             if( Abs(Mah(INH3) - Mah(INH4))*Abs(-Mah(INH3) + Mah(INH5)) .gt. epsi) then 
              if( Abs(Mah(INH4)) .gt. epsi) then 
       self(i,j)=(CS1S1S1(i,INH3,INH4)*CS1S1S1(j,INH3,INH4)*(2*
     &  CFF12S1L(INH4)*CFF12S1R(INH4)*(FD111ChaHCha(2,INH3)-
     &  FD111ChaHCha(2,INH4)-FD111ChaHCha(4,INH3)+FD111ChaHCha(4,INH4)-
     &  FD211HChaCha(2,INH4)*Mah(INH3)**2+FD211HChaCha(3,INH4)*
     &  Mah(INH3)**2+FD211HChaCha(2,INH4)*Mah(INH4)**2-
     &  FD211HChaCha(3,INH4)*Mah(INH4)**2)-3*(-2*FD111THT(2,INH3)*
     &  hy(INH4)*hyc(INH4)+2*FD111THT(2,INH4)*hy(INH4)*hyc(INH4)+2*
     &  FD111THT(4,INH3)*hy(INH4)*hyc(INH4)-2*FD111THT(4,INH4)*hy(INH4)
     &  *hyc(INH4)+M12*FD111THT(1,INH3)*(hy(INH4)**2+hyc(INH4)**2)-M12*
     &  FD111THT(1,INH4)*(hy(INH4)**2+hyc(INH4)**2)-M12*
     &  FD211HTT(1,INH4)*hy(INH4)**2*Mah(INH3)**2+2*FD211HTT(2,INH4)*
     &  hy(INH4)*hyc(INH4)*Mah(INH3)**2-2*FD211HTT(3,INH4)*hy(INH4)*
     &  hyc(INH4)*Mah(INH3)**2-M12*FD211HTT(1,INH4)*hyc(INH4)**2*
     &  Mah(INH3)**2+M12*FD211HTT(1,INH4)*hy(INH4)**2*Mah(INH4)**2-2*
     &  FD211HTT(2,INH4)*hy(INH4)*hyc(INH4)*Mah(INH4)**2+2*
     &  FD211HTT(3,INH4)*hy(INH4)*hyc(INH4)*Mah(INH4)**2+M12*
     &  FD211HTT(1,INH4)*hyc(INH4)**2*Mah(INH4)**2)+MCha2*
     &  CFF12S1L(INH4)**2*(-FD111ChaHCha(1,INH3)+FD111ChaHCha(1,INH4)+
     &  FD211HChaCha(1,INH4)*(Mah(INH3)**2-Mah(INH4)**2))+MCha2*
     &  CFF12S1R(INH4)**2*(-FD111ChaHCha(1,INH3)+FD111ChaHCha(1,INH4)+
     &  FD211HChaCha(1,INH4)*(Mah(INH3)**2-Mah(INH4)**2))))/(8.*
     &  (Mah(INH3)**2-Mah(INH4)**2)**2)+self(i,j)

              endif
             endif
             if( Abs(-Mah(INH3) + Mah(INH5)) .lt. 1D-15 .AND. Abs(Mah(INH3) - Mah(INH4)) .lt. 1D-15) then 
              if( Abs(Mah2(INH3)) .gt.epsi) then 
       self(i,j)=-(CS1S1S1(i,INH3,INH3)*CS1S1S1(j,INH3,INH3)*(MCha2*
     &  CFF12S1L(INH3)**2*FD311HChaCha(1,INH3)+MCha2*CFF12S1R(INH3)**2*
     &  FD311HChaCha(1,INH3)+2*CFF12S1L(INH3)*CFF12S1R(INH3)*(-
     &  FD311HChaCha(2,INH3)+FD311HChaCha(5,INH3))+3*M12*
     &  FD311HTT(1,INH3)*hy(INH3)**2-6*FD311HTT(2,INH3)*hy(INH3)*
     &  hyc(INH3)+6*FD311HTT(5,INH3)*hy(INH3)*hyc(INH3)+3*M12*
     &  FD311HTT(1,INH3)*hyc(INH3)**2))/8.+self(i,j)

              endif
             endif
           endif
       enddo 
       enddo 
       enddo 


       do INe3=ineu,3
       do INe4=ineu,3
       do INH3= ihiggs,6
       do INH4= ihiggs,6
       do INH5= ihiggs,6
          if( Abs(-Mah(INH3) + Mah(INH4))*Abs(-Mah(INH3) + Mah(INH5))*Abs(-Mah(INH4) + Mah(INH5)) .gt. epsi) then 
       self(i,j)=(CS1S1S1(i,INH3,INH4)*CS1S1S1(j,INH3,INH5)*
     &  (CFF11S1L(INe4,INe3,INH5)*(CFF11S1R(INe3,INe4,INH4)*
     &  (FD111ChiHChi(4,INe3,INH4,INe4)*Mah(INH3)**2-
     &  FD111ChiHChi(4,INe3,INH5,INe4)*Mah(INH3)**2+
     &  FD111ChiHChi(2,INe3,INH3,INe4)*Mah(INH4)**2-
     &  FD111ChiHChi(4,INe3,INH3,INe4)*Mah(INH4)**2+
     &  FD111ChiHChi(4,INe3,INH5,INe4)*Mah(INH4)**2+
     &  FD111ChiHChi(2,INe3,INH5,INe4)*(Mah(INH3)**2-Mah(INH4)**2)-
     &  FD111ChiHChi(2,INe3,INH3,INe4)*Mah(INH5)**2+
     &  FD111ChiHChi(4,INe3,INH3,INe4)*Mah(INH5)**2-
     &  FD111ChiHChi(4,INe3,INH4,INe4)*Mah(INH5)**2+
     &  FD111ChiHChi(2,INe3,INH4,INe4)*(-Mah(INH3)**2+Mah(INH5)**2))+
     &  CFF11S1L(INe3,INe4,INH4)*(FD111ChiHChi(1,INe3,INH5,INe4)*(-
     &  Mah(INH3)**2+Mah(INH4)**2)+FD111ChiHChi(1,INe3,INH4,INe4)*
     &  (Mah(INH3)**2-Mah(INH5)**2)+FD111ChiHChi(1,INe3,INH3,INe4)*(-
     &  Mah(INH4)**2+Mah(INH5)**2))*MNeu(INe3)*MNeu(INe4))+
     &  CFF11S1R(INe4,INe3,INH5)*(CFF11S1L(INe3,INe4,INH4)*
     &  (FD111ChiHChi(4,INe3,INH4,INe4)*Mah(INH3)**2-
     &  FD111ChiHChi(4,INe3,INH5,INe4)*Mah(INH3)**2+
     &  FD111ChiHChi(2,INe3,INH3,INe4)*Mah(INH4)**2-
     &  FD111ChiHChi(4,INe3,INH3,INe4)*Mah(INH4)**2+
     &  FD111ChiHChi(4,INe3,INH5,INe4)*Mah(INH4)**2+
     &  FD111ChiHChi(2,INe3,INH5,INe4)*(Mah(INH3)**2-Mah(INH4)**2)-
     &  FD111ChiHChi(2,INe3,INH3,INe4)*Mah(INH5)**2+
     &  FD111ChiHChi(4,INe3,INH3,INe4)*Mah(INH5)**2-
     &  FD111ChiHChi(4,INe3,INH4,INe4)*Mah(INH5)**2+
     &  FD111ChiHChi(2,INe3,INH4,INe4)*(-Mah(INH3)**2+Mah(INH5)**2))+
     &  CFF11S1R(INe3,INe4,INH4)*(FD111ChiHChi(1,INe3,INH5,INe4)*(-
     &  Mah(INH3)**2+Mah(INH4)**2)+FD111ChiHChi(1,INe3,INH4,INe4)*
     &  (Mah(INH3)**2-Mah(INH5)**2)+FD111ChiHChi(1,INe3,INH3,INe4)*(-
     &  Mah(INH4)**2+Mah(INH5)**2))*MNeu(INe3)*MNeu(INe4))))/(16.*
     &  (Mah(INH3)-Mah(INH4))*(Mah(INH3)+Mah(INH4))*(Mah(INH3)-
     &  Mah(INH5))*(Mah(INH4)-Mah(INH5))*(Mah(INH3)+Mah(INH5))*
     &  (Mah(INH4)+Mah(INH5)))+self(i,j)
           else
             if( Abs(-Mah(INH3) + Mah(INH5))*Abs(-Mah(INH4) + Mah(INH5)) .gt.epsi) then 
              if( Abs(Mah(INH3)) .gt. epsi) then 
       self(i,j)=(CS1S1S1(i,INH3,INH3)*CS1S1S1(j,INH3,INH5)*
     &  (CFF11S1L(INe4,INe3,INH5)*(CFF11S1R(INe3,INe4,INH3)*(-
     &  FD111ChiHChi(2,INe3,INH3,INe4)+FD111ChiHChi(2,INe3,INH5,INe4)+
     &  FD111ChiHChi(4,INe3,INH3,INe4)-FD111ChiHChi(4,INe3,INH5,INe4)+
     &  FD211HNeuNeu(2,INH3,INe3,INe4)*Mah(INH3)**2-
     &  FD211HNeuNeu(3,INH3,INe3,INe4)*Mah(INH3)**2-
     &  FD211HNeuNeu(2,INH3,INe3,INe4)*Mah(INH5)**2+
     &  FD211HNeuNeu(3,INH3,INe3,INe4)*Mah(INH5)**2)+
     &  CFF11S1L(INe3,INe4,INH3)*(FD111ChiHChi(1,INe3,INH3,INe4)-
     &  FD111ChiHChi(1,INe3,INH5,INe4)+FD211HNeuNeu(1,INH3,INe3,INe4)*
     &  (-Mah(INH3)**2+Mah(INH5)**2))*MNeu(INe3)*MNeu(INe4))+
     &  CFF11S1R(INe4,INe3,INH5)*(CFF11S1L(INe3,INe4,INH3)*(-
     &  FD111ChiHChi(2,INe3,INH3,INe4)+FD111ChiHChi(2,INe3,INH5,INe4)+
     &  FD111ChiHChi(4,INe3,INH3,INe4)-FD111ChiHChi(4,INe3,INH5,INe4)+
     &  FD211HNeuNeu(2,INH3,INe3,INe4)*Mah(INH3)**2-
     &  FD211HNeuNeu(3,INH3,INe3,INe4)*Mah(INH3)**2-
     &  FD211HNeuNeu(2,INH3,INe3,INe4)*Mah(INH5)**2+
     &  FD211HNeuNeu(3,INH3,INe3,INe4)*Mah(INH5)**2)+
     &  CFF11S1R(INe3,INe4,INH3)*(FD111ChiHChi(1,INe3,INH3,INe4)-
     &  FD111ChiHChi(1,INe3,INH5,INe4)+FD211HNeuNeu(1,INH3,INe3,INe4)*
     &  (-Mah(INH3)**2+Mah(INH5)**2))*MNeu(INe3)*MNeu(INe4))))/(16.*
     &  (Mah(INH3)**2-Mah(INH5)**2)**2)+self(i,j)
              endif
             endif
             if( Abs(-Mah(INH3) + Mah(INH4))*Abs(-Mah(INH4) + Mah(INH5)) .gt.epsi) then 
              if( Abs(Mah(INH3)) .gt. epsi) then 
       self(i,j)=(CS1S1S1(i,INH3,INH4)*CS1S1S1(j,INH3,INH3)*
     &  (CFF11S1L(INe4,INe3,INH3)*(CFF11S1R(INe3,INe4,INH4)*(-
     &  FD111ChiHChi(2,INe3,INH3,INe4)+FD111ChiHChi(2,INe3,INH4,INe4)+
     &  FD111ChiHChi(4,INe3,INH3,INe4)-FD111ChiHChi(4,INe3,INH4,INe4)+
     &  FD211HNeuNeu(2,INH3,INe3,INe4)*Mah(INH3)**2-
     &  FD211HNeuNeu(3,INH3,INe3,INe4)*Mah(INH3)**2-
     &  FD211HNeuNeu(2,INH3,INe3,INe4)*Mah(INH4)**2+
     &  FD211HNeuNeu(3,INH3,INe3,INe4)*Mah(INH4)**2)+
     &  CFF11S1L(INe3,INe4,INH4)*(FD111ChiHChi(1,INe3,INH3,INe4)-
     &  FD111ChiHChi(1,INe3,INH4,INe4)+FD211HNeuNeu(1,INH3,INe3,INe4)*
     &  (-Mah(INH3)**2+Mah(INH4)**2))*MNeu(INe3)*MNeu(INe4))+
     &  CFF11S1R(INe4,INe3,INH3)*(CFF11S1L(INe3,INe4,INH4)*(-
     &  FD111ChiHChi(2,INe3,INH3,INe4)+FD111ChiHChi(2,INe3,INH4,INe4)+
     &  FD111ChiHChi(4,INe3,INH3,INe4)-FD111ChiHChi(4,INe3,INH4,INe4)+
     &  FD211HNeuNeu(2,INH3,INe3,INe4)*Mah(INH3)**2-
     &  FD211HNeuNeu(3,INH3,INe3,INe4)*Mah(INH3)**2-
     &  FD211HNeuNeu(2,INH3,INe3,INe4)*Mah(INH4)**2+
     &  FD211HNeuNeu(3,INH3,INe3,INe4)*Mah(INH4)**2)+
     &  CFF11S1R(INe3,INe4,INH4)*(FD111ChiHChi(1,INe3,INH3,INe4)-
     &  FD111ChiHChi(1,INe3,INH4,INe4)+FD211HNeuNeu(1,INH3,INe3,INe4)*
     &  (-Mah(INH3)**2+Mah(INH4)**2))*MNeu(INe3)*MNeu(INe4))))/(16.*
     &  (Mah(INH3)**2-Mah(INH4)**2)**2)+self(i,j)
              endif
             endif
             if( Abs(Mah(INH3) - Mah(INH4))*Abs(-Mah(INH3) + Mah(INH5)) .gt. epsi) then 
              if( Abs(Mah(INH4)) .gt. epsi) then 
       self(i,j)=(CS1S1S1(i,INH3,INH4)*CS1S1S1(j,INH3,INH4)*
     &  (CFF11S1L(INe4,INe3,INH4)*(CFF11S1R(INe3,INe4,INH4)*
     &  (FD111ChiHChi(2,INe3,INH3,INe4)-FD111ChiHChi(2,INe3,INH4,INe4)-
     &  FD111ChiHChi(4,INe3,INH3,INe4)+FD111ChiHChi(4,INe3,INH4,INe4)-
     &  FD211HNeuNeu(2,INH4,INe3,INe4)*Mah(INH3)**2+
     &  FD211HNeuNeu(3,INH4,INe3,INe4)*Mah(INH3)**2+
     &  FD211HNeuNeu(2,INH4,INe3,INe4)*Mah(INH4)**2-
     &  FD211HNeuNeu(3,INH4,INe3,INe4)*Mah(INH4)**2)+
     &  CFF11S1L(INe3,INe4,INH4)*(-FD111ChiHChi(1,INe3,INH3,INe4)+
     &  FD111ChiHChi(1,INe3,INH4,INe4)+FD211HNeuNeu(1,INH4,INe3,INe4)*
     &  (Mah(INH3)**2-Mah(INH4)**2))*MNeu(INe3)*MNeu(INe4))+
     &  CFF11S1R(INe4,INe3,INH4)*(CFF11S1L(INe3,INe4,INH4)*
     &  (FD111ChiHChi(2,INe3,INH3,INe4)-FD111ChiHChi(2,INe3,INH4,INe4)-
     &  FD111ChiHChi(4,INe3,INH3,INe4)+FD111ChiHChi(4,INe3,INH4,INe4)-
     &  FD211HNeuNeu(2,INH4,INe3,INe4)*Mah(INH3)**2+
     &  FD211HNeuNeu(3,INH4,INe3,INe4)*Mah(INH3)**2+
     &  FD211HNeuNeu(2,INH4,INe3,INe4)*Mah(INH4)**2-
     &  FD211HNeuNeu(3,INH4,INe3,INe4)*Mah(INH4)**2)+
     &  CFF11S1R(INe3,INe4,INH4)*(-FD111ChiHChi(1,INe3,INH3,INe4)+
     &  FD111ChiHChi(1,INe3,INH4,INe4)+FD211HNeuNeu(1,INH4,INe3,INe4)*
     &  (Mah(INH3)**2-Mah(INH4)**2))*MNeu(INe3)*MNeu(INe4))))/(16.*
     &  (Mah(INH3)**2-Mah(INH4)**2)**2)+self(i,j)
              endif
             endif
             if( Abs(-Mah(INH3) + Mah(INH5)) .lt. 1D-15 .AND. Abs(Mah(INH3) - Mah(INH4)) .lt. 1D-15) then 
              if( Abs(Mah(INH3)) .gt. epsi) then 
       self(i,j)=(CS1S1S1(i,INH3,INH3)*CS1S1S1(j,INH3,INH3)*
     &  (CFF11S1L(INe4,INe3,INH3)*(CFF11S1R(INe3,INe4,INH3)*
     &  (FD311HChiChi(2,INH3,INe3,INe4)-FD311HChiChi(5,INH3,INe3,INe4))
     &  -CFF11S1L(INe3,INe4,INH3)*FD311HChiChi(1,INH3,INe3,INe4)*
     &  MNeu(INe3)*MNeu(INe4))+CFF11S1R(INe4,INe3,INH3)*
     &  (CFF11S1L(INe3,INe4,INH3)*(FD311HChiChi(2,INH3,INe3,INe4)-
     &  FD311HChiChi(5,INH3,INe3,INe4))-CFF11S1R(INe3,INe4,INH3)*
     &  FD311HChiChi(1,INH3,INe3,INe4)*MNeu(INe3)*MNeu(INe4))))/16.+
     &  self(i,j)
              endif
             endif
           endif
       enddo 
       enddo 
       enddo 
       enddo 
       enddo 



       do ICH3=1,2
       do ICH4=1,2
       do ICH5=1,2
          if( Abs(-MassHpm(ICH3) + MassHpm(ICH4))*Abs(-MassHpm(ICH3) + 
     &  MassHpm(ICH5))*Abs(-MassHpm(ICH4) + MassHpm(ICH5)) .gt. epsi) then 
       self(i,j)=(3*(CS1S3S3(i,ICH4,ICH3)*CS1S3S3(j,ICH3,ICH5)*
     &  CTBS3(ICH5)*CTBS3C(ICH4)+CS1S3S3(i,ICH3,ICH4)*
     &  CS1S3S3(j,ICH5,ICH3)*CTBS3(ICH4)*CTBS3C(ICH5))*
     &  (FD111THpB(4,ICH4)*MassHpm(ICH3)**2-FD111THpB(4,ICH5)*
     &  MassHpm(ICH3)**2+FD111THpB(2,ICH3)*MassHpm(ICH4)**2-
     &  FD111THpB(4,ICH3)*MassHpm(ICH4)**2+FD111THpB(4,ICH5)*
     &  MassHpm(ICH4)**2+FD111THpB(2,ICH5)*(MassHpm(ICH3)**2-
     &  MassHpm(ICH4)**2)-FD111THpB(2,ICH3)*MassHpm(ICH5)**2+
     &  FD111THpB(4,ICH3)*MassHpm(ICH5)**2-FD111THpB(4,ICH4)*
     &  MassHpm(ICH5)**2+FD111THpB(2,ICH4)*(-MassHpm(ICH3)**2+
     &  MassHpm(ICH5)**2)))/(8.*(MassHpm(ICH3)-MassHpm(ICH4))*
     &  (MassHpm(ICH3)+MassHpm(ICH4))*(MassHpm(ICH3)-MassHpm(ICH5))*
     &  (MassHpm(ICH4)-MassHpm(ICH5))*(MassHpm(ICH3)+MassHpm(ICH5))*
     &  (MassHpm(ICH4)+MassHpm(ICH5)))+self(i,j)
           else
             if( Abs(-MassHpm(ICH3) + MassHpm(ICH5))*Abs(-MassHpm(ICH4) + MassHpm(ICH5)) .gt. epsi) then 
              if( Abs(MassHpm(ICH3)) .gt. epsi) then 
       self(i,j)=(3*CS1S3S3(i,ICH3,ICH3)*(CS1S3S3(j,ICH3,ICH5)*
     &  CTBS3(ICH5)*CTBS3C(ICH3)+CS1S3S3(j,ICH5,ICH3)*CTBS3(ICH3)*
     &  CTBS3C(ICH5))*(-FD111THpB(2,ICH3)+FD111THpB(2,ICH5)+
     &  FD111THpB(4,ICH3)-FD111THpB(4,ICH5)+FD211HpTB(2,ICH3)*
     &  MassHpm(ICH3)**2-FD211HpTB(3,ICH3)*MassHpm(ICH3)**2-
     &  FD211HpTB(2,ICH3)*MassHpm(ICH5)**2+FD211HpTB(3,ICH3)*
     &  MassHpm(ICH5)**2))/(8.*(MassHpm(ICH3)**2-MassHpm(ICH5)**2)**2)+
     &  self(i,j)
              endif
             endif
             if( Abs(-MassHpm(ICH3) + MassHpm(ICH4))*Abs(-MassHpm(ICH4) + MassHpm(ICH5)) .gt. epsi) then 
              if( Abs(MassHpm(ICH3)) .gt. epsi) then 
       self(i,j)=(3*CS1S3S3(j,ICH3,ICH3)*(CS1S3S3(i,ICH3,ICH4)*
     &  CTBS3(ICH4)*CTBS3C(ICH3)+CS1S3S3(i,ICH4,ICH3)*CTBS3(ICH3)*
     &  CTBS3C(ICH4))*(-FD111THpB(2,ICH3)+FD111THpB(2,ICH4)+
     &  FD111THpB(4,ICH3)-FD111THpB(4,ICH4)+FD211HpTB(2,ICH3)*
     &  MassHpm(ICH3)**2-FD211HpTB(3,ICH3)*MassHpm(ICH3)**2-
     &  FD211HpTB(2,ICH3)*MassHpm(ICH4)**2+FD211HpTB(3,ICH3)*
     &  MassHpm(ICH4)**2))/(8.*(MassHpm(ICH3)**2-MassHpm(ICH4)**2)**2)+
     &  self(i,j)
              endif
             endif
             if( Abs(MassHpm(ICH3) - MassHpm(ICH4))*Abs(-MassHpm(ICH3) + MassHpm(ICH5)) .gt. epsi) then 
              if( Abs(MassHpm(ICH4)) .gt. epsi) then 
       self(i,j)=(3*(CS1S3S3(i,ICH4,ICH3)*CS1S3S3(j,ICH3,ICH4)+
     &  CS1S3S3(i,ICH3,ICH4)*CS1S3S3(j,ICH4,ICH3))*CTBS3(ICH4)*
     &  CTBS3C(ICH4)*(FD111THpB(2,ICH3)-FD111THpB(2,ICH4)-
     &  FD111THpB(4,ICH3)+FD111THpB(4,ICH4)-FD211HpTB(2,ICH4)*
     &  MassHpm(ICH3)**2+FD211HpTB(3,ICH4)*MassHpm(ICH3)**2+
     &  FD211HpTB(2,ICH4)*MassHpm(ICH4)**2-FD211HpTB(3,ICH4)*
     &  MassHpm(ICH4)**2))/(8.*(MassHpm(ICH3)**2-MassHpm(ICH4)**2)**2)+
     &  self(i,j)
              endif
             endif
             if( Abs(-MassHpm(ICH3) + MassHpm(ICH5)) .lt. 1D-15 .AND.
     &   Abs(MassHpm(ICH3) - MassHpm(ICH4)) .lt. 1D-15) then 
              if( Abs(MassHpm(ICH3)) .gt.epsi) then 
       self(i,j)=(3*CS1S3S3(i,ICH3,ICH3)*CS1S3S3(j,ICH3,ICH3)*
     &  CTBS3(ICH3)*CTBS3C(ICH3)*(FD311HpTB(2,ICH3)-FD311HpTB(5,ICH3)))
     &  /4.+self(i,j)
              endif
             endif
           endif
       enddo 
       enddo 
       enddo
       do ICH3=1,2
       do ICH4=1,2
       do ICH5=1,2
       do INe3=ineu,3
          if( Abs(-MassHpm(ICH3) + MassHpm(ICH4))*Abs(-MassHpm(ICH3) +
     &    MassHpm(ICH5))*Abs(-MassHpm(ICH4) + MassHpm(ICH5)) .gt.epsi) then 
       self(i,j)=(-(CF11F12S3R(INe3,ICH5)*CS1S3S3(i,ICH3,ICH4)*
     &  CS1S3S3(j,ICH5,ICH3)*DCONJG(CF11F12S3R(INe3,ICH4))*
     &  FD111ChiHpCha(2,INe3,ICH4)*MassHpm(ICH3)**2)-
     &  CF11F12S3R(INe3,ICH4)*CS1S3S3(i,ICH4,ICH3)*CS1S3S3(j,ICH3,ICH5)
     &  *DCONJG(CF11F12S3R(INe3,ICH5))*FD111ChiHpCha(2,INe3,ICH4)*
     &  MassHpm(ICH3)**2+CF11F12S3R(INe3,ICH5)*CS1S3S3(i,ICH3,ICH4)*
     &  CS1S3S3(j,ICH5,ICH3)*DCONJG(CF11F12S3R(INe3,ICH4))*
     &  FD111ChiHpCha(2,INe3,ICH5)*MassHpm(ICH3)**2+
     &  CF11F12S3R(INe3,ICH4)*CS1S3S3(i,ICH4,ICH3)*CS1S3S3(j,ICH3,ICH5)
     &  *DCONJG(CF11F12S3R(INe3,ICH5))*FD111ChiHpCha(2,INe3,ICH5)*
     &  MassHpm(ICH3)**2+CF11F12S3R(INe3,ICH5)*CS1S3S3(i,ICH3,ICH4)*
     &  CS1S3S3(j,ICH5,ICH3)*DCONJG(CF11F12S3R(INe3,ICH4))*
     &  FD111ChiHpCha(4,INe3,ICH4)*MassHpm(ICH3)**2+
     &  CF11F12S3R(INe3,ICH4)*CS1S3S3(i,ICH4,ICH3)*CS1S3S3(j,ICH3,ICH5)
     &  *DCONJG(CF11F12S3R(INe3,ICH5))*FD111ChiHpCha(4,INe3,ICH4)*
     &  MassHpm(ICH3)**2-CF11F12S3R(INe3,ICH5)*CS1S3S3(i,ICH3,ICH4)*
     &  CS1S3S3(j,ICH5,ICH3)*DCONJG(CF11F12S3R(INe3,ICH4))*
     &  FD111ChiHpCha(4,INe3,ICH5)*MassHpm(ICH3)**2-
     &  CF11F12S3R(INe3,ICH4)*CS1S3S3(i,ICH4,ICH3)*CS1S3S3(j,ICH3,ICH5)
     &  *DCONJG(CF11F12S3R(INe3,ICH5))*FD111ChiHpCha(4,INe3,ICH5)*
     &  MassHpm(ICH3)**2+CF11F12S3R(INe3,ICH5)*CS1S3S3(i,ICH3,ICH4)*
     &  CS1S3S3(j,ICH5,ICH3)*DCONJG(CF11F12S3R(INe3,ICH4))*
     &  FD111ChiHpCha(2,INe3,ICH3)*MassHpm(ICH4)**2+
     &  CF11F12S3R(INe3,ICH4)*CS1S3S3(i,ICH4,ICH3)*CS1S3S3(j,ICH3,ICH5)
     &  *DCONJG(CF11F12S3R(INe3,ICH5))*FD111ChiHpCha(2,INe3,ICH3)*
     &  MassHpm(ICH4)**2-CF11F12S3R(INe3,ICH5)*CS1S3S3(i,ICH3,ICH4)*
     &  CS1S3S3(j,ICH5,ICH3)*DCONJG(CF11F12S3R(INe3,ICH4))*
     &  FD111ChiHpCha(2,INe3,ICH5)*MassHpm(ICH4)**2-
     &  CF11F12S3R(INe3,ICH4)*CS1S3S3(i,ICH4,ICH3)*CS1S3S3(j,ICH3,ICH5)
     &  *DCONJG(CF11F12S3R(INe3,ICH5))*FD111ChiHpCha(2,INe3,ICH5)*
     &  MassHpm(ICH4)**2-CF11F12S3R(INe3,ICH5)*CS1S3S3(i,ICH3,ICH4)*
     &  CS1S3S3(j,ICH5,ICH3)*DCONJG(CF11F12S3R(INe3,ICH4))*
     &  FD111ChiHpCha(4,INe3,ICH3)*MassHpm(ICH4)**2-
     &  CF11F12S3R(INe3,ICH4)*CS1S3S3(i,ICH4,ICH3)*CS1S3S3(j,ICH3,ICH5)
     &  *DCONJG(CF11F12S3R(INe3,ICH5))*FD111ChiHpCha(4,INe3,ICH3)*
     &  MassHpm(ICH4)**2+CF11F12S3R(INe3,ICH5)*CS1S3S3(i,ICH3,ICH4)*
     &  CS1S3S3(j,ICH5,ICH3)*DCONJG(CF11F12S3R(INe3,ICH4))*
     &  FD111ChiHpCha(4,INe3,ICH5)*MassHpm(ICH4)**2+
     &  CF11F12S3R(INe3,ICH4)*CS1S3S3(i,ICH4,ICH3)*CS1S3S3(j,ICH3,ICH5)
     &  *DCONJG(CF11F12S3R(INe3,ICH5))*FD111ChiHpCha(4,INe3,ICH5)*
     &  MassHpm(ICH4)**2-CF11F12S3R(INe3,ICH5)*CS1S3S3(i,ICH3,ICH4)*
     &  CS1S3S3(j,ICH5,ICH3)*DCONJG(CF11F12S3R(INe3,ICH4))*
     &  FD111ChiHpCha(2,INe3,ICH3)*MassHpm(ICH5)**2-
     &  CF11F12S3R(INe3,ICH4)*CS1S3S3(i,ICH4,ICH3)*CS1S3S3(j,ICH3,ICH5)
     &  *DCONJG(CF11F12S3R(INe3,ICH5))*FD111ChiHpCha(2,INe3,ICH3)*
     &  MassHpm(ICH5)**2+CF11F12S3R(INe3,ICH5)*CS1S3S3(i,ICH3,ICH4)*
     &  CS1S3S3(j,ICH5,ICH3)*DCONJG(CF11F12S3R(INe3,ICH4))*
     &  FD111ChiHpCha(2,INe3,ICH4)*MassHpm(ICH5)**2+
     &  CF11F12S3R(INe3,ICH4)*CS1S3S3(i,ICH4,ICH3)*CS1S3S3(j,ICH3,ICH5)
     &  *DCONJG(CF11F12S3R(INe3,ICH5))*FD111ChiHpCha(2,INe3,ICH4)*
     &  MassHpm(ICH5)**2+CF11F12S3R(INe3,ICH5)*CS1S3S3(i,ICH3,ICH4)*
     &  CS1S3S3(j,ICH5,ICH3)*DCONJG(CF11F12S3R(INe3,ICH4))*
     &  FD111ChiHpCha(4,INe3,ICH3)*MassHpm(ICH5)**2+
     &  CF11F12S3R(INe3,ICH4)*CS1S3S3(i,ICH4,ICH3)*CS1S3S3(j,ICH3,ICH5)
     &  *DCONJG(CF11F12S3R(INe3,ICH5))*FD111ChiHpCha(4,INe3,ICH3)*
     &  MassHpm(ICH5)**2-CF11F12S3R(INe3,ICH5)*CS1S3S3(i,ICH3,ICH4)*
     &  CS1S3S3(j,ICH5,ICH3)*DCONJG(CF11F12S3R(INe3,ICH4))*
     &  FD111ChiHpCha(4,INe3,ICH4)*MassHpm(ICH5)**2-
     &  CF11F12S3R(INe3,ICH4)*CS1S3S3(i,ICH4,ICH3)*CS1S3S3(j,ICH3,ICH5)
     &  *DCONJG(CF11F12S3R(INe3,ICH5))*FD111ChiHpCha(4,INe3,ICH4)*
     &  MassHpm(ICH5)**2+MCha*CF11F12S3R(INe3,ICH5)*
     &  CS1S3S3(i,ICH3,ICH4)*CS1S3S3(j,ICH5,ICH3)*
     &  DCONJG(CF11F12S3L(INe3,ICH4))*FD111ChiHpCha(1,INe3,ICH4)*
     &  MassHpm(ICH3)**2*MNeu(INe3)+MCha*CF11F12S3R(INe3,ICH4)*
     &  CS1S3S3(i,ICH4,ICH3)*CS1S3S3(j,ICH3,ICH5)*
     &  DCONJG(CF11F12S3L(INe3,ICH5))*FD111ChiHpCha(1,INe3,ICH4)*
     &  MassHpm(ICH3)**2*MNeu(INe3)-MCha*CF11F12S3R(INe3,ICH5)*
     &  CS1S3S3(i,ICH3,ICH4)*CS1S3S3(j,ICH5,ICH3)*
     &  DCONJG(CF11F12S3L(INe3,ICH4))*FD111ChiHpCha(1,INe3,ICH5)*
     &  MassHpm(ICH3)**2*MNeu(INe3)-MCha*CF11F12S3R(INe3,ICH4)*
     &  CS1S3S3(i,ICH4,ICH3)*CS1S3S3(j,ICH3,ICH5)*
     &  DCONJG(CF11F12S3L(INe3,ICH5))*FD111ChiHpCha(1,INe3,ICH5)*
     &  MassHpm(ICH3)**2*MNeu(INe3)-MCha*CF11F12S3R(INe3,ICH5)*
     &  CS1S3S3(i,ICH3,ICH4)*CS1S3S3(j,ICH5,ICH3)*
     &  DCONJG(CF11F12S3L(INe3,ICH4))*FD111ChiHpCha(1,INe3,ICH3)*
     &  MassHpm(ICH4)**2*MNeu(INe3)-MCha*CF11F12S3R(INe3,ICH4)*
     &  CS1S3S3(i,ICH4,ICH3)*CS1S3S3(j,ICH3,ICH5)*
     &  DCONJG(CF11F12S3L(INe3,ICH5))*FD111ChiHpCha(1,INe3,ICH3)*
     &  MassHpm(ICH4)**2*MNeu(INe3)+MCha*CF11F12S3R(INe3,ICH5)*
     &  CS1S3S3(i,ICH3,ICH4)*CS1S3S3(j,ICH5,ICH3)*
     &  DCONJG(CF11F12S3L(INe3,ICH4))*FD111ChiHpCha(1,INe3,ICH5)*
     &  MassHpm(ICH4)**2*MNeu(INe3)+MCha*CF11F12S3R(INe3,ICH4)*
     &  CS1S3S3(i,ICH4,ICH3)*CS1S3S3(j,ICH3,ICH5)*
     &  DCONJG(CF11F12S3L(INe3,ICH5))*FD111ChiHpCha(1,INe3,ICH5)*
     &  MassHpm(ICH4)**2*MNeu(INe3)+MCha*CF11F12S3R(INe3,ICH5)*
     &  CS1S3S3(i,ICH3,ICH4)*CS1S3S3(j,ICH5,ICH3)*
     &  DCONJG(CF11F12S3L(INe3,ICH4))*FD111ChiHpCha(1,INe3,ICH3)*
     &  MassHpm(ICH5)**2*MNeu(INe3)+MCha*CF11F12S3R(INe3,ICH4)*
     &  CS1S3S3(i,ICH4,ICH3)*CS1S3S3(j,ICH3,ICH5)*
     &  DCONJG(CF11F12S3L(INe3,ICH5))*FD111ChiHpCha(1,INe3,ICH3)*
     &  MassHpm(ICH5)**2*MNeu(INe3)-MCha*CF11F12S3R(INe3,ICH5)*
     &  CS1S3S3(i,ICH3,ICH4)*CS1S3S3(j,ICH5,ICH3)*
     &  DCONJG(CF11F12S3L(INe3,ICH4))*FD111ChiHpCha(1,INe3,ICH4)*
     &  MassHpm(ICH5)**2*MNeu(INe3)-MCha*CF11F12S3R(INe3,ICH4)*
     &  CS1S3S3(i,ICH4,ICH3)*CS1S3S3(j,ICH3,ICH5)*
     &  DCONJG(CF11F12S3L(INe3,ICH5))*FD111ChiHpCha(1,INe3,ICH4)*
     &  MassHpm(ICH5)**2*MNeu(INe3)+CF11F12S3L(INe3,ICH5)*
     &  CS1S3S3(i,ICH3,ICH4)*CS1S3S3(j,ICH5,ICH3)*
     &  (DCONJG(CF11F12S3L(INe3,ICH4))*(FD111ChiHpCha(4,INe3,ICH4)*
     &  MassHpm(ICH3)**2-FD111ChiHpCha(4,INe3,ICH5)*MassHpm(ICH3)**2+
     &  FD111ChiHpCha(2,INe3,ICH3)*MassHpm(ICH4)**2-
     &  FD111ChiHpCha(4,INe3,ICH3)*MassHpm(ICH4)**2+
     &  FD111ChiHpCha(4,INe3,ICH5)*MassHpm(ICH4)**2+
     &  FD111ChiHpCha(2,INe3,ICH5)*(MassHpm(ICH3)**2-MassHpm(ICH4)**2)-
     &  FD111ChiHpCha(2,INe3,ICH3)*MassHpm(ICH5)**2+
     &  FD111ChiHpCha(4,INe3,ICH3)*MassHpm(ICH5)**2-
     &  FD111ChiHpCha(4,INe3,ICH4)*MassHpm(ICH5)**2+
     &  FD111ChiHpCha(2,INe3,ICH4)*(-MassHpm(ICH3)**2+MassHpm(ICH5)**2)
     &  )+MCha*DCONJG(CF11F12S3R(INe3,ICH4))*
     &  (FD111ChiHpCha(1,INe3,ICH5)*(-MassHpm(ICH3)**2+MassHpm(ICH4)**
     &  2)+FD111ChiHpCha(1,INe3,ICH4)*(MassHpm(ICH3)**2-MassHpm(ICH5)**
     &  2)+FD111ChiHpCha(1,INe3,ICH3)*(-MassHpm(ICH4)**2+MassHpm(ICH5)*
     &  *2))*MNeu(INe3))+CF11F12S3L(INe3,ICH4)*CS1S3S3(i,ICH4,ICH3)*
     &  CS1S3S3(j,ICH3,ICH5)*(DCONJG(CF11F12S3L(INe3,ICH5))*
     &  (FD111ChiHpCha(4,INe3,ICH4)*MassHpm(ICH3)**2-
     &  FD111ChiHpCha(4,INe3,ICH5)*MassHpm(ICH3)**2+
     &  FD111ChiHpCha(2,INe3,ICH3)*MassHpm(ICH4)**2-
     &  FD111ChiHpCha(4,INe3,ICH3)*MassHpm(ICH4)**2+
     &  FD111ChiHpCha(4,INe3,ICH5)*MassHpm(ICH4)**2+
     &  FD111ChiHpCha(2,INe3,ICH5)*(MassHpm(ICH3)**2-MassHpm(ICH4)**2)-
     &  FD111ChiHpCha(2,INe3,ICH3)*MassHpm(ICH5)**2+
     &  FD111ChiHpCha(4,INe3,ICH3)*MassHpm(ICH5)**2-
     &  FD111ChiHpCha(4,INe3,ICH4)*MassHpm(ICH5)**2+
     &  FD111ChiHpCha(2,INe3,ICH4)*(-MassHpm(ICH3)**2+MassHpm(ICH5)**2)
     &  )+MCha*DCONJG(CF11F12S3R(INe3,ICH5))*
     &  (FD111ChiHpCha(1,INe3,ICH5)*(-MassHpm(ICH3)**2+MassHpm(ICH4)**
     &  2)+FD111ChiHpCha(1,INe3,ICH4)*(MassHpm(ICH3)**2-MassHpm(ICH5)**
     &  2)+FD111ChiHpCha(1,INe3,ICH3)*(-MassHpm(ICH4)**2+MassHpm(ICH5)*
     &  *2))*MNeu(INe3)))/(8.*(MassHpm(ICH3)-MassHpm(ICH4))*(MassHpm(ICH3)
     &  +MassHpm(ICH4))*(MassHpm(ICH3)-MassHpm(ICH5))*(MassHpm(ICH4)
     &  -MassHpm(ICH5))*(MassHpm(ICH3)+MassHpm(ICH5))*(MassHpm(ICH4)+MassHpm(ICH5)))+self(i,j)
           else
             if( Abs(-MassHpm(ICH3) + MassHpm(ICH5))*Abs(-MassHpm(ICH4) + MassHpm(ICH5)) .gt. epsi) then 
              if( Abs(MassHpm(ICH3)) .gt. epsi) then 
       self(i,j)=(CS1S3S3(i,ICH3,ICH3)*(-(CF11F12S3R(INe3,ICH5)*
     &  CS1S3S3(j,ICH5,ICH3)*DCONJG(CF11F12S3R(INe3,ICH3))*
     &  FD111ChiHpCha(2,INe3,ICH3))-CF11F12S3R(INe3,ICH3)*
     &  CS1S3S3(j,ICH3,ICH5)*DCONJG(CF11F12S3R(INe3,ICH5))*
     &  FD111ChiHpCha(2,INe3,ICH3)+CF11F12S3R(INe3,ICH5)*
     &  CS1S3S3(j,ICH5,ICH3)*DCONJG(CF11F12S3R(INe3,ICH3))*
     &  FD111ChiHpCha(2,INe3,ICH5)+CF11F12S3R(INe3,ICH3)*
     &  CS1S3S3(j,ICH3,ICH5)*DCONJG(CF11F12S3R(INe3,ICH5))*
     &  FD111ChiHpCha(2,INe3,ICH5)+CF11F12S3R(INe3,ICH5)*
     &  CS1S3S3(j,ICH5,ICH3)*DCONJG(CF11F12S3R(INe3,ICH3))*
     &  FD111ChiHpCha(4,INe3,ICH3)+CF11F12S3R(INe3,ICH3)*
     &  CS1S3S3(j,ICH3,ICH5)*DCONJG(CF11F12S3R(INe3,ICH5))*
     &  FD111ChiHpCha(4,INe3,ICH3)-CF11F12S3R(INe3,ICH5)*
     &  CS1S3S3(j,ICH5,ICH3)*DCONJG(CF11F12S3R(INe3,ICH3))*
     &  FD111ChiHpCha(4,INe3,ICH5)-CF11F12S3R(INe3,ICH3)*
     &  CS1S3S3(j,ICH3,ICH5)*DCONJG(CF11F12S3R(INe3,ICH5))*
     &  FD111ChiHpCha(4,INe3,ICH5)+CF11F12S3R(INe3,ICH5)*
     &  CS1S3S3(j,ICH5,ICH3)*DCONJG(CF11F12S3R(INe3,ICH3))*
     &  FD211HpChiCha(2,ICH3,INe3)*MassHpm(ICH3)**2+
     &  CF11F12S3R(INe3,ICH3)*CS1S3S3(j,ICH3,ICH5)*
     &  DCONJG(CF11F12S3R(INe3,ICH5))*FD211HpChiCha(2,ICH3,INe3)*
     &  MassHpm(ICH3)**2-CF11F12S3R(INe3,ICH5)*CS1S3S3(j,ICH5,ICH3)*
     &  DCONJG(CF11F12S3R(INe3,ICH3))*FD211HpChiCha(3,ICH3,INe3)*
     &  MassHpm(ICH3)**2-CF11F12S3R(INe3,ICH3)*CS1S3S3(j,ICH3,ICH5)*
     &  DCONJG(CF11F12S3R(INe3,ICH5))*FD211HpChiCha(3,ICH3,INe3)*
     &  MassHpm(ICH3)**2-CF11F12S3R(INe3,ICH5)*CS1S3S3(j,ICH5,ICH3)*
     &  DCONJG(CF11F12S3R(INe3,ICH3))*FD211HpChiCha(2,ICH3,INe3)*
     &  MassHpm(ICH5)**2-CF11F12S3R(INe3,ICH3)*CS1S3S3(j,ICH3,ICH5)*
     &  DCONJG(CF11F12S3R(INe3,ICH5))*FD211HpChiCha(2,ICH3,INe3)*
     &  MassHpm(ICH5)**2+CF11F12S3R(INe3,ICH5)*CS1S3S3(j,ICH5,ICH3)*
     &  DCONJG(CF11F12S3R(INe3,ICH3))*FD211HpChiCha(3,ICH3,INe3)*
     &  MassHpm(ICH5)**2+CF11F12S3R(INe3,ICH3)*CS1S3S3(j,ICH3,ICH5)*
     &  DCONJG(CF11F12S3R(INe3,ICH5))*FD211HpChiCha(3,ICH3,INe3)*
     &  MassHpm(ICH5)**2+MCha*CF11F12S3R(INe3,ICH5)*
     &  CS1S3S3(j,ICH5,ICH3)*DCONJG(CF11F12S3L(INe3,ICH3))*
     &  FD111ChiHpCha(1,INe3,ICH3)*MNeu(INe3)+MCha*
     &  CF11F12S3R(INe3,ICH3)*CS1S3S3(j,ICH3,ICH5)*
     &  DCONJG(CF11F12S3L(INe3,ICH5))*FD111ChiHpCha(1,INe3,ICH3)*
     &  MNeu(INe3)-MCha*CF11F12S3R(INe3,ICH5)*CS1S3S3(j,ICH5,ICH3)*
     &  DCONJG(CF11F12S3L(INe3,ICH3))*FD111ChiHpCha(1,INe3,ICH5)*
     &  MNeu(INe3)-MCha*CF11F12S3R(INe3,ICH3)*CS1S3S3(j,ICH3,ICH5)*
     &  DCONJG(CF11F12S3L(INe3,ICH5))*FD111ChiHpCha(1,INe3,ICH5)*
     &  MNeu(INe3)-MCha*CF11F12S3R(INe3,ICH5)*CS1S3S3(j,ICH5,ICH3)*
     &  DCONJG(CF11F12S3L(INe3,ICH3))*FD211HpChiCha(1,ICH3,INe3)*
     &  MassHpm(ICH3)**2*MNeu(INe3)-MCha*CF11F12S3R(INe3,ICH3)*
     &  CS1S3S3(j,ICH3,ICH5)*DCONJG(CF11F12S3L(INe3,ICH5))*
     &  FD211HpChiCha(1,ICH3,INe3)*MassHpm(ICH3)**2*MNeu(INe3)+MCha*
     &  CF11F12S3R(INe3,ICH5)*CS1S3S3(j,ICH5,ICH3)*
     &  DCONJG(CF11F12S3L(INe3,ICH3))*FD211HpChiCha(1,ICH3,INe3)*
     &  MassHpm(ICH5)**2*MNeu(INe3)+MCha*CF11F12S3R(INe3,ICH3)*
     &  CS1S3S3(j,ICH3,ICH5)*DCONJG(CF11F12S3L(INe3,ICH5))*
     &  FD211HpChiCha(1,ICH3,INe3)*MassHpm(ICH5)**2*MNeu(INe3)+
     &  CF11F12S3L(INe3,ICH5)*CS1S3S3(j,ICH5,ICH3)*
     &  (DCONJG(CF11F12S3L(INe3,ICH3))*(-FD111ChiHpCha(2,INe3,ICH3)+
     &  FD111ChiHpCha(2,INe3,ICH5)+FD111ChiHpCha(4,INe3,ICH3)-
     &  FD111ChiHpCha(4,INe3,ICH5)+FD211HpChiCha(2,ICH3,INe3)*
     &  MassHpm(ICH3)**2-FD211HpChiCha(3,ICH3,INe3)*MassHpm(ICH3)**2-
     &  FD211HpChiCha(2,ICH3,INe3)*MassHpm(ICH5)**2+
     &  FD211HpChiCha(3,ICH3,INe3)*MassHpm(ICH5)**2)+MCha*
     &  DCONJG(CF11F12S3R(INe3,ICH3))*(FD111ChiHpCha(1,INe3,ICH3)-
     &  FD111ChiHpCha(1,INe3,ICH5)+FD211HpChiCha(1,ICH3,INe3)*(-
     &  MassHpm(ICH3)**2+MassHpm(ICH5)**2))*MNeu(INe3))+
     &  CF11F12S3L(INe3,ICH3)*CS1S3S3(j,ICH3,ICH5)*
     &  (DCONJG(CF11F12S3L(INe3,ICH5))*(-FD111ChiHpCha(2,INe3,ICH3)+
     &  FD111ChiHpCha(2,INe3,ICH5)+FD111ChiHpCha(4,INe3,ICH3)-
     &  FD111ChiHpCha(4,INe3,ICH5)+FD211HpChiCha(2,ICH3,INe3)*
     &  MassHpm(ICH3)**2-FD211HpChiCha(3,ICH3,INe3)*MassHpm(ICH3)**2-
     &  FD211HpChiCha(2,ICH3,INe3)*MassHpm(ICH5)**2+
     &  FD211HpChiCha(3,ICH3,INe3)*MassHpm(ICH5)**2)+MCha*
     &  DCONJG(CF11F12S3R(INe3,ICH5))*(FD111ChiHpCha(1,INe3,ICH3)-
     &  FD111ChiHpCha(1,INe3,ICH5)+FD211HpChiCha(1,ICH3,INe3)*(-
     &  MassHpm(ICH3)**2+MassHpm(ICH5)**2))*MNeu(INe3))))/(8.*(MassHpm(ICH3)**2-MassHpm(ICH5)**2)**2)+self(i,j)
              endif
             endif
             if( Abs(-MassHpm(ICH3) + MassHpm(ICH4))*Abs(-MassHpm(ICH4) + MassHpm(ICH5)) .gt. epsi) then 
              if( Abs(MassHpm(ICH3)) .gt. epsi) then 
       self(i,j)=(CS1S3S3(j,ICH3,ICH3)*(-(CF11F12S3R(INe3,ICH4)*
     &  CS1S3S3(i,ICH4,ICH3)*DCONJG(CF11F12S3R(INe3,ICH3))*
     &  FD111ChiHpCha(2,INe3,ICH3))-CF11F12S3R(INe3,ICH3)*
     &  CS1S3S3(i,ICH3,ICH4)*DCONJG(CF11F12S3R(INe3,ICH4))*
     &  FD111ChiHpCha(2,INe3,ICH3)+CF11F12S3R(INe3,ICH4)*
     &  CS1S3S3(i,ICH4,ICH3)*DCONJG(CF11F12S3R(INe3,ICH3))*
     &  FD111ChiHpCha(2,INe3,ICH4)+CF11F12S3R(INe3,ICH3)*
     &  CS1S3S3(i,ICH3,ICH4)*DCONJG(CF11F12S3R(INe3,ICH4))*
     &  FD111ChiHpCha(2,INe3,ICH4)+CF11F12S3R(INe3,ICH4)*
     &  CS1S3S3(i,ICH4,ICH3)*DCONJG(CF11F12S3R(INe3,ICH3))*
     &  FD111ChiHpCha(4,INe3,ICH3)+CF11F12S3R(INe3,ICH3)*
     &  CS1S3S3(i,ICH3,ICH4)*DCONJG(CF11F12S3R(INe3,ICH4))*
     &  FD111ChiHpCha(4,INe3,ICH3)-CF11F12S3R(INe3,ICH4)*
     &  CS1S3S3(i,ICH4,ICH3)*DCONJG(CF11F12S3R(INe3,ICH3))*
     &  FD111ChiHpCha(4,INe3,ICH4)-CF11F12S3R(INe3,ICH3)*
     &  CS1S3S3(i,ICH3,ICH4)*DCONJG(CF11F12S3R(INe3,ICH4))*
     &  FD111ChiHpCha(4,INe3,ICH4)+CF11F12S3R(INe3,ICH4)*
     &  CS1S3S3(i,ICH4,ICH3)*DCONJG(CF11F12S3R(INe3,ICH3))*
     &  FD211HpChiCha(2,ICH3,INe3)*MassHpm(ICH3)**2+
     &  CF11F12S3R(INe3,ICH3)*CS1S3S3(i,ICH3,ICH4)*
     &  DCONJG(CF11F12S3R(INe3,ICH4))*FD211HpChiCha(2,ICH3,INe3)*
     &  MassHpm(ICH3)**2-CF11F12S3R(INe3,ICH4)*CS1S3S3(i,ICH4,ICH3)*
     &  DCONJG(CF11F12S3R(INe3,ICH3))*FD211HpChiCha(3,ICH3,INe3)*
     &  MassHpm(ICH3)**2-CF11F12S3R(INe3,ICH3)*CS1S3S3(i,ICH3,ICH4)*
     &  DCONJG(CF11F12S3R(INe3,ICH4))*FD211HpChiCha(3,ICH3,INe3)*
     &  MassHpm(ICH3)**2-CF11F12S3R(INe3,ICH4)*CS1S3S3(i,ICH4,ICH3)*
     &  DCONJG(CF11F12S3R(INe3,ICH3))*FD211HpChiCha(2,ICH3,INe3)*
     &  MassHpm(ICH4)**2-CF11F12S3R(INe3,ICH3)*CS1S3S3(i,ICH3,ICH4)*
     &  DCONJG(CF11F12S3R(INe3,ICH4))*FD211HpChiCha(2,ICH3,INe3)*
     &  MassHpm(ICH4)**2+CF11F12S3R(INe3,ICH4)*CS1S3S3(i,ICH4,ICH3)*
     &  DCONJG(CF11F12S3R(INe3,ICH3))*FD211HpChiCha(3,ICH3,INe3)*
     &  MassHpm(ICH4)**2+CF11F12S3R(INe3,ICH3)*CS1S3S3(i,ICH3,ICH4)*
     &  DCONJG(CF11F12S3R(INe3,ICH4))*FD211HpChiCha(3,ICH3,INe3)*
     &  MassHpm(ICH4)**2+MCha*CF11F12S3R(INe3,ICH4)*
     &  CS1S3S3(i,ICH4,ICH3)*DCONJG(CF11F12S3L(INe3,ICH3))*
     &  FD111ChiHpCha(1,INe3,ICH3)*MNeu(INe3)+MCha*
     &  CF11F12S3R(INe3,ICH3)*CS1S3S3(i,ICH3,ICH4)*
     &  DCONJG(CF11F12S3L(INe3,ICH4))*FD111ChiHpCha(1,INe3,ICH3)*
     &  MNeu(INe3)-MCha*CF11F12S3R(INe3,ICH4)*CS1S3S3(i,ICH4,ICH3)*
     &  DCONJG(CF11F12S3L(INe3,ICH3))*FD111ChiHpCha(1,INe3,ICH4)*
     &  MNeu(INe3)-MCha*CF11F12S3R(INe3,ICH3)*CS1S3S3(i,ICH3,ICH4)*
     &  DCONJG(CF11F12S3L(INe3,ICH4))*FD111ChiHpCha(1,INe3,ICH4)*
     &  MNeu(INe3)-MCha*CF11F12S3R(INe3,ICH4)*CS1S3S3(i,ICH4,ICH3)*
     &  DCONJG(CF11F12S3L(INe3,ICH3))*FD211HpChiCha(1,ICH3,INe3)*
     &  MassHpm(ICH3)**2*MNeu(INe3)-MCha*CF11F12S3R(INe3,ICH3)*
     &  CS1S3S3(i,ICH3,ICH4)*DCONJG(CF11F12S3L(INe3,ICH4))*
     &  FD211HpChiCha(1,ICH3,INe3)*MassHpm(ICH3)**2*MNeu(INe3)+MCha*
     &  CF11F12S3R(INe3,ICH4)*CS1S3S3(i,ICH4,ICH3)*
     &  DCONJG(CF11F12S3L(INe3,ICH3))*FD211HpChiCha(1,ICH3,INe3)*
     &  MassHpm(ICH4)**2*MNeu(INe3)+MCha*CF11F12S3R(INe3,ICH3)*
     &  CS1S3S3(i,ICH3,ICH4)*DCONJG(CF11F12S3L(INe3,ICH4))*
     &  FD211HpChiCha(1,ICH3,INe3)*MassHpm(ICH4)**2*MNeu(INe3)+
     &  CF11F12S3L(INe3,ICH4)*CS1S3S3(i,ICH4,ICH3)*
     &  (DCONJG(CF11F12S3L(INe3,ICH3))*(-FD111ChiHpCha(2,INe3,ICH3)+
     &  FD111ChiHpCha(2,INe3,ICH4)+FD111ChiHpCha(4,INe3,ICH3)-
     &  FD111ChiHpCha(4,INe3,ICH4)+FD211HpChiCha(2,ICH3,INe3)*
     &  MassHpm(ICH3)**2-FD211HpChiCha(3,ICH3,INe3)*MassHpm(ICH3)**2-
     &  FD211HpChiCha(2,ICH3,INe3)*MassHpm(ICH4)**2+
     &  FD211HpChiCha(3,ICH3,INe3)*MassHpm(ICH4)**2)+MCha*
     &  DCONJG(CF11F12S3R(INe3,ICH3))*(FD111ChiHpCha(1,INe3,ICH3)-
     &  FD111ChiHpCha(1,INe3,ICH4)+FD211HpChiCha(1,ICH3,INe3)*(-
     &  MassHpm(ICH3)**2+MassHpm(ICH4)**2))*MNeu(INe3))+
     &  CF11F12S3L(INe3,ICH3)*CS1S3S3(i,ICH3,ICH4)*
     &  (DCONJG(CF11F12S3L(INe3,ICH4))*(-FD111ChiHpCha(2,INe3,ICH3)+
     &  FD111ChiHpCha(2,INe3,ICH4)+FD111ChiHpCha(4,INe3,ICH3)-
     &  FD111ChiHpCha(4,INe3,ICH4)+FD211HpChiCha(2,ICH3,INe3)*
     &  MassHpm(ICH3)**2-FD211HpChiCha(3,ICH3,INe3)*MassHpm(ICH3)**2-
     &  FD211HpChiCha(2,ICH3,INe3)*MassHpm(ICH4)**2+
     &  FD211HpChiCha(3,ICH3,INe3)*MassHpm(ICH4)**2)+MCha*
     &  DCONJG(CF11F12S3R(INe3,ICH4))*(FD111ChiHpCha(1,INe3,ICH3)-
     &  FD111ChiHpCha(1,INe3,ICH4)+FD211HpChiCha(1,ICH3,INe3)*(-
     &  MassHpm(ICH3)**2+MassHpm(ICH4)**2))*MNeu(INe3))))/(8.*(MassHpm(ICH3)**2-MassHpm(ICH4)**2)**2)+self(i,j)
              endif
             endif
             if( Abs(MassHpm(ICH3) - MassHpm(ICH4))*Abs(-MassHpm(ICH3) + MassHpm(ICH5)) .gt. epsi) then 
              if( Abs(MassHpm(ICH4)) .gt.epsi) then 
       self(i,j)=((CS1S3S3(i,ICH4,ICH3)*CS1S3S3(j,ICH3,ICH4)+
     &  CS1S3S3(i,ICH3,ICH4)*CS1S3S3(j,ICH4,ICH3))*
     &  (CF11F12S3R(INe3,ICH4)*(DCONJG(CF11F12S3R(INe3,ICH4))*
     &  (FD111ChiHpCha(2,INe3,ICH3)-FD111ChiHpCha(2,INe3,ICH4)-
     &  FD111ChiHpCha(4,INe3,ICH3)+FD111ChiHpCha(4,INe3,ICH4)-
     &  FD211HpChiCha(2,ICH4,INe3)*MassHpm(ICH3)**2+
     &  FD211HpChiCha(3,ICH4,INe3)*MassHpm(ICH3)**2+
     &  FD211HpChiCha(2,ICH4,INe3)*MassHpm(ICH4)**2-
     &  FD211HpChiCha(3,ICH4,INe3)*MassHpm(ICH4)**2)+MCha*
     &  DCONJG(CF11F12S3L(INe3,ICH4))*(-FD111ChiHpCha(1,INe3,ICH3)+
     &  FD111ChiHpCha(1,INe3,ICH4)+FD211HpChiCha(1,ICH4,INe3)*
     &  (MassHpm(ICH3)**2-MassHpm(ICH4)**2))*MNeu(INe3))+
     &  CF11F12S3L(INe3,ICH4)*(DCONJG(CF11F12S3L(INe3,ICH4))*
     &  (FD111ChiHpCha(2,INe3,ICH3)-FD111ChiHpCha(2,INe3,ICH4)-
     &  FD111ChiHpCha(4,INe3,ICH3)+FD111ChiHpCha(4,INe3,ICH4)-
     &  FD211HpChiCha(2,ICH4,INe3)*MassHpm(ICH3)**2+
     &  FD211HpChiCha(3,ICH4,INe3)*MassHpm(ICH3)**2+
     &  FD211HpChiCha(2,ICH4,INe3)*MassHpm(ICH4)**2-
     &  FD211HpChiCha(3,ICH4,INe3)*MassHpm(ICH4)**2)+MCha*
     &  DCONJG(CF11F12S3R(INe3,ICH4))*(-FD111ChiHpCha(1,INe3,ICH3)+
     &  FD111ChiHpCha(1,INe3,ICH4)+FD211HpChiCha(1,ICH4,INe3)*
     &  (MassHpm(ICH3)**2-MassHpm(ICH4)**2))*MNeu(INe3))))/(8.*
     &  (MassHpm(ICH3)**2-MassHpm(ICH4)**2)**2)+self(i,j)
              endif
             endif
             if( Abs(-MassHpm(ICH3) + MassHpm(ICH5)) .lt. 1D-15 .AND. Abs(MassHpm(ICH3) - MassHpm(ICH4)) .lt. 1D-15) then 
              if( Abs(MassHpm(ICH3)) .gt. epsi) then 
       self(i,j)=(CS1S3S3(i,ICH3,ICH3)*CS1S3S3(j,ICH3,ICH3)*
     &  (CF11F12S3R(INe3,ICH3)*(DCONJG(CF11F12S3R(INe3,ICH3))*
     &  (FD311HpChiCha(2,ICH3,INe3)-FD311HpChiCha(5,ICH3,INe3))-MCha*
     &  DCONJG(CF11F12S3L(INe3,ICH3))*FD311HpChiCha(1,ICH3,INe3)*
     &  MNeu(INe3))+CF11F12S3L(INe3,ICH3)*(DCONJG(CF11F12S3L(INe3,ICH3)
     &  )*(FD311HpChiCha(2,ICH3,INe3)-FD311HpChiCha(5,ICH3,INe3))-MCha*
     &  DCONJG(CF11F12S3R(INe3,ICH3))*FD311HpChiCha(1,ICH3,INe3)*
     &  MNeu(INe3))))/4.+self(i,j)
              endif
             endif
           endif
       enddo 
       enddo 
       enddo 
       enddo 
c
c topo9
c
       do INH3= ihiggs,6
       do INH4= ihiggs,6
       do INH5= ihiggs,6
       do INH6= ihiggs,6
       do INH7= ihiggs,6
          if( Abs(-Mah(INH3) + Mah(INH4))*Abs(-Mah(INH3) + Mah(INH7))*Abs(-Mah(INH4) + Mah(INH7)) .gt. epsi) then
       self(i,j)=(CS1S1S1(i,INH3,INH4)*CS1S1S1(INH4,INH5,INH6)*
     &  CS1S1S1(INH5,INH6,INH7)*CS1S1S1(j,INH3,INH7)*
     &  (FD111HHH(1,INH5,INH7,INH6)*(Mah(INH3)**2-Mah(INH4)**2)+
     &  FD111HHH(1,INH3,INH5,INH6)*(Mah(INH4)**2-Mah(INH7)**2)+
     &  FD111HHH(1,INH4,INH5,INH6)*(-Mah(INH3)**2+Mah(INH7)**2)))/(32.*
     &  (Mah(INH3)-Mah(INH4))*(Mah(INH3)+Mah(INH4))*(Mah(INH3)-
     &  Mah(INH7))*(Mah(INH4)-Mah(INH7))*(Mah(INH3)+Mah(INH7))*
     &  (Mah(INH4)+Mah(INH7)))+self(i,j)

           else
             if( Abs(-Mah(INH3) + Mah(INH7))*Abs(-Mah(INH4) + Mah(INH7)) .gt. epsi) then 
              if( Abs(Mah(INH3)) .gt. epsi) then 
       self(i,j)=(CS1S1S1(i,INH3,INH3)*CS1S1S1(INH3,INH5,INH6)*
     &  CS1S1S1(INH5,INH6,INH7)*CS1S1S1(j,INH3,INH7)*(-
     &  FD111HHH(1,INH3,INH5,INH6)+FD111HHH(1,INH5,INH7,INH6)+
     &  FD211HHH(1,INH3,INH5,INH6)*(Mah(INH3)**2-Mah(INH7)**2)))/(32.*
     &  (Mah(INH3)**2-Mah(INH7)**2)**2)+self(i,j)

              endif
             endif
             if( Abs(-Mah(INH3) + Mah(INH4))*Abs(-Mah(INH4) + Mah(INH7)) .gt. epsi) then 
              if( Abs(Mah(INH3)) .gt. epsi) then 
       self(i,j)=(CS1S1S1(i,INH3,INH4)*CS1S1S1(INH4,INH5,INH6)*
     &  CS1S1S1(INH5,INH6,INH3)*CS1S1S1(j,INH3,INH3)*(-
     &  FD111HHH(1,INH3,INH5,INH6)+FD111HHH(1,INH4,INH5,INH6)+
     &  FD211HHH(1,INH3,INH5,INH6)*(Mah(INH3)**2-Mah(INH4)**2)))/(32.*
     &  (Mah(INH3)**2-Mah(INH4)**2)**2)+self(i,j)
              endif
             endif
             if( Abs(Mah(INH3) - Mah(INH4))*Abs(-Mah(INH3) + Mah(INH7)) .gt. epsi) then 
              if( Abs(Mah(INH4)) .gt. epsi) then 
       self(i,j)=(CS1S1S1(i,INH3,INH4)*CS1S1S1(INH4,INH5,INH6)*
     &  CS1S1S1(INH5,INH6,INH4)*CS1S1S1(j,INH3,INH4)*
     &  (FD111HHH(1,INH3,INH5,INH6)-FD111HHH(1,INH4,INH5,INH6)+
     &  FD211HHH(1,INH4,INH5,INH6)*(-Mah(INH3)**2+Mah(INH4)**2)))/(32.*
     &  (Mah(INH3)**2-Mah(INH4)**2)**2)+self(i,j)

              endif
             endif
             if( Abs(-Mah(INH3) + Mah(INH7)) .lt. 1D-15 .AND. Abs(Mah(INH3) - Mah(INH4)) .lt. 1D-15) then 
              if( Abs(Mah(INH3)) .gt.epsi) then 
                 if(Mah2(INH3) .ge. 1D-5)then
       self(i,j)=(CS1S1S1(i,INH3,INH3)*CS1S1S1(INH3,INH5,INH6)*
     &  CS1S1S1(INH5,INH6,INH3)*CS1S1S1(j,INH3,INH3)*
     &  FD311HHH(1,INH3,INH5,INH6))/32.+self(i,j)
                 else
       selfSP(i,j)=selfSP(i,j) !to avoid numerical problem 
       self(i,j)=self(i,j)
                endif              
              endif
             endif
           endif
       enddo 
       enddo 
       enddo 
       enddo 
       enddo 


       do ICH3=1,2
       do ICH4=1,2
       do INH3= ihiggs,6
       do INH4= ihiggs,6
       do INH5= ihiggs,6
          if( Abs(-Mah(INH3) + Mah(INH4))*Abs(-Mah(INH3) + Mah(INH5))*Abs(-Mah(INH4) + Mah(INH5)) .gt. epsi) then 
       self(i,j)=(CS1S1S1(i,INH3,INH4)*CS1S1S1(j,INH3,INH5)*
     &  CS1S3S3(INH4,ICH4,ICH3)*CS1S3S3(INH5,ICH3,ICH4)*
     &  (FD111HHpHp(1,INH5,ICH3,ICH4)*(Mah(INH3)**2-Mah(INH4)**2)+
     &  FD111HHpHp(1,INH3,ICH3,ICH4)*(Mah(INH4)**2-Mah(INH5)**2)+
     &  FD111HHpHp(1,INH4,ICH3,ICH4)*(-Mah(INH3)**2+Mah(INH5)**2)))
     &  /(16.*(Mah(INH3)-Mah(INH4))*(Mah(INH3)+Mah(INH4))*(Mah(INH3)-
     &  Mah(INH5))*(Mah(INH4)-Mah(INH5))*(Mah(INH3)+Mah(INH5))*
     &  (Mah(INH4)+Mah(INH5)))+self(i,j)
           else
             if( Abs(-Mah(INH3) + Mah(INH5))*Abs(-Mah(INH4) + Mah(INH5)) .gt. epsi) then 
              if( Abs(Mah(INH3)) .gt. epsi) then 
       self(i,j)=(CS1S1S1(i,INH3,INH3)*CS1S1S1(j,INH3,INH5)*
     &  CS1S3S3(INH3,ICH4,ICH3)*CS1S3S3(INH5,ICH3,ICH4)*(-
     &  FD111HHpHp(1,INH3,ICH3,ICH4)+FD111HHpHp(1,INH5,ICH3,ICH4)+
     &  FD211HHpHp(1,INH3,ICH3,ICH4)*(Mah(INH3)**2-Mah(INH5)**2)))
     &  /(16.*(Mah(INH3)**2-Mah(INH5)**2)**2)+self(i,j)
              endif
             endif
             if( Abs(-Mah(INH3) + Mah(INH4))*Abs(-Mah(INH4) + Mah(INH5)) .gt.epsi) then 
              if( Abs(Mah(INH3)) .gt. epsi) then 
       self(i,j)=(CS1S1S1(i,INH3,INH4)*CS1S1S1(j,INH3,INH3)*
     &  CS1S3S3(INH3,ICH3,ICH4)*CS1S3S3(INH4,ICH4,ICH3)*(-
     &  FD111HHpHp(1,INH3,ICH3,ICH4)+FD111HHpHp(1,INH4,ICH3,ICH4)+
     &  FD211HHpHp(1,INH3,ICH3,ICH4)*(Mah(INH3)**2-Mah(INH4)**2)))
     &  /(16.*(Mah(INH3)**2-Mah(INH4)**2)**2)+self(i,j)
              endif
             endif
             if( Abs(Mah(INH3) - Mah(INH4))*Abs(-Mah(INH3) + Mah(INH5)) .gt. epsi) then 
              if( Abs(Mah(INH4)) .gt.epsi) then 
       self(i,j)=(CS1S1S1(i,INH3,INH4)*CS1S1S1(j,INH3,INH4)*
     &  CS1S3S3(INH4,ICH3,ICH4)*CS1S3S3(INH4,ICH4,ICH3)*
     &  (FD111HHpHp(1,INH3,ICH3,ICH4)-FD111HHpHp(1,INH4,ICH3,ICH4)+
     &  FD211HHpHp(1,INH4,ICH3,ICH4)*(-Mah(INH3)**2+Mah(INH4)**2)))
     &  /(16.*(Mah(INH3)**2-Mah(INH4)**2)**2)+self(i,j)
              endif
             endif
             if( Abs(-Mah(INH3) + Mah(INH5)) .lt. 1D-15 .AND. Abs(Mah(INH3) - Mah(INH4)) .lt. 1D-15) then 
              if( Abs(Mah(INH3)) .gt.epsi) then 
                 if(Mah2(INH3) .ge. 1D-5)then
       self(i,j)=(CS1S1S1(i,INH3,INH3)*CS1S1S1(j,INH3,INH3)*
     &  CS1S3S3(INH3,ICH3,ICH4)*CS1S3S3(INH3,ICH4,ICH3)*
     &  FD311HHpHp(1,INH3,ICH3,ICH4))/16.+self(i,j)
                 else
       selfSP(i,j)=selfSP(i,j) !to avoid numerical problem 
       self(i,j)=self(i,j)
                endif    
              endif
             endif
           endif
       enddo 
       enddo 
       enddo 
       enddo 
       enddo 
       do ICH3=1,2
       do ICH4=1,2
       do ICH5=1,2
       do ICH6=1,2
       do INH3= ihiggs,6
          if( Abs(-MassHpm(ICH3) + MassHpm(ICH4))*Abs(-MassHpm(ICH3) + MassHpm(ICH6))*Abs(-MassHpm(ICH4) + MassHpm(ICH6)) .gt.epsi) then 
       self(i,j)=((CS1S3S3(i,ICH4,ICH3)*CS1S3S3(INH3,ICH5,ICH4)*
     &  CS1S3S3(INH3,ICH6,ICH5)*CS1S3S3(j,ICH3,ICH6)+
     &  CS1S3S3(i,ICH3,ICH4)*CS1S3S3(INH3,ICH4,ICH5)*
     &  CS1S3S3(INH3,ICH5,ICH6)*CS1S3S3(j,ICH6,ICH3))*
     &  (FD111HHpHp(1,INH3,ICH6,ICH5)*(MassHpm(ICH3)**2-MassHpm(ICH4)**
     &  2)+FD111HHpHp(1,INH3,ICH3,ICH5)*(MassHpm(ICH4)**2-MassHpm(ICH6)
     &  **2)+FD111HHpHp(1,INH3,ICH4,ICH5)*(-MassHpm(ICH3)**2+
     &  MassHpm(ICH6)**2)))/(16.*(MassHpm(ICH3)-MassHpm(ICH4))*
     &  (MassHpm(ICH3)+MassHpm(ICH4))*(MassHpm(ICH3)-MassHpm(ICH6))*
     &  (MassHpm(ICH4)-MassHpm(ICH6))*(MassHpm(ICH3)+MassHpm(ICH6))*
     &  (MassHpm(ICH4)+MassHpm(ICH6)))+self(i,j)
           else
             if( Abs(-MassHpm(ICH3) + MassHpm(ICH6))*Abs(-MassHpm(ICH4) + MassHpm(ICH6)) .gt. epsi) then 
              if( Abs(MassHpm(ICH3)) .gt.epsi) then 
       self(i,j)=(CS1S3S3(i,ICH3,ICH3)*(CS1S3S3(INH3,ICH5,ICH3)*
     &  CS1S3S3(INH3,ICH6,ICH5)*CS1S3S3(j,ICH3,ICH6)+
     &  CS1S3S3(INH3,ICH3,ICH5)*CS1S3S3(INH3,ICH5,ICH6)*
     &  CS1S3S3(j,ICH6,ICH3))*(-FD111HHpHp(1,INH3,ICH3,ICH5)+
     &  FD111HHpHp(1,INH3,ICH6,ICH5)+FD211HpHHp(1,ICH3,INH3,ICH5)*
     &  (MassHpm(ICH3)**2-MassHpm(ICH6)**2)))/(16.*(MassHpm(ICH3)**2-
     &  MassHpm(ICH6)**2)**2)+self(i,j)
              endif
             endif
             if( Abs(-MassHpm(ICH3) + MassHpm(ICH4))*Abs(-MassHpm(ICH4) + MassHpm(ICH6)) .gt. epsi) then 
              if( Abs(MassHpm(ICH3)) .gt. epsi) then 
       self(i,j)=((CS1S3S3(i,ICH3,ICH4)*CS1S3S3(INH3,ICH4,ICH5)*
     &  CS1S3S3(INH3,ICH5,ICH3)+CS1S3S3(i,ICH4,ICH3)*
     &  CS1S3S3(INH3,ICH3,ICH5)*CS1S3S3(INH3,ICH5,ICH4))*
     &  CS1S3S3(j,ICH3,ICH3)*(-FD111HHpHp(1,INH3,ICH3,ICH5)+
     &  FD111HHpHp(1,INH3,ICH4,ICH5)+FD211HpHHp(1,ICH3,INH3,ICH5)*
     &  (MassHpm(ICH3)**2-MassHpm(ICH4)**2)))/(16.*(MassHpm(ICH3)**2-
     &  MassHpm(ICH4)**2)**2)+self(i,j)
              endif
             endif
             if( Abs(MassHpm(ICH3) - MassHpm(ICH4))*Abs(-MassHpm(ICH3) + MassHpm(ICH6)) .gt. epsi) then 
              if( Abs(MassHpm(ICH4)) .gt. epsi) then 
       self(i,j)=(CS1S3S3(INH3,ICH4,ICH5)*CS1S3S3(INH3,ICH5,ICH4)*
     &  (CS1S3S3(i,ICH4,ICH3)*CS1S3S3(j,ICH3,ICH4)+CS1S3S3(i,ICH3,ICH4)
     &  *CS1S3S3(j,ICH4,ICH3))*(FD111HHpHp(1,INH3,ICH3,ICH5)-
     &  FD111HHpHp(1,INH3,ICH4,ICH5)+FD211HpHHp(1,ICH4,INH3,ICH5)*(-
     &  MassHpm(ICH3)**2+MassHpm(ICH4)**2)))/(16.*(MassHpm(ICH3)**2-
     &  MassHpm(ICH4)**2)**2)+self(i,j)
              endif
             endif
             if( Abs(-MassHpm(ICH3) + MassHpm(ICH6)) .lt. 1D-15 .AND. Abs(MassHpm(ICH3) - MassHpm(ICH4)) .lt. 1D-15) then 
              if( Abs(MassHpm(ICH3)) .gt. epsi) then 
                 if( Abs(MassHpm(ICH3)**2) .gt. 1D-5) then
       self(i,j)=(CS1S3S3(i,ICH3,ICH3)*CS1S3S3(INH3,ICH3,ICH5)*
     &  CS1S3S3(INH3,ICH5,ICH3)*CS1S3S3(j,ICH3,ICH3)*
     &  FD311HpHHp(1,ICH3,INH3,ICH5))/8.+self(i,j)
                 else
       selfSP(i,j)=selfSP(i,j) !to avoid numerical problem 
       self(i,j)=self(i,j)
                endif    
              endif
             endif
           endif
       enddo 
       enddo 
       enddo 
       enddo 
       enddo 
       do INH3= ihiggs,6
       do INH4= ihiggs,6
       do INH5= ihiggs,6
       do ISt3=1,2
       do ISt4=1,2
          if( Abs(-Mah(INH3) + Mah(INH4))*Abs(-Mah(INH3) + Mah(INH5))*Abs(-Mah(INH4) + Mah(INH5)) .gt. epsi) then 
       self(i,j)=(3*CS1S1S1(i,INH3,INH4)*CS1S1S1(j,INH3,INH5)*
     &  CSSS(INH4,ISt4,ISt3)*CSSS(INH5,ISt3,ISt4)*
     &  (FD111HSTST(1,INH5,ISt3,ISt4)*(Mah(INH3)**2-Mah(INH4)**2)+
     &  FD111HSTST(1,INH3,ISt3,ISt4)*(Mah(INH4)**2-Mah(INH5)**2)+
     &  FD111HSTST(1,INH4,ISt3,ISt4)*(-Mah(INH3)**2+Mah(INH5)**2)))
     &  /(16.*(Mah(INH3)-Mah(INH4))*(Mah(INH3)+Mah(INH4))*(Mah(INH3)-
     &  Mah(INH5))*(Mah(INH4)-Mah(INH5))*(Mah(INH3)+Mah(INH5))*
     &  (Mah(INH4)+Mah(INH5)))+self(i,j)
           else
             if( Abs(-Mah(INH3) + Mah(INH5))*Abs(-Mah(INH4) + Mah(INH5)) .gt. epsi) then 
              if( Abs(Mah(INH3)) .gt.epsi) then 
       self(i,j)=(3*CS1S1S1(i,INH3,INH3)*CS1S1S1(j,INH3,INH5)*
     &  CSSS(INH3,ISt4,ISt3)*CSSS(INH5,ISt3,ISt4)*(-
     &  FD111HSTST(1,INH3,ISt3,ISt4)+FD111HSTST(1,INH5,ISt3,ISt4)+
     &  FD211HSTST(1,INH3,ISt3,ISt4)*(Mah(INH3)**2-Mah(INH5)**2)))
     &  /(16.*(Mah(INH3)**2-Mah(INH5)**2)**2)+self(i,j)
              endif
             endif
             if( Abs(-Mah(INH3) + Mah(INH4))*Abs(-Mah(INH4) + Mah(INH5)) .gt. epsi) then 
              if( Abs(Mah(INH3)) .gt. epsi) then 
       self(i,j)=(3*CS1S1S1(i,INH3,INH4)*CS1S1S1(j,INH3,INH3)*
     &  CSSS(INH3,ISt3,ISt4)*CSSS(INH4,ISt4,ISt3)*(-
     &  FD111HSTST(1,INH3,ISt3,ISt4)+FD111HSTST(1,INH4,ISt3,ISt4)+
     &  FD211HSTST(1,INH3,ISt3,ISt4)*(Mah(INH3)**2-Mah(INH4)**2)))
     &  /(16.*(Mah(INH3)**2-Mah(INH4)**2)**2)+self(i,j)
              endif
             endif
             if( Abs(Mah(INH3) - Mah(INH4))*Abs(-Mah(INH3) + Mah(INH5)) .gt. epsi) then 
              if( Abs(Mah(INH4)) .gt. epsi) then 
       self(i,j)=(3*CS1S1S1(i,INH3,INH4)*CS1S1S1(j,INH3,INH4)*
     &  CSSS(INH4,ISt3,ISt4)*CSSS(INH4,ISt4,ISt3)*
     &  (FD111HSTST(1,INH3,ISt3,ISt4)-FD111HSTST(1,INH4,ISt3,ISt4)+
     &  FD211HSTST(1,INH4,ISt3,ISt4)*(-Mah(INH3)**2+Mah(INH4)**2)))
     &  /(16.*(Mah(INH3)**2-Mah(INH4)**2)**2)+self(i,j)
              endif
             endif
             if( Abs(-Mah(INH3) + Mah(INH5)) .lt. 1D-15 .AND. Abs(Mah(INH3) - Mah(INH4)) .lt. 1D-15) then 
              if( Abs(Mah(INH3)) .gt. epsi) then 
                if( Abs(Mah2(INH3)) .gt. 1D-5) then        
       self(i,j)=(3*CS1S1S1(i,INH3,INH3)*CS1S1S1(j,INH3,INH3)*
     &  CSSS(INH3,ISt3,ISt4)*CSSS(INH3,ISt4,ISt3)*
     &  FD311HSTST(1,INH3,ISt3,ISt4))/16.+self(i,j)
                 else
       selfSP(i,j)=selfSP(i,j) !to avoid numerical problem 
       self(i,j)=self(i,j)
                endif    
              endif
             endif
           endif
       enddo 
       enddo 
       enddo 
       enddo 
       enddo 
       do ICH3=1,2
       do ICH4=1,2
       do ICH5=1,2
       do ISt3=1,2
          if( Abs(-MassHpm(ICH3) + MassHpm(ICH4))*Abs(-MassHpm(ICH3) + MassHpm(ICH5))*Abs(-MassHpm(ICH4) + MassHpm(ICH5)) .gt. epsi) then 
       self(i,j)=(3*(CS1S3S3(i,ICH4,ICH3)*CS1S3S3(j,ICH3,ICH5)*
     &  CS3S13S(ICH5,ISt3)*CS3S13SC(ICH4,ISt3)+CS1S3S3(i,ICH3,ICH4)*
     &  CS1S3S3(j,ICH5,ICH3)*CS3S13S(ICH4,ISt3)*CS3S13SC(ICH5,ISt3))*
     &  (FD111HpSTSB(1,ICH5,ISt3)*(MassHpm(ICH3)**2-MassHpm(ICH4)**2)+
     &  FD111HpSTSB(1,ICH3,ISt3)*(MassHpm(ICH4)**2-MassHpm(ICH5)**2)+
     &  FD111HpSTSB(1,ICH4,ISt3)*(-MassHpm(ICH3)**2+MassHpm(ICH5)**2)))
     &  /(16.*(MassHpm(ICH3)-MassHpm(ICH4))*(MassHpm(ICH3)+
     &  MassHpm(ICH4))*(MassHpm(ICH3)-MassHpm(ICH5))*(MassHpm(ICH4)-
     &  MassHpm(ICH5))*(MassHpm(ICH3)+MassHpm(ICH5))*(MassHpm(ICH4)+
     &  MassHpm(ICH5)))+self(i,j)
           else
             if( Abs(-MassHpm(ICH3) + MassHpm(ICH5))*Abs(-MassHpm(ICH4) + MassHpm(ICH5)) .gt. 1D-15) then 
              if( Abs(MassHpm(ICH3)) .gt. epsi) then 
       self(i,j)=(3*CS1S3S3(i,ICH3,ICH3)*(CS1S3S3(j,ICH3,ICH5)*
     &  CS3S13S(ICH5,ISt3)*CS3S13SC(ICH3,ISt3)+CS1S3S3(j,ICH5,ICH3)*
     &  CS3S13S(ICH3,ISt3)*CS3S13SC(ICH5,ISt3))*(-
     &  FD111HpSTSB(1,ICH3,ISt3)+FD111HpSTSB(1,ICH5,ISt3)+
     &  FD211HpSTSB(1,ICH3,ISt3)*(MassHpm(ICH3)**2-MassHpm(ICH5)**2)))
     &  /(16.*(MassHpm(ICH3)**2-MassHpm(ICH5)**2)**2)+self(i,j)
              endif
             endif
             if( Abs(-MassHpm(ICH3) + MassHpm(ICH4))*Abs(-MassHpm(ICH4) + MassHpm(ICH5)) .gt. 1D-15) then 
              if( Abs(MassHpm(ICH3)) .gt. epsi) then 
       self(i,j)=(3*CS1S3S3(j,ICH3,ICH3)*(CS1S3S3(i,ICH3,ICH4)*
     &  CS3S13S(ICH4,ISt3)*CS3S13SC(ICH3,ISt3)+CS1S3S3(i,ICH4,ICH3)*
     &  CS3S13S(ICH3,ISt3)*CS3S13SC(ICH4,ISt3))*(-
     &  FD111HpSTSB(1,ICH3,ISt3)+FD111HpSTSB(1,ICH4,ISt3)+
     &  FD211HpSTSB(1,ICH3,ISt3)*(MassHpm(ICH3)**2-MassHpm(ICH4)**2)))
     &  /(16.*(MassHpm(ICH3)**2-MassHpm(ICH4)**2)**2)+self(i,j)
              endif
             endif
             if( Abs(MassHpm(ICH3) - MassHpm(ICH4))*Abs(-MassHpm(ICH3) + MassHpm(ICH5)) .gt. 1D-15) then 
              if( Abs(MassHpm(ICH4)) .gt. 1D-15) then 
       self(i,j)=(3*(CS1S3S3(i,ICH4,ICH3)*CS1S3S3(j,ICH3,ICH4)+
     &  CS1S3S3(i,ICH3,ICH4)*CS1S3S3(j,ICH4,ICH3))*CS3S13S(ICH4,ISt3)*
     &  CS3S13SC(ICH4,ISt3)*(FD111HpSTSB(1,ICH3,ISt3)-
     &  FD111HpSTSB(1,ICH4,ISt3)+FD211HpSTSB(1,ICH4,ISt3)*(-
     &  MassHpm(ICH3)**2+MassHpm(ICH4)**2)))/(16.*(MassHpm(ICH3)**2-
     &  MassHpm(ICH4)**2)**2)+self(i,j)
              endif
             endif
             if( Abs(-MassHpm(ICH3) + MassHpm(ICH5)) .lt. 1D-15 .AND. Abs(MassHpm(ICH3) - MassHpm(ICH4)) .lt. 1D-15) then 
              if( Abs(MassHpm(ICH3)) .gt. 1D-15) then 
                 if( Abs(MassHpm(ICH3)**2) .gt.epsi) then        
       self(i,j)=(3*CS1S3S3(i,ICH3,ICH3)*CS1S3S3(j,ICH3,ICH3)*
     &  CS3S13S(ICH3,ISt3)*CS3S13SC(ICH3,ISt3)*FD311HpSTSB(1,ICH3,ISt3)
     &  )/8.+self(i,j)
                 else
       selfSP(i,j)=selfSP(i,j) !to avoid numerical problem 
       self(i,j)=self(i,j)
                endif  
              endif
             endif
           endif
       enddo 
       enddo 
       enddo 
       enddo 
        self(i,j)=self(i,j)*fac
        selfCT(i,j)=selfCT(i,j)*fac1
        self(i,j)=self(i,j)+selfCT(i,j)
        self(j,i)=self(i,j)
       enddo
      enddo
c
c topo10
c
#ifdef printMT4
      Write(16,110) "TwoLoopNeutralSelGBC[SUM][Nhung]={{(",DBLE(self(1,1)),"),(" ,DBLE(self(1,2)),"),("   ,
     &   DBLE(self(1,3)),"),(" , DBLE(self(1,4)),"),(",
     &   DBLE(self(1,5)),"),(",DBLE(self(1,6)),")},{("   
       do i=2,5
      Write(16,111) DBLE(self(i,1)),"),(" ,DBLE(self(i,2)),"),("   ,
     &   DBLE(self(i,3)),"),(" , DBLE(self(i,4)),"),(",
     &   DBLE(self(i,5)),"),(",DBLE(self(i,6)),")},{("
       enddo
       i=6
      Write(16,111) DBLE(self(i,1)),"),(" ,DBLE(self(i,2)),"),("   ,
     &   DBLE(self(i,3)),"),(" , DBLE(self(i,4)),"),(",
     &   DBLE(self(i,5)),"),(",DBLE(self(i,6)),")}};"
110   format(A,F24.14,A,F24.14,A,F24.14,A,F24.14,A,F24.14,A,F24.14,A )   
111   format(F24.14,A,F24.14,A,F24.14,A, F24.14,A,F24.14,A,F24.14,A )  
#endif
      do i=1,6
       do j=1,6 
       selfIN(i,j)=0D0
      do gen3=1,6
        do gen2=1,6
       selfIN(i,j)=selfIN(i,j) + ZH(gen2, i)*ZH(gen3, j)* self(gen2,gen3)
        enddo
      enddo
        enddo
      enddo


c       stop
      end subroutine UnselfHH_atlambda1

c
c======================================================================
c
      subroutine UnselfHH_atlambda2(selfIN)
      implicit none
      integer i,j,gen2,gen3
      double precision fac,MSQ,A0T,fac1,selfIN(6,6)
      double complex selfDP(6,6),selfSP(6,6),self(6,6)
      double complex selfCTDP(6,6),selfCTSP(6,6),selfCT(6,6)
#include "TLMT4.h"
#include "TLMT4lambda.h"
      fac=1D0/16D0/Pi**4
      fac1=1D0/16D0/Pi**2
      self(1:6,1:6) =0D0;  selfSP(1:6,1:6) =0D0;  selfDP(1:6,1:6) =0D0
      selfCT(1:6,1:6) =0D0;  selfCTSP(1:6,1:6) =0D0;  selfCTDP(1:6,1:6) =0D0
      MSQ=Sqrt(MSQ2)

      do i=ihiggs,ihiggse
      do j=i,ihiggse
       do INH3=ihiggs,6
       do INH4=ihiggs,6
       do INH5=ihiggs,6
              if( Mah(INH3)*Mah(INH4) + Mah(INH3)*Mah(INH5) + Mah(INH4)*Mah(INH5) .lt. 1D-15) then 
       selfCT(i,j)=(CS1S1S1(i,INH3,INH5)*CS1S1S1(j,INH4,INH5)*(-2*
     &  (aBEpTNH(INH4,INH5)*dZHiggs1(INH3,INH4,1)+aB0TNH(INH4,INH5)*
     &  dZHiggs1(INH3,INH4,2)+dZHiggs1(INH3,INH4,3))+
     &  aCEpTNH(INH3,INH4,INH5)*(2*dMH1MT4(INH3,INH4,1)+
     &  dZHiggs1(INH3,INH4,1)*(-Mah2(INH3)+Mah2(INH4)))+
     &  aC0TNH(INH3,INH4,INH5)*(2*dMH1MT4(INH3,INH4,2)+
     &  dZHiggs1(INH3,INH4,2)*(-Mah2(INH3)+Mah2(INH4)))))/2.+selfCT(i,j)
              endif
       enddo 
       enddo 
       enddo 

        
       do ICH3=1,2
       do ICH4=1,2
       do ICH5=1,2
         if( MassHpm(ICH3)*MassHpm(ICH4) + MassHpm(ICH3)*MassHpm(ICH5) + MassHpm(ICH4)*MassHpm(ICH5) .lt. 1D-15) then 
       selfCT(i,j)=(-2*(CS1S3S3(i,ICH3,ICH5)*CS1S3S3(j,ICH5,ICH4)*
     &  dZCHiggs1(ICH3,ICH4,3)+aBEpTCH(ICH4,ICH5)*(CS1S3S3(i,ICH3,ICH5)
     &  *CS1S3S3(j,ICH5,ICH4)*dZCHiggs1(ICH3,ICH4,1)+
     &  CS1S3S3(i,ICH5,ICH3)*CS1S3S3(j,ICH4,ICH5)*
     &  dZCHiggs1(ICH4,ICH3,1))+aB0TCH(ICH4,ICH5)*(CS1S3S3(i,ICH3,ICH5)
     &  *CS1S3S3(j,ICH5,ICH4)*dZCHiggs1(ICH3,ICH4,2)+
     &  CS1S3S3(i,ICH5,ICH3)*CS1S3S3(j,ICH4,ICH5)*
     &  dZCHiggs1(ICH4,ICH3,2))+CS1S3S3(i,ICH5,ICH3)*
     &  CS1S3S3(j,ICH4,ICH5)*dZCHiggs1(ICH4,ICH3,3))+
     &  aCEpTCH(ICH3,ICH4,ICH5)*(CS1S3S3(i,ICH3,ICH5)*
     &  CS1S3S3(j,ICH5,ICH4)*(2*dMCH1L(ICH3,ICH4,1)+
     &  dZCHiggs1(ICH3,ICH4,1)*(-MassHpm(ICH3)**2+MassHpm(ICH4)**2))+
     &  CS1S3S3(i,ICH5,ICH3)*CS1S3S3(j,ICH4,ICH5)*(2*
     &  dMCH1L(ICH4,ICH3,1)+dZCHiggs1(ICH4,ICH3,1)*(-MassHpm(ICH3)**2+
     &  MassHpm(ICH4)**2)))+aC0TCH(ICH3,ICH4,ICH5)*
     &  (CS1S3S3(i,ICH3,ICH5)*CS1S3S3(j,ICH5,ICH4)*(2*
     &  dMCH1L(ICH3,ICH4,2)+dZCHiggs1(ICH3,ICH4,2)*(-MassHpm(ICH3)**2+
     &  MassHpm(ICH4)**2))+CS1S3S3(i,ICH5,ICH3)*CS1S3S3(j,ICH4,ICH5)*
     &  (2*dMCH1L(ICH4,ICH3,2)+dZCHiggs1(ICH4,ICH3,2)*(-MassHpm(ICH3)**
     &  2+MassHpm(ICH4)**2))))/2.+selfCT(i,j)
         endif
       enddo 
       enddo 
       enddo
c
c CTtopo2
c
       INH3=6
       INH4=6
       selfCT(i,j)=(CS1S1S1(j,INH3,INH4)*dCS1S1S1(i,INH3,INH4,3)+
     &  aBEpTNH(INH3,INH4)*(CS1S1S1(j,INH3,INH4)*
     &  dCS1S1S1(i,INH3,INH4,1)+CS1S1S1(i,INH3,INH4)*
     &  dCS1S1S1(j,INH3,INH4,1))+aB0TNH(INH3,INH4)*
     &  (CS1S1S1(j,INH3,INH4)*dCS1S1S1(i,INH3,INH4,2)+
     &  CS1S1S1(i,INH3,INH4)*dCS1S1S1(j,INH3,INH4,2))+
     &  CS1S1S1(i,INH3,INH4)*dCS1S1S1(j,INH3,INH4,3))/2.+selfCT(i,j)


       ICH3=1
       ICH4=1
       selfCT(i,j)=(CS1S3S3(j,ICH4,ICH3)*dCS1S3S3(i,ICH3,ICH4,3)+
     &  aBEpTCH(ICH3,ICH4)*(CS1S3S3(j,ICH4,ICH3)*
     &  dCS1S3S3(i,ICH3,ICH4,1)+CS1S3S3(i,ICH3,ICH4)*
     &  dCS1S3S3(j,ICH4,ICH3,1))+aB0TCH(ICH3,ICH4)*
     &  (CS1S3S3(j,ICH4,ICH3)*dCS1S3S3(i,ICH3,ICH4,2)+
     &  CS1S3S3(i,ICH3,ICH4)*dCS1S3S3(j,ICH4,ICH3,2))+
     &  CS1S3S3(i,ICH3,ICH4)*dCS1S3S3(j,ICH4,ICH3,3))+selfCT(i,j)

c
c CTtopo5+8
c
        INH3=6
        INH4=6        
       do INH5=ihiggs,6
       do INH6=ihiggs,6
       self(i,j)=-((aB0TNH(INH3,INH4)*aB0TNH(INH5,INH6)+
     &  aBEpTNH(INH3,INH4)+aBEpTNH(INH5,INH6))*CS1S1S1(i,INH3,INH4)*
     &  CS1S1S1(j,INH5,INH6)*CS1S1S1S1(INH3,INH4,INH5,INH6))/64.+
     &  self(i,j)
       enddo 
       enddo
c! 
        INH5=6
        INH6=6        
       do INH3=ihiggs,6
       do INH4=ihiggs,6
              if( Mah(INH3) + Mah(INH4) .gt. 1D-15) then 
       self(i,j)=-((aB0TNH(INH3,INH4)*aB0TNH(INH5,INH6)+
     &  aBEpTNH(INH3,INH4)+aBEpTNH(INH5,INH6))*CS1S1S1(i,INH3,INH4)*
     &  CS1S1S1(j,INH5,INH6)*CS1S1S1S1(INH3,INH4,INH5,INH6))/64.+
     &  self(i,j)
              endif
       enddo 
       enddo 
c!
        INH3=6
        INH4=6      
       do ICH3=1,2
       do ICH4=1,2
       self(i,j)=-((aB0TCH(ICH3,ICH4)*aB0TNH(INH3,INH4)+
     &  aBEpTCH(ICH3,ICH4)+aBEpTNH(INH3,INH4))*
     &  CS1S1S3S3(INH3,INH4,ICH4,ICH3)*(CS1S1S1(j,INH3,INH4)*
     &  CS1S3S3(i,ICH3,ICH4)+CS1S1S1(i,INH3,INH4)*CS1S3S3(j,ICH3,ICH4))
     &  )/32.+self(i,j)
       enddo 
       enddo 
c!
        ICH3=1
        ICH4=1
       do INH3=ihiggs,6
       do INH4=ihiggs,6
              if( Mah(INH3) + Mah(INH4) .gt. 1D-15) then 
       self(i,j)=-((aB0TCH(ICH3,ICH4)*aB0TNH(INH3,INH4)+
     &  aBEpTCH(ICH3,ICH4)+aBEpTNH(INH3,INH4))*
     &  CS1S1S3S3(INH3,INH4,ICH4,ICH3)*(CS1S1S1(j,INH3,INH4)*
     &  CS1S3S3(i,ICH3,ICH4)+CS1S1S1(i,INH3,INH4)*CS1S3S3(j,ICH3,ICH4))
     &  )/32.+self(i,j)
              endif
       enddo 
       enddo 
c!
        ICH3=1
        ICH4=1       
       do ICH5=1,2
       do ICH6=1,2
       self(i,j)=-((aB0TCH(ICH3,ICH4)*aB0TCH(ICH5,ICH6)+
     &  aBEpTCH(ICH3,ICH4)+aBEpTCH(ICH5,ICH6))*CS1S3S3(i,ICH3,ICH4)*
     &  CS1S3S3(j,ICH5,ICH6)*CS3S3S3S3(ICH4,ICH6,ICH3,ICH5))/16.+
     &  self(i,j)
       enddo 
       enddo 
c!
        ICH5=1
        ICH6=1      
       do ICH3=1,2
       do ICH4=1,2
              if( MassHpm(ICH3) + MassHpm(ICH4) .gt. 1D-15) then 
       self(i,j)=-((aB0TCH(ICH3,ICH4)*aB0TCH(ICH5,ICH6)+
     &  aBEpTCH(ICH3,ICH4)+aBEpTCH(ICH5,ICH6))*CS1S3S3(i,ICH3,ICH4)*
     &  CS1S3S3(j,ICH5,ICH6)*CS3S3S3S3(ICH4,ICH6,ICH3,ICH5))/16.+
     &  self(i,j)
              endif
       enddo 
       enddo 
c!
        INH3=6
        INH4=6      
       do ISt3=1,2
       do ISt4=1,2
       self(i,j)=(-3*(aB0T1(ISt3,ISt4)*aB0TNH(INH3,INH4)+
     &  aBEpT1(ISt3,ISt4)+aBEpTNH(INH3,INH4))*(CS1S1S1(j,INH3,INH4)*
     &  CSSS(i,ISt3,ISt4)+CS1S1S1(i,INH3,INH4)*CSSS(j,ISt3,ISt4))*
     &  CSSSS(INH3,INH4,ISt4,ISt3))/32.+self(i,j)
       enddo 
       enddo 
c! 
        ICH3=1
        ICH4=1       
       do ISt3=1,2
       do ISt4=1,2
       self(i,j)=(-3*(aB0T1(ISt3,ISt4)*aB0TCH(ICH3,ICH4)+
     &  aBEpT1(ISt3,ISt4)+aBEpTCH(ICH3,ICH4))*
     &  CS3S3S13S13(ICH4,ICH3,ISt4,ISt3)*(CS1S3S3(j,ICH3,ICH4)*
     &  CSSS(i,ISt3,ISt4)+CS1S3S3(i,ICH3,ICH4)*CSSS(j,ISt3,ISt4)))/16.+
     &  self(i,j)
       enddo 
       enddo 
c
c topo12
c
        Do INH3=ihiggs,6
        Do INH4=ihiggs,6
        Do INH5=ihiggs,6
              if( Mah(INH3)*Mah(INH4) + Mah(INH3)*Mah(INH5) + Mah(INH4)*Mah(INH5) .lt. 1D-15) then 
        do INH6=ihiggs,6
       self(i,j)=-(CS1S1S1(i,INH3,INH4)*CS1S1S1(j,INH3,INH5)*
     &  CS1S1S1S1(INH4,INH5,INH6,INH6)*(A0TNH(INH6)*
     &  aC0TNH(INH3,INH4,INH5)+aCEpTNH(INH3,INH4,INH5)*Mah2(INH6)))
     &  /32.+self(i,j)
         enddo 
              endif
        Enddo 
        Enddo 
        Enddo 
        
        Do INH3=ihiggs,6
        Do INH4=ihiggs,6
        Do INH5=ihiggs,6
              if( Mah(INH3)*Mah(INH4) + Mah(INH3)*Mah(INH5) + Mah(INH4)*Mah(INH5) .lt. 1D-15) then 
        do ICH3=1,2
       self(i,j)=-(CS1S1S1(i,INH3,INH4)*CS1S1S1(j,INH3,INH5)*
     &  CS1S1S3S3(INH4,INH5,ICH3,ICH3)*(A0THpN(ICH3)*
     &  aC0TNH(INH3,INH4,INH5)+aCEpTNH(INH3,INH4,INH5)*MassHpm(ICH3)**
     &  2))/16.+self(i,j)
         enddo 
              endif
        Enddo 
        Enddo 
        Enddo 
        
        Do ICH3=1,2
        Do ICH4=1,2
        Do ICH5=1,2
              if( MassHpm(ICH3)*MassHpm(ICH4) + MassHpm(ICH3)*MassHpm(ICH5) + MassHpm(ICH4)*MassHpm(ICH5) .lt. 1D-15) then 
        do INH3=ihiggs,6
       self(i,j)=-((CS1S1S3S3(INH3,INH3,ICH5,ICH4)*CS1S3S3(i,ICH4,ICH3)
     &  *CS1S3S3(j,ICH3,ICH5)+CS1S1S3S3(INH3,INH3,ICH4,ICH5)*
     &  CS1S3S3(i,ICH3,ICH4)*CS1S3S3(j,ICH5,ICH3))*(A0TNH(INH3)*
     &  aC0TCH(ICH3,ICH4,ICH5)+aCEpTCH(ICH3,ICH4,ICH5)*Mah2(INH3)))
     &  /32.+self(i,j)
         enddo 
              endif
        Enddo 
        Enddo 
        Enddo 
        
        Do ICH3=1,2
        Do ICH4=1,2
        Do ICH5=1,2
              if( MassHpm(ICH3)*MassHpm(ICH4) + MassHpm(ICH3)*MassHpm(ICH5) + MassHpm(ICH4)*MassHpm(ICH5) .lt. 1D-15) then 
        do ICH6=1,2
       self(i,j)=-((CS1S3S3(i,ICH3,ICH4)*CS1S3S3(j,ICH5,ICH3)*
     &  CS3S3S3S3(ICH4,ICH6,ICH5,ICH6)+CS1S3S3(i,ICH4,ICH3)*
     &  CS1S3S3(j,ICH3,ICH5)*CS3S3S3S3(ICH5,ICH6,ICH4,ICH6))*
     &  (A0THpN(ICH6)*aC0TCH(ICH3,ICH4,ICH5)+aCEpTCH(ICH3,ICH4,ICH5)*
     &  MassHpm(ICH6)**2))/16.+self(i,j)
         enddo 
              endif
        Enddo 
        Enddo 
        Enddo 
        
        Do INH3=ihiggs,6
        Do INH4=ihiggs,6
        Do INH5=ihiggs,6
              if( Mah(INH3)*Mah(INH4) + Mah(INH3)*Mah(INH5) + Mah(INH4)*Mah(INH5) .lt. 1D-15) then 
        do ISt3=1,2
       self(i,j)=(-3*CS1S1S1(i,INH3,INH4)*CS1S1S1(j,INH3,INH5)*
     &  CSSSS(INH4,INH5,ISt3,ISt3)*(aA0TN(ISt3)*aC0TNH(INH3,INH4,INH5)+
     &  aCEpTNH(INH3,INH4,INH5)*MassSu2(ISt3)))/16.+self(i,j)
         enddo 
              endif
        Enddo 
        Enddo 
        Enddo 
        
        Do ICH3=1,2
        Do ICH4=1,2
        Do ICH5=1,2
              if( MassHpm(ICH3)*MassHpm(ICH4) + MassHpm(ICH3)*MassHpm(ICH5) + MassHpm(ICH4)*MassHpm(ICH5) .lt. 1D-15) then 
        do ISt3=1,2
       self(i,j)=(-3*(CS1S3S3(i,ICH3,ICH4)*CS1S3S3(j,ICH5,ICH3)*
     &  CS3S3S13S13(ICH4,ICH5,ISt3,ISt3)+CS1S3S3(i,ICH4,ICH3)*
     &  CS1S3S3(j,ICH3,ICH5)*CS3S3S13S13(ICH5,ICH4,ISt3,ISt3))*
     &  (aA0TN(ISt3)*aC0TCH(ICH3,ICH4,ICH5)+aCEpTCH(ICH3,ICH4,ICH5)*
     &  MassSu2(ISt3)))/16.+self(i,j)
         enddo 
              endif
        Enddo 
        Enddo 
        Enddo 
        
        Do ICH3=1,2
        Do ICH4=1,2
        Do ICH5=1,2
              if( MassHpm(ICH3)*MassHpm(ICH4) + MassHpm(ICH3)*MassHpm(ICH5) + MassHpm(ICH4)*MassHpm(ICH5) .lt. 1D-15) then 
       self(i,j)=(-3*(a0t5*aC0TCH(ICH3,ICH4,ICH5)+MSQ2*
     &  aCEpTCH(ICH3,ICH4,ICH5))*(CS1S3S3(i,ICH3,ICH4)*
     &  CS1S3S3(j,ICH5,ICH3)*CS3S3S14S14(ICH4,ICH5)+
     &  CS1S3S3(i,ICH4,ICH3)*CS1S3S3(j,ICH3,ICH5)*
     &  CS3S3S14S14(ICH5,ICH4)))/16.+self(i,j)
              endif
        Enddo 
        Enddo 
        Enddo 
c
c topo1
c
        INH3=6
        INH6=6
       do INH4=ihiggs,6
       do INH5=ihiggs,6       
       self(i,j)=(CS1S1S1(i,INH3,INH6)*CS1S1S1(INH3,INH4,INH5)*
     &  CS1S1S1S1(j,INH4,INH5,INH6)*FD211HHH(1,INH3,INH4,INH5))/32.+
     &  self(i,j)
       enddo 
       enddo 

        ICH3=1
        ICH5=1
       do ICH4=1,2
       do INH3=ihiggs,6
       self(i,j)=((CS1S1S3S3(j,INH3,ICH4,ICH5)*CS1S3S3(i,ICH5,ICH3)*
     &  CS1S3S3(INH3,ICH3,ICH4)+CS1S1S3S3(j,INH3,ICH5,ICH4)*
     &  CS1S3S3(i,ICH3,ICH5)*CS1S3S3(INH3,ICH4,ICH3))*
     &  FD211HpHHp(1,ICH3,INH3,ICH4))/16.+self(i,j)
       enddo 
       enddo 
        INH3=6
        INH4=6
       do ISt3=1,2
       do ISt4=1,2
       self(i,j)=(3*CS1S1S1(i,INH3,INH4)*CSSS(INH3,ISt3,ISt4)*
     &  CSSSS(j,INH4,ISt4,ISt3)*FD211HSTST(1,INH3,ISt3,ISt4))/16.+
     &  self(i,j)
       enddo 
       enddo 
        ICH3=1
        ICH4=1
       do ISt3=1,2
       self(i,j)=(3*(CS1S3S3(i,ICH4,ICH3)*CS1S3SSC(j,ICH4,ISt3)*
     &  CS3S13S(ICH3,ISt3)+CS1S3S3(i,ICH3,ICH4)*CS1S3SS(j,ICH4,ISt3)*
     &  CS3S13SC(ICH3,ISt3))*FD211HpSTSB(1,ICH3,ISt3))/16.+self(i,j)
       enddo 
c
c topo2
c
        INH3=6
        INH6=6
       do INH4=ihiggs,6
       do INH5=ihiggs,6
       self(i,j)=(CS1S1S1(INH3,INH4,INH5)*CS1S1S1(j,INH3,INH6)*
     &  CS1S1S1S1(i,INH4,INH5,INH6)*FD211HHH(1,INH3,INH4,INH5))/32.+
     &  self(i,j)
       enddo 
       enddo 

        ICH3=1
        ICH5=1
       do ICH4=1,2
       do INH3=ihiggs,6        
       self(i,j)=((CS1S1S3S3(i,INH3,ICH5,ICH4)*CS1S3S3(INH3,ICH4,ICH3)*
     &  CS1S3S3(j,ICH3,ICH5)+CS1S1S3S3(i,INH3,ICH4,ICH5)*
     &  CS1S3S3(INH3,ICH3,ICH4)*CS1S3S3(j,ICH5,ICH3))*
     &  FD211HpHHp(1,ICH3,INH3,ICH4))/16.+self(i,j)
       enddo 
       enddo 
        INH3=6
        INH4=6
       do ISt3=1,2
       do ISt4=1,2       
       self(i,j)=(3*CS1S1S1(j,INH3,INH4)*CSSS(INH3,ISt3,ISt4)*
     &  CSSSS(i,INH4,ISt4,ISt3)*FD211HSTST(1,INH3,ISt3,ISt4))/16.+
     &  self(i,j)
       enddo 
       enddo 
        ICH3=1
        ICH4=1
       do ISt3=1,2
       self(i,j)=(3*(CS1S3S3(j,ICH4,ICH3)*CS1S3SSC(i,ICH4,ISt3)*
     &  CS3S13S(ICH3,ISt3)+CS1S3S3(j,ICH3,ICH4)*CS1S3SS(i,ICH4,ISt3)*
     &  CS3S13SC(ICH3,ISt3))*FD211HpSTSB(1,ICH3,ISt3))/16.+self(i,j)
       enddo

c
c topo3
c 
        INH3=6
        INH4=6       
       self(i,j)=-(CS1S1S1(j,INH3,INH3)*(MCha*CFF12S1L(i)*
     &  (CFF12S1L(INH3)*(MCha**2*CFF12S1L(INH3)*FD221ChaHCha(1,INH3)-2*
     &  CFF12S1R(INH3)*FD221ChaHCha(2,INH3))+CFF12S1R(INH3)*(2*
     &  CFF12S1L(INH3)+CFF12S1R(INH3))*FD221ChaHCha(3,INH3))+MCha*
     &  CFF12S1R(i)*(CFF12S1R(INH3)*(MCha**2*CFF12S1R(INH3)*
     &  FD221ChaHCha(1,INH3)-2*CFF12S1L(INH3)*FD221ChaHCha(2,INH3))+
     &  CFF12S1L(INH3)*(CFF12S1L(INH3)+2*CFF12S1R(INH3))*
     &  FD221ChaHCha(3,INH3))+3*M1*(hy(INH3)**2*(M1**2*FD221THT(1,INH3)
     &  *hy(i)+FD221THT(3,INH3)*hyc(i))+2*(-FD221THT(2,INH3)+
     &  FD221THT(3,INH3))*hy(INH3)*(hy(i)+hyc(i))*hyc(INH3)+
     &  (FD221THT(3,INH3)*hy(i)+M1**2*FD221THT(1,INH3)*hyc(i))*
     &  hyc(INH3)**2)))/8.+self(i,j)
        INH3=6
        INH4=6

       do INe3=ineu,3
       do INe4=ineu,3
       do INe5=ineu,3       
          if( Abs(MNeu(INe3) - MNeu(INe5)) .gt. 1D-15) then 
       self(i,j)=(CS1S1S1(j,INH3,INH3)*(CFF11S1R(INe3,INe4,INH3)*
     &  (CFF11S1L(INe4,INe5,INH3)*(FD211HNeuNeu(2,INH3,INe3,INe4)-
     &  FD211HNeuNeu(2,INH3,INe5,INe4)-FD211HNeuNeu(3,INH3,INe3,INe4)+
     &  FD211HNeuNeu(3,INH3,INe5,INe4))*(CFF11S1R(INe5,INe3,i)*
     &  MNeu(INe3)+CFF11S1L(INe5,INe3,i)*MNeu(INe5))+
     &  CFF11S1R(INe4,INe5,INH3)*MNeu(INe4)*(CFF11S1L(INe5,INe3,i)*(-
     &  FD211HNeuNeu(3,INH3,INe3,INe4)+FD211HNeuNeu(3,INH3,INe5,INe4))+
     &  CFF11S1R(INe5,INe3,i)*(-FD211HNeuNeu(1,INH3,INe3,INe4)+
     &  FD211HNeuNeu(1,INH3,INe5,INe4))*MNeu(INe3)*MNeu(INe5)))+
     &  CFF11S1L(INe3,INe4,INH3)*(CFF11S1L(INe5,INe3,i)*MNeu(INe3)*
     &  (CFF11S1R(INe4,INe5,INH3)*(FD211HNeuNeu(2,INH3,INe3,INe4)-
     &  FD211HNeuNeu(2,INH3,INe5,INe4)-FD211HNeuNeu(3,INH3,INe3,INe4)+
     &  FD211HNeuNeu(3,INH3,INe5,INe4))+CFF11S1L(INe4,INe5,INH3)*(-
     &  FD211HNeuNeu(1,INH3,INe3,INe4)+FD211HNeuNeu(1,INH3,INe5,INe4))*
     &  MNeu(INe4)*MNeu(INe5))+CFF11S1R(INe5,INe3,i)*
     &  (CFF11S1R(INe4,INe5,INH3)*(FD211HNeuNeu(2,INH3,INe3,INe4)-
     &  FD211HNeuNeu(2,INH3,INe5,INe4))*MNeu(INe5)-
     &  (FD211HNeuNeu(3,INH3,INe3,INe4)-FD211HNeuNeu(3,INH3,INe5,INe4))
     &  *(CFF11S1L(INe4,INe5,INH3)*MNeu(INe4)+CFF11S1R(INe4,INe5,INH3)*
     &  MNeu(INe5))))))/(16.*(MNeu(INe3)**2-MNeu(INe5)**2))+self(i,j)
          else
       self(i,j)=(CS1S1S1(j,INH3,INH3)*(CFF11S1L(INe3,INe3,i)*
     &  (CFF11S1R(INe4,INe3,INH3)*(CFF11S1L(INe3,INe4,INH3)*
     &  (FD221ChiHChi(2,INe3,INH3,INe4)-FD221ChiHChi(3,INe3,INH3,INe4))
     &  *MNeu(INe3)-CFF11S1R(INe3,INe4,INH3)*
     &  FD221ChiHChi(3,INe3,INH3,INe4)*MNeu(INe4))+
     &  CFF11S1L(INe4,INe3,INH3)*(CFF11S1R(INe3,INe4,INH3)*
     &  (FD221ChiHChi(2,INe3,INH3,INe4)-FD221ChiHChi(3,INe3,INH3,INe4))
     &  *MNeu(INe3)-CFF11S1L(INe3,INe4,INH3)*
     &  FD221ChiHChi(1,INe3,INH3,INe4)*MNeu(INe4)*MNeu2(INe3)))+
     &  CFF11S1R(INe3,INe3,i)*(CFF11S1L(INe4,INe3,INH3)*
     &  (CFF11S1R(INe3,INe4,INH3)*(FD221ChiHChi(2,INe3,INH3,INe4)-
     &  FD221ChiHChi(3,INe3,INH3,INe4))*MNeu(INe3)-
     &  CFF11S1L(INe3,INe4,INH3)*FD221ChiHChi(3,INe3,INH3,INe4)*
     &  MNeu(INe4))+CFF11S1R(INe4,INe3,INH3)*(CFF11S1L(INe3,INe4,INH3)*
     &  (FD221ChiHChi(2,INe3,INH3,INe4)-FD221ChiHChi(3,INe3,INH3,INe4))
     &  *MNeu(INe3)-CFF11S1R(INe3,INe4,INH3)*
     &  FD221ChiHChi(1,INe3,INH3,INe4)*MNeu(INe4)*MNeu2(INe3)))))/16.+self(i,j)
          endif
       enddo 
       enddo 
       enddo 

        ICH3=1
        ICH4=1       
       self(i,j)=(3*M1*CS1S3S3(j,ICH3,ICH3)*CTBS3(ICH3)*CTBS3C(ICH3)*
     &  (FD221THpB(2,ICH3)-FD221THpB(3,ICH3))*(hy(i)+hyc(i)))/8.+
     &  self(i,j)

        ICH3=1
        ICH4=1
       do INe3=ineu,3
       do INe4=ineu,3 
          if( Abs(MNeu(INe3) - MNeu(INe4)) .gt. 1D-15) then 
       self(i,j)=(CS1S3S3(j,ICH3,ICH3)*(CF11F12S3R(INe4,ICH3)*
     &  (CFF11S1L(INe4,INe3,i)*(MCha*DCONJG(CF11F12S3L(INe3,ICH3))*(-
     &  FD211HpChiCha(3,ICH3,INe3)+FD211HpChiCha(3,ICH3,INe4))+
     &  DCONJG(CF11F12S3R(INe3,ICH3))*(FD211HpChiCha(2,ICH3,INe3)-
     &  FD211HpChiCha(2,ICH3,INe4)-FD211HpChiCha(3,ICH3,INe3)+
     &  FD211HpChiCha(3,ICH3,INe4))*MNeu(INe3))+CFF11S1R(INe4,INe3,i)*
     &  (DCONJG(CF11F12S3R(INe3,ICH3))*(FD211HpChiCha(2,ICH3,INe3)-
     &  FD211HpChiCha(2,ICH3,INe4)-FD211HpChiCha(3,ICH3,INe3)+
     &  FD211HpChiCha(3,ICH3,INe4))+MCha*DCONJG(CF11F12S3L(INe3,ICH3))*
     &  (-FD211HpChiCha(1,ICH3,INe3)+FD211HpChiCha(1,ICH3,INe4))*
     &  MNeu(INe3))*MNeu(INe4))+CF11F12S3L(INe4,ICH3)*
     &  (CFF11S1R(INe4,INe3,i)*(MCha*DCONJG(CF11F12S3R(INe3,ICH3))*(-
     &  FD211HpChiCha(3,ICH3,INe3)+FD211HpChiCha(3,ICH3,INe4))+
     &  DCONJG(CF11F12S3L(INe3,ICH3))*(FD211HpChiCha(2,ICH3,INe3)-
     &  FD211HpChiCha(2,ICH3,INe4)-FD211HpChiCha(3,ICH3,INe3)+
     &  FD211HpChiCha(3,ICH3,INe4))*MNeu(INe3))+CFF11S1L(INe4,INe3,i)*
     &  (DCONJG(CF11F12S3L(INe3,ICH3))*(FD211HpChiCha(2,ICH3,INe3)-
     &  FD211HpChiCha(2,ICH3,INe4)-FD211HpChiCha(3,ICH3,INe3)+
     &  FD211HpChiCha(3,ICH3,INe4))+MCha*DCONJG(CF11F12S3R(INe3,ICH3))*
     &  (-FD211HpChiCha(1,ICH3,INe3)+FD211HpChiCha(1,ICH3,INe4))*
     &  MNeu(INe3))*MNeu(INe4))))/(8.*(MNeu(INe3)**2-MNeu(INe4)**2))+
     &  self(i,j)
          else
       self(i,j)=-(CS1S3S3(j,ICH3,ICH3)*(CF11F12S3R(INe3,ICH3)*
     &  (CFF11S1L(INe3,INe3,i)*(MCha*DCONJG(CF11F12S3L(INe3,ICH3))*
     &  FD221ChiHpCha(3,INe3,ICH3)+DCONJG(CF11F12S3R(INe3,ICH3))*(-
     &  FD221ChiHpCha(2,INe3,ICH3)+FD221ChiHpCha(3,INe3,ICH3))*
     &  MNeu(INe3))+CFF11S1R(INe3,INe3,i)*(DCONJG(CF11F12S3R(INe3,ICH3)
     &  )*(-FD221ChiHpCha(2,INe3,ICH3)+FD221ChiHpCha(3,INe3,ICH3))*
     &  MNeu(INe3)+MCha*DCONJG(CF11F12S3L(INe3,ICH3))*
     &  FD221ChiHpCha(1,INe3,ICH3)*MNeu2(INe3)))+CF11F12S3L(INe3,ICH3)*
     &  (CFF11S1R(INe3,INe3,i)*(MCha*DCONJG(CF11F12S3R(INe3,ICH3))*
     &  FD221ChiHpCha(3,INe3,ICH3)+DCONJG(CF11F12S3L(INe3,ICH3))*(-
     &  FD221ChiHpCha(2,INe3,ICH3)+FD221ChiHpCha(3,INe3,ICH3))*
     &  MNeu(INe3))+CFF11S1L(INe3,INe3,i)*(DCONJG(CF11F12S3L(INe3,ICH3)
     &  )*(-FD221ChiHpCha(2,INe3,ICH3)+FD221ChiHpCha(3,INe3,ICH3))*
     &  MNeu(INe3)+MCha*DCONJG(CF11F12S3R(INe3,ICH3))*
     &  FD221ChiHpCha(1,INe3,ICH3)*MNeu2(INe3)))))/8.+self(i,j)
          endif
       enddo 
       enddo
        ICH3=1
        ICH4=1
       do INe3=ineu,3
          if(abs(MCha2-MNeu2(INe3)).gt.1D-10) then       
       self(i,j)=(CS1S3S3(j,ICH3,ICH3)*(MCha*(CFF12S1L(i)+CFF12S1R(i))*
     &  (CF11F12S3L(INe3,ICH3)*DCONJG(CF11F12S3L(INe3,ICH3))+
     &  CF11F12S3R(INe3,ICH3)*DCONJG(CF11F12S3R(INe3,ICH3)))*
     &  (FD221ChaHpChi(2,ICH3,INe3)-FD221ChaHpChi(3,ICH3,INe3))-
     &  (CF11F12S3R(INe3,ICH3)*DCONJG(CF11F12S3L(INe3,ICH3))*(MCha2*
     &  CFF12S1R(i)*FD221ChaHpChi(1,ICH3,INe3)+CFF12S1L(i)*
     &  FD221ChaHpChi(3,ICH3,INe3))+CF11F12S3L(INe3,ICH3)*
     &  DCONJG(CF11F12S3R(INe3,ICH3))*(MCha2*CFF12S1L(i)*
     &  FD221ChaHpChi(1,ICH3,INe3)+CFF12S1R(i)*
     &  FD221ChaHpChi(3,ICH3,INe3)))*MNeu(INe3)))/8.+self(i,j)

        else
            ! need to implement here
        endif
       enddo
c
c topo5
c
        INH3=6
        INH4=6       
       self(i,j)=-(CS1S1S1(i,6,6)*(-2*MCha*CFF12S1L(6)*CFF12S1R(6)*
     &  (CFF12S1L(j)+CFF12S1R(j))*(FD221ChaHCha(2,6)-FD221ChaHCha(3,6))
     &  +CFF12S1R(6)**2*(MCha**3*CFF12S1R(j)*FD221ChaHCha(1,6)+MCha*
     &  CFF12S1L(j)*FD221ChaHCha(3,6))+CFF12S1L(6)**2*(MCha**3*
     &  CFF12S1L(j)*FD221ChaHCha(1,6)+MCha*CFF12S1R(j)*
     &  FD221ChaHCha(3,6))+3*M1*(-2*FD221THT(2,6)*hy(6)*hyc(6)*(hy(j)+
     &  hyc(j))+M1**2*FD221THT(1,6)*(hy(6)**2*hy(j)+hyc(6)**2*hyc(j))+
     &  FD221THT(3,6)*(hy(j)*hyc(6)*(2*hy(6)+hyc(6))+hy(6)*(hy(6)+2*
     &  hyc(6))*hyc(j)))))/8.+self(i,j)


        INH3=6
        INH4=6
       do INe3=ineu,3
       do INe4=ineu,3
       do INe5=ineu,3       
          if( Abs(MNeu(INe3) - MNeu(INe5)) .gt. 1D-15) then 
       self(i,j)=(CS1S1S1(i,6,6)*(CFF11S1R(INe3,INe4,6)*
     &  (CFF11S1L(INe4,INe5,6)*(FD211HNeuNeu(2,6,INe3,INe4)-
     &  FD211HNeuNeu(2,6,INe5,INe4)-FD211HNeuNeu(3,6,INe3,INe4)+
     &  FD211HNeuNeu(3,6,INe5,INe4))*(CFF11S1R(INe5,INe3,j)*MNeu(INe3)+
     &  CFF11S1L(INe5,INe3,j)*MNeu(INe5))+CFF11S1R(INe4,INe5,6)*
     &  MNeu(INe4)*(CFF11S1L(INe5,INe3,j)*(-FD211HNeuNeu(3,6,INe3,INe4)
     &  +FD211HNeuNeu(3,6,INe5,INe4))+CFF11S1R(INe5,INe3,j)*(-
     &  FD211HNeuNeu(1,6,INe3,INe4)+FD211HNeuNeu(1,6,INe5,INe4))*
     &  MNeu(INe3)*MNeu(INe5)))+CFF11S1L(INe3,INe4,6)*
     &  (CFF11S1L(INe5,INe3,j)*MNeu(INe3)*(CFF11S1R(INe4,INe5,6)*
     &  (FD211HNeuNeu(2,6,INe3,INe4)-FD211HNeuNeu(2,6,INe5,INe4)-
     &  FD211HNeuNeu(3,6,INe3,INe4)+FD211HNeuNeu(3,6,INe5,INe4))+
     &  CFF11S1L(INe4,INe5,6)*(-FD211HNeuNeu(1,6,INe3,INe4)+
     &  FD211HNeuNeu(1,6,INe5,INe4))*MNeu(INe4)*MNeu(INe5))+
     &  CFF11S1R(INe5,INe3,j)*(CFF11S1R(INe4,INe5,6)*
     &  (FD211HNeuNeu(2,6,INe3,INe4)-FD211HNeuNeu(2,6,INe5,INe4))*
     &  MNeu(INe5)-(FD211HNeuNeu(3,6,INe3,INe4)-
     &  FD211HNeuNeu(3,6,INe5,INe4))*(CFF11S1L(INe4,INe5,6)*MNeu(INe4)+
     &  CFF11S1R(INe4,INe5,6)*MNeu(INe5))))))/(16.*(MNeu(INe3)**2-
     &  MNeu(INe5)**2))+self(i,j)
          else
       self(i,j)=(CS1S1S1(i,INH3,INH3)*(CFF11S1L(INe3,INe3,j)*
     &  (CFF11S1R(INe4,INe3,INH3)*(CFF11S1L(INe3,INe4,INH3)*
     &  (FD221ChiHChi(2,INe3,INH3,INe4)-FD221ChiHChi(3,INe3,INH3,INe4))
     &  *MNeu(INe3)-CFF11S1R(INe3,INe4,INH3)*
     &  FD221ChiHChi(3,INe3,INH3,INe4)*MNeu(INe4))+
     &  CFF11S1L(INe4,INe3,INH3)*(CFF11S1R(INe3,INe4,INH3)*
     &  (FD221ChiHChi(2,INe3,INH3,INe4)-FD221ChiHChi(3,INe3,INH3,INe4))
     &  *MNeu(INe3)-CFF11S1L(INe3,INe4,INH3)*
     &  FD221ChiHChi(1,INe3,INH3,INe4)*MNeu(INe4)*MNeu2(INe3)))+
     &  CFF11S1R(INe3,INe3,j)*(CFF11S1L(INe4,INe3,INH3)*
     &  (CFF11S1R(INe3,INe4,INH3)*(FD221ChiHChi(2,INe3,INH3,INe4)-
     &  FD221ChiHChi(3,INe3,INH3,INe4))*MNeu(INe3)-
     &  CFF11S1L(INe3,INe4,INH3)*FD221ChiHChi(3,INe3,INH3,INe4)*
     &  MNeu(INe4))+CFF11S1R(INe4,INe3,INH3)*(CFF11S1L(INe3,INe4,INH3)*
     &  (FD221ChiHChi(2,INe3,INH3,INe4)-FD221ChiHChi(3,INe3,INH3,INe4))
     &  *MNeu(INe3)-CFF11S1R(INe3,INe4,INH3)*
     &  FD221ChiHChi(1,INe3,INH3,INe4)*MNeu(INe4)*MNeu2(INe3)))))/16.+self(i,j)
          endif
       enddo 
       enddo 
       enddo 

        

        ICH3=1
        ICH4=1     
       self(i,j)=(3*M1*CS1S3S3(i,1,1)*CTBS3(1)*CTBS3C(1)*
     &  (FD221THpB(2,1)-FD221THpB(3,1))*(hy(j)+hyc(j)))/8.+self(i,j)
        ICH3=1
        ICH4=1
       do INe3=ineu,3
       do INe4=ineu,3       
          if( Abs(MNeu(INe3) - MNeu(INe4)) .gt. 1D-15) then 
       self(i,j)=(CS1S3S3(i,1,1)*(CF11F12S3R(INe4,1)*
     &  (CFF11S1L(INe4,INe3,j)*(MCha*DCONJG(CF11F12S3L(INe3,1))*(-
     &  FD211HpChiCha(3,1,INe3)+FD211HpChiCha(3,1,INe4))+
     &  DCONJG(CF11F12S3R(INe3,1))*(FD211HpChiCha(2,1,INe3)-
     &  FD211HpChiCha(2,1,INe4)-FD211HpChiCha(3,1,INe3)+
     &  FD211HpChiCha(3,1,INe4))*MNeu(INe3))+CFF11S1R(INe4,INe3,j)*
     &  (DCONJG(CF11F12S3R(INe3,1))*(FD211HpChiCha(2,1,INe3)-
     &  FD211HpChiCha(2,1,INe4)-FD211HpChiCha(3,1,INe3)+
     &  FD211HpChiCha(3,1,INe4))+MCha*DCONJG(CF11F12S3L(INe3,1))*(-
     &  FD211HpChiCha(1,1,INe3)+FD211HpChiCha(1,1,INe4))*MNeu(INe3))*
     &  MNeu(INe4))+CF11F12S3L(INe4,1)*(CFF11S1R(INe4,INe3,j)*(MCha*
     &  DCONJG(CF11F12S3R(INe3,1))*(-FD211HpChiCha(3,1,INe3)+
     &  FD211HpChiCha(3,1,INe4))+DCONJG(CF11F12S3L(INe3,1))*
     &  (FD211HpChiCha(2,1,INe3)-FD211HpChiCha(2,1,INe4)-
     &  FD211HpChiCha(3,1,INe3)+FD211HpChiCha(3,1,INe4))*MNeu(INe3))+
     &  CFF11S1L(INe4,INe3,j)*(DCONJG(CF11F12S3L(INe3,1))*
     &  (FD211HpChiCha(2,1,INe3)-FD211HpChiCha(2,1,INe4)-
     &  FD211HpChiCha(3,1,INe3)+FD211HpChiCha(3,1,INe4))+MCha*
     &  DCONJG(CF11F12S3R(INe3,1))*(-FD211HpChiCha(1,1,INe3)+
     &  FD211HpChiCha(1,1,INe4))*MNeu(INe3))*MNeu(INe4))))/(8.*
     &  (MNeu(INe3)**2-MNeu(INe4)**2))+self(i,j)
          else
       self(i,j)=-(CS1S3S3(i,ICH3,ICH3)*(CF11F12S3R(INe3,ICH3)*
     &  (CFF11S1L(INe3,INe3,j)*(MCha*DCONJG(CF11F12S3L(INe3,ICH3))*
     &  FD221ChiHpCha(3,INe3,ICH3)+DCONJG(CF11F12S3R(INe3,ICH3))*(-
     &  FD221ChiHpCha(2,INe3,ICH3)+FD221ChiHpCha(3,INe3,ICH3))*
     &  MNeu(INe3))+CFF11S1R(INe3,INe3,j)*(DCONJG(CF11F12S3R(INe3,ICH3)
     &  )*(-FD221ChiHpCha(2,INe3,ICH3)+FD221ChiHpCha(3,INe3,ICH3))*
     &  MNeu(INe3)+MCha*DCONJG(CF11F12S3L(INe3,ICH3))*
     &  FD221ChiHpCha(1,INe3,ICH3)*MNeu2(INe3)))+CF11F12S3L(INe3,ICH3)*
     &  (CFF11S1R(INe3,INe3,j)*(MCha*DCONJG(CF11F12S3R(INe3,ICH3))*
     &  FD221ChiHpCha(3,INe3,ICH3)+DCONJG(CF11F12S3L(INe3,ICH3))*(-
     &  FD221ChiHpCha(2,INe3,ICH3)+FD221ChiHpCha(3,INe3,ICH3))*
     &  MNeu(INe3))+CFF11S1L(INe3,INe3,j)*(DCONJG(CF11F12S3L(INe3,ICH3)
     &  )*(-FD221ChiHpCha(2,INe3,ICH3)+FD221ChiHpCha(3,INe3,ICH3))*
     &  MNeu(INe3)+MCha*DCONJG(CF11F12S3R(INe3,ICH3))*
     &  FD221ChiHpCha(1,INe3,ICH3)*MNeu2(INe3)))))/8.+self(i,j)
          endif
       enddo 
       enddo 

        ICH3=1
        ICH4=1
       do INe3=ineu,3
         if(abs(MCha2-MNeu2(INe3)).gt.1D-10)then      
       self(i,j)=(CS1S3S3(i,1,1)*(MCha*(CFF12S1L(j)+CFF12S1R(j))*
     &  (CF11F12S3L(INe3,1)*DCONJG(CF11F12S3L(INe3,1))+
     &  CF11F12S3R(INe3,1)*DCONJG(CF11F12S3R(INe3,1)))*
     &  (FD221ChaHpChi(2,1,INe3)-FD221ChaHpChi(3,1,INe3))-
     &  (CF11F12S3R(INe3,1)*DCONJG(CF11F12S3L(INe3,1))*(MCha2*
     &  CFF12S1R(j)*FD221ChaHpChi(1,1,INe3)+CFF12S1L(j)*
     &  FD221ChaHpChi(3,1,INe3))+CF11F12S3L(INe3,1)*
     &  DCONJG(CF11F12S3R(INe3,1))*(MCha2*CFF12S1L(j)*
     &  FD221ChaHpChi(1,1,INe3)+CFF12S1R(j)*FD221ChaHpChi(3,1,INe3)))*
     &  MNeu(INe3)))/8.+self(i,j)
        else
         ! need to implement
        endif
       enddo 
c
c topo6
c

        INH4=6
        INH7=6
       do INH3=ihiggs,6
       do INH5=ihiggs,6
       do INH6=ihiggs,6
        
        !finite
        
          if( Abs(Mah(INH3) - Mah(INH6)) .gt. 1D-15) then 
       self(i,j)=(CS1S1S1(i,INH3,INH6)*CS1S1S1(INH3,INH4,INH5)*
     &  CS1S1S1(INH5,INH6,INH4)*CS1S1S1(j,INH4,INH4)*
     &  (FD211HHH(1,INH4,INH3,INH5)-FD211HHH(1,INH4,INH6,INH5)))/(32.*
     &  (Mah(INH3)**2-Mah(INH6)**2))+self(i,j)
          else
       self(i,j)=(CS1S1S1(i,INH3,INH3)*CS1S1S1(INH3,INH4,INH5)*
     &  CS1S1S1(INH5,INH3,INH4)*CS1S1S1(j,INH4,INH4)*
     &  FD221HHH(1,INH3,INH4,INH5))/32.+self(i,j)
          endif
       enddo 
       enddo 
       enddo 

       INH3=6
        INH6=6
       do INH4=ihiggs,6
       do INH5=ihiggs,6
       do INH7=ihiggs,6
        
        !finite
        
          if( Abs(Mah(INH4) - Mah(INH7)) .gt. 1D-15) then 
       self(i,j)=(CS1S1S1(i,INH3,INH3)*CS1S1S1(INH3,INH4,INH5)*
     &  CS1S1S1(INH5,INH3,INH7)*CS1S1S1(j,INH4,INH7)*
     &  (FD211HHH(1,INH3,INH4,INH5)-FD211HHH(1,INH3,INH7,INH5)))/(32.*
     &  (Mah(INH4)**2-Mah(INH7)**2))+self(i,j)
          else
          if( Abs(Mah(INH4)) .gt. 1D-15) then 
       self(i,j)=(CS1S1S1(i,INH3,INH3)*CS1S1S1(INH3,INH4,INH5)*
     &  CS1S1S1(INH5,INH3,INH4)*CS1S1S1(j,INH4,INH4)*
     &  FD221HHH(1,INH3,INH4,INH5))/32.+self(i,j)
            endif
          endif
       enddo 
       enddo 
       enddo 


        ICH3=1
        ICH5=1
       do ICH4=1,2
       do INH3=ihiggs,6
       do INH4=ihiggs,6
        
        !finite
        
          if( Abs(Mah(INH3) - Mah(INH4)) .gt. 1D-15) then 
       self(i,j)=(CS1S3S3(INH3,ICH3,ICH4)*CS1S3S3(INH4,ICH4,ICH3)*
     &  (CS1S1S1(j,INH3,INH4)*CS1S3S3(i,ICH3,ICH3)+CS1S1S1(i,INH3,INH4)
     &  *CS1S3S3(j,ICH3,ICH3))*(FD211HpHHp(1,ICH3,INH3,ICH4)-
     &  FD211HpHHp(1,ICH3,INH4,ICH4)))/(16.*(Mah(INH3)**2-Mah(INH4)**2)
     &  )+self(i,j)
          else
       self(i,j)=(CS1S3S3(INH3,ICH3,ICH4)*CS1S3S3(INH3,ICH4,ICH3)*
     &  (CS1S1S1(j,INH3,INH3)*CS1S3S3(i,ICH3,ICH3)+CS1S1S1(i,INH3,INH3)
     &  *CS1S3S3(j,ICH3,ICH3))*FD221HHpHp(1,INH3,ICH3,ICH4))/16.+
     &  self(i,j)
          endif
       enddo 
       enddo 
       enddo 


         INH3=6
        INH4=6
       do ICH3=1,2
       do ICH4=1,2
       do ICH5=1,2
        
        !finite   this give zero contribution
        
          if( Abs(MassHpm(ICH3) - MassHpm(ICH5)) .gt. 1D-15) then 
       self(i,j)=(CS1S3S3(INH3,ICH3,ICH4)*CS1S3S3(INH3,ICH4,ICH5)*
     &  (CS1S1S1(j,INH3,INH3)*CS1S3S3(i,ICH5,ICH3)+CS1S1S1(i,INH3,INH3)
     &  *CS1S3S3(j,ICH5,ICH3))*(FD211HHpHp(1,INH3,ICH3,ICH4)-
     &  FD211HHpHp(1,INH3,ICH5,ICH4)))/(16.*(MassHpm(ICH3)**2-
     &  MassHpm(ICH5)**2))+self(i,j)
          else
          if( Abs(MassHpm(ICH3)) .gt. 1D-15) then 
       self(i,j)=(CS1S3S3(INH3,ICH3,ICH4)*CS1S3S3(INH3,ICH4,ICH3)*
     &  (CS1S1S1(j,INH3,INH3)*CS1S3S3(i,ICH3,ICH3)+CS1S1S1(i,INH3,INH3)
     &  *CS1S3S3(j,ICH3,ICH3))*FD221HHpHp(1,INH3,ICH3,ICH4))/16.+
     &  self(i,j)
            endif
          endif
       enddo 
       enddo 
       enddo 

        ICH4=1
        ICH6=1
       do ICH3=1,2
       do ICH5=1,2
       do INH3=ihiggs,6
        
        !finite
        
          if( Abs(MassHpm(ICH3) - MassHpm(ICH5)) .gt. 1D-15) then 
       self(i,j)=(CS1S3S3(i,ICH5,ICH3)*CS1S3S3(INH3,ICH3,ICH4)*
     &  CS1S3S3(INH3,ICH4,ICH5)*CS1S3S3(j,ICH4,ICH4)*
     &  (FD211HpHpH(1,ICH4,ICH3,INH3)-FD211HpHpH(1,ICH4,ICH5,INH3)))
     &  /(16.*(MassHpm(ICH3)**2-MassHpm(ICH5)**2))+self(i,j)
          else
       self(i,j)=(CS1S3S3(i,ICH3,ICH3)*CS1S3S3(INH3,ICH3,ICH4)*
     &  CS1S3S3(INH3,ICH4,ICH3)*CS1S3S3(j,ICH4,ICH4)*
     &  FD221HpHpH(1,ICH3,ICH4,INH3))/16.+self(i,j)
          endif
       enddo 
       enddo 
       enddo 


        ICH3=1
        ICH5=1
       do ICH4=1,2
       do ICH6=1,2
       do INH3=ihiggs,6
        
        !finite
        
          if( Abs(MassHpm(ICH4) - MassHpm(ICH6)) .gt. 1D-15) then 
       self(i,j)=(CS1S3S3(i,ICH3,ICH3)*CS1S3S3(INH3,ICH3,ICH4)*
     &  CS1S3S3(INH3,ICH6,ICH3)*CS1S3S3(j,ICH4,ICH6)*
     &  (FD211HpHpH(1,ICH3,ICH4,INH3)-FD211HpHpH(1,ICH3,ICH6,INH3)))
     &  /(16.*(MassHpm(ICH4)**2-MassHpm(ICH6)**2))+self(i,j)
          else
          if( Abs(MassHpm(ICH4)) .gt. 1D-15) then 
       self(i,j)=(CS1S3S3(i,ICH3,ICH3)*CS1S3S3(INH3,ICH3,ICH4)*
     &  CS1S3S3(INH3,ICH4,ICH3)*CS1S3S3(j,ICH4,ICH4)*
     &  FD221HpHpH(1,ICH3,ICH4,INH3))/16.+self(i,j)
            endif
          endif
       enddo 
       enddo 
       enddo 



        INH3=6
        INH4=6
       do ISt3=1,2
       do ISt4=1,2
       do ISt5=1,2
        
        !finite
        
          if( Abs(MassSu(ISt3) - MassSu(ISt5)) .gt. 1D-15) then 
       self(i,j)=(3*CSSS(INH3,ISt3,ISt4)*CSSS(INH3,ISt4,ISt5)*
     &  (CS1S1S1(j,INH3,INH3)*CSSS(i,ISt5,ISt3)+CS1S1S1(i,INH3,INH3)*
     &  CSSS(j,ISt5,ISt3))*(FD211HSTST(1,INH3,ISt3,ISt4)-
     &  FD211HSTST(1,INH3,ISt5,ISt4)))/(16.*(MassSu(ISt3)**2-
     &  MassSu(ISt5)**2))+self(i,j)
          else
       self(i,j)=(3*CSSS(INH3,ISt3,ISt4)*CSSS(INH3,ISt4,ISt3)*
     &  (CS1S1S1(j,INH3,INH3)*CSSS(i,ISt3,ISt3)+CS1S1S1(i,INH3,INH3)*
     &  CSSS(j,ISt3,ISt3))*FD221HStSt(1,INH3,ISt3,ISt4))/16.+self(i,j)
          endif
       enddo 
       enddo 
       enddo 

        ICH3=1
        ICH4=1
       do ISt3=1,2
       do ISt4=1,2
        
        !finite
        
          if( Abs(MassSu(ISt3) - MassSu(ISt4)) .gt. 1D-15) then 
       self(i,j)=(3*CS3S13S(ICH3,ISt3)*CS3S13SC(ICH3,ISt4)*
     &  (CS1S3S3(j,ICH3,ICH3)*CSSS(i,ISt4,ISt3)+CS1S3S3(i,ICH3,ICH3)*
     &  CSSS(j,ISt4,ISt3))*(FD211HpSTSB(1,ICH3,ISt3)-
     &  FD211HpSTSB(1,ICH3,ISt4)))/(16.*(MassSu(ISt3)**2-MassSu(ISt4)**
     &  2))+self(i,j)
          else
       self(i,j)=(3*CS3S13S(ICH3,ISt3)*CS3S13SC(ICH3,ISt3)*
     &  (CS1S3S3(j,ICH3,ICH3)*CSSS(i,ISt3,ISt3)+CS1S3S3(i,ICH3,ICH3)*
     &  CSSS(j,ISt3,ISt3))*FD221HpStSb(1,ICH3,ISt3))/16.+self(i,j)
          endif
       enddo 
       enddo 


c
c topo7
c

       ! diagram  1  
        INH3=6
        INH4=6
            do INH5=ihiggs,5
       self(i,j)=(CS1S1S1(i,6,6)*CS1S1S1(j,6,INH5)*(3*(-(FD111THT(2,6)*
     &  hy(INH5)*hyc(6))+FD111THT(2,INH5)*hy(INH5)*hyc(6)+FD111THT(4,6)
     &  *hy(INH5)*hyc(6)-FD111THT(4,INH5)*hy(INH5)*hyc(6)-FD111THT(2,6)
     &  *hy(6)*hyc(INH5)+FD111THT(2,INH5)*hy(6)*hyc(INH5)+FD111THT(4,6)
     &  *hy(6)*hyc(INH5)-FD111THT(4,INH5)*hy(6)*hyc(INH5)+M12*
     &  FD111THT(1,6)*(hy(6)*hy(INH5)+hyc(6)*hyc(INH5))-M12*
     &  FD111THT(1,INH5)*(hy(6)*hy(INH5)+hyc(6)*hyc(INH5))+M12*
     &  FD211HTT(1,6)*hy(6)*hy(INH5)*Mah(INH5)**2-FD211HTT(2,6)*
     &  hy(INH5)*hyc(6)*Mah(INH5)**2+FD211HTT(3,6)*hy(INH5)*hyc(6)*
     &  Mah(INH5)**2-FD211HTT(2,6)*hy(6)*hyc(INH5)*Mah(INH5)**2+
     &  FD211HTT(3,6)*hy(6)*hyc(INH5)*Mah(INH5)**2+M12*FD211HTT(1,6)*
     &  hyc(6)*hyc(INH5)*Mah(INH5)**2)+CFF12S1R(6)*(MCha2*
     &  CFF12S1R(INH5)*(FD111ChaHCha(1,6)-FD111ChaHCha(1,INH5)+
     &  FD211HChaCha(1,6)*Mah(INH5)**2)+CFF12S1L(INH5)*(-
     &  FD111ChaHCha(2,6)+FD111ChaHCha(2,INH5)+FD111ChaHCha(4,6)-
     &  FD111ChaHCha(4,INH5)-FD211HChaCha(2,6)*Mah(INH5)**2+
     &  FD211HChaCha(3,6)*Mah(INH5)**2))+CFF12S1L(6)*(MCha2*
     &  CFF12S1L(INH5)*(FD111ChaHCha(1,6)-FD111ChaHCha(1,INH5)+
     &  FD211HChaCha(1,6)*Mah(INH5)**2)+CFF12S1R(INH5)*(-
     &  FD111ChaHCha(2,6)+FD111ChaHCha(2,INH5)+FD111ChaHCha(4,6)-
     &  FD111ChaHCha(4,INH5)-FD211HChaCha(2,6)*Mah(INH5)**2+
     &  FD211HChaCha(3,6)*Mah(INH5)**2))))/(8.*Mah(INH5)**4)+self(i,j)
              enddo
        INH3=6
        INH5=6
            do INH4=ihiggs,5
       self(i,j)=(CS1S1S1(i,6,INH4)*CS1S1S1(j,6,6)*(3*(-(FD111THT(2,6)*
     &  hy(INH4)*hyc(6))+FD111THT(2,INH4)*hy(INH4)*hyc(6)+FD111THT(4,6)
     &  *hy(INH4)*hyc(6)-FD111THT(4,INH4)*hy(INH4)*hyc(6)-FD111THT(2,6)
     &  *hy(6)*hyc(INH4)+FD111THT(2,INH4)*hy(6)*hyc(INH4)+FD111THT(4,6)
     &  *hy(6)*hyc(INH4)-FD111THT(4,INH4)*hy(6)*hyc(INH4)+M12*
     &  FD111THT(1,6)*(hy(6)*hy(INH4)+hyc(6)*hyc(INH4))-M12*
     &  FD111THT(1,INH4)*(hy(6)*hy(INH4)+hyc(6)*hyc(INH4))+M12*
     &  FD211HTT(1,6)*hy(6)*hy(INH4)*Mah(INH4)**2-FD211HTT(2,6)*
     &  hy(INH4)*hyc(6)*Mah(INH4)**2+FD211HTT(3,6)*hy(INH4)*hyc(6)*
     &  Mah(INH4)**2-FD211HTT(2,6)*hy(6)*hyc(INH4)*Mah(INH4)**2+
     &  FD211HTT(3,6)*hy(6)*hyc(INH4)*Mah(INH4)**2+M12*FD211HTT(1,6)*
     &  hyc(6)*hyc(INH4)*Mah(INH4)**2)+CFF12S1R(6)*(MCha2*
     &  CFF12S1R(INH4)*(FD111ChaHCha(1,6)-FD111ChaHCha(1,INH4)+
     &  FD211HChaCha(1,6)*Mah(INH4)**2)+CFF12S1L(INH4)*(-
     &  FD111ChaHCha(2,6)+FD111ChaHCha(2,INH4)+FD111ChaHCha(4,6)-
     &  FD111ChaHCha(4,INH4)-FD211HChaCha(2,6)*Mah(INH4)**2+
     &  FD211HChaCha(3,6)*Mah(INH4)**2))+CFF12S1L(6)*(MCha2*
     &  CFF12S1L(INH4)*(FD111ChaHCha(1,6)-FD111ChaHCha(1,INH4)+
     &  FD211HChaCha(1,6)*Mah(INH4)**2)+CFF12S1R(INH4)*(-
     &  FD111ChaHCha(2,6)+FD111ChaHCha(2,INH4)+FD111ChaHCha(4,6)-
     &  FD111ChaHCha(4,INH4)-FD211HChaCha(2,6)*Mah(INH4)**2+
     &  FD211HChaCha(3,6)*Mah(INH4)**2))))/(8.*Mah(INH4)**4)+self(i,j)
              enddo
        INH5=6
        INH4=6
            do INH3=ihiggs,5
       self(i,j)=(CS1S1S1(i,INH3,6)*CS1S1S1(j,INH3,6)*(MCha2*
     &  CFF12S1L(6)**2*(FD111ChaHCha(1,6)-FD111ChaHCha(1,INH3)+
     &  FD211HChaCha(1,6)*Mah(INH3)**2)+MCha2*CFF12S1R(6)**2*
     &  (FD111ChaHCha(1,6)-FD111ChaHCha(1,INH3)+FD211HChaCha(1,6)*
     &  Mah(INH3)**2)+2*CFF12S1L(6)*CFF12S1R(6)*(-FD111ChaHCha(2,6)+
     &  FD111ChaHCha(2,INH3)+FD111ChaHCha(4,6)-FD111ChaHCha(4,INH3)-
     &  FD211HChaCha(2,6)*Mah(INH3)**2+FD211HChaCha(3,6)*Mah(INH3)**2)-
     &  3*(2*FD111THT(2,6)*hy(6)*hyc(6)-2*FD111THT(2,INH3)*hy(6)*hyc(6)
     &  -2*FD111THT(4,6)*hy(6)*hyc(6)+2*FD111THT(4,INH3)*hy(6)*hyc(6)-
     &  M12*FD111THT(1,6)*(hy(6)**2+hyc(6)**2)+M12*FD111THT(1,INH3)*
     &  (hy(6)**2+hyc(6)**2)-M12*FD211HTT(1,6)*hy(6)**2*Mah(INH3)**2+2*
     &  FD211HTT(2,6)*hy(6)*hyc(6)*Mah(INH3)**2-2*FD211HTT(3,6)*hy(6)*
     &  hyc(6)*Mah(INH3)**2-M12*FD211HTT(1,6)*hyc(6)**2*Mah(INH3)**2)))
     &  /(8.*Mah(INH3)**4)+self(i,j)
              enddo
        INH3=6
       self(i,j)=-(CS1S1S1(i,6,6)*CS1S1S1(j,6,6)*(MCha2*CFF12S1L(6)**2*
     &  FD311HChaCha(1,6)+MCha2*CFF12S1R(6)**2*FD311HChaCha(1,6)+2*
     &  CFF12S1L(6)*CFF12S1R(6)*(-FD311HChaCha(2,6)+FD311HChaCha(5,6))+
     &  3*M12*FD311HTT(1,6)*hy(6)**2-6*FD311HTT(2,6)*hy(6)*hyc(6)+6*
     &  FD311HTT(5,6)*hy(6)*hyc(6)+3*M12*FD311HTT(1,6)*hyc(6)**2))/8.+
     &  self(i,j)
       ! diagram  2  
       do INe3=ineu,3
       do INe4=ineu,3
        INH3=6
        INH4=6
            do INH5=ihiggs,5
       self(i,j)=(CS1S1S1(i,6,6)*CS1S1S1(j,6,INH5)*
     &  (CFF11S1L(INe4,INe3,INH5)*(CFF11S1R(INe3,INe4,6)*(-
     &  FD111ChiHChi(2,INe3,6,INe4)+FD111ChiHChi(2,INe3,INH5,INe4)+
     &  FD111ChiHChi(4,INe3,6,INe4)-FD111ChiHChi(4,INe3,INH5,INe4)-
     &  FD211HNeuNeu(2,6,INe3,INe4)*Mah(INH5)**2+
     &  FD211HNeuNeu(3,6,INe3,INe4)*Mah(INH5)**2)+CFF11S1L(INe3,INe4,6)
     &  *(FD111ChiHChi(1,INe3,6,INe4)-FD111ChiHChi(1,INe3,INH5,INe4)+
     &  FD211HNeuNeu(1,6,INe3,INe4)*Mah(INH5)**2)*MNeu(INe3)*MNeu(INe4)
     &  )+CFF11S1R(INe4,INe3,INH5)*(CFF11S1L(INe3,INe4,6)*(-
     &  FD111ChiHChi(2,INe3,6,INe4)+FD111ChiHChi(2,INe3,INH5,INe4)+
     &  FD111ChiHChi(4,INe3,6,INe4)-FD111ChiHChi(4,INe3,INH5,INe4)-
     &  FD211HNeuNeu(2,6,INe3,INe4)*Mah(INH5)**2+
     &  FD211HNeuNeu(3,6,INe3,INe4)*Mah(INH5)**2)+CFF11S1R(INe3,INe4,6)
     &  *(FD111ChiHChi(1,INe3,6,INe4)-FD111ChiHChi(1,INe3,INH5,INe4)+
     &  FD211HNeuNeu(1,6,INe3,INe4)*Mah(INH5)**2)*MNeu(INe3)*MNeu(INe4)
     &  )))/(16.*Mah(INH5)**4)+self(i,j)
              enddo
        INH3=6
        INH5=6
            do INH4=ihiggs,5
       self(i,j)=(CS1S1S1(i,6,INH4)*CS1S1S1(j,6,6)*
     &  (CFF11S1L(INe4,INe3,6)*(CFF11S1R(INe3,INe4,INH4)*(-
     &  FD111ChiHChi(2,INe3,6,INe4)+FD111ChiHChi(2,INe3,INH4,INe4)+
     &  FD111ChiHChi(4,INe3,6,INe4)-FD111ChiHChi(4,INe3,INH4,INe4)-
     &  FD211HNeuNeu(2,6,INe3,INe4)*Mah(INH4)**2+
     &  FD211HNeuNeu(3,6,INe3,INe4)*Mah(INH4)**2)+
     &  CFF11S1L(INe3,INe4,INH4)*(FD111ChiHChi(1,INe3,6,INe4)-
     &  FD111ChiHChi(1,INe3,INH4,INe4)+FD211HNeuNeu(1,6,INe3,INe4)*
     &  Mah(INH4)**2)*MNeu(INe3)*MNeu(INe4))+CFF11S1R(INe4,INe3,6)*
     &  (CFF11S1L(INe3,INe4,INH4)*(-FD111ChiHChi(2,INe3,6,INe4)+
     &  FD111ChiHChi(2,INe3,INH4,INe4)+FD111ChiHChi(4,INe3,6,INe4)-
     &  FD111ChiHChi(4,INe3,INH4,INe4)-FD211HNeuNeu(2,6,INe3,INe4)*
     &  Mah(INH4)**2+FD211HNeuNeu(3,6,INe3,INe4)*Mah(INH4)**2)+
     &  CFF11S1R(INe3,INe4,INH4)*(FD111ChiHChi(1,INe3,6,INe4)-
     &  FD111ChiHChi(1,INe3,INH4,INe4)+FD211HNeuNeu(1,6,INe3,INe4)*
     &  Mah(INH4)**2)*MNeu(INe3)*MNeu(INe4))))/(16.*Mah(INH4)**4)+
     &  self(i,j)
              enddo
        INH5=6
        INH4=6
            do INH3=ihiggs,5
       self(i,j)=(CS1S1S1(i,INH3,6)*CS1S1S1(j,INH3,6)*
     &  (CFF11S1L(INe4,INe3,6)*(CFF11S1R(INe3,INe4,6)*(-
     &  FD111ChiHChi(2,INe3,6,INe4)+FD111ChiHChi(2,INe3,INH3,INe4)+
     &  FD111ChiHChi(4,INe3,6,INe4)-FD111ChiHChi(4,INe3,INH3,INe4)-
     &  FD211HNeuNeu(2,6,INe3,INe4)*Mah(INH3)**2+
     &  FD211HNeuNeu(3,6,INe3,INe4)*Mah(INH3)**2)+CFF11S1L(INe3,INe4,6)
     &  *(FD111ChiHChi(1,INe3,6,INe4)-FD111ChiHChi(1,INe3,INH3,INe4)+
     &  FD211HNeuNeu(1,6,INe3,INe4)*Mah(INH3)**2)*MNeu(INe3)*MNeu(INe4)
     &  )+CFF11S1R(INe4,INe3,6)*(CFF11S1L(INe3,INe4,6)*(-
     &  FD111ChiHChi(2,INe3,6,INe4)+FD111ChiHChi(2,INe3,INH3,INe4)+
     &  FD111ChiHChi(4,INe3,6,INe4)-FD111ChiHChi(4,INe3,INH3,INe4)-
     &  FD211HNeuNeu(2,6,INe3,INe4)*Mah(INH3)**2+
     &  FD211HNeuNeu(3,6,INe3,INe4)*Mah(INH3)**2)+CFF11S1R(INe3,INe4,6)
     &  *(FD111ChiHChi(1,INe3,6,INe4)-FD111ChiHChi(1,INe3,INH3,INe4)+
     &  FD211HNeuNeu(1,6,INe3,INe4)*Mah(INH3)**2)*MNeu(INe3)*MNeu(INe4)
     &  )))/(16.*Mah(INH3)**4)+self(i,j)
              enddo
        INH3=6
       self(i,j)=(CS1S1S1(i,6,6)*CS1S1S1(j,6,6)*(CFF11S1L(INe4,INe3,6)*
     &  (CFF11S1R(INe3,INe4,6)*(FD311HChiChi(2,6,INe3,INe4)-
     &  FD311HChiChi(5,6,INe3,INe4))-CFF11S1L(INe3,INe4,6)*
     &  FD311HChiChi(1,6,INe3,INe4)*MNeu(INe3)*MNeu(INe4))+
     &  CFF11S1R(INe4,INe3,6)*(CFF11S1L(INe3,INe4,6)*
     &  (FD311HChiChi(2,6,INe3,INe4)-FD311HChiChi(5,6,INe3,INe4))-
     &  CFF11S1R(INe3,INe4,6)*FD311HChiChi(1,6,INe3,INe4)*MNeu(INe3)*
     &  MNeu(INe4))))/16.+self(i,j)
       enddo 
       enddo 
       ! diagram  3  
        ICH3=1
        ICH4=1
            ICH5=2
       self(i,j)=(3*CS1S3S3(i,1,1)*(CS1S3S3(j,1,ICH5)*CTBS3(ICH5)*
     &  CTBS3C(1)+CS1S3S3(j,ICH5,1)*CTBS3(1)*CTBS3C(ICH5))*(-
     &  FD111THpB(2,1)+FD111THpB(2,ICH5)+FD111THpB(4,1)-
     &  FD111THpB(4,ICH5)-FD211HpTB(2,1)*MassHpm(ICH5)**2+
     &  FD211HpTB(3,1)*MassHpm(ICH5)**2))/(8.*MassHpm(ICH5)**4)+
     &  self(i,j)
        ICH3=1
        ICH5=1
            ICH4=2
       self(i,j)=(3*CS1S3S3(j,1,1)*(CS1S3S3(i,1,ICH4)*CTBS3(ICH4)*
     &  CTBS3C(1)+CS1S3S3(i,ICH4,1)*CTBS3(1)*CTBS3C(ICH4))*(-
     &  FD111THpB(2,1)+FD111THpB(2,ICH4)+FD111THpB(4,1)-
     &  FD111THpB(4,ICH4)-FD211HpTB(2,1)*MassHpm(ICH4)**2+
     &  FD211HpTB(3,1)*MassHpm(ICH4)**2))/(8.*MassHpm(ICH4)**4)+
     &  self(i,j)
        ICH5=1
        ICH4=1
            ICH3=2
       self(i,j)=(3*(CS1S3S3(i,ICH3,1)*CS1S3S3(j,1,ICH3)+
     &  CS1S3S3(i,1,ICH3)*CS1S3S3(j,ICH3,1))*CTBS3(1)*CTBS3C(1)*(-
     &  FD111THpB(2,1)+FD111THpB(2,ICH3)+FD111THpB(4,1)-
     &  FD111THpB(4,ICH3)-FD211HpTB(2,1)*MassHpm(ICH3)**2+
     &  FD211HpTB(3,1)*MassHpm(ICH3)**2))/(8.*MassHpm(ICH3)**4)+
     &  self(i,j)
        ICH3=1
       self(i,j)=(3*CS1S3S3(i,1,1)*CS1S3S3(j,1,1)*CTBS3(1)*CTBS3C(1)*
     &  (FD311HpTB(2,1)-FD311HpTB(5,1)))/4.+self(i,j)
       ! diagram  4  
       do INe3=ineu,3
        ICH3=1
        ICH4=1
            ICH5=2
       self(i,j)=(CS1S3S3(i,1,1)*(-(CF11F12S3R(INe3,ICH5)*
     &  CS1S3S3(j,ICH5,1)*DCONJG(CF11F12S3R(INe3,1))*
     &  FD111ChiHpCha(2,INe3,1))-CF11F12S3R(INe3,1)*CS1S3S3(j,1,ICH5)*
     &  DCONJG(CF11F12S3R(INe3,ICH5))*FD111ChiHpCha(2,INe3,1)+
     &  CF11F12S3R(INe3,ICH5)*CS1S3S3(j,ICH5,1)*
     &  DCONJG(CF11F12S3R(INe3,1))*FD111ChiHpCha(2,INe3,ICH5)+
     &  CF11F12S3R(INe3,1)*CS1S3S3(j,1,ICH5)*
     &  DCONJG(CF11F12S3R(INe3,ICH5))*FD111ChiHpCha(2,INe3,ICH5)+
     &  CF11F12S3R(INe3,ICH5)*CS1S3S3(j,ICH5,1)*
     &  DCONJG(CF11F12S3R(INe3,1))*FD111ChiHpCha(4,INe3,1)+
     &  CF11F12S3R(INe3,1)*CS1S3S3(j,1,ICH5)*
     &  DCONJG(CF11F12S3R(INe3,ICH5))*FD111ChiHpCha(4,INe3,1)-
     &  CF11F12S3R(INe3,ICH5)*CS1S3S3(j,ICH5,1)*
     &  DCONJG(CF11F12S3R(INe3,1))*FD111ChiHpCha(4,INe3,ICH5)-
     &  CF11F12S3R(INe3,1)*CS1S3S3(j,1,ICH5)*
     &  DCONJG(CF11F12S3R(INe3,ICH5))*FD111ChiHpCha(4,INe3,ICH5)-
     &  CF11F12S3R(INe3,ICH5)*CS1S3S3(j,ICH5,1)*
     &  DCONJG(CF11F12S3R(INe3,1))*FD211HpChiCha(2,1,INe3)*
     &  MassHpm(ICH5)**2-CF11F12S3R(INe3,1)*CS1S3S3(j,1,ICH5)*
     &  DCONJG(CF11F12S3R(INe3,ICH5))*FD211HpChiCha(2,1,INe3)*
     &  MassHpm(ICH5)**2+CF11F12S3R(INe3,ICH5)*CS1S3S3(j,ICH5,1)*
     &  DCONJG(CF11F12S3R(INe3,1))*FD211HpChiCha(3,1,INe3)*
     &  MassHpm(ICH5)**2+CF11F12S3R(INe3,1)*CS1S3S3(j,1,ICH5)*
     &  DCONJG(CF11F12S3R(INe3,ICH5))*FD211HpChiCha(3,1,INe3)*
     &  MassHpm(ICH5)**2+MCha*CF11F12S3R(INe3,ICH5)*CS1S3S3(j,ICH5,1)*
     &  DCONJG(CF11F12S3L(INe3,1))*FD111ChiHpCha(1,INe3,1)*MNeu(INe3)+
     &  MCha*CF11F12S3R(INe3,1)*CS1S3S3(j,1,ICH5)*
     &  DCONJG(CF11F12S3L(INe3,ICH5))*FD111ChiHpCha(1,INe3,1)*
     &  MNeu(INe3)-MCha*CF11F12S3R(INe3,ICH5)*CS1S3S3(j,ICH5,1)*
     &  DCONJG(CF11F12S3L(INe3,1))*FD111ChiHpCha(1,INe3,ICH5)*
     &  MNeu(INe3)-MCha*CF11F12S3R(INe3,1)*CS1S3S3(j,1,ICH5)*
     &  DCONJG(CF11F12S3L(INe3,ICH5))*FD111ChiHpCha(1,INe3,ICH5)*
     &  MNeu(INe3)+MCha*CF11F12S3R(INe3,ICH5)*CS1S3S3(j,ICH5,1)*
     &  DCONJG(CF11F12S3L(INe3,1))*FD211HpChiCha(1,1,INe3)*
     &  MassHpm(ICH5)**2*MNeu(INe3)+MCha*CF11F12S3R(INe3,1)*
     &  CS1S3S3(j,1,ICH5)*DCONJG(CF11F12S3L(INe3,ICH5))*
     &  FD211HpChiCha(1,1,INe3)*MassHpm(ICH5)**2*MNeu(INe3)+
     &  CF11F12S3L(INe3,ICH5)*CS1S3S3(j,ICH5,1)*
     &  (DCONJG(CF11F12S3L(INe3,1))*(-FD111ChiHpCha(2,INe3,1)+
     &  FD111ChiHpCha(2,INe3,ICH5)+FD111ChiHpCha(4,INe3,1)-
     &  FD111ChiHpCha(4,INe3,ICH5)-FD211HpChiCha(2,1,INe3)*
     &  MassHpm(ICH5)**2+FD211HpChiCha(3,1,INe3)*MassHpm(ICH5)**2)+
     &  MCha*DCONJG(CF11F12S3R(INe3,1))*(FD111ChiHpCha(1,INe3,1)-
     &  FD111ChiHpCha(1,INe3,ICH5)+FD211HpChiCha(1,1,INe3)*
     &  MassHpm(ICH5)**2)*MNeu(INe3))+CF11F12S3L(INe3,1)*
     &  CS1S3S3(j,1,ICH5)*(DCONJG(CF11F12S3L(INe3,ICH5))*(-
     &  FD111ChiHpCha(2,INe3,1)+FD111ChiHpCha(2,INe3,ICH5)+
     &  FD111ChiHpCha(4,INe3,1)-FD111ChiHpCha(4,INe3,ICH5)-
     &  FD211HpChiCha(2,1,INe3)*MassHpm(ICH5)**2+
     &  FD211HpChiCha(3,1,INe3)*MassHpm(ICH5)**2)+MCha*
     &  DCONJG(CF11F12S3R(INe3,ICH5))*(FD111ChiHpCha(1,INe3,1)-
     &  FD111ChiHpCha(1,INe3,ICH5)+FD211HpChiCha(1,1,INe3)*MassHpm(ICH5)**2)*MNeu(INe3))))/(8.*MassHpm(ICH5)**4)+self(i,j)
        ICH3=1
        ICH5=1
            ICH4=2
       self(i,j)=(CS1S3S3(j,1,1)*(-(CF11F12S3R(INe3,ICH4)*
     &  CS1S3S3(i,ICH4,1)*DCONJG(CF11F12S3R(INe3,1))*
     &  FD111ChiHpCha(2,INe3,1))-CF11F12S3R(INe3,1)*CS1S3S3(i,1,ICH4)*
     &  DCONJG(CF11F12S3R(INe3,ICH4))*FD111ChiHpCha(2,INe3,1)+
     &  CF11F12S3R(INe3,ICH4)*CS1S3S3(i,ICH4,1)*
     &  DCONJG(CF11F12S3R(INe3,1))*FD111ChiHpCha(2,INe3,ICH4)+
     &  CF11F12S3R(INe3,1)*CS1S3S3(i,1,ICH4)*
     &  DCONJG(CF11F12S3R(INe3,ICH4))*FD111ChiHpCha(2,INe3,ICH4)+
     &  CF11F12S3R(INe3,ICH4)*CS1S3S3(i,ICH4,1)*
     &  DCONJG(CF11F12S3R(INe3,1))*FD111ChiHpCha(4,INe3,1)+
     &  CF11F12S3R(INe3,1)*CS1S3S3(i,1,ICH4)*
     &  DCONJG(CF11F12S3R(INe3,ICH4))*FD111ChiHpCha(4,INe3,1)-
     &  CF11F12S3R(INe3,ICH4)*CS1S3S3(i,ICH4,1)*
     &  DCONJG(CF11F12S3R(INe3,1))*FD111ChiHpCha(4,INe3,ICH4)-
     &  CF11F12S3R(INe3,1)*CS1S3S3(i,1,ICH4)*
     &  DCONJG(CF11F12S3R(INe3,ICH4))*FD111ChiHpCha(4,INe3,ICH4)-
     &  CF11F12S3R(INe3,ICH4)*CS1S3S3(i,ICH4,1)*
     &  DCONJG(CF11F12S3R(INe3,1))*FD211HpChiCha(2,1,INe3)*
     &  MassHpm(ICH4)**2-CF11F12S3R(INe3,1)*CS1S3S3(i,1,ICH4)*
     &  DCONJG(CF11F12S3R(INe3,ICH4))*FD211HpChiCha(2,1,INe3)*
     &  MassHpm(ICH4)**2+CF11F12S3R(INe3,ICH4)*CS1S3S3(i,ICH4,1)*
     &  DCONJG(CF11F12S3R(INe3,1))*FD211HpChiCha(3,1,INe3)*
     &  MassHpm(ICH4)**2+CF11F12S3R(INe3,1)*CS1S3S3(i,1,ICH4)*
     &  DCONJG(CF11F12S3R(INe3,ICH4))*FD211HpChiCha(3,1,INe3)*
     &  MassHpm(ICH4)**2+MCha*CF11F12S3R(INe3,ICH4)*CS1S3S3(i,ICH4,1)*
     &  DCONJG(CF11F12S3L(INe3,1))*FD111ChiHpCha(1,INe3,1)*MNeu(INe3)+
     &  MCha*CF11F12S3R(INe3,1)*CS1S3S3(i,1,ICH4)*
     &  DCONJG(CF11F12S3L(INe3,ICH4))*FD111ChiHpCha(1,INe3,1)*
     &  MNeu(INe3)-MCha*CF11F12S3R(INe3,ICH4)*CS1S3S3(i,ICH4,1)*
     &  DCONJG(CF11F12S3L(INe3,1))*FD111ChiHpCha(1,INe3,ICH4)*
     &  MNeu(INe3)-MCha*CF11F12S3R(INe3,1)*CS1S3S3(i,1,ICH4)*
     &  DCONJG(CF11F12S3L(INe3,ICH4))*FD111ChiHpCha(1,INe3,ICH4)*
     &  MNeu(INe3)+MCha*CF11F12S3R(INe3,ICH4)*CS1S3S3(i,ICH4,1)*
     &  DCONJG(CF11F12S3L(INe3,1))*FD211HpChiCha(1,1,INe3)*
     &  MassHpm(ICH4)**2*MNeu(INe3)+MCha*CF11F12S3R(INe3,1)*
     &  CS1S3S3(i,1,ICH4)*DCONJG(CF11F12S3L(INe3,ICH4))*
     &  FD211HpChiCha(1,1,INe3)*MassHpm(ICH4)**2*MNeu(INe3)+
     &  CF11F12S3L(INe3,ICH4)*CS1S3S3(i,ICH4,1)*
     &  (DCONJG(CF11F12S3L(INe3,1))*(-FD111ChiHpCha(2,INe3,1)+
     &  FD111ChiHpCha(2,INe3,ICH4)+FD111ChiHpCha(4,INe3,1)-
     &  FD111ChiHpCha(4,INe3,ICH4)-FD211HpChiCha(2,1,INe3)*
     &  MassHpm(ICH4)**2+FD211HpChiCha(3,1,INe3)*MassHpm(ICH4)**2)+
     &  MCha*DCONJG(CF11F12S3R(INe3,1))*(FD111ChiHpCha(1,INe3,1)-
     &  FD111ChiHpCha(1,INe3,ICH4)+FD211HpChiCha(1,1,INe3)*
     &  MassHpm(ICH4)**2)*MNeu(INe3))+CF11F12S3L(INe3,1)*
     &  CS1S3S3(i,1,ICH4)*(DCONJG(CF11F12S3L(INe3,ICH4))*(-
     &  FD111ChiHpCha(2,INe3,1)+FD111ChiHpCha(2,INe3,ICH4)+
     &  FD111ChiHpCha(4,INe3,1)-FD111ChiHpCha(4,INe3,ICH4)-
     &  FD211HpChiCha(2,1,INe3)*MassHpm(ICH4)**2+
     &  FD211HpChiCha(3,1,INe3)*MassHpm(ICH4)**2)+MCha*
     &  DCONJG(CF11F12S3R(INe3,ICH4))*(FD111ChiHpCha(1,INe3,1)-
     &  FD111ChiHpCha(1,INe3,ICH4)+FD211HpChiCha(1,1,INe3)*MassHpm(ICH4)**2)*MNeu(INe3))))/(8.*MassHpm(ICH4)**4)+self(i,j)
        ICH5=1
        ICH4=1
            ICH3=2
       self(i,j)=((CS1S3S3(i,ICH3,1)*CS1S3S3(j,1,ICH3)+
     &  CS1S3S3(i,1,ICH3)*CS1S3S3(j,ICH3,1))*(CF11F12S3R(INe3,1)*
     &  (DCONJG(CF11F12S3R(INe3,1))*(-FD111ChiHpCha(2,INe3,1)+
     &  FD111ChiHpCha(2,INe3,ICH3)+FD111ChiHpCha(4,INe3,1)-
     &  FD111ChiHpCha(4,INe3,ICH3)-FD211HpChiCha(2,1,INe3)*
     &  MassHpm(ICH3)**2+FD211HpChiCha(3,1,INe3)*MassHpm(ICH3)**2)+
     &  MCha*DCONJG(CF11F12S3L(INe3,1))*(FD111ChiHpCha(1,INe3,1)-
     &  FD111ChiHpCha(1,INe3,ICH3)+FD211HpChiCha(1,1,INe3)*
     &  MassHpm(ICH3)**2)*MNeu(INe3))+CF11F12S3L(INe3,1)*
     &  (DCONJG(CF11F12S3L(INe3,1))*(-FD111ChiHpCha(2,INe3,1)+
     &  FD111ChiHpCha(2,INe3,ICH3)+FD111ChiHpCha(4,INe3,1)-
     &  FD111ChiHpCha(4,INe3,ICH3)-FD211HpChiCha(2,1,INe3)*
     &  MassHpm(ICH3)**2+FD211HpChiCha(3,1,INe3)*MassHpm(ICH3)**2)+
     &  MCha*DCONJG(CF11F12S3R(INe3,1))*(FD111ChiHpCha(1,INe3,1)-
     &  FD111ChiHpCha(1,INe3,ICH3)+FD211HpChiCha(1,1,INe3)*
     &  MassHpm(ICH3)**2)*MNeu(INe3))))/(8.*MassHpm(ICH3)**4)+self(i,j)
        ICH3=1
       self(i,j)=(CS1S3S3(i,1,1)*CS1S3S3(j,1,1)*(CF11F12S3R(INe3,1)*
     &  (DCONJG(CF11F12S3R(INe3,1))*(FD311HpChiCha(2,1,INe3)-
     &  FD311HpChiCha(5,1,INe3))-MCha*DCONJG(CF11F12S3L(INe3,1))*
     &  FD311HpChiCha(1,1,INe3)*MNeu(INe3))+CF11F12S3L(INe3,1)*
     &  (DCONJG(CF11F12S3L(INe3,1))*(FD311HpChiCha(2,1,INe3)-
     &  FD311HpChiCha(5,1,INe3))-MCha*DCONJG(CF11F12S3R(INe3,1))*
     &  FD311HpChiCha(1,1,INe3)*MNeu(INe3))))/4.+self(i,j)
       enddo 

c
c topo9
c
       ! diagram  1  
       ! diagram  1  
       do INH5=ihiggs,6
       do INH6=ihiggs,6

        INH3=6
        INH4=6
            do INH7=ihiggs,5
       self(i,j)=(CS1S1S1(6,INH5,INH6)*CS1S1S1(i,6,6)*
     &  CS1S1S1(INH5,INH6,INH7)*CS1S1S1(j,6,INH7)*(-
     &  FD111HHH(1,6,INH5,INH6)+FD111HHH(1,INH5,INH7,INH6)-
     &  FD211HHH(1,6,INH5,INH6)*Mah(INH7)**2))/(32.*Mah(INH7)**4)+
     &  self(i,j)
              enddo
        INH3=6
        INH7=6
            do INH4=ihiggs,5
       self(i,j)=(CS1S1S1(i,6,INH4)*CS1S1S1(INH4,INH5,INH6)*
     &  CS1S1S1(INH5,INH6,6)*CS1S1S1(j,6,6)*(-FD111HHH(1,6,INH5,INH6)+
     &  FD111HHH(1,INH4,INH5,INH6)-FD211HHH(1,6,INH5,INH6)*Mah(INH4)**
     &  2))/(32.*Mah(INH4)**4)+self(i,j)
              enddo
        INH7=6
        INH4=6
            do INH3=ihiggs,5
       self(i,j)=(CS1S1S1(6,INH5,INH6)*CS1S1S1(i,INH3,6)*
     &  CS1S1S1(INH5,INH6,6)*CS1S1S1(j,INH3,6)*(-
     &  FD111HHH(1,6,INH5,INH6)+FD111HHH(1,INH3,INH5,INH6)-
     &  FD211HHH(1,6,INH5,INH6)*Mah(INH3)**2))/(32.*Mah(INH3)**4)+
     &  self(i,j)
              enddo

        INH3=6
       self(i,j)=(CS1S1S1(6,INH5,INH6)*CS1S1S1(i,6,6)*
     &  CS1S1S1(INH5,INH6,6)*CS1S1S1(j,6,6)*FD311HHH(1,6,INH5,INH6))
     &  /32.+self(i,j)


       enddo 
       enddo 
       ! diagram  2  zero

       ! diagram  3  
       do ICH5=1,2
       do INH3=ihiggs,6
        ICH3=1
        ICH4=1
            ICH6=2
       self(i,j)=(CS1S3S3(i,1,1)*(CS1S3S3(INH3,ICH5,1)*
     &  CS1S3S3(INH3,ICH6,ICH5)*CS1S3S3(j,1,ICH6)+CS1S3S3(INH3,1,ICH5)*
     &  CS1S3S3(INH3,ICH5,ICH6)*CS1S3S3(j,ICH6,1))*(-
     &  FD111HHpHp(1,INH3,1,ICH5)+FD111HHpHp(1,INH3,ICH6,ICH5)-
     &  FD211HpHHp(1,1,INH3,ICH5)*MassHpm(ICH6)**2))/(16.*MassHpm(ICH6)
     &  **4)+self(i,j)
        ICH3=1
        ICH6=1
            ICH4=2
       self(i,j)=((CS1S3S3(i,1,ICH4)*CS1S3S3(INH3,ICH4,ICH5)*
     &  CS1S3S3(INH3,ICH5,1)+CS1S3S3(i,ICH4,1)*CS1S3S3(INH3,1,ICH5)*
     &  CS1S3S3(INH3,ICH5,ICH4))*CS1S3S3(j,1,1)*(-
     &  FD111HHpHp(1,INH3,1,ICH5)+FD111HHpHp(1,INH3,ICH4,ICH5)-
     &  FD211HpHHp(1,1,INH3,ICH5)*MassHpm(ICH4)**2))/(16.*MassHpm(ICH4)
     &  **4)+self(i,j)
        ICH6=1
        ICH4=1
            ICH3=2
       self(i,j)=(CS1S3S3(INH3,1,ICH5)*CS1S3S3(INH3,ICH5,1)*
     &  (CS1S3S3(i,ICH3,1)*CS1S3S3(j,1,ICH3)+CS1S3S3(i,1,ICH3)*
     &  CS1S3S3(j,ICH3,1))*(-FD111HHpHp(1,INH3,1,ICH5)+
     &  FD111HHpHp(1,INH3,ICH3,ICH5)-FD211HpHHp(1,1,INH3,ICH5)*
     &  MassHpm(ICH3)**2))/(16.*MassHpm(ICH3)**4)+self(i,j)
        ICH3=1
       self(i,j)=(CS1S3S3(i,1,1)*CS1S3S3(INH3,1,ICH5)*
     &  CS1S3S3(INH3,ICH5,1)*CS1S3S3(j,1,1)*FD311HpHHp(1,1,INH3,ICH5))
     &  /8.+self(i,j)
       enddo 
       enddo 


       ! diagram  4  
       do ISt3=1,2
       do ISt4=1,2
        INH3=6
        INH4=6
            do INH5=ihiggs,5
       self(i,j)=(3*CS1S1S1(i,6,6)*CS1S1S1(j,6,INH5)*CSSS(6,ISt4,ISt3)*
     &  CSSS(INH5,ISt3,ISt4)*(-FD111HSTST(1,6,ISt3,ISt4)+
     &  FD111HSTST(1,INH5,ISt3,ISt4)-FD211HSTST(1,6,ISt3,ISt4)*
     &  Mah(INH5)**2))/(16.*Mah(INH5)**4)+self(i,j)
              enddo
        INH3=6
        INH5=6
            do INH4=ihiggs,5
       self(i,j)=(3*CS1S1S1(i,6,INH4)*CS1S1S1(j,6,6)*CSSS(6,ISt3,ISt4)*
     &  CSSS(INH4,ISt4,ISt3)*(-FD111HSTST(1,6,ISt3,ISt4)+
     &  FD111HSTST(1,INH4,ISt3,ISt4)-FD211HSTST(1,6,ISt3,ISt4)*
     &  Mah(INH4)**2))/(16.*Mah(INH4)**4)+self(i,j)
              enddo
        INH5=6
        INH4=6
            do INH3=ihiggs,5
       self(i,j)=(3*CS1S1S1(i,INH3,6)*CS1S1S1(j,INH3,6)*
     &  CSSS(6,ISt3,ISt4)*CSSS(6,ISt4,ISt3)*(-FD111HSTST(1,6,ISt3,ISt4)
     &  +FD111HSTST(1,INH3,ISt3,ISt4)-FD211HSTST(1,6,ISt3,ISt4)*
     &  Mah(INH3)**2))/(16.*Mah(INH3)**4)+self(i,j)
              enddo
        INH3=6
       self(i,j)=(3*CS1S1S1(i,6,6)*CS1S1S1(j,6,6)*CSSS(6,ISt3,ISt4)*
     &  CSSS(6,ISt4,ISt3)*FD311HSTST(1,6,ISt3,ISt4))/16.+self(i,j)
       enddo 
       enddo 

       ! diagram  5  
       do ISt3=1,2
        ICH3=1
        ICH4=1
            ICH5=2
       self(i,j)=(3*CS1S3S3(i,1,1)*(CS1S3S3(j,1,ICH5)*
     &  CS3S13S(ICH5,ISt3)*CS3S13SC(1,ISt3)+CS1S3S3(j,ICH5,1)*
     &  CS3S13S(1,ISt3)*CS3S13SC(ICH5,ISt3))*(-FD111HpSTSB(1,1,ISt3)+
     &  FD111HpSTSB(1,ICH5,ISt3)-FD211HpSTSB(1,1,ISt3)*MassHpm(ICH5)**
     &  2))/(16.*MassHpm(ICH5)**4)+self(i,j)
        ICH3=1
        ICH5=1
            ICH4=2
       self(i,j)=(3*CS1S3S3(j,1,1)*(CS1S3S3(i,1,ICH4)*
     &  CS3S13S(ICH4,ISt3)*CS3S13SC(1,ISt3)+CS1S3S3(i,ICH4,1)*
     &  CS3S13S(1,ISt3)*CS3S13SC(ICH4,ISt3))*(-FD111HpSTSB(1,1,ISt3)+
     &  FD111HpSTSB(1,ICH4,ISt3)-FD211HpSTSB(1,1,ISt3)*MassHpm(ICH4)**
     &  2))/(16.*MassHpm(ICH4)**4)+self(i,j)
        ICH5=1
        ICH4=1
            ICH3=2
       self(i,j)=(3*(CS1S3S3(i,ICH3,1)*CS1S3S3(j,1,ICH3)+
     &  CS1S3S3(i,1,ICH3)*CS1S3S3(j,ICH3,1))*CS3S13S(1,ISt3)*
     &  CS3S13SC(1,ISt3)*(-FD111HpSTSB(1,1,ISt3)+
     &  FD111HpSTSB(1,ICH3,ISt3)-FD211HpSTSB(1,1,ISt3)*MassHpm(ICH3)**
     &  2))/(16.*MassHpm(ICH3)**4)+self(i,j)
        ICH3=1
       self(i,j)=(3*CS1S3S3(i,1,1)*CS1S3S3(j,1,1)*CS3S13S(1,ISt3)*
     &  CS3S13SC(1,ISt3)*FD311HpSTSB(1,1,ISt3))/8.+self(i,j)
       enddo 

c
c topo10
c
       INH3=6
       INH4=6
       selfCT(i,j)=(CS1S1S1S1(i,j,INH3,INH4)*(2*dMH1MT4(INH3,INH4,3)-2*
     &  AETNH(INH4)*dZHiggs1(INH3,INH4,1)-2*A0TNH(INH4)*
     &  dZHiggs1(INH3,INH4,2)-dZHiggs1(INH3,INH4,3)*(Mah2(INH3)+
     &  Mah2(INH4))+aBEpTNH(INH3,INH4)*(2*dMH1MT4(INH3,INH4,1)+
     &  dZHiggs1(INH3,INH4,1)*(-Mah2(INH3)+Mah2(INH4)))+
     &  aB0TNH(INH3,INH4)*(2*dMH1MT4(INH3,INH4,2)+dZHiggs1(INH3,INH4,2)
     &  *(-Mah2(INH3)+Mah2(INH4)))))/4.+selfCT(i,j)

       ICH3=1
       ICH4=1       
       selfCT(i,j)=(CS1S1S3S3(i,j,ICH4,ICH3)*(2*dMCH1L(ICH4,ICH3,3)-2*
     &  AETHpN(ICH4)*dZCHiggs1(ICH4,ICH3,1)-2*A0THpN(ICH4)*
     &  dZCHiggs1(ICH4,ICH3,2)-dZCHiggs1(ICH4,ICH3,3)*(MassHpm(ICH3)**
     &  2+MassHpm(ICH4)**2)+aBEpTCH(ICH3,ICH4)*(2*dMCH1L(ICH4,ICH3,1)+
     &  dZCHiggs1(ICH4,ICH3,1)*(-MassHpm(ICH3)**2+MassHpm(ICH4)**2))+
     &  aB0TCH(ICH3,ICH4)*(2*dMCH1L(ICH4,ICH3,2)+dZCHiggs1(ICH4,ICH3,2)
     &  *(-MassHpm(ICH3)**2+MassHpm(ICH4)**2))))/2.+selfCT(i,j)

c
c topo6
c
        INH3=6
        INH4=6       
       do INH5=ihiggs,6
       self(i,j)=-(CS1S1S1S1(i,j,INH3,INH4)*
     &  CS1S1S1S1(INH3,INH4,INH5,INH5)*(A0TNH(INH5)*aB0TNH(INH3,INH4)+
     &  AETNH(INH5)+aBEpTNH(INH3,INH4)*Mah2(INH5)))/64.+self(i,j)
       enddo 
        INH3=6
        INH4=6        
       do ICH3=1,2
       self(i,j)=-(CS1S1S1S1(i,j,INH3,INH4)*
     &  CS1S1S3S3(INH3,INH4,ICH3,ICH3)*(A0THpN(ICH3)*aB0TNH(INH3,INH4)+
     &  AETHpN(ICH3)+aBEpTNH(INH3,INH4)*MassHpm(ICH3)**2))/32.+
     &  self(i,j)
       enddo 
        ICH3=1
        ICH4=1        
       do INH3=ihiggs,6
       self(i,j)=-(CS1S1S3S3(i,j,ICH3,ICH4)*
     &  CS1S1S3S3(INH3,INH3,ICH4,ICH3)*(A0TNH(INH3)*aB0TCH(ICH3,ICH4)+
     &  AETNH(INH3)+aBEpTCH(ICH3,ICH4)*Mah2(INH3)))/32.+self(i,j)
       enddo 
        ICH3=1
        ICH4=1
       do ICH5=1,2
       self(i,j)=-(CS1S1S3S3(i,j,ICH3,ICH4)*
     &  CS3S3S3S3(ICH4,ICH5,ICH3,ICH5)*(A0THpN(ICH5)*aB0TCH(ICH3,ICH4)+
     &  AETHpN(ICH5)+aBEpTCH(ICH3,ICH4)*MassHpm(ICH5)**2))/16.+
     &  self(i,j)
       enddo 
        INH3=6
        INH4=6      
       do ISt3=1,2
       self(i,j)=(-3*CS1S1S1S1(i,j,INH3,INH4)*
     &  CSSSS(INH3,INH4,ISt3,ISt3)*(aAETN(ISt3)+aA0TN(ISt3)*
     &  aB0TNH(INH3,INH4)+aBEpTNH(INH3,INH4)*MassSu2(ISt3)))/32.+
     &  self(i,j)
       enddo 
        ICH3=1
        ICH4=1       
       do ISt3=1,2
       self(i,j)=(-3*CS1S1S3S3(i,j,ICH3,ICH4)*
     &  CS3S3S13S13(ICH4,ICH3,ISt3,ISt3)*(aAETN(ISt3)+aA0TN(ISt3)*
     &  aB0TCH(ICH3,ICH4)+aBEpTCH(ICH3,ICH4)*MassSu2(ISt3)))/16.+
     &  self(i,j)
       enddo 
        ICH3=1
        ICH4=1        
       self(i,j)=(-3*(aet5+a0t5*aB0TCH(ICH3,ICH4)+MSQ2*
     &  aBEpTCH(ICH3,ICH4))*CS1S1S3S3(i,j,ICH3,ICH4)*
     &  CS3S3S14S14(ICH4,ICH3))/16.+self(i,j)

c
c topo11
c
        INH3=6
        INH4=6      
       self(i,j)=-(CS1S1S1S1(i,j,INH3,INH4)*(CFF12S1R(INH3)*(MCha2*
     &  CFF12S1R(INH4)*FD211HChaCha(1,INH3)+CFF12S1L(INH4)*(-
     &  FD211HChaCha(2,INH3)+FD211HChaCha(3,INH3)))+CFF12S1L(INH3)*
     &  (MCha2*CFF12S1L(INH4)*FD211HChaCha(1,INH3)+CFF12S1R(INH4)*(-
     &  FD211HChaCha(2,INH3)+FD211HChaCha(3,INH3)))-3*(FD211HTT(2,INH3)
     &  -FD211HTT(3,INH3))*(hy(INH4)*hyc(INH3)+hy(INH3)*hyc(INH4))+3*
     &  M12*FD211HTT(1,INH3)*(hy(INH3)*hy(INH4)+hyc(INH3)*hyc(INH4))))
     &  /16.+self(i,j)
        INH3=6
        INH4=6
       do INe3=ineu,3
       do INe4=ineu,3       
       self(i,j)=(CS1S1S1S1(i,j,INH3,INH4)*((CFF11S1L(INe4,INe3,INH3)*
     &  CFF11S1R(INe3,INe4,INH4)+CFF11S1L(INe3,INe4,INH4)*
     &  CFF11S1R(INe4,INe3,INH3))*(FD211HNeuNeu(2,INH3,INe4,INe3)-
     &  FD211HNeuNeu(3,INH3,INe4,INe3))-(CFF11S1L(INe3,INe4,INH4)*
     &  CFF11S1L(INe4,INe3,INH3)+CFF11S1R(INe3,INe4,INH4)*
     &  CFF11S1R(INe4,INe3,INH3))*FD211HNeuNeu(1,INH3,INe4,INe3)*
     &  MNeu(INe3)*MNeu(INe4)))/32.+self(i,j)
       enddo 
       enddo 
        ICH3=1
        ICH4=1      
       self(i,j)=(3*CS1S1S3S3(i,j,ICH4,ICH3)*CTBS3(ICH3)*CTBS3C(ICH4)*
     &  (FD211HpTB(2,ICH3)-FD211HpTB(3,ICH3)))/8.+self(i,j)
        ICH3=1
        ICH4=1
       do INe3=ineu,3      
       self(i,j)=(CS1S1S3S3(i,j,ICH3,ICH4)*((CF11F12S3L(INe3,ICH3)*
     &  DCONJG(CF11F12S3L(INe3,ICH4))+CF11F12S3R(INe3,ICH3)*
     &  DCONJG(CF11F12S3R(INe3,ICH4)))*(FD211HpChiCha(2,ICH3,INe3)-
     &  FD211HpChiCha(3,ICH3,INe3))-MCha*(CF11F12S3R(INe3,ICH3)*
     &  DCONJG(CF11F12S3L(INe3,ICH4))+CF11F12S3L(INe3,ICH3)*
     &  DCONJG(CF11F12S3R(INe3,ICH4)))*FD211HpChiCha(1,ICH3,INe3)*
     &  MNeu(INe3)))/8.+self(i,j)
       enddo 


c
c topo13
c
        INH5=6
        INH6=6
       do INH3=ihiggs,6
       do INH4=ihiggs,6       
       self(i,j)=(CS1S1S1(INH3,INH4,INH5)*CS1S1S1(INH3,INH4,INH6)*
     &  CS1S1S1S1(i,j,INH5,INH6)*FD211HHH(1,INH5,INH4,INH3))/64.+
     &  self(i,j)
       enddo 
       enddo 

        ICH4=1
        ICH5=1
       do ICH3=1,2
       do INH3=ihiggs,6        
       self(i,j)=(CS1S1S3S3(i,j,ICH4,ICH5)*CS1S3S3(INH3,ICH3,ICH4)*
     &  CS1S3S3(INH3,ICH5,ICH3)*FD211HpHpH(1,ICH4,ICH3,INH3))/16.+
     &  self(i,j)
       enddo 
       enddo 
        INH3=6
        INH4=6
       do ISt3=1,2
       do ISt4=1,2     
       self(i,j)=(3*CS1S1S1S1(i,j,INH3,INH4)*CSSS(INH3,ISt3,ISt4)*
     &  CSSS(INH4,ISt4,ISt3)*FD211HSTST(1,INH3,ISt4,ISt3))/32.+
     &  self(i,j)
       enddo 
       enddo 
        ICH3=1
        ICH4=1
       do ISt3=1,2      
       self(i,j)=(3*CS1S1S3S3(i,j,ICH4,ICH3)*CS3S13S(ICH3,ISt3)*
     &  CS3S13SC(ICH4,ISt3)*FD211HpSTSB(1,ICH3,ISt3))/16.+self(i,j)
       enddo 
        self(i,j)=self(i,j)*fac
        selfCT(i,j)=selfCT(i,j)*fac1
        self(i,j)=self(i,j)+selfCT(i,j)
        self(j,i)=self(i,j)
       enddo
      enddo
c
c topo14
c
#ifdef printMT4
      Write(16,110) "TwoLoopNeutralSelfNoGBC[SUM][Nhung]={{(",DBLE(self(1,1)),"),(" ,DBLE(self(1,2)),"),("   ,
     &   DBLE(self(1,3)),"),(" , DBLE(self(1,4)),"),(",
     &   DBLE(self(1,5)),"),(",DBLE(self(1,6)),")},{("   
       do i=2,5
      Write(16,111) DBLE(self(i,1)),"),(" ,DBLE(self(i,2)),"),("   ,
     &   DBLE(self(i,3)),"),(" , DBLE(self(i,4)),"),(",
     &   DBLE(self(i,5)),"),(",DBLE(self(i,6)),")},{("
       enddo
       i=6
      Write(16,111) DBLE(self(i,1)),"),(" ,DBLE(self(i,2)),"),("   ,
     &   DBLE(self(i,3)),"),(" , DBLE(self(i,4)),"),(",
     &   DBLE(self(i,5)),"),(",DBLE(self(i,6)),")}};"
110   format(A,F24.14,A,F24.14,A,F24.14,A,F24.14,A,F24.14,A,F24.14,A )   
111   format(F24.14,A,F24.14,A,F24.14,A, F24.14,A,F24.14,A,F24.14,A ) 
#endif
      do i=1,6
       do j=1,6 
       selfIN(i,j)=0D0
      do gen3=1,6
        do gen2=1,6
       selfIN(i,j)=selfIN(i,j) + ZH(gen2, i)*ZH(gen3, j)* self(gen2,gen3)
        enddo
      enddo
        enddo
      enddo

 
c Martin Gabelmann added connections to mathematica code for momentum dependent Higgs
c selfenergies 3/2021.  
      end subroutine UnselfHH_atlambda2

      subroutine UnselfHH_atlambdap2(selfIN, selfINla1, selfINla2, mode)
      implicit none
      integer mode, rc, stat
      logical exist_file
      character*999 cmd
      character*200 input
      double precision selfIN(6,6),selfINla1(6,6),selfINla2(6,6)
     &,res(6,6)
#include "TLMT4.h"
#include "TLMT4lambda.h"

      call getarg(1,input)
      inquire(file=input, exist=exist_file)
      if(.not.exist_file) then
        input='inp.dat'
      end if
 
      open(unit=1234, iostat=stat, file='p2results.dat', status='old')
      if (stat == 0) close(1234, status='delete')

      if(mode.eq.1) then
          write(*,*) 'Expand GBC diagrams with small momentum'
      else
          write(*,*) 'O((alpha_t+alpha_lambda+alpha_kappa)^2)',
     & ' with full momenutm dependence'
      endif
      write(cmd,*) '/export/pc/bin/math1110 -script ',
     & '/users/tp/marting/ownCloud/Unifiles/PhD/2LoopNMSSM/',
     & 'NMSSMSpecific/NeutralSelfNonInteractive.m ', input
       cmd = trim(cmd)
       write(*,*) cmd
       call execute_command_line(cmd, wait=.true.,exitstat=rc)

      if(rc.eq.0)then
         selfINla2 = 0D0
         open(12, file='p2results.dat')
         read(12,*) res
         res = transpose(res)
         
         if(mode.lt.2)then
           selfINla1 = res
         else ! with full p^2 mathematica also calculates the MSSM-like diagrams
           selfINla1 = 0D0 
           selfIN = res
         endif
      else
          write(*,*) 'Mathematica failed to execute'
      endif

      end subroutine UnselfHH_atlambdap2
c end Martin Gabelmann added connections to mathematica code for momentum dependent Higgs
c selfenergies 3/2021.  
